/*---------------------------------------------------
-----------------------------------------------------
Filename:	cbuttons.m
Version:	1.0

Type:		maki
Date:		03. Nov. 2006 - 17:02 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "lib/pldir.mi"
#include "attribs/init_browser.m"
#include "attribs/init_Playlist.m"
#include "attribs/init_appearance.m"// Waveseeker integration v1.1
#include "lib/application.mi" // Waveseeker integration v1.1

#define WAVESEEKER_GUID "{E124F4D6-AA3E-4f3d-A813-C2A8CD6501E5}"

Class ToggleButton InfoToggleButton;
Global Button b_play, b_pause, b_eject, b_prev, b_next, b_stop, ToggleAlwaysOnTop, Switch2shade;
Global InfoToggleButton b_repeat, b_shuffle;
Global Group scriptGroup, PlayerCbuttons, PlayerTitlebar;
Global GuiObject SongTicker, shuffleActive, repeatActive, mainframe_big;
Global Int shuffleActive_Y, repeatActive_Y, minW, grabbX, /*grabbXmousetrap0, */grabbXmousetrap1, grabbXmousetrap2, grabbXmousetrap3, grabbXmousetrap4;
Global Layer mainframe_grabber, mainframe_grabber_mousetrap, mainframe_grabber_mousetrap1, mainframe_grabber_mousetrap2, mainframe_grabber_mousetrap3, mainframe_grabber_mousetrap4;
Global Layer PlaybackRing;
Global GuiObject PlaypauseAnimation, VolumeAnim, VolumeMousetrap4; // v1.13
Global Timer timeToHide;
Global Timer timeToShowWS; // v1.13
Global Timer timeToCheckWS; // v1.13

//Global ToggleButton WSButton;
Global Layout shade, normal; // Waveseeker integration v1.13
Global Windowholder WSHolder; // Waveseeker integration v1.1
Global Layer WSRounderBg, WSRounder; // Waveseeker integration v1.1
Global Int WaveSeekerIsVisible; // Waveseeker integration v1.13

System.onScriptLoaded ()
{
	initAttribs_browser();
	initAttribs_Playlist();
	initAttribs_Appearance(); // Waveseeker integration v1.1
  
	scriptGroup = getScriptGroup();
	
	PlayerCbuttons = scriptGroup.findObject("player.cbuttons");
  
	b_play = PlayerCbuttons.getObject("play.track");
	b_pause = PlayerCbuttons.getObject("pause.track");
	b_eject = PlayerCbuttons.getObject("progbutton.open");
	b_prev = PlayerCbuttons.getObject("Prev");
	b_next = PlayerCbuttons.getObject("Next");
	b_stop = PlayerCbuttons.getObject("Stop");
	b_repeat = PlayerCbuttons.getObject("repeat");
	b_shuffle = PlayerCbuttons.getObject("shuffle");

 // Waveseeker integration v1.1 //////////////////////////////////////

  Normal = getContainer("main").getLayout("normal"); // v1.13
  PlayerTitlebar = Normal.findObject("player.titlebar"); // v1.13
  Switch2shade = PlayerTitlebar.findObject("switch2shade"); // v1.13
  
  VolumeAnim = Normal.getObject("VolumeAnim"); // v1.13
  VolumeMousetrap4 = Normal.getObject("volume.mousetrap4"); // v1.13
  
  WSHolder = PlayerCbuttons.findObject("wdh.waveseeker");
	WSRounderBg = PlayerCbuttons.findObject("waveseeker.rounder.bg");
	WSRounder = PlayerCbuttons.findObject("waveseeker.rounder");

	PlaybackRing = scriptGroup.findObject("player.playback.ring");
	PlaypauseAnimation = scriptGroup.findObject("playpause.animation.main");
	//WSButton = PlayerCbuttons.findObject("waveseeker.button");

 // Waveseeker integration v1.1 //////////////////////////////////////
 
 
	shuffleActive = PlayerCbuttons.findObject("shuffle.active"); // v1.13
	shuffleActive_Y = shuffleActive.getGuiY();
	repeatActive = PlayerCbuttons.findObject("repeat.active"); // v1.13
	repeatActive_Y = repeatActive.getGuiY();
	
  mainframe_big = PlayerCbuttons.getParentLayout().getObject("player.mainframe.big");
  mainframe_grabber = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber");
	mainframe_grabber_mousetrap = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber.mousetrap");

  mainframe_grabber_mousetrap1 = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber.mousetrap1");
  mainframe_grabber_mousetrap2 = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber.mousetrap2");
  mainframe_grabber_mousetrap3 = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber.mousetrap3");
  mainframe_grabber_mousetrap4 = PlayerCbuttons.getParentLayout().getObject("player.mainframe.grabber.mousetrap4");

  ToggleAlwaysOnTop = PlayerCbuttons.getParentLayout().findObject("progbutton.always.on.top");

	minW = stringToInteger(getParam());
	grabbX = mainframe_grabber.getGuiX();
	//grabbXmousetrap0 = mainframe_grabber_mousetrap.getGuiX();
	grabbXmousetrap1 = mainframe_grabber_mousetrap1.getGuiX();
	grabbXmousetrap2 = mainframe_grabber_mousetrap2.getGuiX();
	grabbXmousetrap3 = mainframe_grabber_mousetrap3.getGuiX();
	grabbXmousetrap4 = mainframe_grabber_mousetrap4.getGuiX();


	mainframe_grabber.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	mainframe_grabber_mousetrap.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	mainframe_grabber_mousetrap1.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	mainframe_grabber_mousetrap2.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	mainframe_grabber_mousetrap3.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	mainframe_grabber_mousetrap4.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
	
	timeToHide = new Timer;
	timeToHide.setDelay(400);

	timeToShowWS = new Timer;
	timeToShowWS.setDelay(100);
	
	timeToCheckWS = new Timer;
	timeToCheckWS.setDelay(190);
		
	SongTicker = PlayerCbuttons.getParentLayout().findObject("songticker");

  if (wacup_attrib.getData() == "1")
  {
    if (waveseeker_attrib.getData() == "1")
    {
      WSHolder.setxmlparam("hold", WAVESEEKER_GUID);
    }
    else if (waveseeker_attrib.getData() == "0")
    {
      WSHolder.setxmlparam("hold", "none");
    }
  }
  
  String guidws = WSHolder.getGuid();
  timeToCheckWS.start();
}


system.onScriptUnloading ()
{
	delete timeToHide;
	delete timeToShowWS; // v1.13
	delete timeToCheckWS; // v1.13
}

waveseeker_attrib.onDataChanged () // v1.13 improved
{
  if (getData() == "1" && !System.isNamedWindowVisible(WAVESEEKER_GUID))
  {
    WSHolder.show();
    WaveSeekerIsVisible = 1;
    WSHolder.setxmlparam("hold", WAVESEEKER_GUID);
    //System.showWindow(WAVESEEKER_GUID, "", 1);
    timeToShowWS.start();
    //WSButton.leftClick();
  }
  else if (getData() == "1" && System.isNamedWindowVisible(WAVESEEKER_GUID))
  {
    WSHolder.show();
    WaveSeekerIsVisible = 1;
    //System.showWindow(WAVESEEKER_GUID, "", 0);
    System.hideNamedWindow(WAVESEEKER_GUID);
    WSHolder.setxmlparam("hold", WAVESEEKER_GUID);
    WSHolder.setxmlparam("autoopen", "1");
    timeToShowWS.start();
  }
  else if (getData() == "0" && System.isNamedWindowVisible(WAVESEEKER_GUID))
  {
    WaveSeekerIsVisible = 0;
    WSHolder.setxmlparam("hold", "none");
    //System.hideNamedWindow(WAVESEEKER_GUID);
    WSHolder.setxmlparam("autoopen", "0");
    WSHolder.hide();
    //System.showWindow(WAVESEEKER_GUID, "", 0);
    timeToShowWS.start();
  }
  else if (getData() == "0" && !System.isNamedWindowVisible(WAVESEEKER_GUID))
  {
    WaveSeekerIsVisible = 0;
    //System.hideNamedWindow(WAVESEEKER_GUID);
    System.showWindow(WAVESEEKER_GUID, "", 0);
    WSHolder.setxmlparam("hold", "none");
    WSHolder.setxmlparam("autoopen", "0");
    WSHolder.hide();
    timeToShowWS.start();
  }
}

timeToShowWS.onTimer(){ // v1.13
  timeToShowWS.stop();
  System.showWindow(WAVESEEKER_GUID, "", 1);
  return; // Not sure if it's needed
}


InfoToggleButton.onLeftButtonDown (int x, int y)
{
	if (InfoToggleButton == b_shuffle)
	{
		if (getCurCfgVal() == 1)
		{
			SongTicker.sendAction("showinfo", "Shuffle: On", 0, 0, 0, 0);
		}
		else
		{
			SongTicker.sendAction("showinfo", "Shuffle: Off", 0, 0, 0, 0);
		}
	}
	else if (InfoToggleButton == b_repeat)
	{
		if (getCurCfgVal() == 1)
		{
			SongTicker.sendAction("showinfo", "Repeat: Playlist", 0, 0, 0, 0);
		}
		else if (getCurCfgVal() == -1)
		{
			SongTicker.sendAction("showinfo", "Repeat: Track", 0, 0, 0, 0);
		}
		else if (getCurCfgVal() == 0)
		{
			SongTicker.sendAction("showinfo", "Repeat: Off", 0, 0, 0, 0);
		}
	}
}

InfoToggleButton.onLeftButtonUp (int x, int y)
{
	if (InfoToggleButton == b_shuffle)
	{
		if (getCurCfgVal() == 1)
		{
			SongTicker.sendAction("showinfo", "Shuffle: On", 0, 0, 0, 0);
		}
		else
		{
			SongTicker.sendAction("showinfo", "Shuffle: Off", 0, 0, 0, 0);
		}
	}
	else if (InfoToggleButton == b_repeat)
	{
		if (getCurCfgVal() == 1)
		{
			SongTicker.sendAction("showinfo", "Repeat: Playlist", 0, 0, 0, 0);
		}
		else if (getCurCfgVal() == -1)
		{
			SongTicker.sendAction("showinfo", "Repeat: Track", 0, 0, 0, 0);
		}
		else if (getCurCfgVal() == 0)
		{
			SongTicker.sendAction("showinfo", "Repeat: Off", 0, 0, 0, 0);
		}
	}
}

Global Boolean shuffleDown, repeatDown;
b_shuffle.onLeftButtonDown (int x, int y)
{
	shuffleDown = 1;
	shuffleActive.setXmlParam("y", integerToString(shuffleActive_Y+1));
}

b_shuffle.onLeftButtonUp (int x, int y)
{
	shuffleDown = 0;
	shuffleActive.setXmlParam("y", integerToString(shuffleActive_Y));
}

b_shuffle.onleaveArea ()
{
	shuffleActive.setXmlParam("y", integerToString(shuffleActive_Y));
}

b_shuffle.onEnterArea ()
{
	if (shuffleDown) shuffleActive.setXmlParam("y", integerToString(shuffleActive_Y+1));
}

b_repeat.onLeftButtonDown (int x, int y)
{
	repeatDown = 1;
	repeatActive.setXmlParam("y", integerToString(repeatActive_Y+1));
}

b_repeat.onLeftButtonUp (int x, int y)
{
	repeatDown = 0;
	repeatActive.setXmlParam("y", integerToString(repeatActive_Y));
}

b_repeat.onleaveArea ()
{
	repeatActive.setXmlParam("y", integerToString(repeatActive_Y));
}

b_repeat.onEnterArea ()
{
	if (repeatDown) repeatActive.setXmlParam("y", integerToString(repeatActive_Y+1));
}

PlayerCbuttons.onResize (int x, int y, int w, int h)
{
	mainframe_grabber.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
  mainframe_grabber_mousetrap.setXmlParam("x", integerToString(grabbX + PlayerCbuttons.GetWidth() - minW));
  mainframe_grabber_mousetrap1.setXmlParam("x", integerToString(grabbXmousetrap1 + PlayerCbuttons.GetWidth() - minW));
  mainframe_grabber_mousetrap2.setXmlParam("x", integerToString(grabbXmousetrap2 + PlayerCbuttons.GetWidth() - minW));
  mainframe_grabber_mousetrap3.setXmlParam("x", integerToString(grabbXmousetrap3 + PlayerCbuttons.GetWidth() - minW));
  mainframe_grabber_mousetrap4.setXmlParam("x", integerToString(grabbXmousetrap4 + PlayerCbuttons.GetWidth() - minW));
}



// Victhor mod: Grabber hover state


mainframe_grabber_mousetrap.onEnterArea ()
{
	mainframe_grabber_mousetrap.setXmlParam("ghost", "1"); // Vic note:  Here I previously tried ("visible", "0") but it wasn't fast enough so it ended up being buggy
	mainframe_grabber.setXmlParam("image", "v.divider.suiframe.h2");
	timeToHide.start();	
}

mainframe_big.onLeftButtonUp (int x, int y)
{
  mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
}

mainframe_grabber_mousetrap1.onEnterArea ()
{
	mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
	timeToHide.start();
}

mainframe_grabber_mousetrap2.onEnterArea ()
{
	mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
	timeToHide.start();
}

mainframe_grabber_mousetrap3.onEnterArea ()
{
	mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
	timeToHide.start();
}

mainframe_grabber_mousetrap4.onEnterArea ()
{
	mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
	timeToHide.start();
}

timeToHide.onTimer(){
	mainframe_grabber_mousetrap.setXmlParam("ghost", "0");
	mainframe_grabber.setXmlParam("image", "v.divider");
  timeToHide.stop(); // v1.15 added
}

b_stop.onLeftClick()
{
  if (System.isKeyDown(VK_CONTROL) == 1) {
    SongTicker.sendAction("showinfo", "Stop after current", 0, 0, 0, 0);
  }
}

Switch2shade.onLeftButtonDown(int x, int y) // v1.13 Fix
{
  if (wacup_attrib.getData() == "1")
  {
    if (waveseeker_attrib.getData() == "1")
    {
      //if (WSHolder.isVisible())
      if (System.isNamedWindowVisible(WAVESEEKER_GUID))
      {
        WaveSeekerIsVisible = 1;
        //WSHolder.setxmlparam("autoopen", "1");
      }
      else
      {
        WaveSeekerIsVisible = 0;
        //WSHolder.setxmlparam("autoopen", "0");
      }
    }
    else if (waveseeker_attrib.getData() == "0")
    {
      // do nothing
    }
  }
}

/*Switch2shade.onLeftButtonUp(int x, int y) // v1.13 used this to check if WaveSeekerIsVisible was getting the state of "isNamedWindowVisible.."
{
  if (WaveSeekerIsVisible == 1)
  {
    System.messageBox("IS VISIBLE", "IS VISIBLE", 1, "");
  }
  else if (WaveSeekerIsVisible == 0)
  {
    System.messageBox("IS NOT VISIBLE", "IS NOT VISIBLE", 1, "");
  }
}*/


Switch2shade.onsetVisible(Boolean onoff) // v1.13 Fix
{
  if (wacup_attrib.getData() == "1")
  {
    if (waveseeker_attrib.getData() == "1")
    {
      if (WaveSeekerIsVisible == 1)
      {
        WSHolder.setxmlparam("autoopen", "1");
      }
      else if (WaveSeekerIsVisible == 0)
      {
        WSHolder.setxmlparam("autoopen", "0");
      }
    }
    else if (waveseeker_attrib.getData() == "0")
    {
      // do nothing
    }
  }
}

WSHolder.onSetVisible(Boolean onoff)
{
  if (WSHolder.isVisible())
  {
    WaveSeekerIsVisible == 1;
    //System.messageBox("IS VISIBLE", "IS VISIBLE", 1, "");
  }
  else
  {
    WaveSeekerIsVisible == 0;
    //System.messageBox("IS NOT VISIBLE", "IS NOT VISIBLE", 1, "");
  }
}


System.onLookForComponent(String guidws)
{
  /*if (waveseeker_attrib.getData() == "1")
  {
    WSHolder.setxmlparam("hold", WAVESEEKER_GUID);
    WSHolder.setxmlparam("autoopen", "1");
  }
  else if (waveseeker_attrib.getData() == "0")
  {
    WSHolder.setxmlparam("hold", "none");
    WSHolder.setxmlparam("autoopen", "0");
  }*/
    
  if (guidws) { timeToCheckWS.start(); }
}

System.onGetCancelComponent(String guidws, boolean goingvisible)
{
  /*if (waveseeker_attrib.getData() == "1")
  {
    WSHolder.setxmlparam("hold", WAVESEEKER_GUID);
    WSHolder.setxmlparam("autoopen", "1");
  }
  else if (waveseeker_attrib.getData() == "0")
  {
    WSHolder.setxmlparam("hold", "none");
    WSHolder.setxmlparam("autoopen", "0");
  }*/
  
  if (guidws = WAVESEEKER_GUID) { timeToCheckWS.start(); }
}


timeToCheckWS.onTimer()
{
  timeToCheckWS.stop();

  if (System.isNamedWindowVisible(WAVESEEKER_GUID) && WSHolder.getxmlparam("hold") == WAVESEEKER_GUID)
  {
    WSRounderBg.show();
    WSRounder.setxmlParam("y", "88");
    PlayerCbuttons.setxmlParam("y", "132");
    PlaybackRing.setxmlParam("y", "132");
    PlaypauseAnimation.setxmlParam("y", "133");

    VolumeAnim.setxmlParam("y", "173");
    VolumeMousetrap4.setxmlParam("y", "172"); VolumeMousetrap4.setxmlParam("h", "42");
    /*System.messageBox("VISIBLE", guidws, 1, ""); return;*/
  }
  /*else if (System.isNamedWindowVisible(WAVESEEKER_GUID) && WSHolder.getxmlparam("hold") == "none") { System.messageBox("NOT VISIBLE", guidws, 1, ""); return; }*/
  else
  {
    WSRounderBg.hide();
    WSRounder.setxmlParam("y", "71");
    PlayerCbuttons.setxmlParam("y", "126");
    PlaybackRing.setxmlParam("y", "126");
    PlaypauseAnimation.setxmlParam("y", "127");

    VolumeAnim.setxmlParam("y", "167");
    VolumeMousetrap4.setxmlParam("y", "166"); VolumeMousetrap4.setxmlParam("h", "48");
  
    /*System.messageBox("NOT VISIBLE", guidws, 1, "");*/
  }
}