/********************************************************\
**  Filename:	coverflow.m				**
**  Version:	1.0					**
**  Date:	20. Nov. 2007 - 15:25			**
**********************************************************
**  Type:	winamp.wasabi/maki			**
**  Project:	Cover Flow				**
**********************************************************
**  Author:	Martin Poehlmann aka Deimos		**
**  E-Mail:	martin@skinconsortium.com		**
**  Internet:	http://www.skinconsortium.com		**
**		http://home.cs.tum.edu/~poehlman	**
**  Victhor mod 2017: removed 2 cover from the total. The purpose of this script is different now.
\********************************************************/


#include "std.mi"
#include "lib/pldir.mi"
#include "lib/com/songinfo.m"
#include "attribs/init_browser.m"

Function update();
Function fade (GuiObject o, int alpha, float s);

Class GuiObject AlbumCover, curr_bg, prev1_bg, prev2_bg, next1_bg, next2_bg;

Global AlbumCover prev2, prev1, curr, next1, next2;
Global String sprev2, sprev1, scurr, snext1, snext2;
Global text info;
Global layer info_bg, album_overlay_effect;
Global Group scriptGroup;
Global PlEdit PleditListener;

Global Timer delay;



System.onScriptLoaded ()
{
	initAttribs_browser();
	
	scriptGroup = getScriptGroup();	

	PleditListener = new PlEdit;

	prev2 = scriptGroup.getObject("aa.prev2");
	prev1 = scriptGroup.getObject("aa.prev1");
	curr = scriptGroup.getObject("aa.curr");
	next1 = scriptGroup.getObject("aa.next1");
	next2 = scriptGroup.getObject("aa.next2");
	
	prev2_bg = scriptGroup.getObject("aa.prev2.bg.filler");
	prev1_bg = scriptGroup.getObject("aa.prev1.bg.filler");
	curr_bg = scriptGroup.getObject("aa.curr.bg.filler");
	next1_bg = scriptGroup.getObject("aa.next1.bg.filler");
	next2_bg = scriptGroup.getObject("aa.next2.bg.filler");
	
	
	album_overlay_effect = scriptGroup.getObject("album.overlay.effect");

	info = scriptGroup.getParent().findObject("info");
	info_bg = scriptGroup.getParent().findObject("info.bg");

	delay = new Timer;
	delay.setDelay(10);

	if (scriptGroup.isVisible() == 1) update();
}

System.onScriptUnloading ()
{
	delete delay;
}

scriptGroup.onSetVisible(int on) {
	if (on) update();
}

System.onTitleChange (String newtitle)
{
	update();

}

update ()
{
	int cur = PlEdit.getCurrentIndex();
	int max = PlEdit.getNumTracks();

  sprev2 = PlEdit.getTitle(cur-2);
  sprev1 = PlEdit.getTitle(cur-1);
  scurr = PlEdit.getTitle(cur);
  snext1 = PlEdit.getTitle(cur+1);
  snext2 = PlEdit.getTitle(cur+2);

  songinfo_reload();
    
  String isstreamv = getPlayItemMetaDataString("streamtype");
  if (isstreamv != "") { curr.setXMLParam("notfoundimage", "cover.aolr.coverflow"); }
  
    
	if (cur < 1)
	{
    next1.setXmlParam("source", PlEdit.getFileName(cur+1));
    next2.setXmlParam("source", PlEdit.getFileName(cur+2));
    prev1.hide();
    next1.show();
    next2.show();
    next2_bg.show();
    
    next1.setXmlParam("x", "43");
    
    next1_bg.setXmlParam("x", "43");
    
    next2.setXmlParam("x", "70");

    next2_bg.setXmlParam("x", "70");
    
    curr.setXmlParam("x", "6");
    if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "winamp.cover.notfound.140");
        
    curr_bg.setXmlParam("x", "6");
    album_overlay_effect.setXmlParam("x", "-4");
   }
   
	else if (cur >= 0 && cur <= max-2)
	{
		prev1.setXmlParam("source", PlEdit.getFileName(cur-1));
		next1.setXmlParam("source", PlEdit.getFileName(cur+1));
		prev1.show();
		next1.show();
		prev2.hide();
    prev2_bg.hide();
		next2.hide();
    next2_bg.hide();		
		
    prev1.setXmlParam("x", "0");
    
    prev1_bg.setXmlParam("x", "0");
  
    next1.setXmlParam("x", "70");
    
    next1_bg.setXmlParam("x", "70");
    
    
		curr.setXmlParam("x", "30");
    if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "winamp.cover.notfound.140");
        
		curr_bg.setXmlParam("x", "30");
		album_overlay_effect.setXmlParam("x", "20");
	}
	
  else if (cur >= max-1)
  {
	prev1.setXmlParam("source", PlEdit.getFileName(cur-1));
	prev2.setXmlParam("source", PlEdit.getFileName(cur-2));
  next1.hide();
	prev1.show();
  prev2.show();
  prev2_bg.show();
  
  prev1.setXmlParam("x", "30");
  
  prev1_bg.setXmlParam("x", "30");
    
  prev2.setXmlParam("x", "0");
  
  prev2_bg.setXmlParam("x", "0");

  curr.setXmlParam("x", "60");
  if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "winamp.cover.notfound.140");      
  
  curr_bg.setXmlParam("x", "60");
  album_overlay_effect.setXmlParam("x", "50");
  }
    
}

PleditListener.onPleditModified ()
{
	if (delay) delay.start();
}

delay.onTimer ()
{
	delay.stop();
	update();
}

AlbumCover.onRightButtonDown (int x, int y)
{
	songinfo_reload(); // refresh vars
	
  popupmenu p = new popupmenu;

  if (songinfo_isStream == 0) p.addCommand("Refresh Album Art", 1, 0, 0);
	//if (songinfo_isStream == 0) p.addSeparator();
	if (songinfo_isStream == 0) p.addCommand("Open Folder", 2, 0, 0);
	//if (songinfo_isStream == 0) p.addSeparator();
  if (songinfo_isStream == 0 && search_google_attrib.getdata() == "1") p.addCommand("Search Album art (Google)", 3, 0, 0);
  if (songinfo_isStream == 0 && search_bing_attrib.getdata() == "1") p.addCommand("Search Album art (Bing)", 5, 0, 0);
  //if (songinfo_isStream == 0) p.addSeparator();
  if (search_google_attrib.getdata() == "1") p.addCommand("Search Lyrics (Google)", 4, 0, 0);
  if (search_bing_attrib.getdata() == "1") p.addCommand("Search Lyrics (Bing)", 6, 0, 0);
  //if (songinfo_isStream == 1) p.addSeparator();  
  if (songinfo_isStream == 1) p.addCommand("Open Station / Stream Homepage", 7, 0, 0);

	int result = p.popatmouse();
	//int result = p.popAtXY(getMousePosX()-12, getMousePosY()+15);
	delete p;

	String pis = getXmlParam("source");
	if (pis == "") pis = system.getPlayItemString();

	if (result == 1)
	{
		if (system.getAlbumArt(pis) > 0)
		{
			setXmlParam("notfoundimage", getXmlParam("notfoundimage")); // a nesty refresh - isn't it?
		}
	}	

	else if (result == 2)
	{
      String path = getPath(getPlayItemMetaDataString("filename"));
      System.navigateUrl(path);
	}
	
		else if (result == 3) // Google
    {
      String sartist = getPlayItemMetaDataString("artist");
      String salbum = getPlayItemMetaDataString("album");
  
		  if (use_browser_attrib.getdata() == "1")
      {
        System.navigateUrl("www.google.com/search?tbm=isch&q="+ urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
        group sui = getContainer("main").getLayout("normal").findObject("sui.content");
        sui.sendAction ("browser_navigate", ("www.google.com/search?tbm=isch&q=" + urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover"), 0, 0, 0, 0);
      }
      
	}
	
			else if (result == 4) // Google
      {
      String sartist = getPlayItemMetaDataString("artist");
      String stitle = getPlayItemMetaDataString("title");
          
        if (use_browser_attrib.getdata() == "1")
        {
          System.navigateUrl("www.google.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
        }

        if (use_reader_attrib.getdata() == "1")
        {
          String lyricsearch = (urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
          
          group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
          sui.sendAction ("browser_search", lyricsearch, 0, 0, 0, 0);
          
          
            if (songinfo_isStream)
            {          
              String stitlestream = (songinfo_streamtitle);
          
              String lyricsearch = (urlEncode(stitlestream) + " " + "lyrics");
          
              group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
              sui.sendAction ("browser_search", lyricsearch, 0, 0, 0, 0);
            }
        }
      }
      
      
      		else if (result == 5) // Bing
    {
      String sartist = getPlayItemMetaDataString("artist");
      String salbum = getPlayItemMetaDataString("album");
  
		  if (use_browser_attrib.getdata() == "1")
      {
        System.navigateUrl("www.bing.com/?scope=images&FORM=Z9LH1&q="+ urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
        String coversearch = ("www.bing.com/?scope=images&FORM=Z9LH1&q=" + urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");

        group sui = getContainer("main").getLayout("normal").findObject("sui.content");
        sui.sendAction ("browser_navigate", coversearch, 0, 0, 0, 0);
      }
      
	}
	
				else if (result == 6) // Bing
      {
      String sartist = getPlayItemMetaDataString("artist");
      String stitle = getPlayItemMetaDataString("title");
          
        if (use_browser_attrib.getdata() == "1")
        {
          System.navigateUrl("www.bing.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
        }

        if (use_reader_attrib.getdata() == "1")
        {
          String lyricsearch = (urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
         
          group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
          sui.sendAction ("browser_search", lyricsearch, 0, 0, 0, 0);
          
          
          if (songinfo_isStream)
          {          
            String stitlestream = (songinfo_streamtitle);
          
            String lyricsearch = (urlEncode(stitlestream) + " " + "lyrics");
          
            group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
            sui.sendAction ("browser_search", lyricsearch, 0, 0, 0, 0);
          }
        }
      }

    else if (result == 7) // Station URL
    {
	
      if (use_browser_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      System.navigateUrl(nav);
      }
      if (use_reader_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      }
    }

}

AlbumCover.onLeftButtonDblClk (int x, int y)
{
	songinfo_reload();
	  
  String isstreamv = getPlayItemMetaDataString("streamtype");
  
  if (songinfo_isStream == 0)
  {
  System.navigateUrl(getPath(getPlayItemMetaDataString("filename")));
  }
  else if (isstreamv != "")
  {
      if (use_browser_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      System.navigateUrl(nav);
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      }  
  }
}

AlbumCover.onEnterArea ()
{
	if (!findObject("aa." + getToken(getId(), ".", 1)).isVisible())
	{
		return;
	}

	int cur = PlEdit.getCurrentIndex();

	if (AlbumCover == prev2){
		info.setText(sprev2);
		info.setXmlParam ("visible", "1");
		info_bg.setXmlParam ("visible", "1");
		}
	
	else if (AlbumCover == prev1){
		info.setText(sprev1);
		info.setXmlParam ("visible", "1");
		info_bg.setXmlParam ("visible", "1");
		}
	else if (AlbumCover == curr){
		info.setText(scurr);
    info.setxmlparam ("visible", "1");
    info_bg.setxmlparam ("visible", "1");
    }
	else if (AlbumCover == next1){
		info.setText(snext1);
    info.setxmlparam ("visible", "1");
    info_bg.setxmlparam ("visible", "1");
    }
	else if (AlbumCover == next2){
		info.setText(snext2);
		info.setXmlParam ("visible", "1");
		info_bg.setXmlParam ("visible", "1");
		}
	
	GuiObject o = scriptGroup.findObject("play." + getToken(getId(), ".", 1));
	if (o )
	{
		fade(o, 253, 0.133);
	}
}

AlbumCover.onLeaveArea ()
{
	info.setText("");
  info.setxmlparam ("visible", "0");
  info_bg.setxmlparam ("visible", "0");

	GuiObject o = scriptGroup.findObject("play." + getToken(getId(), ".", 1));
	if (o)
	{
		fade(o, 0, 0.3);
	}
}

fade (GuiObject o, int alpha, float s)
{
	o.cancelTarget();
	o.setTargetA(alpha);
	o.setTargetSpeed(s);
	o.gotoTarget();
}