#include "std.mi"
#include "lib/winampconfig.mi"

Function setBassBands(Int intValue);
Function setTrebleBands(Int intValue);

Global Group scriptGroup;
Global Button buttonEqReset, ButtonCenterBalance;
Global GuiObject SongTicker;

Global Slider sliderEqNormalBalance;
Global Slider sliderEqNormalBass;
Global Slider sliderEqNormalTreble;

Global Slider sliderEqNormalEQBand00;
Global Slider sliderEqNormalEQBand01;
Global Slider sliderEqNormalEQBand02;
Global Slider sliderEqNormalEQBand03;
Global Slider sliderEqNormalEQBand04;
Global Slider sliderEqNormalEQBand05;
Global Slider sliderEqNormalEQBand06;
Global Slider sliderEqNormalEQBand07;
Global Slider sliderEqNormalEQBand08;
Global Slider sliderEqNormalEQBand09;
Global Slider sliderEqNormalEQBand10;

Global Boolean boolEqMyChange;

System.onScriptLoaded () {
	scriptGroup = getScriptGroup();
	buttonEqReset = scriptGroup.findObject("eq.preset.reset");
	
	sliderEqNormalBass = scriptGroup.findObject("slider.bass");
	sliderEqNormalTreble = scriptGroup.findObject("slider.treble");
	sliderEqNormalBalance = scriptGroup.findObject("Balance");
	ButtonCenterBalance = scriptGroup.findObject("Center.balance");
	
	sliderEqNormalEQBand00 = scriptGroup.findObject("preamp");
	sliderEqNormalEQBand01 = scriptGroup.findObject("eq1");
	sliderEqNormalEQBand02 = scriptGroup.findObject("eq2");
	sliderEqNormalEQBand03 = scriptGroup.findObject("eq3");
	sliderEqNormalEQBand04 = scriptGroup.findObject("eq4");
	sliderEqNormalEQBand05 = scriptGroup.findObject("eq5");
	sliderEqNormalEQBand06 = scriptGroup.findObject("eq6");
	sliderEqNormalEQBand07 = scriptGroup.findObject("eq7");
	sliderEqNormalEQBand08 = scriptGroup.findObject("eq8");
	sliderEqNormalEQBand09 = scriptGroup.findObject("eq9");
	sliderEqNormalEQBand10 = scriptGroup.findObject("eq10");
	
	SongTicker = scriptGroup.getParentLayout().findObject("songticker");	
  
}

scriptGroup.onSetVisible(int on) {
	if (on) System.setEqBand(0, System.getEqBand(0));
}

System.onEqBandChanged(Int intBand, Int intValue) {
	Float fltAverage;
	if (!boolEqMyChange) {
		boolEqMyChange = true;
		
		for(Int i = 0; i < 5; i++) fltAverage += ((getEqBand(i)+127)*(5-i)*(5-i)*(5-i)  );
		fltAverage /= 210;
		if (fltAverage < 0) fltAverage = 0;
		if (fltAverage > 255) fltAverage = 255;
		sliderEqNormalBass.setPosition(fltAverage);
		
		for(Int i = 5; i < 10; i++) fltAverage += ((getEqBand(i)+127)*(i-4)*(i-4)*(i-4)  );
		fltAverage /= 210;
		if (fltAverage < 0) fltAverage = 0;
		if (fltAverage > 255) fltAverage = 255;
		sliderEqNormalTreble.setPosition(fltAverage);
		
		boolEqMyChange = false;
	}
}

buttonEqReset.onLeftClick() {
	sliderEqNormalBass.setPosition(127);
	sliderEqNormalTreble.setPosition(127);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("None"), 0, 0, 0, 0);	
}


ButtonCenterBalance.onLeftClick() {
	sliderEqNormalBalance.setPosition(127);
}


sliderEqNormalBass.onSetPosition(Int intNewPosition) {
	setBassBands(intNewPosition);
}

sliderEqNormalTreble.onSetPosition(Int intNewPosition) {
	setTrebleBands(intNewPosition);
}

setBassBands(Int intValue) {
	if (!boolEqMyChange) {
		boolEqMyChange = true;
		for (Int i = 0; i < 5; i++) {
			System.setEqBand(i, (intValue -127) * 1.27 / (i + 1));
		}
		string t=translate("Bass")+":"+ System.integerToString((intValue / 255) * 100) + "%";
		SongTicker.sendAction("showinfo", t, 0, 0, 0, 0);
		boolEqMyChange = false;
	}
}

setTrebleBands(Int intValue) {
	if (!boolEqMyChange) {
		boolEqMyChange = true;
		for (Int i = 5; i < 10; i++) {
			System.setEqBand(i, (intValue -127) * 1.27 / (10 - i));
		}
		string t=translate("Treble")+":"+ System.integerToString((intValue / 255) * 100) + "%";
		SongTicker.sendAction("showinfo", t, 0, 0, 0, 0);
		boolEqMyChange = false;
	}
}