/*************************************************************
  KameleonDUI - eq-presets.m
  by Leechbite + Victhor Mods

  - script for the EQ preset buttons, including the
    programmable USER button.

*************************************************************/

#include "std.mi"
#include "eq-utilities.m"

Global group ScriptGroup;
Global layout eqLayout;
Global GuiObject SongTicker;

Global button eqFULL, eqROCK, eqPOP, eqSOFT, eqDANCE, eqUSER;
Global layer eqACTIVE;
Global int eqUser0,eqUser1,eqUser2,eqUser3,eqUser4,eqUser5,eqUser6,eqUser7,eqUser8,eqUser9,eqUserPreamp;

Global timer eqUsertimer;
Global boolean eqUserDown;

System.onScriptLoaded() {
  ScriptGroup = getScriptGroup();
	SongTicker = ScriptGroup.getParentLayout().findObject("songticker");	

  eqFULL = ScriptGroup.findObject("eq.preset.full");
  eqROCK = ScriptGroup.findObject("eq.preset.rock");
  eqPOP = ScriptGroup.findObject("eq.preset.pop");
  eqDANCE = ScriptGroup.findObject("eq.preset.dance");
  eqSOFT = ScriptGroup.findObject("eq.preset.soft");
  eqUSER = ScriptGroup.findObject("eq.preset.user");
  eqACTIVE = ScriptGroup.findObject("eq.preset.active");


  eqUser0 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 0", 1);
  eqUser1 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 1", 1);
  eqUser2 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 2", 1);
  eqUser3 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 3", 1);
  eqUser4 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 4", 1);
  eqUser5 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 5", 1);
  eqUser6 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 6", 1);
  eqUser7 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 7", 1);
  eqUser8 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 8", 1);
  eqUser9 = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ 9", 1);
  
  eqUserPreamp = getPrivateInt("Big Bento Modern Windows 10 edition", "User EQ Preamp", 1);
}

scriptGroup.onSetVisible(int on) {
	if (on)
	{
    eqUserTimer = new Timer;
    eqUserTimer.setDelay(750);
  }
}

System.onScriptUnLoading() {
  delete eqUserTimer;
}

setEQPreset(int preamp, int eq0, int eq1, int eq2, int eq3, 
	int eq4, int eq5, int eq6, int eq7, int eq8, int eq9) {

  setEQPreamp(preamp);
  setEQBand(0, eq0);
  setEQBand(1, eq1);
  setEQBand(2, eq2);
  setEQBand(3, eq3);
  setEQBand(4, eq4);
  setEQBand(5, eq5);
  setEQBand(6, eq6);
  setEQBand(7, eq7);
  setEQBand(8, eq8);
  setEQBand(9, eq9);  
}

eqFULL.onLeftClick() {
  setEQPreset(EQ_Full);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("Full"), 0, 0, 0, 0);
}

eqROCK.onLeftClick() {
  setEQPreset(EQ_Rock);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("Rock"), 0, 0, 0, 0);
}

eqPOP.onLeftClick() {
  setEQPreset(EQ_Pop);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("Pop"), 0, 0, 0, 0);
}

eqSOFT.onLeftClick() {
  setEQPreset(EQ_Soft);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("Soft"), 0, 0, 0, 0);
}

eqDANCE.onLeftClick() {
  setEQPreset(EQ_Dance);
  SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("Dance"), 0, 0, 0, 0);
}

eqUSER.onLeftButtonDown(int x, int y) {
  eqUserTimer.start();
  eqUserDown = TRUE;
}

eqUSER.onLeftButtonUp(int x, int y) {
	if (eqUserTimer.isRunning()) {
		eqUserTimer.stop();
		setEQPresetUSER();
    SongTicker.sendAction("showinfo", translate("EQ Preset") + ": " + translate("USER"), 0, 0, 0, 0);
	}
		eqUserDown = FALSE;
}

eqUserTimer.onTimer() {
	stop();
	eqUserDown = FALSE;
	
	setUSEREQ();

  SongTicker.sendAction("showinfo", "USER Preset set", 0, 0, 0, 0);
}