/*---------------------------------------------------
-----------------------------------------------------
Version:	2.01
Author:		Martin Poehlmann aka Deimos + Victhor mods
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "lib/winampconfig.mi"


#define ISOBANDS "31.5 Hz,63 Hz,125 Hz,250 Hz,500 Hz,1 KHz,2 KHz,4 KHz,8 KHz,16 KHz"
#define WINAMPBANDS "70 Hz,180 Hz,320 Hz,600 Hz,1 KHz,3 KHz,6 KHz,12 KHz,14 KHz,16 KHz"

Class Button Eqbutton;
Member int EqButton.setTo;

Global Group scriptGroup, PlayerCButtons, EqContent;
Global Slider slidercb, Balance;
Global Text fadertext, fadertext2, EQparam;
Global Button CFIncrease, CFDecrease, eqon;
Global Togglebutton eqauto;
Global ToggleButton Crossfade;
Global GuiObject CrossfadeActive, eqonActive, eqautoActive, SongTicker;
Global Int CrossfadeActive_Y, eqonActive_Y, eqautoActive_Y;
Global Eqbutton btnEQp12,btnEQ0,btnEQm12;
Global layer frequencyLabel, mousetrap;
Function MousetrapActivation();

System.onScriptLoaded()
{
	PlayerCButtons = getScriptGroup().findObject("player.cbuttons");
  SongTicker = PlayerCButtons.getParentLayout().findObject("songticker");
	WinampConfigGroup eqwcg = WinampConfig.getGroup("{72409F84-BAF1-4448-8211-D84A30A1591A}");

	int freqmode = eqwcg.getInt("frequencies"); // returns 0 for classical winamp levels, 1 for ISO levels

	scriptGroup = getScriptGroup();
	EqContent = scriptGroup.getObject("info.component.eq.content");
	mousetrap = scriptGroup.findObject("mousetrapscroll");
	EQparam = EqContent.findObject("scrollbars.param");
	slidercb = scriptGroup.findObject("sCrossfade");
	fadertext = scriptGroup.findObject("CFDisplay");
	fadertext2 = scriptGroup.findObject("CFDisplay2");
	CFIncrease = scriptGroup.findObject("CrossfadeIncrease");
	CFDecrease = scriptGroup.findObject("CrossfadeDecrease");
	Crossfade = scriptGroup.findObject("Crossfade");
	CrossfadeActive = scriptGroup.findObject("CrossfadeActive");
	CrossfadeActive_Y = CrossfadeActive.getGuiY();

	eqon = scriptGroup.findObject("eqonoff");
	eqonActive = scriptGroup.findObject("eqonoffActive");
	eqonActive_Y = eqonActive.getGuiY();

	eqauto = scriptGroup.findObject("eqauto");
	eqautoActive = scriptGroup.findObject("eqautoActive");
	eqautoActive_Y = eqautoActive.getGuiY();

	btnEQp12 = scriptGroup.findObject("EQ_p12");
	btnEQp12.setTo = 127;
	btnEQ0 = scriptGroup.findObject("EQ_0");
	btnEQ0.setTo = 0;
	btnEQm12 = scriptGroup.findObject("EQ_m12");
	btnEQm12.setTo = -127;

	Balance = scriptGroup.findObject("Balance");

	frequencyLabel = scriptGroup.findObject("frequency.labels");
    system.onEqFreqChanged(freqmode);

  if (PlayerCButtons.isVisible() == 1)
  {
    slidercb.onSetPosition(slidercb.getPosition());
    Crossfade.onToggle(Crossfade.getActivated());
  }
  
  MousetrapActivation();
}


PlayerCButtons.onSetVisible(int on) {
	if (on)
	{
    slidercb.onSetPosition(slidercb.getPosition());
    Crossfade.onToggle(Crossfade.getActivated());
  }
}

Balance.onSetPosition(int newpos)
{
	string t=translate("Balance")+":";
	if (newpos==127) t+= " " + translate("Center");
	if (newpos<127) t += " " + integerToString((100-(newpos/127)*100))+"% "+translate("Left");
	if (newpos>127) t += " " + integerToString(((newpos-127)/127)*100)+"% "+translate("Right");

	SongTicker.sendAction("showinfo", t, 0, 0, 0, 0);
}

slidercb.onSetPosition(int val)
{
	String s = IntegerToString(val);
	fadertext.setText(s);
	fadertext2.setText(s);
}

CFIncrease.onLeftClick()
{
	slidercb.SetPosition(slidercb.getPosition()+1);
}

CFDecrease.onLeftClick()
{
	slidercb.SetPosition(slidercb.getPosition()-1);
}

Crossfade.onToggle(boolean on)
{
	if (!on)
	{
		fadertext.setAlpha(253);
		fadertext2.setAlpha(0);
		fadertext2.setXmlParam("ghost" , "1");
		CFIncrease.setAlpha(150);
		CFDecrease.setXmlParam("ghost" , "1");
		CFDecrease.setAlpha(150);
		CFIncrease.setXmlParam("ghost" , "1");
		CrossfadeActive.hide();
    if (scriptGroup.isVisible () == 1)	SongTicker.sendAction("showinfo", "Crossfade OFF", 0, 0, 0, 0);
	}
	else
	{
    fadertext.setAlpha(0);
		fadertext2.setAlpha(253);
		fadertext2.setXmlParam("ghost" , "0");
		CFIncrease.setAlpha(253);
		CFDecrease.setAlpha(253);
		CFIncrease.setXmlParam("ghost" , "0");
		CFDecrease.setXmlParam("ghost" , "0");
		CrossfadeActive.show();
    if (scriptGroup.isVisible () == 1)	SongTicker.sendAction("showinfo", "Crossfade ON", 0, 0, 0, 0);
	}
}

Global Boolean cfDown, onDown, autoDown, manual_set;
Crossfade.onLeftButtonDown (int x, int y)
{
	cfDown = 1;
	CrossfadeActive.setXmlParam("y", integerToString(CrossfadeActive_Y+1));
}

Crossfade.onLeftButtonUp (int x, int y)
{
	cfDown = 0;
	CrossfadeActive.setXmlParam("y", integerToString(CrossfadeActive_Y));
}

Crossfade.onleaveArea ()
{
	CrossfadeActive.setXmlParam("y", integerToString(CrossfadeActive_Y));
}

Crossfade.onEnterArea ()
{
	if (cfDown) CrossfadeActive.setXmlParam("y", integerToString(CrossfadeActive_Y+1));
}

eqon.onEnterArea ()
{
	if (onDown) eqonActive.setXmlParam("y", integerToString(eqonActive_Y+1));
}

eqon.onLeftButtonDown (int x, int y)
{
	onDown = 1;
	eqonActive.setXmlParam("y", integerToString(eqonActive_Y+1));
}

eqon.onLeftButtonUp (int x, int y)
{
	onDown = 0;
	eqonActive.setXmlParam("y", integerToString(eqonActive_Y));
}


eqon.onleaveArea ()
{
	eqonActive.setXmlParam("y", integerToString(eqonActive_Y));
}

eqauto.onLeftButtonDown (int x, int y)
{
	autoDown = 1;
	eqautoActive.setXmlParam("y", integerToString(eqautoActive_Y+1));
}

eqauto.onLeftButtonUp (int x, int y)
{
	autoDown = 0;
	eqautoActive.setXmlParam("y", integerToString(eqautoActive_Y));
}

eqauto.onleaveArea ()
{
	eqautoActive.setXmlParam("y", integerToString(eqautoActive_Y));
}

eqauto.onEnterArea ()
{
	if (autoDown) eqautoActive.setXmlParam("y", integerToString(eqautoActive_Y+1));
}


EqButton.onLeftClick()
{
	manual_set = 1;
	for(int i=0; i<10; i++) setEqBand(i, EqButton.setTo);
	manual_set = 0;
}

System.onEqFreqChanged (boolean isoonoff)
{
	if (isoonoff == 1)
	{
		frequencyLabel.setXmlParam("image", "equalizer.labels.iso");
		for(int i=0; i<10; i++) scriptGroup.findObject("eq"+integerToString(i+1)).setXmlParam("tooltip", getToken(ISOBANDS,",",i));
	}
	else
	{
		frequencyLabel.setXmlParam("image", "equalizer.labels.winamp");
		for(int i=0; i<10; i++) scriptGroup.findObject("eq"+integerToString(i+1)).setXmlParam("tooltip", getToken(WINAMPBANDS,",",i));
	}
  	
}

system.onEqBandChanged(int band, int value)
{
	if (manual_set) return;
	String t;
	Float f = value;
	f = f / 10.5;
	WinampConfigGroup eqwcg = WinampConfig.getGroup("{72409F84-BAF1-4448-8211-D84A30A1591A}");
	if (eqwcg.getInt("frequencies") == 1) {
		if (f >= 0) t = "EQ: " + translate(getToken(ISOBANDS,",",band)) + ": +" + floattostring(f, 1) + " "+ translate("dB");
		else t = "EQ: " + translate(getToken(ISOBANDS,",",band)) + ": " + floattostring(f, 1) + " "+ translate("dB");
	}
	else {
		if (f >= 0) t = "EQ: " + translate(getToken(WINAMPBANDS,",",band)) + ": +" + floattostring(f, 1) + " "+ translate("dB");
		else t = "EQ: " + translate(getToken(WINAMPBANDS,",",band)) + ": " + floattostring(f, 1) + " "+ translate("dB");
	}
	
	if (scriptGroup.isVisible () == 1)	SongTicker.sendAction("showinfo", t, 0, 0, 0, 0);
	else { /*do nothing*/ }

}

system.onEqPreampChanged(int value)
{
	slider s = getScriptGroup().findObject("preamp");
	value = s.getPosition(); // Somehow this function returns a range from [-127;125] with hotpos -3, so we take the slider instead
	String t = "EQ: " + translate("Preamp:") + " ";
	Float f = value;
	f = f / 10.5;
	if (f >= 0) t += "+"+floattostring(f, 1) + " "+ translate("dB");
	else t += floattostring(f, 1) + " "+ translate("dB");
	SongTicker.sendAction("showinfo", t, 0, 0, 0, 0);
}


System.onEqChanged (boolean newstatus)
{
	if (!newstatus)
	{
		SongTicker.sendAction("showinfo", "EQUALIZER: OFF", 0, 0, 0, 0);
	}
	else
	{
		SongTicker.sendAction("showinfo", "EQUALIZER: ON", 0, 0, 0, 0);	
	}
}

eqauto.onToggle(boolean onoff)
{
	if (onoff) {
	SongTicker.sendAction("showinfo", "AUTO: ON", 0, 0, 0, 0);
	}
	else {
	SongTicker.sendAction("showinfo", "AUTO: OFF", 0, 0, 0, 0);
	}
}


scriptGroup.onresize(int x, int y, int w, int h)
{
  MousetrapActivation();
}


MousetrapActivation()
{
  String EQb = GetPrivateString("Big Bento Modern Windows 10 edition", "Component", "Media Library");
  
  int EqGroupint = scriptGroup.getHeight();
  int Eqparamint = StringToInteger(EQparam.getText());

  if (EQb == "Equalizer" && EqGroupint < Eqparamint)
  {
    mousetrap.show();
  }
  else { mousetrap.hide(); }
}