/*---------------------------------------------------
-----------------------------------------------------
Filename:	fileinfo.m
Version:	3.3
Type:		maki
Date:		10. Aug. 2007 - 20:42 
Author:		Martin Poehlmann aka Deimos + Victhor mods
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_windowpage.m"
#include "attribs/init_appearance.m"
#include "attribs/init_browser.m"
#include "attribs/init_Playlist.m"
#include "lib/com/songinfo.m"

#define WEBCOVER_SHOUTCAST "cover.aolr"
#define COVERVIDEO "cover.video"
#define NOCOVER "winamp.cover.notfound.84x84"

Function loadFileInfo();
Function AnimateCovers();
Function AnimationSongInfoIN();
Function AnimationSongInfoOUT();
Function SongInfoHide();
Function SongInfoShow();
Function DoNotAnimateCovers();
Class GuiObject LinkObject;
Class GuiObject CycleObject;
Function refreshRating(int rating);
Class Button RatingButton;
Function showBranding();
Class Group Infoline;
Function getTextHeight(InfoLine gn);

Global GuiObject SongTicker, bg_songinfo_filler; //v1.2 bg_songinfo_filler added
Global Group scriptGroup, g_cover, info_component_albumbg_overlay, info_component_albumbg_container, sui_fisong2, parent, g_vis2, InfoComponentInfodisplay;
Global AlbumArtLayer l_albumart, l_albumart2;
Global InfoLine g_rating, g_title, g_album, g_artist, g_year, g_genre, g_track, g_comment, g_bpm, g_sname, g_surl, g_albumartist, g_composer, g_publisher, g_format, g_disc, g_filepath; // v1.2 "g_filepath"
Global InfoLine g_target;
Global Text t_title, t_album, t_artist, t_year, t_genre, t_track, t_comment, t_bpm, t_sname, t_surl, t_composer, t_publisher, t_albumartist, t_format, t_disc, t_filepath, /*t_rating, */widthtxt, heighttxt; // v1.2 "t_filepath"
Global Timer cycler;
Global String stationLink = "";
Global String lv_title, lv_album;
Global Button Hidecoverbtn;

Global List cycle;
Global Boolean cycler_paused, quick_change/*, HAVE_ML = TRUE*/; // v1.1
Global List ratingStars;



#define CENTER_VAR Albumart
Global group info_component_albumbg;
#include "lib/com/centerlayer.m"
#undef CENTER_VAR

#define CENTER_VAR Branding
Global Layer l_branding;
#include "lib/com/centerlayer.m"
#undef CENTER_VAR


Global LinkObject linkArtist, linkAlbum, linkTitle/*, linkGenre, linkcomment, linkPublisher, linkbpm*/, linkSURl, linkSname, linkPath; // v1.2 "linkPath"
Global CycleObject cycleGenre, cyclePublisher, cycleTrack, cycleYear, cycleComposer, cycleAlbumartist, cycleFormat, cycleDisc, cycleComment, cycleBpm, cycleFilePath; // v1.2 "cycleFilePath"

Global RatingButton rate1, rate2, rate3, rate4, rate5, rate0;
Global Layer star1, star2, star3, star4, star5, info_component_album_overlay2, ShadeLeftRounder;

Global Int startwith = 0;
Global Int artRetries = 0;
Global Int maxlines;

Global timer delayLoad;
Global timer CloseCoverBtnTimer; // v1.15


System.onScriptLoaded()
{
	initAttribs_windowpage();
	initAttribs_browser();
  initAttribs_Playlist();
  initAttribs_Appearance();

	//HAVE_ML = stringToInteger(getToken(getParam(), ",", 0)); // v1.1 (disabled)
	maxlines = stringToInteger(getToken(getParam(), ",", 0));

	scriptGroup = getScriptGroup();
  SongTicker = scriptGroup.getParentLayout().findObject("songticker");

	cycler = new Timer;
	cycler.setDelay(4000);

	delayLoad = new Timer;
	delayLoad.setDelay(10);

	CloseCoverBtnTimer = new Timer; // v1.15
	CloseCoverBtnTimer.setDelay(500);
	
	g_rating = scriptGroup.findObject("infodisplay.line.rating");
	g_title = scriptGroup.findObject("infodisplay.line.title");
	g_album = scriptGroup.findObject("infodisplay.line.album");
	g_artist = scriptGroup.findObject("infodisplay.line.artist");
	g_year = scriptGroup.findObject("infodisplay.line.year");
	g_genre = scriptGroup.findObject("infodisplay.line.genre");
	g_track = scriptGroup.findObject("infodisplay.line.track");
	g_publisher = scriptGroup.findObject("infodisplay.line.publisher");
	g_sname = scriptGroup.findObject("infodisplay.line.sname");
	g_surl = scriptGroup.findObject("infodisplay.line.surl");
	g_composer = scriptGroup.findObject("infodisplay.line.composer");
	g_albumartist = scriptGroup.findObject("infodisplay.line.albumartist");
	g_format = scriptGroup.findObject("infodisplay.line.format");
	g_disc = scriptGroup.findObject("infodisplay.line.disc");
	g_comment = scriptGroup.findObject("infodisplay.line.comment");
	g_bpm = scriptGroup.findObject("infodisplay.line.bpm");
	g_filepath = scriptGroup.findObject("infodisplay.line.filepath"); // v1.2
	
	Hidecoverbtn = scriptGroup.findObject("hide.cover.button01");


	t_title = g_title.findObject("text");
	t_album = g_album.findObject("text");
	t_artist = g_artist.findObject("text");
	t_year = g_year.findObject("text");
	t_genre = g_genre.findObject("text");
	t_track = g_track.findObject("text");
	t_Publisher = g_publisher.findObject("text");
	t_sname = g_sname.findObject("text");
	t_surl = g_surl.findObject("text");
	t_albumartist = g_albumartist.findObject("text");
	t_composer = g_composer.findObject("text");
	t_format = g_format.findObject("text");
	t_disc = g_disc.findObject("text");
	t_comment = g_comment.findObject("text");
	t_bpm = g_bpm.findObject("text");
	t_filepath = g_filepath.findObject("text"); // v1.2


	linkArtist = g_artist.findObject("link");
	linkAlbum = g_album.findObject("link");
	linkTitle = g_title.findObject("link");
	linksUrl = g_surl.findObject("link");
	linkSname = g_sname.findObject("link");
	linkPath = g_filepath.findObject("link2"); // v1.2
	cycleGenre = g_genre.findObject("link");
	cyclePublisher = g_publisher.findObject("link");
	cycleTrack = g_track.findObject("link");
	cycleYear = g_year.findObject("link");
	cycleAlbumartist = g_albumartist.findObject("link");
	cycleComposer = g_composer.findObject("link");
	cycleFormat = g_format.findObject("link");
	cycleDisc = g_disc.findObject("link");
	cycleComment = g_comment.findObject("link");
	cycleBpm = g_bpm.findObject("link");
	cycleFilePath = g_filepath.findObject("link"); // v1.2

	cycle = new List;
	ratingStars = new List;
	
	parent = scriptGroup.getParent();
	l_branding = parent.findObject("branding");
	g_cover = parent.findObject("info.component.cover");
	g_vis2 = parent.findObject("info.component.vis");
	info_component_albumbg_container = parent.findObject("info.component.albumbg.container");
	info_component_albumbg_overlay = parent.findObject("info.component.albumbg.overlay");
	bg_songinfo_filler = info_component_albumbg_overlay.findObject("bg.songinfo.filler"); // v1.2 added
	info_component_albumbg = parent.findObject("info.component.albumbg");
	info_component_album_overlay2 = info_component_albumbg.findObject("aa.overlay.shade");
	widthtxt = info_component_albumbg.getObject("width.txt");
	heighttxt = info_component_albumbg.getObject("height.txt");

  sui_fisong2 = parent.getObject("info.component.songinfodisplay");
  InfoComponentInfodisplay = parent.getObject("info.component.infodisplay");

 
	l_albumart = g_cover.findObject("winamp.albumart");
	l_albumart2 = info_component_albumbg.getObject("winamp.albumart");

	_AlbumartInit(info_component_albumbg, parent, 1, 0);
	_BrandingInit(l_branding, parent, 1, 0);
	

	rate1 = g_rating.findObject("rate.1");
	rate2 = g_rating.findObject("rate.2");
	rate3 = g_rating.findObject("rate.3");
	rate4 = g_rating.findObject("rate.4");
	rate5 = g_rating.findObject("rate.5");
	rate0 = g_rating.findObject("rate.0");
	ratingStars.addItem(rate1);
	ratingStars.addItem(rate2);
	ratingStars.addItem(rate3);
	ratingStars.addItem(rate4);
	ratingStars.addItem(rate5);

	star1 = g_rating.findObject("star.1");
	star2 = g_rating.findObject("star.2");
	star3 = g_rating.findObject("star.3");
	star4 = g_rating.findObject("star.4");
	star5 = g_rating.findObject("star.5");

	ShadeLeftRounder = info_component_albumbg_container.findObject("shade.left.rounder"); //v1.2
		
	//t_rating = g_rating.findObject("label"); // v1.1 (disabled)
	//t_rating.onTextChanged (""); // v1.1 (disabled)
}

System.onScriptUnloading ()
{
	cycler.stop();
	delete cycler;

	delayLoad.stop();
	delete delayLoad;

	CloseCoverBtnTimer.stop();
	delete CloseCoverBtnTimer;
}

// Reload fileInfo if track has changed

delayLoad.onTimer()
{
	System.onTitleChange (getPlayItemString());

	delayLoad.stop();
}

System.onTitleChange (String newtitle)
{
	// Get rid of "" calls
	if (newtitle == "" && getplayitemmetadatastring("title") == "" && !delayLoad.isRunning())
	{
		delayLoad.start();
	}


	// Get rid of buffering (txt?) during stream connection & playback
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" || StrLeft(newtitle, 4) == "[ICY") return;
	}
	
	// Show branding for DJ Mike
	if (removePath(getPlayItemString()) == "demo.mp3")
	{
		if (getPlayitemmetadatastring("artist") == "DJ Mike Llama" && getplayitemmetadatastring("title") == "Llama Whippin' Intro")
		{
			showBranding();
      ShadeLeftRounder.setAlpha(0); //v1.2
      AnimationSongInfoOUT(); //v1.2
			return;
		}
	}
				
	loadFileInfo();
  AnimateCovers();
	refreshRating(System.getCurrentTrackRating());

  //if (isVideo() == 1) { bg_songinfo_filler.setxmlparam("y", "20"); sui_fisong2.setxmlparam("y", "4"); sui_fisong2.setAlpha(253); } //v1.2
    

  
  if (getStatus() != STATUS_STOPPED && l_branding.isVisible() == 0) { SongInfoShow(); } //v1.2 new method to show the bg
  else { SongInfoHide(); }

  if (rounded_attrib.getData() == "1" && ic_cover_fileinfo.getData() == "1" && ShadeLeftRounder.getAlpha() == 0 && songinfo_isStream == 0)
  {
    ShadeLeftRounder.setAlpha(255);
  }
}


// Reload fileInfo if textline attribs have changed
InfoLineAttribute.onDataChanged ()
{
	if (l_branding.isVisible()) return;
	loadFileInfo ();
  //AnimateCovers(); //v1.2 disabled
}


//----------------------------------------------------------------------------------------------------------------
// Our main machine.
//----------------------------------------------------------------------------------------------------------------

loadFileInfo ()
{
	songinfo_reload(); // refresh vars
  
	// cancel g_target
	if (g_target) g_target.cancelTarget();
	if (g_target) g_target.setAlpha(233); // v1.2
	g_target = NULL;


  //v1.2 vic method to detect video. Not ideal, but is the most effective to catch most video formats
  String getpath = songinfo_location; //I get the whole file path with this function (from songinfo.m)
  String getextension = strright(getpath, 3); //then I extract the last 3 characters
  int isvid = (getextension == "mp4" || getextension == "mkv" || getextension == "avi" || getextension == "mov" || getextension == "flv" || getextension == "ebm" || getextension == "ogv" || getextension == "m4p" || getextension == "m4v" || getextension == "3gp"); //set it to a simple yes (1) or no (0) output
  //System.messageBox(removepath, "FORMAT", 1, ""); //check
  
  if (isvid == 1)
  {
    l_albumart.setXMLParam("image", COVERVIDEO);
    l_albumart.setXMLParam("notfoundimage", COVERVIDEO);
  }
  else if (songinfo_isStream == 0) l_albumart.setXMLParam("notfoundimage", NOCOVER); // old Vic mod: more simple?

		// setCover either from a supplied url or from in-stream artwork or default to a generic image
		if (songinfo_streamAlbumArt != "")
		{
			l_albumart.setXMLParam("image", songinfo_streamAlbumArt);
			l_albumart.setXMLParam("notfoundImage", WEBCOVER_SHOUTCAST);
		}

		if(songinfo_streamType == SONGINFO_STREAMTYPE_SHOUTCAST || songinfo_streamType == SONGINFO_STREAMTYPE_SHOUTCAST2)
		{
			if(songinfo_streamType == SONGINFO_STREAMTYPE_SHOUTCAST2)
			{
				if(l_albumart.isInvalid() && artRetries < 3)
				{
					if(!artRetries)
					{
						l_albumart.setXMLParam("notfoundImage", WEBCOVER_SHOUTCAST);
					}
					artRetries += 1;
					l_albumart.refresh();
				}
			}
			else
			{
				l_albumart.setXMLParam("notfoundImage", WEBCOVER_SHOUTCAST);
			}
		}
		       
	// hide all lines and cycle buttons
  g_rating.hide();
	g_title.hide();
	g_album.hide();
	g_artist.hide();
	g_year.hide();
	g_genre.hide();
	g_track.hide();
	g_publisher.hide();
	g_surl.hide();
	g_sname.hide();
	g_albumartist.hide();
	g_composer.hide();
	g_format.hide();
	g_disc.hide();
	g_comment.hide();
  g_bpm.hide();
  g_filepath.hide(); // v1.2
	l_branding.hide();
	//g_cover.setAlpha(255); // v1.2  disabled (redundant)
	
	cycleAlbumartist.hide();
	cycleTrack.hide();
	cycleGenre.hide();
	cyclePublisher.hide();
	cycleFormat.hide();
	cycleYear.hide();
	cycleDisc.hide();
	cycleComment.hide();
	cycleComposer.hide();
	cycleBpm.hide();
	cycleFilePath.hide(); // v1.2
	
	cycler.stop();
	cycler_paused = 0;
	stationLink = "";
	
	g_cover.setXmlParam("ghost", "0");	

	artRetries = 0;

	Boolean _cycle = (infocomp_cycle.getData() == "1");
	Boolean _rating = (infocomp_show_rating.getData() == "1");

	// empty cycle list
	cycle.removeAll();

	int pos = 1;

	if (maxlines > 4)
	{
		pos += 2;
	}

	int n = 0;

	if (songinfo_isStream)
	{
    AnimationSongInfoIN(); //v1.2 added

		if (songinfo_title != "")
		{
			// Title
			if (n > 0) pos += getTextHeight(g_title);
			t_title.setText(songinfo_title);
			g_title.setXmlParam("y", integerToString(pos - 1)); // 1.2 (added "-1")
			g_title.show();
			n++;
			cycle.addItem(g_title);

			// Artist 
			if (songinfo_artist != "")
			{
				if (n > 0) pos += getTextHeight(g_artist);
				t_artist.setText(songinfo_artist);
				g_artist.setXmlParam("y", integerToString(pos));
				g_artist.show();
				n++;
				cycle.addItem(g_artist);
			}
		}
		else
		{
			if (songinfo_streamtitle != "")
			{
				int v = strsearch(songinfo_streamtitle, " - ");
				if (v > 0) {
					string s1 = strleft (songinfo_streamtitle, v);
					string s2 = strright (songinfo_streamtitle, strlen(songinfo_streamtitle) - 3 - v);

					// Title
					if (n > 0) pos += getTextHeight(g_title);
					t_title.setText(s2);
					g_title.setXmlParam("y", integerToString(pos - 1)); // 1.2 (added "-1")
					g_title.show();
					n++;
					cycle.addItem(g_title);

					// Artist 
					if (n > 0) pos += getTextHeight(g_artist);
					if (songinfo_artist == "") t_artist.setText(s1);
					else t_artist.setText(songinfo_artist);
					g_artist.setXmlParam("y", integerToString(pos));
					g_artist.show();
					n++;
					cycle.addItem(g_artist);
				}
				else
				{
					// Title
					if (n > 0) pos += getTextHeight(g_title);
					t_title.setText(songinfo_streamtitle);
					g_title.setXmlParam("y", integerToString(pos - 1)); // 1.2 (added "-1")
					g_title.show();
					n++;
					cycle.addItem(g_title);

					// Artist 
					if (songinfo_artist != "") {
						if (n > 0) pos += getTextHeight(g_artist);
						t_artist.setText(songinfo_artist);
						g_artist.setXmlParam("y", integerToString(pos));
						g_artist.show();
						n++;
						cycle.addItem(g_artist);
					}
				}
			}
		}

		// Stream Album
		if (songinfo_album != "")
		{
			if (n > 0) pos += getTextHeight(g_album);
			t_album.setText(songinfo_album);
			g_album.setXmlParam("y", integerToString(pos));
			g_album.show();
			n++;
			cycle.addItem(g_album);
		}

		// Stream Genre
		String s = getPlayItemMetaDataString("streamgenre");
		if (s != "")
		{
			t_genre.setText(s);
			cycleGenre.setXmlParam("w", "0");
			cycle.addItem(g_genre);
			if (n > 0) pos += getTextHeight(g_genre);
			g_genre.setXmlParam("y", integerToString(pos));
			g_genre.show();
			n++;
		}

		// Set Stream Name
		if (songinfo_streamName != "")
		{
			if (n > 0) pos += getTextHeight(g_sname);
			t_sname.setText(songinfo_streamName);
			g_sname.setXmlParam("y", integerToString(pos));
			g_sname.show();
			n++;
			cycle.addItem(g_sname);
		}

		// Stream URL (only visible if we have less than 4 lines till now)
		if (songinfo_streamURL != "")
		{
			if (n > 0) pos += getTextHeight(g_surl);
			t_surl.setText(songinfo_streamURL);
			g_surl.setXmlParam("y", integerToString(pos));
			g_surl.show();
			n++;
			cycle.addItem(g_surl);
		}

		}

	// ---------- Local Info ----------
	else
	{
    l_albumart.show();

		string s = songinfo_title;
		if (s == "") songinfo_displayTitle;
		if (s != "")
		{
			t_title.setText(s);
			g_title.setXmlParam("y", integerToString(pos - 1)); // 1.2 (added "-1")
			g_title.show();
			n++;
			cycle.addItem(g_title);
		}

		if (songinfo_artist != "")
		{
			if (n > 0) pos += getTextHeight(g_artist);
			t_artist.setText(songinfo_artist);
			g_artist.setXmlParam("y", integerToString(pos));
			g_artist.show();
			n++;
			cycle.addItem(g_artist);
		}

		if (songinfo_album != "")
		{
			if (n > 0) pos += getTextHeight(g_album);
			t_album.setText(songinfo_album);
			g_album.setXmlParam("y", integerToString(pos));
			g_album.show();
			n++;
			cycle.addItem(g_album);
		}

		if (infocomp_show_track.getData() == "1")
		{
			s = getPlayitemMetaDataString("track");
			if (s != "" && s != "-1")
			{
				// if tracknumber is like 1/9 we display 1 of 9
				if (strsearch(s, "/") != -1)
				{
					s = getToken(s, "/", 0) + translate(" of ") + getToken(s, "/", 1);
				}
				if (n > 0) pos += getTextHeight(g_track);
				t_track.setText(s);
				g_track.setXmlParam("y", integerToString(pos));
				g_track.show();
				n++;
				cycle.addItem(g_track);
			}
		}

		if (infocomp_show_year.getData() == "1")
		{
			s = getPlayItemMetaDataString("year");
			if (s != "")
			{
				t_year.setText(s);
				cycle.addItem(g_year);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_year);
					g_year.setXmlParam("y", integerToString(pos));
					g_year.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					cycleYear.show();
					g_year.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "year")
					{
						if (g_Track.getGuiY() == pos) g_track.hide();
						startwith = cycle.getNumitems() - 1;
						g_year.show();
					}
				}
			}
		}

		if (infocomp_show_genre.getData() == "1")
		{
			s = getPlayItemMetaDataString("genre");
			if (s != "")
			{
				t_genre.setText(s);
				cycle.addItem(g_genre);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_genre);
					g_genre.setXmlParam("y", integerToString(pos));
					g_genre.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					cycleGenre.show();
					g_genre.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "genre")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						startwith = cycle.getNumitems() - 1;
						g_genre.show();
					}
				}
			}
		}

		if (infocomp_show_disc.getData() == "1")
		{
			s = getPlayItemMetaDataString("disc");
			if (s != "")
			{
				t_disc.setText(s);
				cycle.addItem(g_disc);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_disc);
					g_disc.setXmlParam("y", integerToString(pos));
					g_disc.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					cycleDisc.show();
					g_disc.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "disc")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						startwith = cycle.getNumitems() - 1;
						g_disc.show();
					}
				}
			}
		}

		if (infocomp_show_albumartist.getData() == "1")
		{
			s = getPlayItemMetaDataString("albumartist");
			if (s != "")
			{
				t_albumartist.setText(s);
				cycle.addItem(g_albumartist);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_albumartist);
					g_albumartist.setXmlParam("y", integerToString(pos));
					g_albumartist.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					cycleAlbumartist.show();
					g_albumartist.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "albumartist")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						startwith = cycle.getNumitems() - 1;
						g_albumartist.show();
					}
				}
			}
		}

		if (infocomp_show_composer.getData() == "1")
		{
			s = getPlayItemMetaDataString("composer");
			if (s != "")
			{
				t_composer.setText(s);
				cycle.addItem(g_composer);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_composer);
					g_composer.setXmlParam("y", integerToString(pos));
					g_composer.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					cycleComposer.show();
					g_composer.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "composer")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						startwith = cycle.getNumitems() - 1;
						g_composer.show();	
					}
				}
			}
		}

		if (infocomp_show_publisher.getData() == "1")
		{
			s = getPlayItemMetaDataString("publisher");
			if (s != "")
			{
				t_publisher.setText(s);
				cycle.addItem(g_publisher);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_publisher);
					g_publisher.setXmlParam("y", integerToString(pos));
					g_publisher.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					if (g_composer.getGuiY() == pos) cycleComposer.show();
					cyclePublisher.show();
					g_publisher.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "publisher")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						if (g_composer.getGuiY() == pos) g_composer.hide();
						startwith = cycle.getNumitems() - 1;
						g_publisher.show();	
					}
				}
			}
		}

		if (infocomp_show_format.getData() == "1")
		{
			s = system.getDecoderName(system.getPlayItemString());
			if (s != "")
			{
				t_format.setText(s);
				cycle.addItem(g_format);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_format);
					g_format.setXmlParam("y", integerToString(pos));
					g_format.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					if (g_composer.getGuiY() == pos) cycleComposer.show();
					if (g_publisher.getGuiY() == pos) cyclePublisher.show();
					cycleFormat.show();
					g_format.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "format")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						if (g_composer.getGuiY() == pos) g_composer.hide();
						if (g_publisher.getGuiY() == pos) g_publisher.hide();
						startwith = cycle.getNumitems() - 1;
						g_format.show();
					}
				}
			}
		}

	if (infocomp_show_comment.getData() == "1")
		{
			s = getPlayItemMetaDataString("comment");
			if (s != "")
			{
				t_comment.setText(s);
				cycle.addItem(g_comment);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_comment);
					g_comment.setXmlParam("y", integerToString(pos));
					g_comment.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					if (g_composer.getGuiY() == pos) cycleComposer.show();
					if (g_publisher.getGuiY() == pos) cyclePublisher.show();
					if (g_format.getGuiY() == pos) cycleFormat.show();
					cycleComment.show();
					g_comment.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "comment")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						if (g_composer.getGuiY() == pos) g_composer.hide();
						if (g_publisher.getGuiY() == pos) g_publisher.hide();
						if (g_format.getGuiY() == pos) g_format.hide();
						startwith = cycle.getNumitems() - 1;
						g_comment.show();	
					}
				}
			}
		}

	if (infocomp_show_bpm.getData() == "1")
		{
			s = getPlayItemMetaDataString("bpm");
			if (s != "")
			{
				t_bpm.setText(s);
				cycle.addItem(g_bpm);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_bpm);
					g_bpm.setXmlParam("y", integerToString(pos));
					g_bpm.show();
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					if (g_composer.getGuiY() == pos) cycleComposer.show();
					if (g_publisher.getGuiY() == pos) cyclePublisher.show();
					if (g_format.getGuiY() == pos) cycleFormat.show();
					if (g_comment.getGuiY() == pos) cycleComment.show();
					cycleBpm.show();
					g_bpm.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "bpm")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						if (g_composer.getGuiY() == pos) g_composer.hide();
						if (g_publisher.getGuiY() == pos) g_publisher.hide();
						if (g_format.getGuiY() == pos) g_format.hide();
						if (g_comment.getGuiY() == pos) g_comment.hide();
						startwith = cycle.getNumitems() - 1;
						g_bpm.show();
					}
				}
			}
		}

if (infocomp_show_filepath.getData() == "1") // v1.2 added
		{

    s = getPath(getPlayItemString());
		if(System.strsearch(s, "file://")==0) s = System.strright(s, System.strlen(s)-7);
		
			if (s != "")
			{
				t_filepath.setText(s);
				cycle.addItem(g_filepath);
				if ((!_rating && n < maxlines) || (_rating && n < maxlines-1))
				{
					if (n > 0) pos += getTextHeight(g_filepath);
					g_filepath.setXmlParam("y", integerToString(pos));
					g_filepath.show();
					linkPath.show(); // Items are not cycling so I'm enabling the link
					n++;
				}
				else
				{
					if (g_Track.getGuiY() == pos) cycleTrack.show();
					if (g_year.getGuiY() == pos) cycleYear.show();
					if (g_genre.getGuiY() == pos) cycleGenre.show();
					if (g_disc.getGuiY() == pos) cycleDisc.show();
					if (g_albumartist.getGuiY() == pos) cycleAlbumartist.show();
					if (g_composer.getGuiY() == pos) cycleComposer.show();
					if (g_publisher.getGuiY() == pos) cyclePublisher.show();
					if (g_format.getGuiY() == pos) cycleFormat.show();
					if (g_comment.getGuiY() == pos) cycleComment.show();
					if (g_comment.getGuiY() == pos) cycleBpm.show();
					cycleFilePath.show(); // Cycler begins (right click on it will open File Path)
					linkPath.hide(); // Since we want to cycle the items on left click I'm disabling the link
					g_filepath.setXmlParam("y", integerToString(pos));
					if (_cycle) cycler.start();
					else if (getPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "") == "filepath")
					{
						if (g_Track.getGuiY() == pos) g_Track.hide();
						if (g_year.getGuiY() == pos) g_year.hide();
						if (g_genre.getGuiY() == pos) g_genre.hide();
						if (g_disc.getGuiY() == pos) g_disc.hide();
						if (g_albumartist.getGuiY() == pos) g_albumartist.hide();
						if (g_composer.getGuiY() == pos) g_composer.hide();
						if (g_publisher.getGuiY() == pos) g_publisher.hide();
						if (g_format.getGuiY() == pos) g_format.hide();
						if (g_comment.getGuiY() == pos) g_comment.hide();
						if (g_bpm.getGuiY() == pos) g_bpm.hide();
						startwith = cycle.getNumitems() - 1;
						g_filepath.show();	
            linkPath.hide(); // Items are cycling so I'm disabling the link
					}
				}
			}
		}


		if (_rating && n > 1) // v1.1
		{
			if (n > 0) pos += getTextHeight(g_rating)-3; // v1.1
					g_rating.setXmlParam("y", integerToString(pos));
					g_rating.show();
		}
		
		// check the media library status as well as input plug-in support
		// to help determine if we show the rating control or not for here
		/*if (_rating)
		{
			if (!HAVE_ML)
			{
				s = getPlayitemMetaDataString("rateable");
				if (s != "" && s == "1")
				{
					if (n > 0) pos += getTextHeight(g_rating);
					g_rating.setXmlParam("y", integerToString(pos));
					g_rating.show();
				}
			} else {
				if (n > 0) pos += getTextHeight(g_rating);
				g_rating.setXmlParam("y", integerToString(pos));
				g_rating.show();
			}
		}*/ // v1.1 disabled
	}

	/*if (n==0) //v1.2 disabled to try to get back the info when playing video
	{
		showBranding();
	}*/

	if (n==0 && !isvideo() && getIdealVideoWidth() == -1) // v1.2 added "!isvideo()" and "getIdealVideoWidth() == -1"
	{
		showBranding();
	}
	
}

//----------------------------------------------------------------------------------------------------------------
// Item Cycler: Only active if we have more items to display as lines
// if you click on a cycle line, this group is saved as g_target
//----------------------------------------------------------------------------------------------------------------

cycler.onTimer ()
{
	// Important: stop the cycler if branding is visible
	if (l_branding.isvisible()) cycler.stop();
	if (infocomp_cycle.getData() == "0" && !quick_change) { cycler.stop(); return; }

	// g_target is defined --> we save the currently shown line as g_target
	if (!g_target)
	{
		// check if rating is visible...
		if (infocomp_show_rating.getData() == "1")
		{
			// if auto-cycler is disabled, and not the default line is shown, the line number is stored in startwith.
			if (startwith)
			{
				// resort the cycle list and set startwith to 0
				for ( int i = maxlines-2; i < startwith; i++ )
				{
					g_target = cycle.enumItem(maxlines-2);
					cycle.removeItem(maxlines-2);
					cycle.addItem(g_target);
				}
				startwith = 0;
			}

			// save g_target and remove from cycle
			g_target = cycle.enumItem(maxlines-2);
			cycle.removeItem(maxlines-2);
		}
		else
		{
			if (startwith)
			{
				for ( int i = maxlines-1; i < startwith; i++ )
				{
					g_target = cycle.enumItem(maxlines-1);
					cycle.removeItem(maxlines-1);
					cycle.addItem(g_target);
				}
				startwith = 0;
			}
			g_target = cycle.enumItem(maxlines-1);
			cycle.removeItem(maxlines-1);
		}
		// put g_target at the end of cycle
		cycle.addItem(g_target);
	}

	// otherwise g_target is the last item of cycle
	else g_target = cycle.enumItem(cycle.getNumItems()-1);

	// TODO verify fix from pieter!
	if (g_target == null)
		return;


	// fade out g_target
	g_target.setTargetA(0);
	g_target.setTargetY(g_target.getGuiY());
	if (!quick_change) g_target.setTargetSpeed(0.25); // fade or quick show/hide
	else g_target.setTargetSpeed(0);
	g_target.gotoTarget();
}

g_target.onTargetReached ()
{
	if (g_target.getAlpha() == 0)
	{
		// setback g_target to default values
		g_target.hide();
		g_target.setAlpha(233);
		// detect if rating stars are visible and store the line tb shown in g_target
		if (infocomp_show_rating.getData() == "1")
		{
			g_target = cycle.enumItem(maxlines-2);
			cycle.removeItem(maxlines-2);
		}
		else
		{
			g_target = cycle.enumItem(maxlines-1);
			cycle.removeItem(maxlines-1);
		}
		// better set g-target alpha to 0 and, show this line and fade in
		g_target.setAlpha(0);
		g_target.show();
		g_target.setTargetA(253);
		g_target.setTargetY(getGuiY());
		if (!quick_change) g_target.setTargetSpeed(0.25); // fade or quick show/hide
		else 
		{
			g_target.setTargetSpeed(0);
			string v = getToken(g_target.getID(), ".", 2);
			setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", v); // save current line
		}
		g_target.gotoTarget();
		// add g_target to end of cycle
		cycle.addItem(g_target);
		if (infocomp_cycle.getData() == "1" && !cycler.isRunning()) cycler.start(); // check if we should start cycler
		quick_change = 0;
	}
}

// Automatic cycling through items on/off
infocomp_cycle.onDataChanged ()
{
	if (l_branding.isVisible()) return;
	if (getData() == "1")
	{
		if (cycler_paused) cycler.start();
		else loadFileInfo();
		cycler_paused = 0;
	}
	else
	{
		if (cycler.isRunning()) cycler_paused = 1;
		cycler.stop();
		if (g_track.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "track");
		else if (g_year.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "year");
		else if (g_genre.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "genre");
		else if (g_disc.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "disc");		
    else if (g_albumartist.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "albumartist");
		else if (g_composer.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "composer");
		else if (g_publisher.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "publisher");
		else if (g_format.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "format");
		else if (g_comment.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "comment");
		else if (g_bpm.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "bpm");
		else if (g_filepath.isVisible()) setPrivateString ("Big Bento Modern Windows 10 edition", "FileInfo_usersel", "filepath"); //v1.2
	}
}

// Visual Stuff

CycleObject.onEnterArea () //v1.2 re-added and modded
{
	CycleObject.getParent().findObject("text").setAlpha(253);
}

CycleObject.onLeaveArea () //v1.2 re-added and modded
{
	CycleObject.getParent().findObject("text").setAlpha(210);
}

CycleObject.onLeftButtonUp (int x, int y)
{
	if (quick_change) return;
	quick_change = 1;

	cycler.onTimer ();
}


//----------------------------------------------------------------------------------------------------------------
// If user clicks on a link item (artist, album, title), let's start a web search
// Therefore we will send an action to the group "sui.content". This action is either "browser_navigate" or 
// "browser_search". This action is then proccessed by suicore.maki (showing browser) and then (again) delivered
// to browser.maki (from suicore.maki) // Heavily modded by Victhor.
//----------------------------------------------------------------------------------------------------------------

LinkObject.onEnterArea () //v1.2 re-added and modded
{
	LinkObject.getParent().findObject("text").setAlpha(253);
}

LinkObject.onLeaveArea () //v1.2 re-added and modded
{
	LinkObject.getParent().findObject("text").setAlpha(210);
}

LinkObject.onLeftButtonUp (int x, int y)
{
  if (use_browser_attrib.getdata() == "1")
  {
    if (LinkObject == linkSurl || LinkObject == linkSname)
      {
      String nav = t_surl.getText();
      System.navigateUrl(nav); // vic mod
			return;
			}
			      
    string s;
    {
      if (LinkObject == linkArtist) s = t_artist.getText();
      if (LinkObject == linkAlbum) s = t_artist.getText() + " " + t_album.getText();
      if (LinkObject == linkTitle) s = t_artist.getText() + " " + t_title.getText();

      if (s == "") return;
    
      if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(s));
      else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(s));
      return;
    }

    if (stationLink != "" && (LinkObject == linkSname || LinkObject == linkSurl))
    {
      System.navigateUrl(stationLink);
      return;
    }

    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    
    String icid = "fileinfotitle";
    if (LinkObject == linkArtist) icid = "fileinfoartist";
    if (LinkObject == linkAlbum) icid = "fileinfoalbum";

    String artist = t_artist.getText();
    if (artist == "") return;
    if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q=" + artist);
    else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q=" + artist);
		}
  
  if (use_reader_attrib.getdata() == "1")
  {    
    if (LinkObject == linkSurl || LinkObject == linkSname)
    {
      String nav = t_surl.getText();
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      if (nav != "")
      {
        sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
        return;
      }
    }   
    
    string s;
    {
      if (LinkObject == linkArtist) s = t_artist.getText();
      if (LinkObject == linkAlbum) s = t_artist.getText() + " " + t_album.getText();
      if (LinkObject == linkTitle) s = t_artist.getText() + " " + t_title.getText();
  
      if (s == "") return;
  
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      sui.sendAction ("browser_search", s, 0, 0, 0, 0);
    
      return;
    }

    if (stationLink != "" && ( LinkObject == linkSname || LinkObject == linkSurl))
    {
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      sui.sendAction ("browser_navigate", stationLink, 0, 0, 0, 0);
    
      return;
    }

    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    
    String icid = "fileinfotitle";
    if (LinkObject == linkArtist) icid = "fileinfoartist";
    if (LinkObject == linkAlbum) icid = "fileinfoalbum";
  
    String artist = t_artist.getText();
    if (artist == "") return;
    sui.sendAction ("browser_search", artist, 0, 0, 0, 0);
	}
}


linkPath.onLeftButtonUp (int x, int y) // v1.2
{
  String nav = getPath(getPlayItemString());
  
  if (use_browser_attrib.getdata() == "1")
  {
    System.navigateUrl(nav);
    return;
  }
  
  else if (use_reader_attrib.getdata() == "1")
  {
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    if (nav != "")
    {
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      return;
    }
  }
}

linkPath.onRightButtonUp (int x, int y) // v1.2
{
  String nav = getPath(getPlayItemString());
  
  if (use_browser_attrib.getdata() == "1")
  {
    System.navigateUrl(nav);
    complete;
  }
  
  else if (use_reader_attrib.getdata() == "1")
  {
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    if (nav != "")
    {
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      complete;
    }
  }
  
}

cycleFilePath.onRightButtonUp (int x, int y) // v1.2
{
  
  String nav = getPath(getPlayItemString());
  
  if (use_browser_attrib.getdata() == "1")
  {
    System.navigateUrl(nav);
    complete;
  }
  
  else if (use_reader_attrib.getdata() == "1")
  {
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    if (nav != "")
    {
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      complete;
    }
  }
}

l_albumart.onRightButtonDown (int x, int y)
{
	popupmenu p = new popupmenu;

  if (songinfo_isStream == 0) p.addCommand("Refresh Album Art", 1, 0, 0);
	String path = getPath(getPlayItemMetaDataString("filename"));
	if(path != "")
	{
		p.addCommand("Open Folder", 2, 0, 0);
	}
  if (songinfo_isStream == 0 && search_google_attrib.getdata() == "1") p.addCommand("Search Album art (Google)", 3, 0, 0);
  if (songinfo_isStream == 0 && search_bing_attrib.getdata() == "1") p.addCommand("Search Album art (Bing)", 5, 0, 0);
  if (search_google_attrib.getdata() == "1") p.addCommand("Search Lyrics (Google)", 4, 0, 0);
  if (search_bing_attrib.getdata() == "1") p.addCommand("Search Lyrics (Bing)", 6, 0, 0);
  if (songinfo_isStream == 1) p.addCommand("Open Station / Stream Homepage", 7, 0, 0);

	int result = p.popatmouse();
	delete p;

	if (result == 1)
	{
		l_albumart.refresh();
	}
	else if (result == 2)
	{
    if (use_browser_attrib.getdata() == "1")
    {
      String path = getPath(getPlayItemMetaDataString("filename"));
      if(path != "")
      {
        System.navigateUrl(path);
      }
      else
      {
        String url = getPlayItemMetaDataString("streamurl");
        if(url != "")
        {
          System.navigateUrl(url);
        }
      }
    
    }
    if (use_reader_attrib.getdata() == "1")
    {
      group sui = scriptGroup.getParentLayout().findObject("sui.content");
        
      String path = getPath(getPlayItemMetaDataString("filename"));
      if(path != "")
      {
      sui.sendAction ("browser_navigate", path, 0, 0, 0, 0);
      }
      else
      {
        String url = getPlayItemMetaDataString("streamurl");
        if(url != "")
        {
          sui.sendAction ("browser_navigate", url, 0, 0, 0, 0);
        }
      }  
  
    }
	}
	
		else if (result == 3) // Google
    {	
    String sartist = t_artist.gettext();
    String salbum = t_album.gettext();
  
		  if (use_browser_attrib.getdata() == "1")
      {
        System.navigateUrl("www.google.com/search?tbm=isch&q="+ urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
        group sui = getContainer("main").getLayout("normal").findObject("sui.content");
        sui.sendAction ("browser_navigate", ("www.google.com/search?tbm=isch&q=" + urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover"), 0, 0, 0, 0);
      }
      
	}
	
			else if (result == 4) // Google
      {
      String sartist = t_artist.gettext();
      String stitle = t_title.gettext();
          
        if (use_browser_attrib.getdata() == "1")
        {
          System.navigateUrl("www.google.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
        }

        if (use_reader_attrib.getdata() == "1")
        {
          String lyricsearch = ("www.google.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
          
          group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
          sui.sendAction ("browser_navigate", lyricsearch, 0, 0, 0, 0);
        }
      }
      
      
      		else if (result == 5) // Bing
    {
    String sartist = t_artist.gettext();
    String salbum = t_album.gettext();
  
		  if (use_browser_attrib.getdata() == "1")
      {
        System.navigateUrl("www.bing.com/?scope=images&FORM=Z9LH1&q="+ urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
        String sartist = t_artist.gettext();
        String salbum = t_album.gettext();
          
        String coversearch = ("www.bing.com/?scope=images&FORM=Z9LH1&q=" + urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");

        group sui = getContainer("main").getLayout("normal").findObject("sui.content");
        sui.sendAction ("browser_navigate", coversearch, 0, 0, 0, 0);
      }
      
	}
	
				else if (result == 6) // Bing
      {
      String sartist = t_artist.gettext();
      String stitle = t_title.gettext();
          
        if (use_browser_attrib.getdata() == "1")
        {
          System.navigateUrl("www.bing.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
        }

        if (use_reader_attrib.getdata() == "1")
        {
          String lyricsearch = ("www.bing.com/search?q="+ urlEncode(sartist) + " " + urlEncode(stitle) + " " + "lyrics");
          
          getContainer("main").switchToLayout("normal");
          group sui = getContainer("main").getLayout("normal").findObject("sui.content");
          
          sui.sendAction ("browser_navigate", lyricsearch, 0, 0, 0, 0);
        }
      }

    else if (result == 7) // Station URL
    {
	
      if (use_browser_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      System.navigateUrl(nav);
      }
      if (use_reader_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      }
    }
	
}


l_albumart.onLeftButtonDblClk (int x, int y)
{
  songinfo_reload();
	  
  String isstreamv = getPlayItemMetaDataString("streamtype");
  
  if (songinfo_isStream == 0)
  {
    System.navigateUrl(getPath(getPlayItemMetaDataString("filename")));
  }
  else if (isstreamv != "")
  {
      if (use_browser_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      System.navigateUrl(nav);
      }
      
      if (use_reader_attrib.getdata() == "1")
      {
      String nav = getPlayItemMetaDataString("streamurl");
      
      group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      sui.sendAction ("browser_navigate", nav, 0, 0, 0, 0);
      }  
  }
}


AnimateCovers()
{
  l_albumart.setAlpha(253);
    
  /*if (ic_vis_fileinfo.getdata() == "0")
  {
    g_cover.setXmlParam("x", "83");
    g_cover.setXmlParam("w", "1");
    g_cover.setTargetX(3);
    g_cover.setTargetW(189);
    g_cover.setTargetA(253);
  }*/
  
  /*else if (ic_vis_fileinfo.getdata() == "1")
  {
    g_cover.setXmlParam("x", "269");
    g_cover.setXmlParam("w", "1");
    g_cover.setTargetX(192);
    g_cover.setTargetW(189);
    g_cover.setTargetA(253);    
  }*/  //v1.2 disabled
  
    /*else */if (ic_vis_fileinfo.getdata() == "1" && ic_cover_fileinfo.getdata() == "1") //v1.2
  {
    g_cover.setXmlParam("x", "266");
    g_cover.setXmlParam("w", "1");
    g_cover.setTargetX(195);
    g_cover.setTargetW(186);
    g_cover.setTargetA(253);
  }
  
   else if (ic_vis_fileinfo.getdata() == "0" && ic_cover_fileinfo.getdata() == "1") //v1.2
  {
    g_cover.setXmlParam("x", "80");
    g_cover.setXmlParam("w", "1");
    g_cover.setTargetX(6);
    g_cover.setTargetW(186);
    g_cover.setTargetA(253);
  }
    g_cover.setTargetSpeed(0.7);
    g_cover.gotoTarget();
}


DoNotAnimateCovers()
{
    if (l_branding.isVisible() == 0)
    {
      /*if (ic_vis_fileinfo.getdata() == "0")
      {
        g_cover.setTargetX(3);
        g_cover.setTargetA(253);
        g_cover.setTargetW(186);
      }*/
      
      /*else if (ic_vis_fileinfo.getdata() == "1")
      {
        g_cover.setTargetX(192);
        g_cover.setTargetW(186);
        g_cover.setTargetA(253);
      }*/
      /*else if (ic_vis_fileinfo.getdata() == "1" && ic_cover_fileinfo.getdata() == "1")
      {
        g_cover.setxmlparam("x", "192");
        g_cover.setxmlparam("w", "189");
        g_cover.setxmlparam("alpha", "253");
        /*g_cover.setTargetX(192);
        g_cover.setTargetW(189);
        g_cover.setTargetA(253);
      }*/  //v1.2 disabled
    
      if (ic_vis_fileinfo.getdata() == "0" && ic_cover_fileinfo.getdata() == "1") //v1.2
      {
        g_cover.setxmlparam("x", "6");
        g_cover.setxmlparam("w", "186");
        g_cover.setxmlparam("alpha", "253");
        /*g_cover.setTargetX(3);
        g_cover.setTargetW(189);
        g_cover.setTargetA(253);*/ //v1.2disabled
      }
      g_cover.setTargetSpeed(0.1);
      g_cover.gotoTarget();
    }
        
    else if (l_branding.isVisible() == 1)
    {
      g_cover.hide();
    }
}


//----------------------------------------------------------------------------------------------------------------
// Rating System
//----------------------------------------------------------------------------------------------------------------

System.onCurrentTrackRated (int rating)
{
  DoNotAnimateCovers(); // Vic note: Ignored, IDK why..
	refreshRating(rating);
}

RatingButton.onleftClick ()
{
	int rating = stringToInteger(getToken(getId(), ".", 1));
	refreshRating(rating);
	setCurrentTrackRating(rating);
	for ( int i = 1; i <= rating; i++ )
	{
		guiobject o = ratingStars.enumItem(i-1);
		o.setAlpha(253);
	}
}


rate1.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + "1", 0, 0, 0, 0);
}

rate2.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + "2", 0, 0, 0, 0);
}

rate3.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + "3", 0, 0, 0, 0);
}

rate4.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + "4", 0, 0, 0, 0);
}

rate5.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + "5", 0, 0, 0, 0);
}

rate0.onleftClick ()
{
  SongTicker.sendAction("showinfo", translate("Song rating") + ": " + translate("None"), 0, 0, 0, 0);
}

RatingButton.onEnterArea () // Vic note: OnEnterArea only works on buttons!!
{
	//RatingButton.getParent().findObject("label").setAlpha(0); // v1.1 (disabled)

	int pos = stringToInteger(getToken(getId(), ".", 1));
	int rating = System.getCurrentTrackRating();

	star1.hide();
	star2.hide();
	star3.hide();
	star4.hide();
	star5.hide();

	if (pos >= 1) star1.show();
	if (pos >= 2) star2.show();
	if (pos >= 3) star3.show();
	if (pos >= 4) star4.show();
	if (pos >= 5) star5.show();

	if (pos > rating)
	{
		for ( int i = 1; i <= 5; i++ )
		{
			guiobject o = ratingStars.enumItem(i-1);
			if ( i > pos || i <= rating)
			{
				o.setAlpha(253);
			}
			else
			{
				o.setAlpha(0);
			}
		}
	}
	else
	{
		rate1.setAlpha(253);
		rate2.setAlpha(253);
		rate3.setAlpha(253);
		rate4.setAlpha(253);
		rate5.setAlpha(253);
	}
}

RatingButton.onLeaveArea () // Vic note: OnLeaveArea only works on buttons!!
{
	//RatingButton.getParent().findObject("label").setAlpha(0); // v1.1 (disabled)

	star1.hide();
	star2.hide();
	star3.hide();
	star4.hide();
	star5.hide();
	rate1.setAlpha(253);
	rate2.setAlpha(253);
	rate3.setAlpha(253);
	rate4.setAlpha(253);
	rate5.setAlpha(253);
}

refreshRating (int rating)
{
	rate1.setActivated(rating >= 1);
	rate2.setActivated(rating >= 2);
	rate3.setActivated(rating >= 3);
	rate4.setActivated(rating >= 4);
	rate5.setActivated(rating >= 5);
}

RatingButton.onRightButtonUp (int x, int y)
{
	popupmenu rmenu = new popupmenu;
	rmenu.addcommand("Remove Rating", 1, 0,0);
	int result = rmenu.popAtMouse();
	if (result == 1)
	{
		setCurrentTrackRating(0);
		refreshRating(0);
	}
	complete;
}

//----------------------------------------------------------------------------------------------------------------
// Winamp Branding
//----------------------------------------------------------------------------------------------------------------

showBranding()
{
  DoNotAnimateCovers();
  
	// stop cycler and hide all infolines
	cycler.stop();
  cycler_paused = 1; //v1.2 extra check
	g_cover.setAlpha(0);
	g_cover.setXmlParam("ghost", "1");
	g_rating.hide();
	g_title.hide();
	g_album.hide();
	g_artist.hide();
	g_year.hide();
	g_genre.hide();
	g_track.hide();
	g_comment.hide();
	g_composer.hide();
	g_format.hide();
	g_albumartist.hide();
	g_surl.hide();
	g_sname.hide();
	g_disc.hide();
	g_bpm.hide();
	g_filepath.hide();
	g_publisher.hide();


	if (ic_vis_fileinfo.getData() == "1")
	{
		_BrandingsetXSpace((g_cover.getGuiW() + 2) / 2);
		_BrandingsetWSpace(-2);
	}
	else
	{
		_BrandingsetXSpace(2);
		_BrandingsetWSpace(-2);
	}
	_BrandinghandleResize();
	l_branding.show();
}

scriptGroup.onResize (int x, int y, int w, int h)
{
  if (l_branding.isVisible())
  {
    sui_fisong2.setxmlparam("ghost", "1"); //v1.2
    g_cover.setXmlParam("ghost", "1");

    if (ic_vis_fileinfo.getData() == "1")
    {
      if (w < 350) l_branding.setAlpha(0);
      else if (w > 350 && l_branding.getAlpha() == 0) l_branding.setAlpha(253); g_cover.setXmlParam("ghost", "1");
    }
  
    else if (ic_cover_fileinfo.getData() == "1")
    {
      if (w < 200) l_branding.setAlpha(0);
      else if (w > 200 && l_branding.getAlpha() == 0) l_branding.setAlpha(253); g_cover.setXmlParam("ghost", "1");
    }
    
    else if (ic_vis_fileinfo.getData() == "1" && ic_cover_fileinfo.getData() == "1")
    {
      if (w < 200) l_branding.setAlpha(0);
      else if (w > 200 && l_branding.getAlpha() == 0) l_branding.setAlpha(253); g_cover.setXmlParam("ghost", "1");
    }	
  
    else if (ic_vis_fileinfo.getData() == "0" && ic_cover_fileinfo.getData() == "0")
    {
      if (w < 320) l_branding.setAlpha(0);
      else if (w > 320 && l_branding.getAlpha() == 0) l_branding.setAlpha(253); g_cover.setXmlParam("ghost", "1");
    }			
  
    else if (ic_vis_fileinfo.getData() == "0")
    {
      if (w < 320) l_branding.setAlpha(0);
      else if (w > 320 && l_branding.getAlpha() == 0) l_branding.setAlpha(253); g_cover.setXmlParam("ghost", "1");
    }
  }

  if (ic_fileinfo.getData() == "1" && l_branding.isVisible() == 0)// v1.1= Added "ic_fileinfo.getData", this controls the big Album art visibility on load, even when the view is not ON
  {
    if (w < 30) info_component_albumbg_container.hide();
    else if (w > 30) info_component_albumbg_container.show();
  }
}

// Hide branding if we start playback
System.onPlay ()
{
  DoNotAnimateCovers();
  
	if (ic_fileinfo.getData() == "1" && removePath(getPlayItemString()) == "demo.mp3")
	{
		if (getPlayitemmetadatastring("artist") == "DJ Mike Llama" && getplayitemmetadatastring("title") == "Llama Whippin' Intro")
		{
			showBranding();
			SongInfoHide();
			return;
		}
	}
	refreshRating(System.getCurrentTrackRating());
	
	loadFileInfo();

  l_albumart.setXmlParam("alpha", "253");
  l_albumart.setXmlParam("ghost", "0");

  AnimationSongInfoIN(); //v1.2
}

ic_fileinfo.onDataChanged ()
{
	if (getData() == "0")
	{
		cycler.stop();
		l_branding.hide();
	}
  else if (getStatus() == STATUS_STOPPED && songinfo_location == "")
  {
    showBranding(); g_cover.setXmlParam("ghost", "1"); // show branding if playback is stopped and the playlist is empty
  }
	else if (l_branding.isVisible())
	{
		showBranding();
    g_cover.setXmlParam("ghost", "1");
	}
	else
	{
		loadFileInfo();
	}
}

ic_cover_fileinfo.onDataChanged ()
{
	if (l_branding.isVisible())
	{
		//showBranding(); // v1.2 disabled
    g_cover.setXmlParam("ghost", "1");
	}

	if (getData() == "1" && l_branding.isVisible() == 0 && songinfo_isStream == 0) // v1.2 Show the bg behind the rounded albumart to hide the trick
	{
    ShadeLeftRounder.setAlpha(255);
	}
	else
	{
    ShadeLeftRounder.setAlpha(0);
	}
}

ic_vis_fileinfo.onDataChanged ()
{
	if (l_branding.isVisible())
	{
		//showBranding(); // v1.2 disabled
    g_cover.setXmlParam("ghost", "1");
	}
}

getTextHeight (InfoLine gn)
{
	return stringToInteger(gn.getXmlParam("h"));
}


System.onStop()
{
  if (songinfo_isStream == 1)
  {
    l_albumart.setXmlParam("alpha", "0");
    l_albumart.setXmlParam("ghost", "1"); // Vic note: This DOES hide the AlbumArt and shows Branding.. (IF songinfo_reload is disabled)
    showBranding();
  }
 
  if (l_branding.isVisible() == 1)
  {
    g_cover.setXmlParam("ghost", "1");
    g_cover.setAlpha(0);
    showBranding();
  }

  AnimationSongInfoOUT(); //v1.2
}

System.onResume() //v1.2 added to ensure Autoplay works (works in combination with mcvcore.maki)
{
  SongInfoShow();
}

// Animation to enable / disable Background pic
fibg_attrib.onDataChanged ()
{
  if (fibg_attrib.getdata() == "0")
  {
    l_albumart2.setAlpha(0);
    l_albumart2.setTargetA(100); // v1.2 changed to get more contrast with foreground text
    l_albumart2.setTargetSpeed(1.7);
    l_albumart2.gotoTarget();
    
    info_component_albumbg_container.show();
    info_component_albumbg_container.setTargetA(253);
    info_component_albumbg_container.setTargetSpeed(1.7);
    info_component_albumbg_container.gotoTarget();
  }
  else if (fibg_attrib.getdata() == "1")
  {
    info_component_albumbg_container.setTargetA(0);
    info_component_albumbg_container.setTargetSpeed(0.9);
    info_component_albumbg_container.gotoTarget();
  }
}

info_component_albumbg.onTargetReached()
{
  if (fibg_attrib.getdata() == "1") info_component_albumbg_container.hide();
}


/*System.onKeyDown(String key) { //v1.2 removed
	
	if (key == "ctrl+f") {
	
    if (playlist_victrick_attrib.getData() == "1") { return; }
    
    else if (playlist_victrick_attrib.getData() == "0") {
        if (use_browser_attrib.getdata() == "1")
        {
          if (songinfo_isStream)
          {
          string lv_title = t_title.getText();
          string lv_artist = t_artist.getText();

          if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title));
          else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title));

          complete;
          }
              
            else if (System.isVideo())
            {
            string lv_songticker = getPlayItemDisplayTitle();
      
            if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ lv_songticker);
            else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ lv_songticker);
            complete;        
            }
              
              else
              {
              string lv_title = getPlayItemMetaDataString("title");
              string lv_artist = getPlayItemMetaDataString("artist");
        
              if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title));
              else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title));
              complete;        
              }
        }
        
          if (use_reader_attrib.getdata() == "1")
          {
            if (songinfo_isStream)
            {
              string lv_title = t_title.getText();
              string lv_artist = t_artist.getText();
              string search = (urlEncode(lv_artist) + " " + urlEncode(lv_title));
        
              getContainer("main").switchToLayout("normal");
              group sui = getContainer("main").getLayout("normal").findObject("sui.content");

              sui.sendAction ("browser_search", search, 0, 0, 0, 0);
              complete;
            }
            
            else if (System.isVideo())
            {
              string lv_songticker = getPlayItemDisplayTitle();
      
              getContainer("main").switchToLayout("normal");
              group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
              sui.sendAction ("browser_search", lv_songticker, 0, 0, 0, 0);
              complete;
            }
              else
              {
                string lv_title = getPlayItemMetaDataString("title");
                string lv_artist = getPlayItemMetaDataString("artist");
                string searchv = (urlEncode(lv_artist) + " " + urlEncode(lv_title));
            
                getContainer("main").switchToLayout("normal");
                group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
                sui.sendAction ("browser_search", searchv, 0, 0, 0, 0);
                complete;
              }
      
          }
    }
  }
}*/


scriptGroup.onSetVisible(int on)
{
  if (on) {
    //System.messageBox("THIS IS LOADED NOW", "BBM", 1, ""); //checker

    // v1.2 (moved here from "onLoadScript", experimenting if it makes loading faster)
    if (wacup_attrib.getData() == "1")
    {
      l_branding.setXmlParam("image", "infocomp.branding.wacup");
    }
    else
    {
      l_branding.setXmlParam("image", "infocomp.branding");
    }

    // v1.2 (added + experimenting if it makes loading faster)
    if (rounded_attrib.getData() == "1" && ic_cover_fileinfo.getData() == "1" && songinfo_isStream == 0)
    {
      ShadeLeftRounder.setAlpha(255);
    }
    else { ShadeLeftRounder.setAlpha(0); }
    
    
    
    if (fibg_attrib.getdata() == "0")
    {
      info_component_albumbg_container.show();
      info_component_albumbg_container.setAlpha(253);
    }
    else if (fibg_attrib.getdata() == "1")
    {
      info_component_albumbg_container.hide();
      info_component_albumbg_container.setAlpha(0);
    }
   
    if (ic_fileinfo.getData() == "1")
    {
      loadFileInfo();  

      if (getStatus() == STATUS_STOPPED && songinfo_location == "") showBranding(); g_cover.setXmlParam("ghost", "1"); //Show branding if playback is stopped and PL is empty
      
      if (removePath(getPlayItemString()) == "demo.mp3") // Show branding if playing DJ Mike
      {
        if (getPlayitemmetadatastring("artist") == "DJ Mike Llama" && getplayitemmetadatastring("title") == "Llama Whippin' Intro")
        {
          showBranding();
          DoNotAnimateCovers();
        }
        g_cover.hide();
      }
    }

    refreshRating(System.getCurrentTrackRating());

    /*if (l_branding.isVisible() == 0 && ic_vis_fileinfo.getdata() == "0") //v1.2 disabled (not needed?)
    {
      g_cover.setAlpha(0);
      g_cover.setXmlParam("x", "-34");
      g_cover.setXmlParam("w", "1");
      g_cover.setTargetA(253); //v1.2 changed to 253
      g_cover.setTargetW(189);
      g_cover.setTargetX(83);
    }*/
    
    if (l_branding.isVisible() == 1 && rounded_attrib.getData() == "1" && ic_cover_fileinfo.getData() == "1")
    {
      ShadeLeftRounder.setAlpha(0);
    }
      
    g_cover.setTargetSpeed(0.5);
    g_cover.gotoTarget();
    
    if (getStatus() == STATUS_STOPPED) { SongInfoHide(); }
    //else if (getStatus() != STATUS_STOPPED && l_branding.isVisible() == 0 && delayLoad.isRunning()) { SongInfoShow(); }
    //else if (getStatus() != STATUS_STOPPED && l_branding.isVisible() == 0) { SongInfoShow(); }
    else if (getStatus() != STATUS_STOPPED && l_branding.isVisible() == 0) { AnimationSongInfoIN(); }
    else if (getStatus() != STATUS_STOPPED && l_branding.isVisible() == 1) { SongInfoHide(); }

    //int isplaying = InfoComponentInfodisplay.getTop();
    //if (isplaying == 20) AnimationSongInfoIN(); //v1.2 added
  }
  else { return; }
}

	
g_cover.onTargetReached()
{
  if (scriptGroup.isVisible() == 1 && ic_cover_fileinfo.getdata() == "1" && ic_vis_fileinfo.getdata() == "0") //v1.2
  {
    if (l_branding.isVisible() == 0)
    {
      g_cover.show();
      g_cover.setTargetA(253);
      g_cover.setTargetX(6);
      g_cover.setTargetW(189);
      g_cover.setTargetSpeed(0.4);
      g_cover.gotoTarget();
    }
    else 	if (l_branding.isVisible() == 1)
    {
      DoNotAnimateCovers();
    }
  }
  
  else if (scriptGroup.isVisible() == 1 && ic_cover_fileinfo.getdata() == "1" && ic_vis_fileinfo.getdata() == "1")
  {
    if (l_branding.isVisible() == 0)
    {
      g_cover.show();
      g_cover.setTargetA(253);
      g_cover.setTargetX(195);
      g_cover.setTargetW(186);
      g_cover.setTargetSpeed(0.4);
      g_cover.gotoTarget();
    }
    else 	if (l_branding.isVisible() == 1)
    {
      DoNotAnimateCovers();
    }
  }
}

/*l_branding.onSetVisible(Boolean onoff) // v1.2 disabled
{
  DoNotAnimateCovers();
}*/


l_albumart.onEnterArea() // v1.15 from here on
{
	CloseCoverBtnTimer.start();
	
	Hidecoverbtn.show();
	return 1;
}

l_albumart.onLeaveArea()
{
  if (l_albumart.isMouseOverRect())
  {
    Hidecoverbtn.show();
    return 1;
  }
  else
  {
    Hidecoverbtn.hide();
  	return 0;
  }

}

Hidecoverbtn.onLeaveArea()
{
  if (l_albumart.isMouseOverRect())
  {
    return 1; // not sure if this is needed, but seems to perform better with it
  }
  else
  {
    Hidecoverbtn.hide();
  	return 0;
  }
}


CloseCoverBtnTimer.onTimer()
{
  if (l_albumart.isMouseOverRect())
  {
    Hidecoverbtn.show();
    //CloseCoverBtnTimer.stop();
	}
	else
	{
    Hidecoverbtn.hide();
    CloseCoverBtnTimer.stop();
	}
}


//v1.2 from here
AnimationSongInfoIN() {
  if (!delayLoad.isRunning()) {
    sui_fisong2.setxmlparam("h", "0");

    if (ic_cover_fileinfo.getData() == "1" && ic_vis_fileinfo.getData() == "1") { sui_fisong2.setTargetX(377); }
    else if (ic_cover_fileinfo.getData() == "1" && ic_vis_fileinfo.getData() == "0") { sui_fisong2.setTargetX(188); }
    else if (ic_cover_fileinfo.getData() == "0" && ic_vis_fileinfo.getData() == "1") { sui_fisong2.setTargetX(188); }
    else if (ic_fileinfo.getData() == "1" && ic_cover_fileinfo.getData() == "0" && ic_vis_fileinfo.getData() == "0") { sui_fisong2.setTargetX(8); }
    
    
    bg_songinfo_filler.setTargetY(1);
    bg_songinfo_filler.setTargetA(253);
    sui_fisong2.setTargetY(3);
    sui_fisong2.setTargetH(30);
    sui_fisong2.setTargetA(253);

    bg_songinfo_filler.setTargetSpeed(0.55);
    sui_fisong2.setTargetSpeed(0.55);
    sui_fisong2.gotoTarget();
    bg_songinfo_filler.gotoTarget();
  }
  else
  {
    SongInfoShow();
  }
}


AnimationSongInfoOUT() {
  if (ic_cover_fileinfo.getData() == "1" && ic_vis_fileinfo.getData() == "1") { sui_fisong2.setTargetX(377); }
  else if (ic_cover_fileinfo.getData() == "1" && ic_vis_fileinfo.getData() == "0") { sui_fisong2.setTargetX(188); }
  else if (ic_cover_fileinfo.getData() == "0" && ic_vis_fileinfo.getData() == "1") { sui_fisong2.setTargetX(188); }
  else if (ic_fileinfo.getData() == "1" && ic_cover_fileinfo.getData() == "0" && ic_vis_fileinfo.getData() == "0") { sui_fisong2.setTargetX(8); }
  
  bg_songinfo_filler.setTargetY(-30);
  bg_songinfo_filler.setTargetA(0);
  sui_fisong2.setTargetY(-40);
  sui_fisong2.setTargetH(0);
  sui_fisong2.setTargetA(0);

  bg_songinfo_filler.setTargetSpeed(0.55);
  sui_fisong2.setTargetSpeed(0.55);
  sui_fisong2.gotoTarget();
  bg_songinfo_filler.gotoTarget(); 
}


SongInfoShow() {
  info_component_albumbg_overlay.show();
  info_component_albumbg_overlay.setxmlparam("alpha", "253");

  sui_fisong2.setXmlParam("y", "3");
  sui_fisong2.setxmlparam("h", "33");
  sui_fisong2.setxmlparam("alpha", "253");

  bg_songinfo_filler.setxmlparam("y", "1");
  bg_songinfo_filler.setxmlparam("alpha", "253");
}

SongInfoHide() {
  sui_fisong2.setXmlParam("y", "-40"); 
  sui_fisong2.setxmlparam("h", "0");
  sui_fisong2.setxmlparam("alpha", "0");
  bg_songinfo_filler.setxmlparam("y", "-30");
}

rounded_attrib.onDataChanged()
{
  if (getData() == "1" && ic_cover_fileinfo.getData() == "1" && l_branding.isVisible() == 0 && songinfo_isStream == 0)
  {
    ShadeLeftRounder.setAlpha(255); // v1.2 The prestige: Show the -slightly extended- bg behind the rounded albumart
  }
  else { ShadeLeftRounder.setAlpha(0); }
}