#include "std.mi"
#include "lib/pldir.mi"
#include "lib/config.mi"
#include "lib/application.mi"
#include "lib/quickPlaylist.mi"
#include "lib/com/songinfo.m"
#include "attribs/init_windowpage.m"

Global Group scriptGroup, parent, PlayerLayout, PlayerDisplay;
Global Frame PlayerMainframe;
Global Popupmenu selMenu;
Global Button bolt, fakeAbout, changeTheme, changeThemePrev, SuiShowButton;
Global Togglebutton ToggleAlwaysOnTop;


System.onScriptLoaded() {
	scriptGroup = getScriptGroup();

	initAttribs_windowpage();
  
	String param = getParam();
	parent = scriptGroup.getParent();
	SuiShowButton = parent.findObject("sui.show");
	//SuiShowButton = parent.findObject("sui.show");
	bolt = scriptGroup.findObject(getToken(param,";",0));
	fakeAbout = scriptGroup.findObject(getToken(param,";",1));
	changeTheme = scriptGroup.findObject(getToken(param,";",2));
	
	changeThemePrev = scriptGroup.findObject("colorthemes.prev");

	ToggleAlwaysOnTop = scriptGroup.findObject("progbutton.always.on.top");	

	int a = getPublicInt("cpro2.multibutton", 0);

  if(a==0){
    bolt.setXmlParam("tooltip",translate("Default Lightning Bolt Behaviour")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==1){
      bolt.setXmlParam("tooltip",translate("Explore Folder")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==2){
      bolt.setXmlParam("tooltip",translate("Show Quick Playlist")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==3){
      bolt.setXmlParam("tooltip",translate("Change Color Theme")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==4){
      bolt.setXmlParam("tooltip",translate("Show Send to Menu")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==5){
      bolt.setXmlParam("tooltip",translate("Show Track Menu")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==6){
      bolt.setXmlParam("tooltip",translate("Toggle Always on top")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==7){
      bolt.setXmlParam("tooltip",translate("Skin Settings")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    else if(a==8){
      bolt.setXmlParam("tooltip",translate("View Bookmarks")+" | "+translate("Multi-Button (right-click for Options)"));
    }    
}

bolt.onLeftClick(){
	int a = getPublicInt("cpro2.multibutton", 0);
		
		if(a==0){
		
    bolt.setXmlParam("tooltip",translate("Default Lightning Bolt Behaviour")+" | "+translate("Multi-Button (right-click for Options)"));
   
		fakeAbout.setXmlParam("action", "TOGGLE");
		fakeAbout.setXmlParam("param", "guid:{D6201408-476A-4308-BF1B-7BACA1124B12}");

		fakeAbout.leftClick();
	}
	
	else if(a==1){
		songinfo_reload();
		
	  String isstreamv = getPlayItemMetaDataString("streamtype");
    if (songinfo_isStream == 0)
    {
      System.navigateUrl(getPath(getPlayItemMetaDataString("filename")));
    }
    else if (isstreamv != "")
    {
      String nav = getPlayItemMetaDataString("streamurl");
      System.navigateUrl(nav);
    }
	}
	else if(a==2){
		popQuickPlaylist(System.getViewportHeight()/24, false);
	}
	else if(a==3){
    
    if (System.isKeyDown(VK_CONTROL) == 1) { changeThemePrev.leftClick(); }
    else { changeTheme.leftClick(); }
	}
	else if(a==4){
		fakeAbout.setXmlParam("param", "");
		fakeAbout.setXmlParam("action", "ML_SendTo");
		fakeAbout.leftClick();
	}
	else if(a==5){
		fakeAbout.setXmlParam("param", "");
		fakeAbout.setXmlParam("action", "trackmenu");
		fakeAbout.leftClick();
	}
	else if(a==6){
    ToggleAlwaysOnTop.leftClick();
	}
	else if(a==7){
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    sui.sendAction ("opentab", "cnfg", 0, 0, 0, 0); // v1.1
	}
  else if(a==8){

    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    sui.sendAction ("opentab", "ml", 0, 0, 0, 0); // v1.1
    
    String skinpath = Application.GetApplicationPath()+ "/Skins/Big Bento Modern Windows 10 edition/scripts/shortcuts/bbm_sendmessage_40320.exe";
    
    navigateURL(skinpath);
	}
	
}

bolt.onRightButtonUp(int x, int y){
	selMenu = new PopupMenu;
	selMenu.addCommand("Multi-Button Action:", -1, 0, 1);
	selMenu.addSeparator();
	selMenu.addCommand("Default Lightning Bolt Behaviour", 0, 0, 0);
	selMenu.addCommand("Change Color Theme", 3, 0, 0);
	selMenu.addCommand("Explore Folder", 1, 0, 0);
	selMenu.addCommand("Show Quick Playlist", 2, 0, 0);
	selMenu.addCommand("Show Send to Menu", 4, 0, 0);
	selMenu.addCommand("Show Track Menu", 5, 0, 0);
	selMenu.addCommand("Toggle Always on top", 6, 0, 0);
	selMenu.addCommand("Skin Settings", 7, 0, 0);
	selMenu.addCommand("View Bookmarks", 8, 0, 0);
	selMenu.checkCommand(getPublicInt("cpro2.multibutton", 0), 1);
	
	int a = selMenu.popAtXY(clientToScreenX(bolt.getLeft()), clientToScreenY(bolt.getTop())+36);
	
	if(a>=0){
		setPublicInt("cpro2.multibutton", a);
    bolt.setXmlParam("tooltip",translate("Default Lightning Bolt Behaviour")+" | "+translate("Multi-Button (right-click for Options)"));
	}
    if(a==1){
      bolt.setXmlParam("tooltip",translate("Explore Folder")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==2){
      bolt.setXmlParam("tooltip",translate("Show Quick Playlist")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==3){
      bolt.setXmlParam("tooltip",translate("Change Color Theme")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==4){
      bolt.setXmlParam("tooltip",translate("Show Send to Menu")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==5){
      bolt.setXmlParam("tooltip",translate("Show Track Menu")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==6){
      bolt.setXmlParam("tooltip",translate("Toggle Always on top")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==7){
      bolt.setXmlParam("tooltip",translate("Skin Settings")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    if(a==8){
      bolt.setXmlParam("tooltip",translate("View Bookmarks")+" | "+translate("Multi-Button (right-click for Options)"));
    }
    

	Complete;
	delete selMenu;
}