/*---------------------------------------------------
-----------------------------------------------------
Filename:	notifier.m
Version:	2.0 (Victhor heavy mods)
Author:		Martin Poehlmann aka Deimos

-----------------------------------------------------
// Workaround for Winamp bug by Pieter Nieuwoudt (pjn123) - pjn123@outlook.com \\

Temparary fix for the Winamp bug where the...
extern AlbumArtLayer.onAlbumArtLoaded(boolean success);
...event stops working.

Please note that this workaround only kicks in if the above event stops responding.
If you want to test the workaround, just add // after the FORCE_BUG_MODE below.
Once the above event stop responding the first notifier trigger will be delayed (3 sec),
but after that there will be no delays anymore.

To remove this fix in the future just search //BUGFIX for steps ;)

-----------------------------------------------------
---------------------------------------------------*/

#define FORCE_BUG_MODE 

#include "std.mi"
#include "attribs/init_notifier.m"
#include "attribs/init_browser.m"
#define DEBUG 
#define DebugString

Function refreshRating(int rating); // Victhor mod
Function click_to_layout(); // Victhor mod 1.1

Global Button Mousetrap; // Victhor mod

//edit by pjn123 start
Function onCover(Boolean success);
Function popSettings();
Function int getSaveValue(int input);
Function onAlbumArt(Boolean success);
//edit by pjn123 end

Function reset();
Function createNotifier(boolean cancel);
Function showNotifier(Int w);
Function onNext();
function cancelAnimation();

Function Int fillNextTrackInfo(String corneroverride);
Function Int fillCustomInfo(String customstring);
Function prepareAlbumArtNotifier();

Function checkPref(int bypassfs);

Function getArtist();

Global Container notifier_container;
Global Layout notifier_layout;
Global Timer notifier_timer;
Global String last_autotitle, last_autopis, cur_status;


//edit by pjn123 start
Global Timer notifier_settingshelp;
Global Boolean msgbox_open, switchOnce;
Global PopupMenu myMenu, timeIn, timeStay, timeOut;
Global Boolean triggerBug; //BUGFIX remove this
Global Timer fallbackTempFix; //BUGFIX remove this
//edit by pjn123 end

Global Boolean b_tohide = 0;
Global boolean handleAACalback = false;
Global boolean menuOpen = false;


Global AlbumArtLayer cover;

Class Button RatingButton;
Global Button CloseNotification;
Global Group g_text;

Global RatingButton rate1, rate2, rate3, rate4, rate5;
Global Layer star1, star2, star3, star4, star5;


#define WEBCOVER_SHOUTCAST "cover.aolr"

// ------------------------------------------------------------------------------
// init
// ------------------------------------------------------------------------------
System.onScriptLoaded() {

	initAttribs_notifier();
	initAttribs_browser();
		
	notifier_timer = new Timer;
	fallbackTempFix = new Timer; //BUGFIX remove this
	fallbackTempFix.setDelay(300); //BUGFIX remove this / Time that onAlbumArtLoaded have to execute before bug mode is ON
}

// ------------------------------------------------------------------------------
// shutdown
// ------------------------------------------------------------------------------
System.onScriptUnloading() {
	delete notifier_timer;
	delete notifier_settingshelp;
	delete fallbackTempFix; //BUGFIX remove this
}


// ------------------------------------------------------------------------------
// called by the system when the global hotkey for notification is pressed
// ------------------------------------------------------------------------------
System.onShowNotification() {
	createNotifier(false);
	if (getStatus() == STATUS_PLAYING) cur_status = "Playing";
	if (getStatus() == STATUS_PAUSED) cur_status = "Playback Paused"; // v1.1
	if (getStatus() == STATUS_STOPPED) cur_status = "Playback Stopped";
	prepareAlbumArtNotifier();
	complete; // prevents other scripts from getting the message
	return 1; // tells anybody else that might watch the returned value that, yes, we implemented that
}

// ------------------------------------------------------------------------------
// called by the system when the title for the playing item changes, this could be the result of the player
// going to the next track, or of an update in the track title
// ------------------------------------------------------------------------------
// mpdeimos> seems like we get an onTitleChange callback sometimes on pause/resume, d'oh
Global String lastUrl = 0;
System.onTitleChange(String newtitle) {

	if (getPlayItemMetaDataString("streamtype") == "0" && lastUrl == getPlayItemString())
	{
		return;
	}
	lastUrl = getPlayItemString();
	
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" ||
				StrLeft(newtitle, 4) == "[ICY") return;
	}
	//DebugString("onTitleChange: "+getPlayItemString(), 9);
	onNext();
}

// ------------------------------------------------------------------------------
// called by the system when the user clicks the next button
// ------------------------------------------------------------------------------
onNext() {
	if (checkPref(0)) return;
	createNotifier(false);
	cur_status = "";
	prepareAlbumArtNotifier();
	
	fallbackTempFix.stop(); //BUGFIX remove later
	fallbackTempFix.start(); //BUGFIX remove later
}

// ------------------------------------------------------------------------------
// called by the system when the user clicks the play button
// ------------------------------------------------------------------------------
System.onPlay() {
	if (checkPref(0)) return;
	createNotifier(false);
	cur_status = "Playing";
	prepareAlbumArtNotifier();
	
	fallbackTempFix.stop(); //BUGFIX remove later
	fallbackTempFix.start(); //BUGFIX remove later
	
}

// ------------------------------------------------------------------------------
// called by the system when the user clicks the pause button // Vic note: 1.1 re-enabled and fixed
// ------------------------------------------------------------------------------
System.onPause() {
		fallbackTempFix.stop();
    if (checkPref(0)) return;

	if (notifier_container == NULL) {
    createNotifier(true);
    showNotifier(fillCustomInfo("Playback Paused"));
	}
	else
	{
    createNotifier(false);
	}
}


// ------------------------------------------------------------------------------
// called by the system when the user clicks the pause button again // Vic note: 1.1 re-enabled and fixed
// ------------------------------------------------------------------------------
System.onResume() {
		fallbackTempFix.stop();
    if (checkPref(0)) return;

	if (notifier_container == NULL) {
    createNotifier(true);
    prepareAlbumArtNotifier();
	
    fallbackTempFix.start(); //BUGFIX remove later

    //showNotifier(fillCustomInfo("Resuming Playback"));
	}
	else
	{
    createNotifier(false);
    cur_status = "";
    prepareAlbumArtNotifier();
	
    fallbackTempFix.stop(); //BUGFIX remove later
    fallbackTempFix.start(); //BUGFIX remove later
	}
}

// ------------------------------------------------------------------------------
// called by the system when the user clicks the play button
// ------------------------------------------------------------------------------
System.onStop() {
	if (checkPref(0)) return;
	createNotifier(true);
	showNotifier(fillCustomInfo("End of Playback"));
}


// ------------------------------------------------------------------------------
// checks if we should display anything
// ------------------------------------------------------------------------------
Int checkPref(int bypassfs) {
	if (!bypassfs && notifier_hideinfullscreen_attrib.getData() == "1" && isVideoFullscreen()) return 1;
	if (notifier_never_attrib.getData() == "1") return 1;
	if (notifier_minimized_attrib.getData() == "1" && !isMinimized()) return 1;
	if (notifier_windowshade_attrib.getData() == "1") {
		if (isMinimized()) return 0;
		Container c = getContainer("main");
		if (!c) return 1;
		Layout l = c.getCurLayout();
		if (!l) return 1;
		if (l.getId() != "shade") return 1;
	}
	return 0;

}

// ------------------------------------------------------------------------------
// fade in/out completed
// ------------------------------------------------------------------------------
notifier_layout.onTargetReached() {

  Mousetrap = notifier_layout.findObject("mousetrap.hold"); // v1.1: This needs to be up here, otherwise alpha reaches 0 (reset(); is executed) and we can't get the mousetrap
  
  if (notifier_holdopen_attrib.getData() == "1"){
    Mousetrap.setXmlParam("ghost", "0");
  }
  else if (notifier_holdopen_attrib.getData() == "0"){
    Mousetrap.setXmlParam("ghost", "1");
  }

	if (b_tohide) {
		notifier_layout.setAlpha(0);
		reset();
		return;
	}
	int a = notifier_layout.getAlpha();
	if (a == 255 && !b_tohide) {
		notifier_timer.setDelay(StringToInteger(notifier_holdtime_attrib.getData()));
		notifier_timer.start();
	}
	else if (a == 0) {
		reset();
	}


}

// ------------------------------------------------------------------------------
// hold time elapsed // cPro2 edited
// ------------------------------------------------------------------------------
notifier_timer.onTimer() {
	stop();
	if (notifier_fdout_alpha.getData() == "1") {
		if (notifier_layout.isTransparencySafe()) {
			notifier_layout.setTargetA(0);
			notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeouttime_attrib.getData()) / 1000);
			notifier_layout.gotoTarget();
			return;
		}
		else {
			reset();
			return;
		}
	}
	else if (notifier_fdout_vslide.getData() == "1") {
		b_tohide = 1;
		int sy;
		int geth;
		
		if (notifier_loc_vport_attrib.getData() == "1")
		{
			geth = getViewportHeight();
		}
		else
		{
			geth = getMonitorHeight();
		}
		if (notifier_layout.getGuiY() == 2) sy = -150;
		else sy = geth + 150;
		notifier_layout.setTargetY(sy);
		notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeouttime_attrib.getData()) / 1000);
		notifier_layout.gotoTarget();
		return;
	}
	else {
		if (b_tohide) return;
		b_tohide = 1;
		int sx;
		int getw;
		
		if (notifier_loc_vport_attrib.getData() == "1") {
			getw = getViewportWidth();
		}
		else {
			getw = getMonitorWidth();
		}

		if (notifier_layout.getGuiX() == 2) sx = -notifier_layout.getWidth();
		else sx = getw + notifier_layout.getWidth();
		notifier_layout.setTargetX(sx);
		notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeouttime_attrib.getData()) / 1000);
		notifier_layout.gotoTarget();
		return;
	}	
}


// ------------------------------------------------------------------------------
// when notifier is clicked, bring back the app from minimized state if its minimized and focus it
// ------------------------------------------------------------------------------
notifier_layout.onLeftButtonDown(int x, int y) {
  if(getPublicInt("cpro2.asknotifier", 1)){ // edit by pjn123 start
  notifier_settingshelp= new Timer;
  notifier_settingshelp.setDelay(100);
  notifier_settingshelp.start();
	cancelAnimation();
	restoreApplication();
	activateApplication();
  reset();
  return;
	} // edit by pjn123 end

  cancelAnimation();
	
	if (notifier_opennowplaying_attrib.getData() == "1") // v1.1 from here..
  {
      Mousetrap.onLeftClick ();
	} // v1.1 to here..
	else {
	//Do nothing
	}
	
	if (notifier_openapp_attrib.getData() == "1")
	{
    cancelAnimation();
    restoreApplication();
    activateApplication();
	} 
	
  if (notifier_closenotification_attrib.getData() == "1")
	{
    cancelAnimation();
    //reset(); // v1.1 disabled to fix ghostly Guru error
	}
	
  reset();
}


notifier_settingshelp.onTimer(){// edit by pjn123 start
	notifier_settingshelp.stop();
	if(msgbox_open) return;
	msgbox_open = true;
	int l = System.messageBox(translate("Do you want to disable song notifications?\n\nThis message won't appear again.\nTo manually disable it later go to 'Options >> Notifier'"), translate("Big Bento Modern Windows 10 edition"), 12, "");
	msgbox_open = false;
	if(l==4) notifier_never_attrib.setData("1");
	setPublicInt("cpro2.asknotifier", 0);
}// edit by pjn123 end


//TODO merge w/ code below
String getArtist ()
{
	String artist = getPlayItemMetaDataString("artist");
	if (artist == "") artist = getPlayItemMetaDataString("uvox/artist");
	if (artist == "") artist = getPlayItemMetaDataString("cbs/artist");
	if (artist == "") artist = getPlayItemMetaDataString("streamtitle");
	if (artist == "") artist = getPlayItemDisplayTitle();
	
	return artist;
}


// ------------------------------------------------------------------------------
// close the notifier window, destroys the container automatically because it's dynamic
// ------------------------------------------------------------------------------
reset() {
  if(!menuOpen){
  notifier_container.close();
	}
	
	notifier_container = NULL;
	notifier_layout = NULL;
	handleAACalback = FALSE;
}

// ------------------------------------------------------------------------------
createNotifier(boolean cancel) {
	if (notifier_container == NULL) {
		notifier_container = newDynamicContainer("notifier");
		if (!notifier_container) return; // reinstall duh!
		if (isDesktopAlphaAvailable())
			notifier_layout = notifier_container.getLayout("desktopalpha");
		else
			notifier_layout = notifier_container.getLayout("normal");
		if (!notifier_layout) return; // reinstall twice, man
	} else if (cancel) {
		cancelAnimation();
	}


  Mousetrap = notifier_layout.findObject("mousetrap.hold");
  Mousetrap.setXmlParam("ghost", "1"); // v1.1: Added to avoid stopping the animation WHEN ENTERING
}

cancelAnimation()
{
	notifier_layout.cancelTarget();
	notifier_timer.stop();
}


// ------------------------------------------------------------------------------
// cPro2 edited - and re-edited..
// ------------------------------------------------------------------------------
showNotifier(int w) {
// From here..
	b_tohide = 0;
	int x; int y;
	int sy; int sx;
	w = w + 60;

	int getx, gety, geth, getw;

	Layout m = getContainer("main").getCurLayout();
	if (notifier_loc_vport_attrib.getData() == "1")
	{
		getx = getViewportLeftFromGuiObject(m);
		gety = getViewportTopFromGuiObject(m);
		geth = getViewportHeightFromGuiObject(m);
		getw = getViewportWidthFromGuiObject(m);
	}
	else
	{
		getx = getMonitorLeftFromGuiObject(m);
		gety = getMonitorTopFromGuiObject(m);
		geth = getMonitorHeightFromGuiObject(m);
		getw = getMonitorWidthFromGuiObject(m);
	}
	if (notifier_loc_br_attrib.getData() == "1") {
		x = getw + getx - w - 2;
		y = geth + gety - 150 - 2;
	}
	else if (notifier_loc_bl_attrib.getData() == "1") {
		x = getx + 2;
		y = geth + gety - 150 - 2;
	}
	else if (notifier_loc_bc_attrib.getData() == "1") {
		x = getx + ((getw - w) / 2);
		y = geth + gety - 150 - 2;
	}
	else if (notifier_loc_tr_attrib.getData() == "1") {
		x = getw + getx - w - 2;
		y = 2;
	}
	else if (notifier_loc_tc_attrib.getData() == "1") {
		x = getx + ((getw - w) / 2);
		y = 2;
	}
	else {
		x = getx + 2;
		y = 2;
	}
	
// To here, the code is original from Big Bento. cPro script didn't played well with vertical taskbars

	if (notifier_fdin_alpha.getData() == "1") {
		if (!notifier_layout.isVisible()) notifier_layout.resize(x, y, w, 150);
		else
		{
			notifier_layout.resize(notifier_layout.getguiX(), y, notifier_layout.getGuiW(), 150);
		}
		if (notifier_layout.isTransparencySafe()) {
			notifier_layout.show();
			notifier_layout.settargetA(255);
			notifier_layout.setTargetX(x);
			notifier_layout.setTargetY(y);
			notifier_layout.setTargetW(w);
			notifier_layout.setTargetH(150);
			notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeintime_attrib.getData()) / 1000);
			notifier_layout.gotoTarget();
		} else {
			notifier_layout.setAlpha(255);
			notifier_layout.show();
			notifier_layout.settargetA(255);
			notifier_layout.setTargetX(x);
			notifier_layout.setTargetY(y);
			notifier_layout.setTargetW(w);
			notifier_layout.setTargetH(150);
			notifier_timer.setDelay(StringToInteger(notifier_holdtime_attrib.getData()));
			notifier_timer.start();
		}
	}
	else if (notifier_fdin_vslide.getData() == "1") {
		if (y == 2) sy = -150;
		else sy = geth + 150;

		if (!notifier_layout.isVisible()) notifier_layout.resize(x, sy, w, 150);

		
		notifier_layout.show();
		notifier_layout.setAlpha(255);
		notifier_layout.settargetA(255);
		notifier_layout.setTargetX(x);
		notifier_layout.setTargetY(y);
		notifier_layout.setTargetW(w);
		notifier_layout.setTargetH(150);
		notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeintime_attrib.getData()) / 1000);
		notifier_layout.gotoTarget();
	}
		/*else if (notifier_fdin_hdeploy.getData() == "1") { // Not yet
		if (x < (getw + getx)/2) sx = -w;
		else sx = getw + w;
		if (!notifier_layout.isVisible()) {
      notifier_layout.setXmlParam("w", "0");
      notifier_layout.setXmlParam("x", integerToString(getx-getw));
			notifier_layout.resize(sx, y, w, 150);
		}
		else {
      //notifier_layout.setXmlParam("w", "0");
			notifier_layout.resize(notifier_layout.getguiX(), y, notifier_layout.getGuiW(), 150);
		}
		notifier_layout.show();
		notifier_layout.setAlpha(255);
		notifier_layout.settargetA(255);
		notifier_layout.setTargetX(x);
		notifier_layout.setTargetY(y);
		notifier_layout.setTargetW(w);
		notifier_layout.setTargetH(150);
		notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeintime_attrib.getData()) / 1000);
		notifier_layout.gotoTarget();
	}*/
	else {
		if (x < (getw + getx)/2) sx = -w;
		else sx = getw + w;
		if (!notifier_layout.isVisible()) {
			notifier_layout.resize(sx, y, w, 150);
		}
		else {
			notifier_layout.resize(notifier_layout.getguiX(), y, notifier_layout.getGuiW(), 150);
		}
		notifier_layout.show();
		notifier_layout.setAlpha(255);
		notifier_layout.settargetA(255);
		notifier_layout.setTargetX(x);
		notifier_layout.setTargetY(y);
		notifier_layout.setTargetW(w);
		notifier_layout.setTargetH(150);
		notifier_layout.setTargetSpeed(StringToInteger(notifier_fadeintime_attrib.getData()) / 1000);
		notifier_layout.gotoTarget();
	}
}

prepareAlbumArtNotifier()
{
	if (!notifier_layout) return;
	Group g_albumart = notifier_layout.findObject("notifier.albumart");


	if (g_albumart)
	{
		cover = g_albumart.findObject("notifier.cover");
		handleAACalback = true;

		cover.refresh();
	}
	
}

cover.onAlbumArtLoaded(boolean success)
{
	/*
	Created a seperate function for the code that was here because for some reason I couldn't force this
	event (from the fallbackTempFix.onTimer) with cover.onAlbumArtLoaded(success) after the Winamp bug appears.
	Weird, yes.
	*/
	FORCE_BUG_MODE onAlbumArt(success); 
}




// ------------------------------------------------------------------------------
// cPro2 edited
// ------------------------------------------------------------------------------
Int fillNextTrackInfo(String corneroverride) {

	Int maxv = 0;
	Int stream = 0;
  Boolean isAolRadio = 0;
  
	if (!notifier_layout) return 0;

	Group g_text = notifier_layout.findObject("notifier.text");
  Mousetrap = g_text.findObject("mousetrap.hold");
	CloseNotification = g_text.findObject("close.notif.button");
	//Group g_text = notifier_layout.findObject("notifier.text");
	Group g_albumart = notifier_layout.findObject("notifier.albumart");
	
  Group notifier_ratings = notifier_layout.findobject("notifier.ratings");
  
  rate1 = notifier_ratings.findObject("rate.1");
	rate2 = notifier_ratings.findObject("rate.2");
	rate3 = notifier_ratings.findObject("rate.3");
	rate4 = notifier_ratings.findObject("rate.4");
	rate5 = notifier_ratings.findObject("rate.5");

	star1 = notifier_ratings.findObject("star.1");
	star2 = notifier_ratings.findObject("star.2");
	star3 = notifier_ratings.findObject("star.3");
	star4 = notifier_ratings.findObject("star.4");
	star5 = notifier_ratings.findObject("star.5");
	
	refreshRating(System.getCurrentTrackRating());

	Text plentry = g_text.findObject("plentry");
	Text nexttrack = g_text.findObject("nexttrack");
  Text _title = g_text.findObject("title");
  Text _title2 = g_text.findObject("title2");
	Text album = g_text.findObject("album");
	Text artist = g_text.findObject("artist");
	Text endofplayback = notifier_layout.findObject("endofplayback");

  Group g_text = notifier_layout.findObject("notifier.text");
  Group notifier_playback = g_text.findobject("notifier.playback");
  CloseNotification = g_text.findObject("close.notif.button");


	//DebugString("got callback for " + getPlayItemString(), 0);

	// Get Stream Name - if no stream returns ""
	string s = getPlayItemMetaDataString("streamname");
	string stype = getPlayItemMetaDataString("streamtype"); //"streamtype" will return "2" for SHOUTcast and "3" for AOL Radio

	// Are we listening to AOl Radio (uvox://)
	isAolRadio = (stype == "3");
	// map CBS/StreamTheWorld to AOL Radio
	isAolRadio = (isAolRadio||(strsearch(getPlayItemString(), "208.80.52.") >= 0));
	isAolRadio = (isAolRadio||(strsearch(getPlayItemString(), "208.80.53.") >= 0));
	isAolRadio = (isAolRadio||(strsearch(getPlayItemString(), "208.80.54.") >= 0));
	isAolRadio = (isAolRadio||(strsearch(getPlayItemString(), "208.80.55.") >= 0));

	if (stype == "2" || isAolRadio) stream = 1;

	if (endofplayback) endofplayback.hide();

	if (plentry)
	{ 
    String tl = getPlayItemMetaDataString("length");
    
		plentry.setText(integerToString(getPlaylistIndex()+1)+translate(" of ")+integerToString(getPlaylistLength())+" "+"("+integerToTime(stringtointeger(tl))+")");
		plentry.show();
	}
	if (nexttrack) {
		if (corneroverride == "") {
			if (!stream) {
				if (!isVideo())
				{
					nexttrack.setText("New track");
				}
				else
				{
					nexttrack.setText("New video");
				}
			}
			else
			{
				if (isAolRadio)
				{
					nexttrack.setText("AOL Radio");
				}
				else
				{
					nexttrack.setText("On air");
				}
			}
		} 
		else
		{
			nexttrack.setText(corneroverride);
		}
		nexttrack.show();
	}
	string set_artist = "";
	string set = "";
	if (_title) {
		_title.setXmlParam("ticker", "1");
		_title2.setXmlParam("ticker", "1");
		_title.setXmlParam("display", "SONGNAME");
		_title2.setXmlParam("display", "SONGNAME");
		String str;
		if (!stream)
		{
			str = getPlayitemMetaDataString("title"); 
			if (str == "") str = getPlayitemDisplayTitle();
			String l = getPlayItemMetaDataString("length");
			if (l != "") {
				str += " (" + integerToTime(stringtointeger(l)) + ")";
			}
			_title.setText(str);
			_title2.setText(str);
		}
		if (!stream)
		{
			str = getPlayitemMetaDataString("title"); 
			if (str == "") str = getPlayitemDisplayTitle();
			String l = getPlayItemMetaDataString("length");
			if (l != "") {
				str += " (" + integerToTime(stringtointeger(l)) + ")";
			}
			_title.setText(str);
			_title2.setText(str);
		}
		else
		{
			if (isAolRadio && str = getPlayItemMetaDataString("uvox/title") != "")
			{
					_title.setText(str);
					_title2.setText(str);
			}
			else if (str = getPlayItemMetaDataString("streamtitle") != "")
			{
				int v = strsearch(str, " - "); // We divide the string by a " - " sublimiter - no luck for old / wrong tagged stations
				if (v > 0) {
					set_artist = strleft (str, v); // Store artist
					string str = strright (str, strlen(str) - 3 - v);
	 
					_title.setText(str);
					_title2.setText(str);	
					
				}
				else
				{
					_title.setXmlParam("ticker", "1"); // These titles can be _very_ long
					_title2.setXmlParam("ticker", "1");
					_title.setText(str);
					_title2.setText(str);	
				}
			} else
			{
				_title.setXmlParam("ticker", "1");
				_title.setXmlParam("display", "songtitle");
				_title.setText("");
				_title2.setXmlParam("ticker", "1");
				_title2.setXmlParam("display", "songtitle");
				_title2.setText("");			
			}
		}
		_title.show(); 
		_title2.show(); 
	}
	if (artist) { 
		if (!stream) {
			if (isVideo())
			{
				artist.setText(" "); // v1.1
			}
			else
			{
				artist.setText(getPlayitemMetaDataString("artist")); 
			}
 		}
		else
		{
			// Check first if we're playing AOL Radio
			if (isAolRadio && set = getPlayItemMetaDataString("uvox/artist") != "")
			{
				artist.setText(set); 
			}
			// Perhaps we've stored the artist before?
			else if (set_artist != "")
			{
				artist.setText(set_artist); 
			}
			// Then display the station name
			else if (s != "")
			{
				artist.setText(s); 
			}
			// So, we've had no luck - just display a static text :(
			else
			{
				if (isVideo())
				{
					artist.setText("Internet TV"); 
				}
				else
				{
					artist.setText("Internet Radio");
				}
			}
		}
		artist.show(); 
	}
	
	if (album != NULL && notifier_showalbum_attrib.getData() == "1"){ // Victhor mod to add option between showing album tag or playback controls
		String str;
		if (!stream && !isVideo()) {
			album.setXmlParam("display", "");
			album.setXmlParam("y", "94");
			str = getPlayitemMetaDataString("album");
			String l = getPlayitemMetaDataString("track");
			if (l != "" && l != "-1") str += " (" + translate("Track ") + l + ")";
			album.setText(str);
		}
		else
		{
			album.setXmlParam("display", "");
			album.setXmlParam("y", "64");
			if (isAolRadio && set = getPlayItemMetaDataString("uvox/album") != "")
			{
				album.setText(set);

			}
			// we have divided the songname - let's display the station name
			else if (set_artist != "" && s != "")
			{
				album.setText(s);
			}
			// no luck either...
			else
			{
				album.setText("");
				album.setXmlParam("display", "songinfo_localise");
				album.hide();
			}
		}
		album.show();
	}

  else if (album != NULL && notifier_showalbum_attrib.getData() == "0"){ // Victhor mod to add option between showing album tag or playback controls
  	album.hide();
	}
	
	// Album Art Stuff

	layer webcover;
	if (g_albumart)
	{
		cover = g_albumart.findObject("notifier.cover");
		webcover = g_albumart.findObject("notifier.webcover");
	}

	Boolean showAlbumArt = FALSE;

	if (cover != NULL && webcover != NULL && notifier_artworkinnotification_attrib.getData() == "1")
	{
		if (stream)
		{
			// Detect if we are listening to AOL Radio
			if (strlower(strleft(getPlayItemString(), 4)) == "uvox")
			{
				s = getPlayItemMetaDataString("uvox/albumart");
				if (s != "")
				{
					webcover.setXmlParam("image", "http://broadband-albumart.music.aol.com/scan/" + s);
					if (webcover.isInvalid())
					{
						showAlbumArt = FALSE;
					}
					else
					{
						cover.hide();
						webcover.show();
						showAlbumArt = TRUE;
					}
				}
			}
		}
		else
		{
			if (cover.isInvalid()) // Check if the album art obj shows a pic
			{
				showAlbumArt = FALSE;
			}
			else
			{
				webcover.hide();
				cover.show();
				showAlbumArt = TRUE;				
			}
		}
	}
	
	if (showAlbumArt)
	{
		if (g_albumart) g_albumart.show();
		if (g_text) g_text.setXmlParam("x", "170");
		if (g_text) g_text.setXmlParam("w", "-190");
    if (notifier_playback) notifier_playback.setXmlParam("x", "0");
		if (notifier_ratings) notifier_ratings.setXmlParam("x", "5");
	}
	else
	{
		if (g_albumart) g_albumart.hide();
		if (g_text) g_text.setXmlParam("x", "20");
		if (g_text) g_text.setXmlParam("w", "-40");
    if (notifier_playback) notifier_playback.setXmlParam("x", "0");
		if (notifier_ratings) notifier_ratings.setXmlParam("x", "194");
		if (notifier_ratings) notifier_ratings.setXmlParam("y", "113");
	}
	
	if (g_text) g_text.show();
  if (notifier_playback != NULL && notifier_showcontrols_attrib.getData() == "1") notifier_playback.show(); // Victhor mod to add option between shwing album tag or playback controls
  else if (notifier_playback != NULL && notifier_showcontrols_attrib.getData() == "0") notifier_playback.hide(); // Victhor mod to add option between shwing album tag or playback controls
  if (notifier_ratings) notifier_ratings.show();

	maxv = artist.getAutoWidth();
	if (maxv < album.getAutoWidth()) maxv = album.getAutoWidth();
	if (maxv < _title.getAutoWidth()) maxv = _title.getAutoWidth();
	if (maxv < (plentry.getAutoWidth() + nexttrack.getAutoWidth())) maxv = (plentry.getAutoWidth() + nexttrack.getAutoWidth());
	if (maxv < 338) maxv = 338;

	int getw;
	if (notifier_loc_vport_attrib.getData() == "1")
	{
		getw = getViewportWidth();
	}
	else
	{
		getw = getMonitorWidth();
	}

	if (maxv > getw/4) maxv = getw/4;
	
	
	return maxv + ( showAlbumArt * 170 ) + 1; // Adds 170 extra pixels if album art is visible
	
}



// ------------------------------------------------------------------------------
Int fillCustomInfo(String customtext)
{
	
	Group g_text = notifier_layout.findObject("notifier.text");
  Mousetrap = g_text.findObject("mousetrap.hold");
  CloseNotification = g_text.findObject("close.notif.button");
	Group g_albumart = notifier_layout.findObject("notifier.albumart");
	
	Group notifier_playback = g_text.findObject("notifier.playback");
	Group notifier_ratings = notifier_layout.findObject("notifier.ratings");
  //Group g_text = notifier_layout.findObject("notifier.text");
  Text album = g_text.findObject("album");
  
  Text endofplayback = notifier_layout.findObject("endofplayback");

	if (g_text) { g_text.hide(); }
	if (g_albumart) g_albumart.hide();
	
  if (notifier_playback) notifier_playback.hide();
  if (notifier_ratings) notifier_ratings.hide();

  if (endofplayback != NULL) {
		endofplayback.setText(translate(customtext)+" ");
		int aw = endofplayback.getAutoWidth();
		endofplayback.show();
		if (aw > 328)
			return aw;
	}
	return 328;

}


notifier_timewarning_attrib.onDataChanged()
{
	if(switchOnce){
		switchOnce = false;
	}
	else{
		popSettings();
		switchOnce = true;
	}
}


notifier_layout.onRightButtonUp(int x, int y) { // edit by pjn123
  cancelAnimation();
	reset();
	complete;
	return;
}

Mousetrap.onRightButtonUp(int x, int y)
{
	complete; // v1.1: Delete RC menu
}

Mousetrap.onRightClick () {
  notifier_container.hide(); // v1.1: Can't replicate notifier_layout.onRightButtonUp because.. because
}


int getSaveValue(int input){
	if(input==5) input=6;
	else if(input==7) input=8;
	else if(input==9) input=10;
	else if(input==11) input=12;
	else if(input>=35) input=40;
	else if(input>=25) input=30;
	else if(input>=15) input=20;
	else if(input<1) input=1;
	
	return input;
}


popSettings(){
	int temp;
	timeIn = new PopupMenu;
	timeIn.addCommand("250 ms", 1, 0, 0);
	timeIn.addCommand("500 ms", 2, 0, 0);
	timeIn.addCommand("750 ms", 3, 0, 0);
	timeIn.addCommand("1000 ms", 4, 0, 0);
	timeIn.addCommand("1500 ms", 6, 0, 0);
	timeIn.addCommand("2000 ms", 8, 0, 0);
	timeIn.addCommand("2500 ms", 10, 0, 0);
	timeIn.addCommand("3000 ms", 12, 0, 0);
	timeIn.addCommand("5000 ms", 20, 0, 0);
	timeIn.addCommand("7500 ms", 30, 0, 0);
	timeIn.addCommand("10000 ms", 40, 0, 0);
	temp = getSaveValue(stringToInteger(notifier_fadeintime_attrib.getData())/250);
	if(stringToInteger(notifier_fadeintime_attrib.getData())/250!=temp) notifier_fadeintime_attrib.setData(integerToString(temp*250));
	timeIn.checkCommand(temp, 1);

	timeStay = new PopupMenu;
	timeStay.addCommand("250 ms", 101, 0, 0);
	timeStay.addCommand("500 ms", 102, 0, 0);
	timeStay.addCommand("750 ms", 103, 0, 0);
	timeStay.addCommand("1000 ms", 104, 0, 0);
	timeStay.addCommand("1500 ms", 106, 0, 0);
	timeStay.addCommand("2000 ms", 108, 0, 0);
	timeStay.addCommand("2500 ms", 110, 0, 0);
	timeStay.addCommand("3000 ms", 112, 0, 0);
	timeStay.addCommand("5000 ms", 120, 0, 0);
	timeStay.addCommand("7500 ms", 130, 0, 0);
	timeStay.addCommand("10000 ms", 140, 0, 0);
	temp = getSaveValue(stringToInteger(notifier_holdtime_attrib.getData())/250);
	if(stringToInteger(notifier_holdtime_attrib.getData())/250!=temp) notifier_holdtime_attrib.setData(integerToString(temp*250));
	timeStay.checkCommand(temp+100, 1);

	timeOut = new PopupMenu;
	timeOut.addCommand("250 ms", 201, 0, 0);
	timeOut.addCommand("500 ms", 202, 0, 0);
	timeOut.addCommand("750 ms", 203, 0, 0);
	timeOut.addCommand("1000 ms", 204, 0, 0);
	timeOut.addCommand("1500 ms", 206, 0, 0);
	timeOut.addCommand("2000 ms", 208, 0, 0);
	timeOut.addCommand("2500 ms", 210, 0, 0);
	timeOut.addCommand("3000 ms", 212, 0, 0);
	timeOut.addCommand("5000 ms", 220, 0, 0);
	timeOut.addCommand("7500 ms", 230, 0, 0);
	timeOut.addCommand("10000 ms", 240, 0, 0);
	temp = getSaveValue(stringToInteger(notifier_fadeouttime_attrib.getData())/250);
	if(stringToInteger(notifier_fadeouttime_attrib.getData())/250!=temp) notifier_fadeouttime_attrib.setData(integerToString(temp*250));
	timeOut.checkCommand(temp+200, 1);

	myMenu = new PopupMenu;
	myMenu.addSubMenu(timeIn, "Fade In Time");
	myMenu.addSubMenu(timeStay, "Stay Time");
	myMenu.addSubMenu(timeOut, "Fade Out Time");
	
	menuOpen = true;
	int a = myMenu.popAtMouse();
	menuOpen = false;
	
	delete myMenu;
	delete timeIn;
	delete timeStay;
	delete timeOut;
	
	if(a<1) return;
	else if(a<100){
		notifier_fadeintime_attrib.setData(integerToString(a*250));
	}
	else if(a<200){
		notifier_holdtime_attrib.setData(integerToString((a-100)*250));
	}
	else if(a<300){
		notifier_fadeouttime_attrib.setData(integerToString((a-200)*250));
	}
	onNext(); // Post cPro2 removed
}



//BUGFIX remove this timer later
fallbackTempFix.onTimer() //As soon as this timer run, bug mode is ON ;)
{
	if (checkPref(0)) return;

	if (!notifier_layout) onNext();

	if(!triggerBug)
	{
		triggerBug = true;

		onAlbumArt(cover.isInvalid()); //First time whe see the bug
		fallbackTempFix.setDelay(30);
	}
	else if(triggerBug && !cover.isLoading()) onAlbumArt(cover.isInvalid());
}

onAlbumArt(Boolean success){
	fallbackTempFix.stop(); //BUGFIX remove later

	if (!handleAACalback || !notifier_layout /*|| isLoading()*/)
	{
		return;
	}

	handleAACalback = cover.isLoading();
	cancelAnimation();
	showNotifier(fillNextTrackInfo(cur_status));
}


//----------------------------------------------------------------------------------------------------------------
// Rating System
//----------------------------------------------------------------------------------------------------------------

System.onCurrentTrackRated (int rating)
{
	refreshRating(rating);
}

refreshRating (int rating)
{
	rate1.setActivated(rating >= 1);
	rate2.setActivated(rating >= 2);
	rate3.setActivated(rating >= 3);
	rate4.setActivated(rating >= 4);
	rate5.setActivated(rating >= 5);
}


Mousetrap.onEnterArea(){ // v1.1
  if (notifier_holdopen_attrib.getData() == "1"){
    cancelAnimation();
  }
  else {
    // Do nothing
  }

  CloseNotification.show();
	//return 1;
}

Mousetrap.onLeaveArea(){ // v1.1
  if (notifier_holdopen_attrib.getData() == "1"){
    /*int notifw = notifier_layout.getWidth();
    if (notifier_layout.getGuiY() < 150 || notifier_layout.getGuiX() > notifw || notifier_layout.getAlpha() < 252) // v1.1: (Learning) Nice alt way to know if an animation hasn't reached it's target
    {
      notifier_layout.gotoTarget();
    }*/
    
    //notifier_timer.setDelay(0);
    //notifier_timer.start(); // These timer resets the animation, which is not wanted, I want to keep the animation already selected
    
    notifier_layout.gotoTarget();
  }
  else {
    // Do nothing
  }


  if (Mousetrap.isMouseOverRect())
  {
    CloseNotification.show();
    //return 1;
  }
  else
  {
    CloseNotification.hide();
  	//return 0;
  }

}

Mousetrap.onLeftClick () {
	if (notifier_opennowplaying_attrib.getData() == "1")
  {
    String artist = getArtist();
    string lv_songticker = getPlayItemDisplayTitle(); // v1.1 added
    
    if (artist == "") return;
    
    if (use_browser_attrib.getdata() == "1")
    {
        if (getPlayItemMetaDataString("streamtype") == "1" || System.isVideo())
          {          
          if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ lv_songticker);
          else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ lv_songticker);
          return;
          }
              
              else
              {
              if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(artist));
              else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(artist));
              return;
              }
        cancelAnimation();
    }
  
      if (use_reader_attrib.getdata() == "1")
      {
        cancelAnimation();
        restoreApplication();
        activateApplication();
        
            if (getPlayItemMetaDataString("streamtype") == "1" || System.isVideo())
            {
  
            getContainer("main").switchToLayout("normal");
            group sui = getContainer("main").getLayout("normal").findObject("sui.content");

            sui.sendAction ("browser_search", lv_songticker, 0, 0, 0, 0);
            return;
            }
            
              else
              {
              getContainer("main").switchToLayout("normal");
              group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
              sui.sendAction ("browser_search", artist, 0, 0, 0, 0);
              return;
              }
      }
	}

	
	/*if (notifier_openapp_attrib.getData() == "1")
	{
    cancelAnimation();
    restoreApplication();
    activateApplication();

    reset();
	}*/ // v1.1: Removed, conflicting behaviour to trigger from Mousetrap (works fine from notifier_layout). Used click_to_layout(); instead
	
  if (notifier_closenotification_attrib.getData() == "1")
	{
   notifier_container.hide(); // v1.1: Fixed
	}
}

Mousetrap.onLeftButtonUp(int x, int y){ // v1.1
    click_to_layout();
}

click_to_layout(){ // v1.1
if (notifier_openapp_attrib.getData() == "1")
	{
    cancelAnimation();
    restoreApplication();
    activateApplication();
	}
}


CloseNotification.onleftClick()
{
  cancelAnimation();
	reset();
	complete;
	return;
}



notifier_layout.onEnterArea(){ // v1.15
  if (notifier_layout.isMouseOverRect())
  {
    CloseNotification.show();
    //return 1;
  }
  else
  {
    CloseNotification.hide();
  	//return 0;
  }
}

notifier_layout.onLeaveArea(){ // v1.15
  if (notifier_layout.isMouseOverRect())
  {
    CloseNotification.show();
    //return 1;
  }
  else
  {
    CloseNotification.hide();
  	//return 0;
  }
}


Mousetrap.onEnterArea(){ // v1.15
  if (Mousetrap.isMouseOverRect())
  {
    CloseNotification.show();
    //return 1;
  }
  else
  {
    CloseNotification.hide();
  	//return 0;
  }
}

Mousetrap.onLeaveArea(){ // v1.15
  if (Mousetrap.isMouseOverRect())
  {
    CloseNotification.show();
    //return 1;
  }
  else
  {
    CloseNotification.hide();
  	//return 0;
  }
}