/*---------------------------------------------------
-----------------------------------------------------

Author:		Victhor
E-Mail:		victorbrorcaz@gmail.com
Web:	www.victhor.deviantart.com


NOTE: Based on Skin Consortium's MSPP skin engine.

-----------------------------------------------------
---------------------------------------------------*/


#include "std.mi"
#include "lib/application.mi"
#include "lib/pldir.mi"
#include "attribs/init_playlist.m"

#define JTF_GUID "{5F8D8373-EAA7-4390-B5AB-402E86A5F9DD}"

Global Group ScriptGroup, GhostPlaylistGroup;
Global Button savePl, pasteToML, searchPl, viewPl, MPlaylist1, OpenPl;
Global GuiObject SongTicker, BGPlaylistinfoFiller, BGPlaylistinfoFiller2;
Global Text PLInfoTitle, PLInfoViewPLs, PLInfo;
Global Windowholder GhostPlaylist;


System.onScriptLoaded() {

  initAttribs_Playlist();
  
  ScriptGroup = getScriptGroup();
  savePl = ScriptGroup.findObject("pltools.save");
  MPlaylist1 = ScriptGroup.findObject("m.playlist1");
  PLInfoTitle = ScriptGroup.findObject("pl.info.title2"); // v1.1 added
  PLInfoViewPLs = ScriptGroup.findObject("pl.info.view.pls"); // v1.1 added
  ViewPl = ScriptGroup.findObject("pltools.view"); // v1.1 added
  BGPlaylistinfoFiller = ScriptGroup.findObject("bg.playlistinfo.filler"); // v1.1 added
  BGPlaylistinfoFiller2 = ScriptGroup.findObject("bg.playlistinfo.filler2"); // v1.1 added
  OpenPl = ScriptGroup.findObject("pltools.pl"); // v1.1 added
  PLInfo = ScriptGroup.findObject("pl.info.pl"); // v1.1 added

  GhostPlaylistGroup = ScriptGroup.findObject("playlist.info.data");
	GhostPlaylist = GhostPlaylistGroup.findObject("ghost.playlist");
	  
  SongTicker = ScriptGroup.getParentLayout().findObject("songticker");
}

scriptGroup.onSetVisible(int on) {
	if (on)
	{
    pasteToML = ScriptGroup.findObject("pltools.import2lib");
    searchPl = ScriptGroup.findObject("pltools.search");
    viewPl = ScriptGroup.findObject("pltools.view");
  }


  // v1.1: Custom X and W to work better with French lang
  
  if (getLanguageId() == "en-US" || getLanguageId() == "en-GB" || getLanguageId() == "es-US" || getLanguageId() == "pl-PL")
  {
    MPlaylist1.setXmlParam("x", "436");
    MPlaylist1.setXmlParam("w", "225");
    MPlaylist1.setXmlParam("image", "pl.info.button.otherpls.n");
    MPlaylist1.setXmlParam("hoverimage", "pl.info.button.otherpls.h");
    MPlaylist1.setXmlParam("downimage", "pl.info.button.otherpls.d");
    PLInfoTitle.setXmlParam("x", "453");
    PLInfoViewPLs.setXmlParam("x", "453");
    ViewPl.setXmlParam("x", "436");
    ViewPl.setXmlParam("w", "225");
    ViewPl.setXmlParam("image", "pl.info.button.viewpls.n");
    ViewPl.setXmlParam("hoverimage", "pl.info.button.viewpls.h");
    ViewPl.setXmlParam("downimage", "pl.info.button.viewpls.d");
    BGPlaylistinfoFiller.setXmlParam("w", "430");
    BGPlaylistinfoFiller2.setXmlParam("x", "432");
    OpenPl.setXmlParam("x", "436");
    OpenPl.setXmlParam("w", "225");
    OpenPl.setXmlParam("image", "pl.info.button.viewpls.n");
    OpenPl.setXmlParam("hoverimage", "pl.info.button.viewpls.h");
    OpenPl.setXmlParam("downimage", "pl.info.button.viewpls.d");
    PLInfo.setXmlParam("x", "453");
  }
  else
    {
    MPlaylist1.setXmlParam("x", "516");
    MPlaylist1.setXmlParam("w", "315");
    MPlaylist1.setXmlParam("image", "pl.info.button.otherpls.n2");
    MPlaylist1.setXmlParam("hoverimage", "pl.info.button.otherpls.h2");
    MPlaylist1.setXmlParam("downimage", "pl.info.button.otherpls.d2");
    PLInfoTitle.setXmlParam("x", "533");
    PLInfoViewPLs.setXmlParam("x", "533");
    ViewPl.setXmlParam("x", "516");
    ViewPl.setXmlParam("w", "315");
    ViewPl.setXmlParam("image", "pl.info.button.viewpls.n2");
    ViewPl.setXmlParam("hoverimage", "pl.info.button.viewpls.h2");
    ViewPl.setXmlParam("downimage", "pl.info.button.viewpls.d2");
    BGPlaylistinfoFiller.setXmlParam("w", "510");
    BGPlaylistinfoFiller2.setXmlParam("x", "512");
    OpenPl.setXmlParam("x", "516");
    OpenPl.setXmlParam("w", "315");
    OpenPl.setXmlParam("image", "pl.info.button.viewpls.n2");
    OpenPl.setXmlParam("hoverimage", "pl.info.button.viewpls.h2");
    OpenPl.setXmlParam("downimage", "pl.info.button.viewpls.d2");
    PLInfo.setXmlParam("x", "533");
  }

}

savePl.onLeftClick(){
  String skinpath = Application.GetApplicationPath()+ "\Skins\Big Bento Modern Windows 10 edition\scripts\shortcuts\bbm_sendmessage_40204.exe";
  
  navigateURL(skinpath);
  SongTicker.sendAction("showinfo", "Save current playlist", 0, 0, 0, 0);
}

OpenPl.onLeftButtonDown(int x, int y){ // v1.1: Here I hide a "Ghost playlist" so I can trigger PL normally
    GhostPlaylist.hide();
    OpenPl.setxmlParam("action", "--"); // v1.1: Disable button action temporarily
}

OpenPl.onLeftButtonUp(int x, int y){
    OpenPl.setxmlParam("action", "toggle"); // v1.1: Enable button action (till next click)
}

pasteToML.onLeftClick(){
  group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  sui.sendAction ("opentab", "ml", 0, 0, 0, 0);
  
  String skinpath = Application.GetApplicationPath()+ "\Skins\Big Bento Modern Windows 10 edition\scripts\shortcuts\bbm_sendmessage_40374.exe";

  navigateURL(skinpath);
  SongTicker.sendAction("showinfo", "Playlist imported on Media Library", 0, 0, 0, 0);
}

searchPl.onLeftClick(){
  String skinpath = Application.GetApplicationPath()+ "\Skins\Big Bento Modern Windows 10 edition\scripts\shortcuts\bbm_sendmessage_40318.exe";
    
  navigateURL(skinpath);
}


viewPl.onLeftClick(){
  group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  sui.sendAction ("opentab", "ml", 0, 0, 0, 0);
    
  String skinpath = Application.GetApplicationPath()+ "\Skins\Big Bento Modern Windows 10 edition\scripts\shortcuts\bbm_sendmessage_40377.exe";
  navigateURL(skinpath);
  
  SongTicker.sendAction("showinfo", "Viewing Saved Playlists", 0, 0, 0, 0);  
}


MPlaylist1.onLeftClick(){
	Popupmenu mlplMenu = new popupMenu;
	int c;
		
	//mlplMenu.addCommand("Playlists", -1, 0, 1);
	//mlplMenu.addSeparator();
	if (PlDir) {
		int numPL = PlDir.getNumItems();
		if (numPL<=0)
			mlplMenu.addCommand("no playlist found", -1, 0, 1);
		else {
			for (c=1; c <=numPL; c++) {
				mlplMenu.addCommand(PlDir.getItemName(c-1),399+c, 0, 0);
			}
		}
	} else {
		mlplMenu.addCommand("feature requires WA 5.51+", -1, 0, 1);
	}

	int result = mlplMenu.popAtXY(clientToScreenX(MPlaylist1.getLeft())+0, clientToScreenY(MPlaylist1.getTop())+31);

	delete mlplMenu;

}