/*************************************************************
  progbutton.m by Leechbite extracted from Kameleon + Vic mods (2017)

  Script for the programmable button.
  
  param = "buttonID,orogbuttonID,default"
  
  buttonID - button ID. im using right now XUI objects so should be the XUI id.
  progbuttonID - used to identify one programmable button from another. mainly
  				used for the privateString variables. buttons with same
  				progbuttonID will have same programmed function.
  default - default programmed button.
  			e.g. "EQ|Rock" or "PATH|http://www.leechbite.com/radio.nsv|Station Name"
  
*************************************************************/

#include "std.mi"
#include "lib/pldir.mi"
#include "lib/application.mi"
#include "eq-utilities.m"
#include "lib/com/songinfo.m"
#include "attribs/init_browser.m"


Function songinfo_reload();

function string getCurrProg();
function bookmarkCurrent();
function addpathURL();
function setToEQPreset(int preset);
function setToolTip();

function setToAOT();
function setToOpen();

function string pathToURL(string path); // converts local path to URL, nasty workaraound for a WA bug. thanks sLob.

Global group scriptGroup;
Global button progbutton;
Global button progbuttonActive1, progbuttonActive2, progbuttonActive3, progbuttonActive4, progbuttonActive5, progbuttonActive6, progbuttonActive7, progbuttonActive8, progbuttonActive9;
Global button progbutton1, progbutton2, progbutton3, progbutton4, progbutton5, progbutton6, progbutton7, progbutton8, progbutton9;
Global string buttonID, defaultProg;
Global Button ProgButtonOpen;
Global PlEdit PeListener;

Global Togglebutton ToggleAlwaysOnTop;
Global Button progbuttonActiveOpen;

Global GuiObject SongTicker;

Global container queryPathURLCont;
Global layout queryPathURLLayout;
Global button queryPathURLOKButton, queryPathURLCANCELButton;
Global edit queryPathURLEditBox,queryNameEditBox;

System.onScriptLoaded() {

	initAttribs_browser();
  
	scriptGroup = getScriptGroup();
  SongTicker = scriptGroup.getParentLayout().findObject("songticker");

	string param = getParam();

  progbutton1	= scriptGroup.getObject("prog.button.1");
  progbutton2	= scriptGroup.getObject("prog.button.2");
  progbutton3	= scriptGroup.getObject("prog.button.3");
  progbutton4	= scriptGroup.getObject("prog.button.4");
  progbutton5	= scriptGroup.getObject("prog.button.5");
  progbutton6	= scriptGroup.getObject("prog.button.6");
  progbutton7	= scriptGroup.getObject("prog.button.7");
  progbutton8	= scriptGroup.getObject("prog.button.8");
  progbutton9	= scriptGroup.getObject("prog.button.9");
  
  progbuttonActive1	= scriptGroup.getObject("prog.button.active.1");
  progbuttonActive2	= scriptGroup.getObject("prog.button.active.2");
  progbuttonActive3	= scriptGroup.getObject("prog.button.active.3");
  progbuttonActive4	= scriptGroup.getObject("prog.button.active.4");
  progbuttonActive5	= scriptGroup.getObject("prog.button.active.5");
  progbuttonActive6	= scriptGroup.getObject("prog.button.active.6");
  progbuttonActive7	= scriptGroup.getObject("prog.button.active.7");
  progbuttonActive8	= scriptGroup.getObject("prog.button.active.8");
  progbuttonActive9	= scriptGroup.getObject("prog.button.active.9");

  
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
  
	ProgButtonOpen = scriptGroup.getParentLayout().findObject("progbutton.open");
	ToggleAlwaysOnTop = scriptGroup.getParentLayout().findObject("progbutton.always.on.top");
		

  if (objID2 == "")
		progbutton = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		progbutton = temp.getObject(objID2); 
	}
	
	buttonID = getToken(param,",",1);
	defaultProg = getToken(param,",",2);

  if (scriptGroup.isVisible() == 1) setToolTip();
}

System.onScriptUnloading() {
  return;
}

scriptGroup.onSetVisible(int on) {
	if (on) setTooltip();
}

string getCurrProg() {
	string currProg = getPrivateString("Big Bento Modern Windows 10 edition", buttonID, "Default");
	if (currProg=="Default") currProg = defaultProg;
	
	string ret = "";
	string progmode = strupper(getToken(currProg, "|", 0));
	
    
	if (progmode == "PATH") {
		string path = getToken(currProg, "|", 1);
		if (strlen(path) > 30) {
			path = strleft(path, 13)+" .. "+removePath(path);
    	}
      ret = translate("Open") + " " + "[ " + path + " ]";
      }
		
		else if (progmode == "EQ") {
		ret = translate("EQ Preset") + " " + ":" + " " +getToken(currProg, "|", 1);
    }
  
    else if (progmode == "BOOKMARK") {
		ret = translate("Bookmark Current Item");
    }
  
	else if (progmode == "INET") {
		string mode = getToken(currProg, "|", 1);
		if (mode=="MOREINFO")
			ret = translate("Search More Info About current Artist");
		else if (mode=="LYRICS")
			ret = translate("Search Lyrics for current track");
		else if (mode=="YOUTUBE")
			ret = translate("Search Youtube video");
		else if (mode=="ALBUMCOVER")
			ret = translate("Search Album Cover");
    }
      else if (progmode == "MLPL") {
      ret = translate("Playlist") + ": " +getToken(currProg, "|", 1);
      }
      else if (progmode == "SHOUTCASTHP") {
      ret = translate("SHOUTcast Homepage");
      }
      else if (progmode == "AOT") {
      ret = translate("Button: Always on Top");
      }
      else if (progmode == "OPENBUTTON") {
      ret = translate("Button: Open File(s)");
      }
      else if (progmode == "SKINS") {
      ret = translate("Folder > Winamp Skins");
      }
      else if (progmode == "MILKDROP") {
      ret = translate("Folder > Milkdrop2 Presets");
      }
      else if (progmode == "AVS") {
      ret = translate("Folder > AVS Presets");
      }
      else if (progmode == "WINAMPFOLDER") {
      ret = translate("Folder > Winamp install folder");
      }
      else if (progmode == "VBOOKMARKS") {
      ret = translate("View Bookmarks");
      }
	return ret;
}


string pathToURL(string path) {
	int c, len = strlen(path);
	string ret = "", char;

	
	c=0;
	while (c < len) {
		char = strmid(path,c,1);
		if (char==chr(92)) {
			ret = ret + chr(47);
			c ++;
		} else if (char==":") {
			ret = ret + ":";
			c ++;
			
			char = strmid(path,c,1);
			if (char==chr(92)) {
				ret = ret + chr(47) + chr(47);
				c ++;
			}
		} else {
			ret = ret + char;
			c++;
		}
	}
	
	return ret;
}

progbutton.onLeftClick() {
	string currProg = getPrivateString("Big Bento Modern Windows 10 edition", buttonID, "Default");
	if (currProg=="Default") currProg = defaultProg;
	string progmode = strupper(getToken(currProg, "|", 0));
 
	
	if (currProg == "Default") {
		string path = getToken(defaultProg, "|", 1);
		playFile(pathToURL(path));

	} else if (progmode == "BOOKMARK") {
		bookmarkCurrent();
	}
	
	 else if (progmode == "PATH") {
		string path = getToken(currProg, "|", 1);

    // Victhor mod to open folders instead of URLs
		System.navigateUrl(path);
	}
	
	else if (progmode == "EQ") {
		string EQPreset = strupper(getToken(currProg, "|", 1));

				
		if (EQPreset == "Full") {
			setEQPreset(EQ_Full);
		}
			else if (EQPreset == "Rock") {
			setEQPreset(EQ_Rock);
		} else if (EQPreset == "Soft") {
			setEQPreset(EQ_Soft);
		} else if (EQPreset == "Pop") {
			setEQPreset(EQ_Pop);
		} else if (EQPreset == "Dance") {
			setEQPreset(EQ_Dance);			
		} else if (EQPreset == "User") {
			setEQPresetUSER();
		} else {
			setEQPreset(EQ_Flat);
		}
		
		if (!getEQ()) setEQ(ON);
		
	}
	
	else if (progmode == "INET") {

  string mode = strupper(getToken(currProg, "|", 1));	
 
   songinfo_reload();
  
	if (mode == "MOREINFO") {
    if (use_browser_attrib.getdata() == "1")
    {
        if (songinfo_isStream || System.isVideo())
          {
          string lv_songticker = getPlayItemDisplayTitle();
          

          if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ lv_songticker);
          else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ lv_songticker);
          return;
          }
              
              else
              {
              string lv_artist = getPlayItemMetaDataString("artist");
        
              if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(lv_artist));
              else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(lv_artist));
              return;
              }
    }
  
      if (use_reader_attrib.getdata() == "1")
      {
            if (songinfo_isStream || System.isVideo())
            {
            string lv_songticker = getPlayItemDisplayTitle();
        
            group sui = getContainer("main").getLayout("normal").findObject("sui.content");

            sui.sendAction ("browser_search", lv_songticker, 0, 0, 0, 0);
            return;
            }
            
              else
              {
              string lv_artist = getPlayItemMetaDataString("artist");
          
              group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
              sui.sendAction ("browser_search", lv_artist, 0, 0, 0, 0);
              return;
              }
      }
  
  

		}
		
		
			else if (mode == "LYRICS") {
        if (use_browser_attrib.getdata() == "1")
          {
              if (songinfo_isStream || System.isVideo())
                {
                string lv_songticker = getPlayItemDisplayTitle();
          

                if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ lv_songticker + " " + "lyrics");
                else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ lv_songticker + " " + "lyrics");
                return;
                }
              else
              {
                string lv_artist = getPlayItemMetaDataString("artist");
                string lv_title = getPlayItemMetaDataString("title");
                if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title) + " " + "lyrics");
                else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/search?q="+ urlEncode(lv_artist) + " " + urlEncode(lv_title) + " " + "lyrics");
                return;
              }
          }
    
            if (use_reader_attrib.getdata() == "1")
            {
                  if (songinfo_isStream || System.isVideo())
                  {
                  string lv_songticker = (getPlayItemDisplayTitle() + " " + "lyrics");
              
                  group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      
                  sui.sendAction ("browser_search", lv_songticker, 0, 0, 0, 0);
                  return;
                  }
                    else
                    {
                    string lv_artist = getPlayItemMetaDataString("artist");
                    string lv_title = getPlayItemMetaDataString("title");
  
                    string searchv = (urlEncode(lv_artist) + " " + urlEncode(lv_title) + " " + "lyrics");
          
                    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
                    sui.sendAction ("browser_search", searchv, 0, 0, 0, 0);
                    return;
                    }
            }
            
		}
      else if (mode == "YOUTUBE") {
        if (use_browser_attrib.getdata() == "1")
          {
              if (songinfo_isStream || System.isVideo())
                {
                string lv_songticker = getPlayItemDisplayTitle();
          
                System.navigateUrl ("www.youtube.com/results?search_query="+ urlEncode(lv_songticker));
                return;
                }
              else
                {
                System.navigateUrl("www.youtube.com/results?search_query="+ urlEncode(songinfo_artist) + " " + urlEncode(songinfo_title));
                return;
                }
          }
    
            if (use_reader_attrib.getdata() == "1")
            {
                  if (songinfo_isStream || System.isVideo())
                  {
                  string lv_songticker = getPlayItemDisplayTitle();
                  string searchlv = ("www.youtube.com/results?search_query="+ urlEncode(lv_songticker));
              
                  group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      
                  sui.sendAction ("browser_navigate", searchlv, 0, 0, 0, 0);
                  return;
                  }
                    else
                    {
                    string searchv = ("www.youtube.com/results?search_query="+ urlEncode(songinfo_artist) + " " + urlEncode(songinfo_title));
          
                    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
                    sui.sendAction ("browser_navigate", searchv, 0, 0, 0, 0);
                    return;
                    }
            }
		}
		
      else if (mode == "ALBUMCOVER") {


        if (use_browser_attrib.getdata() == "1")
          {
              if (songinfo_isStream || System.isVideo())
                {
                string lv_songticker = getPlayItemDisplayTitle();
          
                if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?tbm=isch&q="+ lv_songticker + " " + "cover");
                else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/?scope=images&FORM=Z9LH1&q="+ lv_songticker + " " + "cover");
                return;
                }
              else
              {
                string lv_artist = getPlayItemMetaDataString("artist");
                string lv_album = getPlayItemMetaDataString("album");
                
                if (search_google_attrib.getdata() == "1") System.navigateUrl("www.google.com/search?tbm=isch&q="+ urlEncode(lv_artist) + " " + urlEncode(lv_album) + " " + "cover");
                else if (search_bing_attrib.getdata() == "1") System.navigateUrl("www.bing.com/?scope=images&FORM=Z9LH1&q="+ urlEncode(lv_artist) + " " + urlEncode(lv_album) + " " + "cover");
                return;
              }
          }
    
            if (use_reader_attrib.getdata() == "1")
            {
                  if (songinfo_isStream || System.isVideo())
                  {
                  string lv_songticker = getPlayItemDisplayTitle();
                  
                  if (search_google_attrib.getdata() == "1") string searchv = ("www.google.com/search?tbm=isch&q="+ lv_songticker + " " + "cover");
                  else if (search_bing_attrib.getdata() == "1") string searchv = ("www.bing.com/?scope=images&FORM=Z9LH1&q="+ lv_songticker + " " + "cover");
              
                  group sui = getContainer("main").getLayout("normal").findObject("sui.content");
      
                  sui.sendAction ("browser_navigate", searchv, 0, 0, 0, 0);
                  return;
                  }
                    else
                    {
                    string lv_artist = getPlayItemMetaDataString("artist");
                    string lv_album = getPlayItemMetaDataString("album");
  
                    if (search_google_attrib.getdata() == "1") string searchv = ("www.google.com/search?tbm=isch&q=" + urlEncode(lv_artist) + " " + urlEncode(lv_album) + " " + "cover");
                    else if (search_bing_attrib.getdata() == "1") string searchv = ("www.bing.com/?scope=images&FORM=Z9LH1&q=" + urlEncode(lv_artist) + " " + urlEncode(lv_album) + " " + "cover");
          
                    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
                    sui.sendAction ("browser_navigate", searchv, 0, 0, 0, 0);
                    return;
                    }
            }      
		}
		
	}
	
	else if (progmode == "MLPL") {
		string plName = getToken(currProg, "|", 1);
		int plID = stringtointeger(getToken(currProg, "|", 2));
		int numPL = PlDir.getNumItems();
		int found = FALSE;
		
		if (plID > (numPL-1)) plID = numPL-1;
		
		if (numPL > 0) {
			if (PlDir.getItemName(plID) == plName) {
				PlDir.playItem(plID);
				found = TRUE;
			} else {
				int c;
				
				for (c=1; c <=numPL; c++) {
	
					if ((PlDir.getItemName(c-1) == plName) && (!found)) {
						PlDir.playItem(c-1);
						found = TRUE;
					}
				}
	
			}
		}
				if (!found)
		{
		SongTicker.sendAction("showinfo", "Playlist not found", 0, 0, 0, 0);
		}
	}

	else if (progmode == "SHOUTCASTHP") {
    if (use_browser_attrib.getdata() == "1")
    {
      System.navigateUrl("www.shoutcast.com");
    }
  
    if (use_reader_attrib.getdata() == "1")
     {
        group sui = getContainer("main").getLayout("normal").findObject("sui.content");
  
        sui.sendAction ("browser_NAVIGATE", "www.shoutcast.com", 0, 0, 0, 0);
        return;
     }
	}	
	else if (progmode == "AOT") {
	setToAOT();
	}
	else if (progmode == "OPENBUTTON") {
	setToOpen();
	}
	else if (progmode == "SKINS") {
	String winamppath = Application.GetApplicationPath();
  System.navigateUrl(winamppath+"/skins/");
  
	}
	else if (progmode == "MILKDROP") {
	String winamppath = Application.GetApplicationPath();
  System.navigateUrl(winamppath+"/plugins/milkdrop2/presets/");  
	}
	else if (progmode == "AVS") {
	String winamppath = Application.GetApplicationPath();
  System.navigateUrl(winamppath+"/plugins/avs/");
	}
  else if (progmode == "WINAMPFOLDER") {
	String winamppath = Application.GetApplicationPath();
  System.navigateUrl(winamppath);
	}
  else if (progmode == "VBOOKMARKS") {
    String skinpath = Application.GetApplicationPath()+ "\Skins/Big Bento Modern Windows 10 edition/scripts/shortcuts/bbm_sendmessage_40320.exe";
    navigateURL(skinpath);
	}	
		
}

progbutton.onRightButtonUp(int x, int y) {
	string tooltip = getXMLParam("tooltip");
	setXMLParam("tooltip","");
	
	popupMenu progMenu, eqProgSubMenu, inetSubMenu, mlplSubMenu;
	int c;

	eqProgSubMenu = new popupMenu;
	eqProgSubMenu.addCommand("EQ Presets", -1, 0, 1);
	eqProgSubMenu.addSeparator();
	eqProgSubMenu.addCommand(" " + translate("Flat"), 100, 0, 0);
	eqProgSubMenu.addCommand(" " + translate("Full"), 101, 0, 0);
	eqProgSubMenu.addCommand(" " + translate("Rock"), 102, 0, 0);
	eqProgSubMenu.addCommand(" " + translate("Soft"), 103, 0, 0);
	eqProgSubMenu.addCommand(" " + translate("Pop"), 104, 0, 0);
	eqProgSubMenu.addCommand(" " + translate("Dance"), 106, 0, 0);	
	eqProgSubMenu.addCommand(" " + translate("User"), 105, 0, 0);
	
	inetSubMenu = new popupMenu;
	inetSubMenu.addCommand("Internet Search", -1, 0, 1);
	inetSubMenu.addSeparator();
	inetSubMenu.addCommand(" " + translate("More Artist Info"), 300, 0, 0);
	inetSubMenu.addCommand(" " + translate("Search Lyrics for current track"), 301, 0, 0);
	inetSubMenu.addCommand(" " + translate("Search Youtube video"), 302, 0, 0);
	inetSubMenu.addCommand(" " + translate("Search Album Cover"), 303, 0, 0);
	
	mlplSubMenu = new popupMenu;
	mlplSubMenu.addCommand("Playlists", -1, 0, 1);
	mlplSubMenu.addSeparator();
	if (PlDir) {
		int numPL = PlDir.getNumItems();
		if (numPL<=0)
			mlplSubMenu.addCommand("no playlist found", -1, 0, 1);
		else {
			for (c=1; c <=numPL; c++) {
				mlplSubMenu.addCommand(PlDir.getItemName(c-1),399+c, 0, 0);
			}
		}
	} else {
		mlplSubMenu.addCommand("feature requires WA 5.51+", -1, 0, 1);
	}
	
	progMenu = new popupMenu;
	progMenu.addCommand(translate("Custom Button ")+buttonID, -1, 0, 1);
	progMenu.addCommand(":: "+getCurrProg(), -2, 0, 1);
	progMenu.addSeparator();
	progMenu.addCommand(" " + translate("Open Folder or URL"), 2, 0, 0);
	progMenu.addCommand(" " + translate("Bookmark Current Item"), 1, 0, 0);
	progMenu.addCommand(" " + translate("View Bookmarks"), 606, 0, 0);
  progMenu.addCommand(" " + translate("Button: Always on Top"), 600, 0, 0);
  progMenu.addCommand(" " + translate("Button: Open File(s)"), 601, 0, 0);
  progMenu.addCommand(" " + translate("Folder > Winamp Skins"), 602, 0, 0);
  progMenu.addCommand(" " + translate("Folder > Milkdrop2 Presets"), 603, 0, 0);
  progMenu.addCommand(" " + translate("Folder > AVS Presets"), 604, 0, 0);
  progMenu.addCommand(" " + translate("Folder > Winamp install folder"), 605, 0, 0);
  progMenu.addCommand(" " + translate("SHOUTCast Homepage"), 607, 0, 0);
	progMenu.addSubMenu(eqProgSubMenu, " " + translate("Equalizer Preset"));
	progMenu.addSubMenu(inetSubMenu," " + translate("Internet Search"));
	progMenu.addSubMenu(mlplSubMenu," " + translate("Playlists"));
  progMenu.addSeparator();
	progMenu.addCommand(" " + translate("Reset to default"), 99, 0, 0);
	
	//int res = progMenu.popAtMouse();
	int res = progMenu.popAtXY(clientToScreenX(progbutton.getLeft())+0, clientToScreenY(progbutton.getTop()+progbutton.getHeight())+2);
	delete mlplSubMenu;
	delete inetSubMenu;
	delete eqProgSubMenu;
	delete progMenu;
	
	if (res == 1) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "BOOKMARK");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Bookmark Current Item"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 2) {
		addpathURL();
	} else if (res >= 100 && res < 200) {
		setToEQPreset(res);
    progbutton.setActivated(true);
	} else if (res == 300) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "INET|MOREINFO");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Search More Info About current Artist"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 301) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "INET|LYRICS");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Search Lyrics for current track"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 302) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "INET|YOUTUBE");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Search Youtube video"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 303) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "INET|ALBUMCOVER");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("search Album Cover"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 99) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "Default");
    SongTicker.sendAction("showinfo", "Default Custom button Restored", 0, 0, 0, 0); 
    progbutton.setActivated(false);
	} else if (res >= 400 && res < 500) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "MLPL|"+PlDir.getItemName(res-400)+"|"+integerToString(res-400));
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("open") + " " + translate("Playlist") + ": " + PlDir.getItemName(res-400), 0, 0, 0, 0);
    progbutton.setActivated(true);
	} else if (res == 600) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "AOT");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Button: Always on Top"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
	else if (res == 601) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "OPENBUTTON");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Button: Open File(s)"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
	else if (res == 602) {
		SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Folder > Winamp Skins"), 0, 0, 0, 0);
    
    setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "SKINS");
    progbutton.setActivated(true);
	}
	else if (res == 603) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "MILKDROP");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Folder > Milkdrop2 Presets"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
	else if (res == 604) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "AVS");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Folder > AVS Presets"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}	
		else if (res == 605) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "WINAMPFOLDER");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("Folder > Winamp install folder"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
		else if (res == 606) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "VBOOKMARKS");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("View Bookmarks"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
    else if (res == 607) {
		setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "SHOUTCASTHP");
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("SHOUTcast Homepage"), 0, 0, 0, 0);
    progbutton.setActivated(true);
	}
		
	setToolTip();
		
	complete;
}

setToolTip() {
	string currProg = getPrivateString("Big Bento Modern Windows 10 edition", buttonID, defaultProg);
	if (currProg=="Default") currProg = defaultProg;
	string progmode = strupper(getToken(currProg, "|", 0));
	string tip = "";
	
	if (progmode == "PATH") {
		string path = getToken(currProg, "|", 1);
		string protocol = strlower(getToken(path, "://", 0));
		tip = getToken(currProg, "|", 2);

		if (tip=="") {
			if (protocol == "http" || protocol == "mms")
				tip = "Internet Radio";
			else
				tip = removePath(path);
		}
	} 
  else if (progmode == "BOOKMARK") {
		tip = translate("Bookmark Current Item");
		}
	else if (progmode == "EQ") {
		tip = translate("EQ Preset") + " " + ":" + " " +getToken(currProg, "|", 1);
	} else if (progmode == "INET") {
		string mode = getToken(currProg, "|", 1);
		if (mode=="MOREINFO") {
			tip = translate("Search More Info About current Artist");
  }
		else if (mode=="LYRICS") {
			tip = translate("Search Lyrics for current track");
  }
		else if (mode=="YOUTUBE") {
			tip = translate("Search Youtube video");
			}
		else if (mode=="ALBUMCOVER") {
			tip = translate("Search Album Cover");
  }
		else
			tip = mode;
	}
	else if (progmode == "MLPL") {
		tip = translate("Playlist") + ": " +getToken(currProg, "|", 1);
	}
		else if (progmode == "SHOUTCASTHP") {
		tip = translate("SHOUTcast Homepage");
	}
	else if (progmode == "AOT") {
		tip = translate("Button: Always on Top");
	}
	else if (progmode == "OPENBUTTON") {
		tip = translate("Button: Open File(s)");
	}
	else if (progmode == "SKINS") {
		tip = translate("Folder > Winamp Skins");
	}
	else if (progmode == "MILKDROP") {
		tip = translate("Folder > Milkdrop2 Presets");
  	}
	else if (progmode == "AVS") {
		tip = translate("Folder > AVS Presets");
		}
  else if (progmode == "WINAMPFOLDER") {
		tip = translate("Folder > Winamp install folder");
		}
  else if (progmode == "VBOOKMARKS") {
		tip = translate("View Bookmarks");
		}
	progButton.setXMLParam("tooltip", tip+translate(" | Right-click to customize button"));
}

bookmarkCurrent() {
  String skinpath = Application.GetApplicationPath()+ "\Skins/Big Bento Modern Windows 10 edition/scripts/shortcuts/bbm_sendMessage_40321.exe";
    
  navigateURL(skinpath);
}

addpathURL() {
	if (isObjectValid(queryPathURLCont)) { // if already open, dont reopen
		layout queryPathURLLayout = queryPathURLCont.enumLayout(0);
		queryPathURLLayout.setFocus();
		queryPathURLLayout.center();
		return;
	}
	
	queryPathURLCont = newDynamicContainer("query.pathurl");
	if (queryPathURLCont) {
		queryPathURLCont.show();
		queryPathURLLayout = queryPathURLCont.getLayout("normal");
		queryPathURLLayout.center();
		queryPathURLOKButton = queryPathURLLayout.findObject("ok");
		queryPathURLCANCELButton = queryPathURLLayout.findObject("cancel");
		queryPathURLEditBox = queryPathURLLayout.findObject("pathurl.editbox");
		queryNameEditBox = queryPathURLLayout.findObject("medianame.editbox");
	}
}

queryPathURLCANCELButton.onLeftClick() {
    progbutton.setActivated(false);
}

queryPathURLOKButton.onLeftClick() {
	if (queryPathURLEditBox.getText()=="") return;
	setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "PATH|"+queryPathURLEditBox.getText()+"|"+queryNameEditBox.getText());
	queryPathURLCont.close();
	queryPathURLCont = NULL;

  SongTicker.sendAction("showinfo", translate("Open Folder or URL") + " " + queryPathURLEditBox.getText(), 0, 0, 0, 0);
  progbutton.setActivated(true);
	setToolTip();
	//PlEdit.enqueueFile(queryPathURLEditBox.getText()); //This line alone makes the button behave like a Set bookmark (folder-album!)
	//To play added item something like this can be used:
  
  // int totaltracks = PlEdit.getNumTracks(); //Gets the total number of tracks BEFORE adding the new ones
  
  // PlEdit.PlayFile(integerToString(totaltracks)+1) // "+1" is to point to the new one

  //And like this I could get the album art (taken from coverflow maki)

  // Class GuiObject AlbumCover; (is this necessary?)
  // Global AlbumCover Newone;
  // Global String snextone;
  // snextone = PlEdit.getNumTracks()+1; or // snextone = totaltracks+1;
  // Newone.setXmlParam("source", snextone);
}

queryPathURLEditBox.onEnter() {
	queryNameEditBox.setFocus();
}

queryNameEditBox.onEnter() {
	queryPathURLOKButton.onLeftClick();
}

setToEQPreset(int preset) {
	string EQPresetName = "";
	if (preset == 101)
		{ EQPresetName = "Full";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("FUll"), 0, 0, 0, 0); }
	else if (preset == 102)
		{ EQPresetName = "Rock";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("Rock"), 0, 0, 0, 0); }
	else if (preset == 103)
		{ EQPresetName = "Soft";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("Soft"), 0, 0, 0, 0); }
	else if (preset == 104)
		{ EQPresetName = "Pop";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("Pop"), 0, 0, 0, 0); }
  else if (preset == 106)
    { EQPresetName = "Dance";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("Dance"), 0, 0, 0, 0); }
	else if (preset == 105)
		{ EQPresetName = "User";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("User"), 0, 0, 0, 0); }
	else
		{ EQPresetName = "Flat";
    SongTicker.sendAction("showinfo", translate("Custom Button set to") + " " + translate("EQ Preset") + ": " + translate("Flat"), 0, 0, 0, 0); }
		
	setPrivateString("Big Bento Modern Windows 10 edition", buttonID, "EQ|"+EQPresetName);
}

setToAOT() {
  ToggleAlwaysOnTop.leftClick();
	SongTicker.sendAction("showinfo", "Always On Top Toggled", 0, 0, 0, 0);
}

setToOpen() {
  ProgButtonOpen.leftClick();
}


progbutton1.onActivate(int activated)
{
  progbutton1.getActivated();
  
  if ((progbutton1.getActivated()) == 1) { progbuttonActive1.setAlpha(253); progbuttonActive1.setXmlParam("image", "icon.tools.active.row1");}
  else if ((progbutton1.getActivated()) == 0) { progbuttonActive1.setAlpha(0); progbuttonActive1.setXmlParam("image", "none");}
}

progbutton2.onActivate(int activated)
{
  progbutton2.getActivated();
  
  if ((progbutton2.getActivated()) == 1) { progbuttonActive2.setAlpha(253); progbuttonActive2.setXmlParam("image", "icon.tools.active.row2"); }
  else if ((progbutton2.getActivated()) == 0) { progbuttonActive2.setAlpha(0); progbuttonActive2.setXmlParam("image", "none"); }
}

progbutton3.onActivate(int activated)
{
  progbutton3.getActivated();
  
  if ((progbutton3.getActivated()) == 1) { progbuttonActive3.setAlpha(253); progbuttonActive3.setXmlParam("image", "icon.tools.active.row3"); }
  else if ((progbutton3.getActivated()) == 0) { progbuttonActive3.setAlpha(0); progbuttonActive3.setXmlParam("image", "none"); }
}

progbutton4.onActivate(int activated)
{
  progbutton4.getActivated();
  
  if ((progbutton4.getActivated()) == 1) { progbuttonActive4.setAlpha(253); progbuttonActive4.setXmlParam("image", "icon.tools.active.row1"); }
  else if ((progbutton4.getActivated()) == 0) { progbuttonActive4.setAlpha(0); progbuttonActive4.setXmlParam("image", "none"); }
}

progbutton5.onActivate(int activated)
{
  progbutton5.getActivated();
  
  if ((progbutton5.getActivated()) == 1) { progbuttonActive5.setAlpha(253); progbuttonActive5.setXmlParam("image", "icon.tools.active.row2"); }
  else if ((progbutton5.getActivated()) == 0) { progbuttonActive5.setAlpha(0); progbuttonActive5.setXmlParam("image", "none"); }
}

progbutton6.onActivate(int activated)
{
  progbutton6.getActivated();
  
  if ((progbutton6.getActivated()) == 1) { progbuttonActive6.setAlpha(253); progbuttonActive6.setXmlParam("image", "icon.tools.active.row3"); }
  else if ((progbutton6.getActivated()) == 0) { progbuttonActive6.setAlpha(0); progbuttonActive6.setXmlParam("image", "none"); }
}

progbutton7.onActivate(int activated)
{
  progbutton7.getActivated();
  
  if ((progbutton7.getActivated()) == 1) { progbuttonActive7.setAlpha(253); progbuttonActive7.setXmlParam("image", "icon.tools.active.row1"); }
  else if ((progbutton7.getActivated()) == 0) { progbuttonActive7.setAlpha(0); progbuttonActive7.setXmlParam("image", "none"); }
}

progbutton8.onActivate(int activated)
{
  progbutton8.getActivated();
  
  if ((progbutton8.getActivated()) == 1) { progbuttonActive8.setAlpha(253); progbuttonActive8.setXmlParam("image", "icon.tools.active.row2"); }
  else if ((progbutton8.getActivated()) == 0) { progbuttonActive8.setAlpha(0); progbuttonActive8.setXmlParam("image", "none"); }
}

progbutton9.onActivate(int activated)
{
  progbutton9.getActivated();
  
  if ((progbutton9.getActivated()) == 1) { progbuttonActive9.setAlpha(253); progbuttonActive9.setXmlParam("image", "icon.tools.active.row3"); }
  else if ((progbutton9.getActivated()) == 0) { progbuttonActive9.setAlpha(0); progbuttonActive9.setXmlParam("image", "none"); }
}