/*---------------------------------------------------
-----------------------------------------------------
Filename:	load_handles.m

Type:		maki
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
Depending Files:
		scripts/suicore.maki
-----------------------------------------------------
---------------------------------------------------*/

#ifndef included
#error This script can only be compiled as a #include
#endif

#include "../attribs/init_browser.m"

Function loadSUI (string content);
Function collectComponents();

Global timer tmr_collect;

System.onScriptLoaded ()
{
	initAttribs_browser();
	
	startup = 1;
	initAttribs_windowpage();
	initAttribs_vis();
	initAttribs_Autoresize();
	initAttribs_Appearance();
	initAttribs_Playlist();
	initVideo();


	player = getContainer("main");
	normal = player.getLayout("normal");
	sui_window = normal.findObject("sui.content");
	sui_components = sui_window.findObject("sui.components");

	h = getToken(getParam(),",",0);

	sui_vis = sui_components.findObject("wdh.vis");
	sui_vis_wdh = sui_components.findObject("wdh.vis.object");
	sui_video = sui_components.findObject("wdh.video");
	sui_ml = sui_components.findObject("wdh.ml");
	sui_pl = sui_components.findObject("wdh.pl");
	sui_brw = sui_components.findObject("wdh.browser");
	sui_eq = sui_components.findObject("wdh.eq");
	sui_cfg = sui_components.findObject("wdh.config");

	switch_video = sui_window.findObject("switch.video");
	switch_vis = sui_window.findObject("switch.vis");
	switch_ml = sui_window.findObject("switch.ml");
	switch_pl = sui_window.findObject("switch.pl");
	switch_eq = sui_window.findObject("switch.eq");
	switch_brw = sui_window.findObject("switch.browser");
	switch_cfg = sui_window.findObject("switch.config");

	hide_sui = normal.getObject("sui.hide");
	show_sui = normal.getObject("sui.show");

	show_sui_tabs = sui_window.findObject("show.sui.tabs");
	show_sui_tabs_bg = sui_window.findObject("show.sui.tabs.bg");

	pe_move_top = sui_pl.findObject("pe.move.top");

	normal_resizer = normal.getObject("player.resizer.bottomright.dummy");
	normal_resizer2 = normal.getObject("player.resizer.bottomleft");
	normal_resizer3 = normal.getObject("player.resizer.bottom");
	normal_resizer4 = normal.getObject("player.resizer.bottom2");

	normal_TBresizer = normal.findObject("titlebar.resizer.topright");
	normal_TBresizer2 = normal.findObject("titlebar.resizer.topleft");
	normal_TBresizer3 = normal.findObject("titlebar.resizer.top");

	callbackTimer = new Timer;
	callbackTimer.setDelay(1);
	tempDisable = new Timer;
	tempDisable.setDelay(100);

	tmr_collect = new timer;
	tmr_collect.setDelay(2000);

	String window_content =  getPrivateString("Big Bento Modern Windows 10 edition", "Component", "Media Library");

	loadSUI(window_content);

	startup = 0;

	/*if (tabs_show_attrib.getdata() == "0") { show_sui_tabs.hide(); show_sui_tabs_bg.hide(); show_sui_tabs.setXmlParam("ghost", "1"); show_sui_tabs_bg.setXmlParam("ghost", "1"); }
	else if (tabs_show_attrib.getdata() == "1") { show_sui_tabs.show(); show_sui_tabs_bg.show(); show_sui_tabs.setXmlParam("ghost", "0"); show_sui_tabs_bg.setXmlParam("ghost", "0"); }*/ // v1.2 disabled
}

System.onScriptUnloading ()
{

	delete callbackTimer;
	delete PSOVCTimer;
	delete tempDisable;
	delete tmr_collect;
}

loadSUI (string content)
{
	if (content == "Vis")
	{
		Mychange = 1;
		vis_inbig_attrib.setData("1");
		Mychange = 0;
		switchToVis();
	}
	else if (content == "Video")
	{
		switchToVideo();
	}
	else if (content == "Media Library")
	{
		switchToMl();
	}
	else if (content == "Pledit")
	{
		switchToPl();
	}
	else if (content == "Web Reader")
	{
		switchToBrw();
	}
	else if (content == "Equalizer")
	{
		switchToEq();
	}
	else if (content == "Config")
	{
		switchToCfg();
	}
	else if (content == "Hidden")
	{
		switchToNoComp();
	}
	else
	{
		// Do nothing
	}
}