/*---------------------------------------------------
-----------------------------------------------------
Filename:	tabbutton.m
Version:	1.0

Type:		maki
Date:		28. Sep. 2007 - 13:12 
Author:		Martin Poehlmann aka Deimos + Heavy mods by Victhor to consider translations
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_appearance.m"

Global GuiObject /*normalGrid, */hoverGrid, hoverGridsm, activeGrid, footerGrid, Win10bgPatch;
Global Button mousetrap;
Global Text normalText, hoverText, activeText;
Global Boolean mouseDown;

System.onScriptLoaded ()
{
	initAttribs_Appearance();
	
	group ScriptGroup = getScriptGroup();

	//normalGrid = ScriptGroup.getObject("bento.tabbutton.normal");
	
	activeGrid = ScriptGroup.getObject("bento.tabbutton.active");
	normalText = ScriptGroup.getObject("bento.tabbutton.normal.text");
	hoverText = ScriptGroup.getObject("bento.tabbutton.hover.text");
	activeText = ScriptGroup.getObject("bento.tabbutton.active.text");
	Win10bgPatch = ScriptGroup.getObject("bento.tabbutton.win10bg.patch"); // v1.1 Win10 OCD patch
	
	hoverGrid = ScriptGroup.getObject("bento.tabbutton.hover");
	hoverGridsm = ScriptGroup.getObject("bento.tabbutton.hover.iconsonly");
 
	mousetrap = ScriptGroup.getObject("bento.tabbutton.mousetrap");

  if (activeGrid.isVisible()) Win10bgPatch.show();
  else Win10bgPatch.hide();
  
	if (tabs_icons_attrib.getData() == "1" && tabs_hide_attrib.getData() == "0" && tabs_text_attrib.getData() == "0")
  {
  hoverGrid.setXmlParam("w", "46");
  hoverGrid.sendAction("set_w", "", 46, 0 , 0, 0);
  activeGrid.setXmlParam("w", "46");
  activeGrid.sendAction("set_w", "", 46, 0 , 0, 0);
  Win10bgPatch.setXmlParam("x", "39"); // v1.1 Win10 OCD patch
  Win10bgPatch.sendAction("set_w", "", 39, 0 , 0, 0); // v1.1 Win10 OCD patch
  }
  else if (tabs_text_attrib.getData() == "1" && tabs_hide_attrib.getData() == "0" && tabs_icons_attrib.getData() == "0")
  {
    if (System.getLanguageId() == "en-US" || System.getLanguageId() == "en-GB" || System.getLanguageId() == "") // v1.2 null lang added for WACUP
    {
      hoverGrid.setXmlParam("w", "-81");
      hoverGrid.sendAction("set_w", "", -81, 0 , 0, 0);
      activeGrid.setXmlParam("w", "-81");
      activeGrid.sendAction("set_w", "", -81, 0 , 0, 0);
      Win10bgPatch.setXmlParam("x", "175"); // v1.1 Win10 OCD patch
      Win10bgPatch.sendAction("set_w", "", 175, 0 , 0, 0); // v1.1 Win10 OCD patch
    }
    else // v1.2
    {
      hoverGrid.setXmlParam("w", "0");
      hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
      activeGrid.setXmlParam("w", "0");
      activeGrid.sendAction("set_w", "", 0, 0 , 0, 0);
      Win10bgPatch.setXmlParam("x", "261"); // v1.1 Win10 OCD patch
      Win10bgPatch.sendAction("set_w", "", 261, 0 , 0, 0); // v1.1 Win10 OCD patch
    }
    //tabs_icons_attrib.setData("0");
    //tabs_hide_attrib.setData("0");
  }
  else if (tabs_hide_attrib.getData() == "1" && tabs_icons_attrib.getData() == "0" && tabs_text_attrib.getData() == "0")
  {
    hoverGrid.setXmlParam("w", "0");
    hoverGridsm.setXmlParam("w", "0");
    hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
    hoverGridsm.sendAction("set_w", "", 0, 0 , 0, 0);

    //tabs_text_attrib.setData("0");
    //tabs_icons_attrib.setData("0");
  }


}

System.onSetXuiParam (String stringParam, String value)
{
	if (strlower(stringParam) == "tabtext" )
	{
		normalText.setText(value);
		hoverText.setText(value);
		activeText.setText(value);
	}
}

mousetrap.onLeftButtonDown (int x, int y)
{
	mouseDown = 1;
	//normalGrid.show();
	hoverGrid.hide();
	hoverGridsm.hide();
	normalText.show();
	hoverText.hide();
}

mousetrap.onLeftButtonUp (int x, int y)
{
	mouseDown = 0;
	if (!getActivated() && isMouseOverRect()) {
	 if (tabs_icons_attrib.getData() == "1")
	{
	hoverGridsm.show(); normalText.hide(); hoverText.show();
	}
	else if (tabs_icons_attrib.getData() == "0")
	{
	hoverGrid.show(); normalText.hide(); hoverText.show();
	}
	else if (tabs_hide_attrib.getData() == "1")
	{
	hoverGrid.hide(); normalText.hide(); hoverText.hide();
	}	
	}
}

mousetrap.onleaveArea ()
{
	//normalGrid.show(); 
	hoverGrid.hide();
	hoverGridsm.hide();
	normalText.show();
	hoverText.hide();
}

mousetrap.onEnterArea ()
{
  if (tabs_icons_attrib.getData() == "1")
	{
	/*normalGrid.hide();*/ hoverGridsm.show(); normalText.hide(); hoverText.show();
	}
	else if (tabs_icons_attrib.getData() == "0")
	{
	/*normalGrid.hide();*/ hoverGrid.show(); normalText.hide(); hoverText.show();
	}
	else if (tabs_hide_attrib.getData() == "1")
	{
	hoverGrid.hide(); normalText.hide(); hoverText.hide();
	}

  if (hoverText.getText() == "Media Library") 
	{
		mousetrap.setXmlParam("tooltip", "Media Library");
	}
  else if (hoverText.getText() == "Playlist") 
	{
		mousetrap.setXmlParam("tooltip", "Playlist");
	}
	  else if (hoverText.getText() == "Video") 
	{
		mousetrap.setXmlParam("tooltip", "Video");
	}
	  else if (hoverText.getText() == "Visualization") 
	{
		mousetrap.setXmlParam("tooltip", "Visualization");
	}
	  else if (hoverText.getText() == "Web Reader") 
	{
		mousetrap.setXmlParam("tooltip", "Web Reader");
	}
	  else if (hoverText.getText() == "Equalizer") 
	{
		mousetrap.setXmlParam("tooltip", "Equalizer");
	}
	  else if (hoverText.getText() == "Skin Settings") // v1.2 'settings' capitalization
	{
		mousetrap.setXmlParam("tooltip", "Skin Settings");  // v1.2 'settings' capitalization
	}

	
}


mousetrap.onActivate (int activated)
{
	if (activated)
	{
		/*normalGrid.hide();*/ hoverGrid.hide(); hoverGridsm.hide(); normalText.hide(); hoverText.hide();
		activeGrid.show(); activeText.show(); Win10bgPatch.show();
	}
	else
	{
		/*normalGrid.show();*/ hoverGrid.hide(); hoverGridsm.hide(); normalText.show(); hoverText.hide();
		activeGrid.hide(); activeText.hide(); Win10bgPatch.hide();
	}
}


tabs_icons_attrib.onDataChanged() {
  if (getData() == "1" && tabs_hide_attrib.getData() == "0" && tabs_text_attrib.getData() == "0")
  {
    hoverGrid.setXmlParam("w", "46");
    hoverGrid.sendAction("set_w", "", 46, 0 , 0, 0);
    //tabs_text_attrib.setData("0");
    //tabs_hide_attrib.setData("0");
  }
  else if (getData() == "0" && tabs_hide_attrib.getData() == "0" && tabs_text_attrib.getData() == "1")
  {
    if (System.getLanguageId() == "en-US" || System.getLanguageId() == "en-GB" || System.getLanguageId() == "") // v1.2 null lang added for WACUP
    {
      hoverGrid.setXmlParam("w", "-81");
      hoverGrid.sendAction("set_w", "", -81, 0 , 0, 0);
    }
    else // v1.2
    {
      hoverGrid.setXmlParam("w", "0");
      hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
    }
    //tabs_text_attrib.setData("1");
    //tabs_hide_attrib.setData("0");
  }
  else if (getData() == "0" && tabs_hide_attrib.getData() == "1" && tabs_text_attrib.getData() == "0")
  {
    hoverGrid.setXmlParam("w", "0");
    hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
    //tabs_text_attrib.setData("0");
    //tabs_hide_attrib.setData("1");
  }
}

/*
tabs_hide_attrib.onDataChanged() {
  if (getData() == "1") {
  hoverGrid.setXmlParam("w", "0");
  hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
  //tabs_icons_attrib.setData("0");
  }
  else if (tabs_text_attrib.getData() == "1") {
    if (System.getLanguageId() == "en-US" || System.getLanguageId() == "en-GB")
    {
      hoverGrid.setXmlParam("w", "-81");
      hoverGrid.sendAction("set_w", "", -81, 0 , 0, 0);
    }
    else if (System.getLanguageId() != "en-US" || System.getLanguageId() != "en-GB")
    {
      hoverGrid.setXmlParam("w", "0");
      hoverGrid.sendAction("set_w", "", 0, 0 , 0, 0);
    }
    //tabs_icons_attrib.setData("0");
    //tabs_hide_attrib.setData("0");
  }
  else if (tabs_icons_attrib.getData() == "1") {
    hoverGrid.setXmlParam("w", "41");
    hoverGrid.sendAction("set_w", "", 41, 0 , 0, 0);
    //tabs_hide_attrib.setData("0");
  }
}*/