/*---------------------------------------------------
-----------------------------------------------------
Filename:	tabcontrol.m
Version:	1.0

Type:		maki
Date:		30. Okt. 2007 - 17:40  
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_appearance.m"
#include "attribs/init_playlist.m"

Function updateTabPos();
Function setAutoHeight(guiobject tab);

Class Text WatchText;

Global Boolean HAVE_ML = TRUE;

Global GuiObject tabMl, tabVideo, tabVis, tabBrowser, tabPl, tabEq, tabConfig;
Global WatchText txtMl, txtVideo, txtVis, txtBrowser, txtPL, txtEq, txtConfig;
Global int startY, curY;
Global int EQStatus;
Global Button btnMl, btnPl;

System.onScriptLoaded ()
{
	initAttribs_Appearance();
	initAttribs_Playlist();
	
	HAVE_ML = stringToInteger(getParam());

	group ScriptGroup = getScriptGroup();

	tabML = ScriptGroup.findObject("switch.ml");
	btnMl = ScriptGroup.findObject("switch.ml");
	txtMl = tabMl.findObject("bento.tabbutton.normal.text");
	tabPL = ScriptGroup.findObject("switch.pl");
	btnPl = ScriptGroup.findObject("switch.pl");
	txtPl = tabPl.findObject("bento.tabbutton.normal.text");
	tabVis = ScriptGroup.findObject("switch.vis");
	txtVis = tabMl.findObject("bento.tabbutton.normal.text");
	tabVideo = ScriptGroup.findObject("switch.video");
	txtVideo = tabMl.findObject("bento.tabbutton.normal.text");
	tabBrowser = ScriptGroup.findObject("switch.browser");
	txtBrowser = tabMl.findObject("bento.tabbutton.normal.text");
	tabEq = ScriptGroup.findObject("switch.eq");
	txtEq = tabEq.findObject("bento.tabbutton.normal.text");
	tabConfig = ScriptGroup.findObject("switch.config");
	txtConfig = tabConfig.findObject("bento.tabbutton.normal.text");

	startY = tabMl.getGuiY();

  EQStatus=getPrivateInt("Big Bento Modern Windows 10 edition", "EQ Status", EQStatus);

  if (EQStatus==0)
  {
  tabEq.setXmlParam("image", "tab.icon.eq.normal");
  tabEq.setXmlParam("hoverimage", "tab.icon.eq.hover");
  tabEq.setXmlParam("downimage", "tab.icon.eq.down");
  EQStatus=0;
  }
  else if (EQStatus==1)
  {
  tabEq.setXmlParam("image", "tab.icon.eq.on.normal");
  tabEq.setXmlParam("hoverimage", "tab.icon.eq.on.hover");
  tabEq.setXmlParam("downimage", "tab.icon.eq.on.down");
  EQStatus=1;
  }

	updateTabPos();
}


System.onScriptUnloading(){
	setPrivateInt("Big Bento Modern Windows 10 edition", "EQ Status", EQStatus);
}


updateTabPos ()
{	
	curY = startY;
	if (!HAVE_ML)
	{
		tabMl.hide();
	}
	else
	{
		curY += setAutoHeight(tabMl) + 1;
	}

	if (playlist_tab_attrib.getData() == "1")
	{
		tabPL.setxmlParam("y", integerToString(curY));
		curY += setAutoHeight(tabPL) + 1;
		tabPL.show();
	}
	else
	{
		tabPL.hide();
	}

	if (System.hasVideoSupport())
	{
		tabVideo.setxmlParam("y", integerToString(curY));
		curY += setAutoHeight(tabVideo) + 1;
		tabVideo.show();
	}
	else
	{
		tabVideo.hide();
	}

		tabVis.setxmlParam("y", integerToString(curY));
		curY += setAutoHeight(tabVis) + 1;

	tabBrowser.setxmlParam("y", integerToString(curY));
	curY += setAutoHeight(tabBrowser) + 1;
	
	tabEq.setxmlParam("y", integerToString(curY));
	curY += setAutoHeight(tabEq) + 1;
	
	tabConfig.setxmlParam("y", integerToString(curY));
	curY += setAutoHeight(tabConfig) + 1;
}

int setAutoHeight (guiObject tab)
{
	text source = tab.findObject("bento.tabbutton.normal.text");
	int y = stringToInteger(source.getxmlparam("y"));
	int h = source.getAutoHeight();

	tab.setxmlParam("h", integerToString(4*y+h));

	return 4*y + h;
}


playlist_tab_attrib.onDataChanged ()
{
	if (playlist_tab_attrib.getData() == "0")
	{
		setPrivateString("Big Bento Modern Windows 10 edition", "Pledit_pos", "top");
		if (btnPl.getActivated())
		{	
			btnMl.leftClick();
			btnMl.getParentLayout().sendAction("load_comp", "pledit", 0,0,0,0);
		}
	}
	
	updateTabPos();
}

System.onEqChanged(int newstatus)
{  
  if (newstatus == 0)
  {
  tabEq.setXmlParam("image", "tab.icon.eq.normal");
  tabEq.setXmlParam("hoverimage", "tab.icon.eq.normal");
  tabEq.setXmlParam("downimage", "tab.icon.eq.normal");
  EQStatus = 0;
  }
  else if (newstatus == 1)
  {
  tabEq.setXmlParam("image", "tab.icon.eq.on.normal");
  tabEq.setXmlParam("hoverimage", "tab.icon.eq.on.hover");
  tabEq.setXmlParam("downimage", "tab.icon.eq.on.down");
  EQStatus = 1;
  }
}