/*---------------------------------------------------
-----------------------------------------------------
Filename:	timecontrol.m
Version:	1.0

Type:		maki
Date:		29. Jun. 2007 - 00:13 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "lib/config.mi"
#include "lib/com/AutoRepeatButton.m"
#include "attribs/init_notifier.m" // Victhor mod


Function updateAttrib (int val);

Global ConfigAttribute timeAttrib;
Global text Display;
Global AutoRepeatButton Increase, Decrease;
Global float multiplier;
Global int maxvalue, step;
Global string suffix;
Global boolean myChange;

// Victhor mod -- Works but crashes winamp if the notification disappear and the menu is still open --
//Function popSettings();
Function int getSaveValue(int input);
Global PopupMenu myMenu2, timeIn2, timeStay2, timeOut2;
Global Button HoldtimeMenu;
Global boolean menuOpen = false;
Global boolean menuOpen_tried = false;
// Victhor mod -- Works but crashes winamp if the notification disappear and the menu is still open --

System.onScriptLoaded ()
{

  initAttribs_notifier(); // Victhor mod -- Works but crashes winamp if the notification disappear and the menu is still open --

	AutoRepeat_Load();
	string param = getParam();

	string objects = getToken(param, "|", 0);
	group scriptGroup = getScriptGroup();
	Display = scriptGroup.findObject(getToken(objects, ";", 0));
	Decrease = scriptGroup.findObject(getToken(objects, ";", 1));
	Increase = scriptGroup.findObject(getToken(objects, ";", 2));
	
	HoldtimeMenu = scriptGroup.findObject("holdtime.menu"); //-- Works but crashes winamp if the notification disappear and the menu is still open --

	objects = getToken(param, "|", 1);
	timeAttrib = config.getItemByGuid(getToken(objects, ";", 0)).getattribute(getToken(objects, ";", 1));

	step = stringToInteger(getToken(param, "|", 2));
	maxvalue = stringToInteger(getToken(param, "|", 3));
	multiplier = stringToFloat(getToken(param, "|", 4));
	suffix = getToken(param, "|", 5);

	AutoRepeat_SetInitalDelay(250);
	AutoRepeat_SetRepeatDelay(125);

	updateAttrib (0);
}

System.onScriptUnloading ()
{
	AutoRepeat_Unload();
}

Increase.onLeftClick ()
{
	if (!AutoRepeat_ClickType) return;
	updateAttrib (step);
}

Decrease.onLeftClick ()
{
	if (!AutoRepeat_ClickType) return;
	updateAttrib (-step);
}

timeAttrib.onDataChanged ()
{
	if (myChange) return;
	updateAttrib (0);
}

updateAttrib (int val)
{
	float i = stringToInteger(timeAttrib.getData());
	i += val;
	if (i < 0 || i > maxvalue) return;
	myChange = 1;
	string s = integerToString(i);
	if (timeAttrib) timeAttrib.setData(s);
	i *= multiplier;
	s = floatToString(i,1);
	Display.setText(s + suffix);
	myChange = 0;
}	


// Victhor mods -- Works but crashes winamp if the notification disappear and the menu is still open --

int getSaveValue(int input){
	if(input==5) input=6;
	else if(input==7) input=8;
	else if(input==9) input=10;
	else if(input==11) input=12;
	else if(input>=35) input=40;
	else if(input>=25) input=30;
	else if(input>=15) input=20;
	else if(input<1) input=1;
	
	return input;
}


//popSettings(){
HoldtimeMenu.onLeftClick() {
	int temp;
	timeIn2 = new PopupMenu;
	timeIn2.addCommand("250 ms", 1, 0, 0);
	timeIn2.addCommand("500 ms", 2, 0, 0);
	timeIn2.addCommand("750 ms", 3, 0, 0);
	timeIn2.addCommand("1000 ms", 4, 0, 0);
	timeIn2.addCommand("1500 ms", 6, 0, 0);
	timeIn2.addCommand("2000 ms", 8, 0, 0);
	timeIn2.addCommand("2500 ms", 10, 0, 0);
	timeIn2.addCommand("3000 ms", 12, 0, 0);
	timeIn2.addCommand("5000 ms", 20, 0, 0);
	timeIn2.addCommand("7500 ms", 30, 0, 0);
	timeIn2.addCommand("10000 ms", 40, 0, 0);
	temp = getSaveValue(stringToInteger(notifier_fadeintime_attrib.getData())/250);
	if(stringToInteger(notifier_fadeintime_attrib.getData())/250!=temp) notifier_fadeintime_attrib.setData(integerToString(temp*250));
	timeIn2.checkCommand(temp, 1);

	timeStay2 = new PopupMenu;
	timeStay2.addCommand("250 ms", 101, 0, 0);
	timeStay2.addCommand("500 ms", 102, 0, 0);
	timeStay2.addCommand("750 ms", 103, 0, 0);
	timeStay2.addCommand("1000 ms", 104, 0, 0);
	timeStay2.addCommand("1500 ms", 106, 0, 0);
	timeStay2.addCommand("2000 ms", 108, 0, 0);
	timeStay2.addCommand("2500 ms", 110, 0, 0);
	timeStay2.addCommand("3000 ms", 112, 0, 0);
	timeStay2.addCommand("5000 ms", 120, 0, 0);
	timeStay2.addCommand("7500 ms", 130, 0, 0);
	timeStay2.addCommand("10000 ms", 140, 0, 0);

	temp = getSaveValue(stringToInteger(notifier_holdtime_attrib.getData())/250);
	if(stringToInteger(notifier_holdtime_attrib.getData())/250!=temp) notifier_holdtime_attrib.setData(integerToString(temp*250));
	timeStay2.checkCommand(temp+100, 1);

	timeOut2 = new PopupMenu;
	timeOut2.addCommand("250 ms", 201, 0, 0);
	timeOut2.addCommand("500 ms", 202, 0, 0);
	timeOut2.addCommand("750 ms", 203, 0, 0);
	timeOut2.addCommand("1000 ms", 204, 0, 0);
	timeOut2.addCommand("1500 ms", 206, 0, 0);
	timeOut2.addCommand("2000 ms", 208, 0, 0);
	timeOut2.addCommand("2500 ms", 210, 0, 0);
	timeOut2.addCommand("3000 ms", 212, 0, 0);
	timeOut2.addCommand("5000 ms", 220, 0, 0);
	timeOut2.addCommand("7500 ms", 230, 0, 0);
	timeOut2.addCommand("10000 ms", 240, 0, 0);

	temp = getSaveValue(stringToInteger(notifier_fadeouttime_attrib.getData())/250);
	if(stringToInteger(notifier_fadeouttime_attrib.getData())/250!=temp) notifier_fadeouttime_attrib.setData(integerToString(temp*250));
	timeOut2.checkCommand(temp+200, 1);

	myMenu2 = new PopupMenu;
	myMenu2.addSubMenu(timeIn2, "Fade In Time");
	myMenu2.addSeparator();
	myMenu2.addSubMenu(timeStay2, "Stay Time");
	myMenu2.addSeparator();
	myMenu2.addSubMenu(timeOut2, "Fade Out Time");
	
	menuOpen = true;
	//int a = myMenu2.popAtMouse();
  int a = myMenu2.popAtXY(clientToScreenX(HoldtimeMenu.getLeft()), clientToScreenY(HoldtimeMenu.getTop())+36);
	menuOpen = false;

	delete myMenu2;
	delete timeIn2;
	delete timeStay2;
	delete timeOut2;

	
	if(a<1) return;
	else if(a<100){
		notifier_fadeintime_attrib.setData(integerToString(a*250));
	}
	else if(a<200){
		notifier_holdtime_attrib.setData(integerToString((a-100)*250));
	}
	else if(a<300){
		notifier_fadeouttime_attrib.setData(integerToString((a-200)*250));
	}
}


/*HoldtimeMenu.onLeftClick() {
  popSettings(); // Why was this here and not as above? (a simple, straightforward onLeftClick())
}*/