
/*---------------------------------------------------
Author:		Victhor
---------------------------------------------------*/

#include "std.mi"
#include "lib/fileio.mi"
#include "lib/application.mi"
#include "attribs/init_localization.m"

//Global Layout normal; //v1.1 // v1.2 disabled
Global Group scriptGroup, GroupTxtEsp, GroupTxtEng, GroupTxtPl, GroupTxtFr;
Global GuiObject SpanishTxt, EnglishTxt, PolishTxt, FrenchTxt, PolishButtonUpInstTxt, SpanishButtonUpInsttxt, FrenchButtonUpInstTxt;
Global Button EnglishButton, SpanishButton, SpanishButtonUpInst, PolishButton, PolishLink, PolishButtonUpInst, HelpTranslate, PolishAuthorLink;
Global Button /*OpenLocalization, */FrenchButton, FrenchButtonUpInst; // v1.2 OpenLocalization x setting removed
Global Text EnglishTitle, SpanishTitle, PolishTitle, FrenchTitle; // v1.2 added
Function Checklang();
Function CheckAvailableLang();
Global File myDoc;
Global File myDoc2;
Global File myDoc3;

System.onScriptLoaded ()
{
  initAttribs_localization();
  
	scriptGroup = getScriptGroup();
	//normal = scriptGroup.getParentLayout(); //v1.1 // v1.2 disabled
	
	EnglishTitle = scriptGroup.getParent().findObject("title.eng"); // v1.2 added
	SpanishTitle = scriptGroup.getParent().findObject("title.esp"); // v1.2 added
	PolishTitle = scriptGroup.getParent().findObject("title.pl"); // v1.2 added
	FrenchTitle = scriptGroup.getParent().findObject("title.fr"); // v1.2 added
	
	EnglishButton = scriptGroup.getObject("english.lang");
	SpanishButton = scriptGroup.getObject("spanish.lang");

	SpanishButtonUpInst = scriptGroup.getObject("lang.spanish.update.install");
	SpanishButtonUpInsttxt = scriptGroup.getObject("lang.spanish.update.install.txt");

	PolishButton = scriptGroup.getObject("polish.lang");
	PolishButtonUpInst = scriptGroup.getObject("lang.polish.update.install");
  PolishButtonUpInstTxt = scriptGroup.getObject("lang.polish.update.install.txt");

	FrenchButton = scriptGroup.getObject("french.lang"); //v1.1
	FrenchButtonUpInst = scriptGroup.getObject("lang.french.update.install"); //v1.1
  FrenchButtonUpInstTxt = scriptGroup.getObject("lang.french.update.install.txt"); //v1.1
  
	PolishLink = scriptGroup.getObject("polish.link");
	PolishAuthorLink = scriptGroup.getObject("lang.polish.author.link");

	HelpTranslate = scriptGroup.getObject("help.translate.button");

  GroupTxtEng = scriptGroup.getObject("config.specific.txt.eng");
  GroupTxtEsp = scriptGroup.getObject("config.specific.txt.esp");
  GroupTxtPl = scriptGroup.getObject("config.specific.txt.pl");
  GroupTxtFr = scriptGroup.getObject("config.specific.txt.fr"); //v1.1
  
  SpanishTxt = scriptGroup.getObject("lang.spanish.txt");
  EnglishTxt = scriptGroup.getObject("lang.english.txt");
  PolishTxt = scriptGroup.getObject("lang.polish.txt");
  FrenchTxt = scriptGroup.getObject("lang.french.txt"); //v1.1

  //OpenLocalization = scriptGroup.getObject("open.localization"); // v1.1 // v1.2 disabled

  Checklang();
  CheckAvailableLang(); // Used for the Right-Click menu
}



HelpTranslate.onLeftClick ()
{
	System.navigateUrl("mailto:victorbrocaz@gmail.com");
}

SpanishButton.onLeftClick ()
{
		myDoc = new File;
		String temp = (Application.GetApplicationPath()+"/Lang/Winamp-es-us.wlz");
		myDoc.load (temp);
		if(!myDoc.exists() || myDoc.getSize() >= 1000000 && myDoc.getSize() <= 1660000) navigateURL(Application.GetApplicationPath()+ "\Skins/Big Bento Modern/languages\Winamp-es-us.wlz"); //If lang pack doesn't exists or size is between 1 and 1.5mb, do this
		
		if(myDoc.exists() && myDoc.getSize() <= 1000000) { //If the lang pack exists and its size is LESS than 1mb, show this
			System.messageBox("Paquete de idioma ya instalado. Para actualizar usa 'Actualizar / Instalar'. Para elegir este idioma usar el botón a la izquierda de 'SELECCIONA TU IDIOMA'.", "BIG BENTO MODERN - LENGUAJE", 1, "");
		}
}

SpanishButtonUpInst.onLeftClick ()
{
		myDoc = new File;
		String temp = (Application.GetApplicationPath()+"/Lang/Winamp-es-us.wlz");
		myDoc.load (temp);
		navigateURL(Application.GetApplicationPath()+ "\Skins/Big Bento Modern/languages\Winamp-es-us.wlz");
}



PolishButton.onLeftClick ()
{
		myDoc = new File;
		String temp = (Application.GetApplicationPath()+"/Lang/Winamp-pl-pl.wlz");
		myDoc.load (temp);
    if(!myDoc.exists() || myDoc.getSize() >= 1000000 && myDoc.getSize() <= 1900600) System.messageBox("DOSTĘPNA JEST NOWA WERSJA PAKIETU JĘZYKOWEGO - UŻYJ PRZYCISKU POBIERANIA", "BIG BENTO MODERN - JĘZYK", 1, "");
		
		if(myDoc.exists() && myDoc.getSize() >= 1910000) { //If the lang pack exists and its size is MORE than 1.91mb, do this
      System.messageBox("Pakiet językowy jest już zainstalowany. Aby go zaktualizować, użyj polecenia 'Aktualizuj / Zainstaluj'. Aby wybrać ten język, użyj przycisku znajdującego się po lewej stronie od 'WYBIERZ SWÓJ JĘZYK'.", "BIG BENTO MODERN - JĘZYK", 1, "");
		}
}

FrenchButton.onLeftClick ()
{
		myDoc = new File;
		String temp = (Application.GetApplicationPath()+"/Lang/Winamp-fr-fr.wlz");
		myDoc.load (temp);
		if(!myDoc.exists() || myDoc.getSize() >= 700000 && myDoc.getSize() <= 1800000) navigateURL(Application.GetApplicationPath()+ "\Skins/Big Bento Modern/languages\Winamp-fr-fr.wlz"); //If lang pack doesn't exists or size is between 0.7 and 1.8mb, do this
		
		if(myDoc.exists() && myDoc.getSize() <= 680000) { //If the lang pack exists -is installed- and its size is LESS than 680kbmb, show this
			System.messageBox("Paquet linguistique déjà installé. Pour mettre à jour, utilisez 'Update / Install'. Pour choisir cette langue, utilisez le bouton situé à gauche de 'SÉLECTIONNEZ VOTRE LANGUE'.", "BIG BENTO MODERN - LANGUE", 1, "");
		}
}

FrenchButtonUpInst.onLeftClick ()
{
		myDoc = new File;
		String temp = (Application.GetApplicationPath()+"/Lang/Winamp-fr-fr.wlz");
		myDoc.load (temp);
		navigateURL(Application.GetApplicationPath()+ "\Skins/Big Bento Modern/languages\Winamp-fr-fr.wlz");
}

PolishButtonUpInst.onLeftClick ()
{
  navigateURL("http://pawelporwisz.pl/winamp/winamp_download.php#winamp"); //Just go to Pawel's site to download new version
}

PolishAuthorLink.onLeftClick ()
{
  navigateURL("www.pawelporwisz.pl");
}


Checklang()
{
  myDoc = new File;
  String temp = (Application.GetApplicationPath()+"/Lang/Winamp-pl-pl.wlz");
  myDoc.load (temp);
  if(!myDoc.exists() || myDoc.getSize() >= 1000000 && myDoc.getSize() <= 1900600) PolishButtonUpInstTxt.setXmlParam("text", "POBIERZ"); //If the lang pack doesn't exists OR its size is between 1 and 1.9mb, do this
  if(myDoc.exists() && myDoc.getSize() >= 1910000) PolishButtonUpInstTxt.setXmlParam("text", "Zaktualizuj / Zainstaluj"); //If the lang pack exists and its size is MORE than 1.91mb, do this
  
	if (System.getLanguageId() == "es-US") // Vic note: Capitalization is important here.
	{
    GroupTxtEng.hide(); EnglishTitle.hide();
    GroupTxtPl.hide(); PolishTitle.hide();
    GroupTxtFr.hide(); FrenchTitle.hide();
    GroupTxtEsp.show(); SpanishTitle.show();
    SpanishTxt.setXmlParam("color", "color.selected.active");
    
    SpanishButtonUpInsttxt.setXmlParam("text", "Actualizar / Instalar");
		
		EnglishButton.setXmlParam("ghost", "0");
	}
	else if (System.getLanguageId() == "en-US" || System.getLanguageId() == "en-GB") // Vic note: Capitalization is important here.
	{
    GroupTxtEng.show(); EnglishTitle.show();
    GroupTxtEsp.hide(); SpanishTitle.hide();
    GroupTxtPl.hide(); PolishTitle.hide();
    GroupTxtFr.hide(); FrenchTitle.hide();
    
    EnglishTxt.setXmlParam("color", "color.selected.active");
	}
		else if (System.getLanguageId() == "pl-PL") // Vic note: Capitalization is important here.
	{
    GroupTxtEng.hide(); EnglishTitle.hide();
    GroupTxtFr.hide(); FrenchTitle.hide();
    GroupTxtEsp.hide(); SpanishTitle.hide();
    GroupTxtPl.show(); PolishTitle.show();

    PolishButtonUpInstTxt.setXmlParam("text", "POBIERZ");
    PolishTxt.setXmlParam("color", "color.selected.active");
		EnglishButton.setXmlParam("ghost", "0");
	}
		else if (System.getLanguageId() == "fr-FR") // Vic note: Capitalization is important here.
	{
    GroupTxtEng.hide(); EnglishTitle.hide();
    GroupTxtEsp.hide(); SpanishTitle.hide();
    GroupTxtPl.hide(); PolishTitle.hide();
    GroupTxtFr.show(); FrenchTitle.show();

    FrenchButtonUpInstTxt.setXmlParam("text", "Mettre à jour / Installer");
    FrenchTxt.setXmlParam("color", "color.selected.active");
		EnglishButton.setXmlParam("ghost", "0");
	}
}


CheckAvailableLang()
{
	myDoc2 = new File;
  String temp2 = (Application.GetApplicationPath()+"/Lang/Winamp-es-us.wlz");
  myDoc2.load (temp2);
  if(myDoc2.exists() && myDoc2.getSize() <= 1000000) // Means the updated lang pack is installed (updated LP weights less than 1mb)
  {
  localization_spanish_attrib.setData("1");
  }
  else if(!myDoc2.exists() || myDoc2.getSize() >= 1000000) // Means the updated lang pack is not installed or its weights is above 1mb
  {
  localization_spanish_attrib.setData("0");
  }
  
  myDoc = new File;
  String temp = (Application.GetApplicationPath()+"/Lang/Winamp-pl-pl.wlz");
  myDoc.load (temp);
  if(myDoc.exists() && myDoc.getSize() >= 1910000) // Means the updated lang pack is installed (updated LP weights more than 1.91mb)
  {
  localization_polish_attrib.setData("1");
  }
  else if (!myDoc.exists() || myDoc.getSize() <= 1910000) // Means the updated lang pack is not installed or its weights is below 1.91mb
  {
  localization_polish_attrib.setData("0");
  }
  
  myDoc3 = new File;
  String temp3 = (Application.GetApplicationPath()+"/Lang/Winamp-fr-fr.wlz");
  myDoc3.load (temp3);
  if(myDoc3.exists() && myDoc3.getSize() <= 680000) // Means the updated lang pack is installed (updated LP weights less than 680kb)
  {
  localization_french_attrib.setData("1");
  }
  else if(!myDoc3.exists() || myDoc3.getSize() >= 680000) // Means the updated lang pack is not installed or its weights is above 680kb
  {
  localization_french_attrib.setData("0");
  }
}



localization_spanish_attrib.onDataChanged()
{
	myDoc2 = new File;
  String temp2 = (Application.GetApplicationPath()+"/Lang/Winamp-es-us.wlz"); // This is the name of the Lang pack we should look for
  myDoc2.load (temp2);
 
  if (getData() == "1" && myDoc2.exists() && myDoc2.getSize() <= 1000000) { /*do nothing*/  } // Means the updated lang pack is installed (updated LP weights less than 1mb)
  else if (getData() == "1" && myDoc2.exists() && myDoc2.getSize() >= 1000000) SpanishButtonUpInst.leftClick(); // Means there is a lang pack installed but is not updated
  else if (getData() == "1" && !myDoc2.exists()) SpanishButtonUpInst.leftClick(); // Means there isn't a lang pack at all
  
  if (getData() == "0" && myDoc2.exists() && myDoc2.getSize() <= 1000000) { localization_spanish_attrib.setData("1"); } // Lang pack is installed so we tick the option again..
}

localization_polish_attrib.onDataChanged()
{
  myDoc = new File;
  String temp = (Application.GetApplicationPath()+"/Lang/Winamp-pl-pl.wlz"); // This is the name of the Lang pack we should look for
  myDoc.load (temp);
  
  if (getData() == "1" && myDoc.exists() && myDoc.getSize() >= 1910000) {  	/* do nothing */  } // Means the updated lang pack is installed (updated LP weights more than 1.91mb)
  else if (getData() == "1" && myDoc.exists() && myDoc.getSize() <= 1910000) PolishButtonUpInst.leftClick(); // Means there is a lang pack installed but is not updated
  else if (getData() == "1" && !myDoc.exists()) PolishButtonUpInst.leftClick(); // Means there isn't a lang pack at all

  if (getData() == "0" && myDoc.exists() && myDoc.getSize() >= 1910000) { localization_polish_attrib.setData("1"); } // Lang pack is installed so we tick the option again..
}


localization_french_attrib.onDataChanged()
{
	myDoc3 = new File;
  String temp3 = (Application.GetApplicationPath()+"/Lang/Winamp-fr-fr.wlz"); // This is the name of the Lang pack we should look for
  myDoc3.load (temp3);
 
  if (getData() == "1" && myDoc3.exists() && myDoc3.getSize() <= 680000) { /*do nothing*/  } // Means the updated lang pack is installed (updated LP weights less than 680kb)
  else if (getData() == "1" && myDoc3.exists() && myDoc3.getSize() >= 680000) FrenchButtonUpInst.leftClick(); // Means there is a lang pack installed but is not updated
  else if (getData() == "1" && !myDoc3.exists()) FrenchButtonUpInst.leftClick(); // Means there isn't a lang pack at all
  
  if (getData() == "0" && myDoc3.exists() && myDoc3.getSize() <= 680000) { localization_french_attrib.setData("1"); } // Lang pack is installed so we tick the option again..
}


// v1.2 disabled
/*normal.onResize (int x, int y, int w, int h)
{
	if (h > 748) // Win 10 mod
	{
    OpenLocalization.setxmlParam("x", "-259");
  }
  else
  {
    OpenLocalization.setxmlParam("x", "-275");
  }
}*/