/*---------------------------------------------------
-----------------------------------------------------
 Refurbished "Manager for Widgets" by mpdeimos (2009/04/28)
 + Victhor mods 2017
 -----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_windowpage.m" // v1.1

Function updateObj(int h);

Global GroupList grplst;
Global Slider vscroll;
Global layer mousetrap;

Global Group Scriptgroup, parent;
Global Layout parentLayout;
Global Button Up, Down;
Global String param3;


System.onScriptLoaded ()
{

  initAttribs_Windowpage(); // v1.1
  
	Scriptgroup = GetScriptgroup();
	parentLayout = scriptGroup.getParentLayout();
	parent = scriptGroup.getParent();
  mousetrap = parent.findObject("mousetrapscroll");

	grplst = Scriptgroup.findObject("grplst");
	vscroll = Scriptgroup.findObject("vscroll");
	Up = vscroll.findObject("up");
	Down = vscroll.findObject("down");

  int vscrollint = vscroll.getPosition(); // v1.1 (Fixes initial missplacement when clicking "up") FROM HERE..
  int percent = 99-vscrollint; // v1.1

	grplst.scrolltopercent(percent); // v1.1
	grplst.setRedraw(percent); // TO HERE..

	string param = getToken(getParam(),";",0);
	string param2 = getToken(getParam(),";",1);

  Group g1 = grplst.instantiate(param, 1); // "1" here is the amount of times the group will be instantiated (in case someone needs duplicated?)
  Group g2 = grplst.instantiate(param2, 1); // "1" here is the amount of times the group will be instantiated (in case someone needs duplicated?)

  if (scriptGroup.isVisible() == 1) updateObj(Scriptgroup.getHeight());  
}

vscroll.onSetPosition(int newpos)
{
	int percent = 99-newpos;

  grplst.scrolltopercent(percent);
  grplst.setRedraw(percent);
}


// Vic mod: Auto-hide scrollbars when not needed, based on param set for every instance

scriptGroup.onResize (int x, int y, int w, int h)
{
	updateObj(h);

  //If this bit is not present, group would not update itself when resizing after scrolling down
  string param3 = getToken(getParam(),";",2);
	if (h > param3)
	{
    grplst.scrolltopercent(0);
	}

  // v1.1 Specific fix for the ultra-large and changing color themes page
  int scrollpos = vscroll.getPosition();
  
	if (scrollpos < 50 && w > 600 && sui_colorthemes_attrib.getData() == "1")
	{
    grplst.scrolltopercent(0);
    grplst.setRedraw(0);
    vscroll.SetPosition(100);
	}
}



vscroll.onSetVisible(int on)
{
  if (on)
  {
    grplst.scrolltopercent(0); // v1.1 Added to fix a conflict when using the scrollbar on various groups
    grplst.setRedraw(0);
    vscroll.SetPosition(100); // v1.1 Added to fix a conflict when using the scrollbar on various groups
  }
}

updateObj (int h)
{
  //Param3 is the minimum height needed to show scrollbars
	string param3 = getToken(getParam(),";",2);
	
	if (h < param3)
	{
    vscroll.show();
    Up.show();
    Down.show();
	}
	else
	{
    vscroll.hide();
    Up.hide();
    Down.hide();
	}
}


parentLayout.onMouseWheelUp(int clicked , int lines) // v1.1
{
  if (mousetrap.isMouseOverRect() && getPrivateString("Big Bento Modern", "Component", "Media Library") == "Equalizer")
  {    sendAction("CFGSCROLLUP", "", 0, 0, clicked, lines);
    return 1;  }
    
  if (mousetrap.isMouseOverRect() && mousetrap.isVisible())
  {
    sendAction("CFGSCROLLUP", "", 0, 0, clicked, lines);
    return 1;
  }
	else { return 0; }
}

parentLayout.onMouseWheelDown(int clicked , int lines) // v1.1 
{
  if (mousetrap.isMouseOverRect() && getPrivateString("Big Bento Modern", "Component", "Media Library") == "Equalizer")
  {    sendAction("CFGSCROLLDOWN", "", 0, 0, clicked, lines);
    return 1;  }
    
  if (mousetrap.isMouseOverRect() && mousetrap.isVisible())
  {
    sendAction("CFGSCROLLDOWN", "", 0, 0, clicked, lines);
    return 1;
  }
	else { return 0; }
}