/*---------------------------------------------------
-----------------------------------------------------
Author:		PJN123 + Victhor mods
E-Mail:		victorbrocaz@gmail.com
Internet:	victhor.deviantart.com

Built from PlaylistPro build 005

Victhor mods:
- Added animation on click + visual clues to denote it's function
- Added Escape key trigger (works along skin.xml references)
-----------------------------------------------------
---------------------------------------------------*/



#include "std.mi"
#include "lib/pldir.mi"
#include "attribs/init_Playlist.m"
#include "attribs/init_appearance.m" //v1.15 WACUP check to handle scrollbars extra gfx

Function resizeResults(int items);
Function doSearch(String input);
Function setSearchBox(boolean onOff);
Function clearSearchBox();
Function int getPlEntry(int search_item);
Function String replaceString(string baseString, string toreplace, string replacedby);

Global int frameNum;
Global Group scriptGroup, topbar, parent, plSearchbarSearch;
Global Edit searchBox;
Global Text helpSearch, searchNews;// fakeText;
Global GuiObject fakeSB, searchXUI, searchButtonXui, ActiveIndicatorTop, ActiveIndicatorBottom, OCDPatch, OCDPatchVertical;
Global Button searchButton, clearButton, clearButtonText;
Global Layer searchButtonBG;
Global GuiList searchResults;
Global Boolean foundsomething;
Global int tn, h_tune, /*nexttrack, */mouseisout;
Global String temptoken;
Global Windowholder plwh;
GLobal Timer refreshActiveCheck;
Global PopupMenu search_rc;
Global Windowholder GhostPlaylist;

Global Container results_container;
Global Layout results_layout, main_layout;


System.onScriptLoaded() {
	initAttribs_Appearance(); // Waveseeker integration v1.1
	
	scriptGroup = getScriptGroup();
	topbar = scriptGroup.findObject("PlaylistPro.topbar");
	plSearchbarSearch = topbar.findObject("player.component.playlist.searchbar.search"); //v1.15
	plwh = scriptGroup.findObject("wdh.playlist");
	OCDPatch = scriptGroup.findObject("pl.ocd.patch"); //v1.15
	OCDPatchVertical = scriptGroup.findObject("pl.ocd.patch.vertical"); //v1.15
	
	ActiveIndicatorTop = scriptGroup.findObject("search.active.indicator.top");
	ActiveIndicatorBottom = scriptGroup.findObject("search.active.indicator.bottom");
	
	searchBox = scriptGroup.findObject("wasabi.edit.box");
	searchXUI = scriptGroup.findObject("pl.search.edit");
	searchButtonBG = scriptGroup.findObject("pl.search.go.bg");
	searchButton = scriptGroup.findObject("pl.search.go");
	searchButtonXui = scriptGroup.findObject("pl.search.go");

  GhostPlaylist = scriptGroup.getParentLayout().findObject("ghost.playlist");
  
	fakeSB = scriptGroup.findObject("pl.search.edit.rect");
	clearButton = scriptGroup.findObject("pl.search.edit.clear");
	clearButtonText = scriptGroup.findObject("pl.search.edit.clear.text");
	helpSearch = scriptGroup.findObject("pl.search.edit.searchhelp");
	
	results_container = newDynamicContainer("searchresults");
	results_layout = results_container.getLayout("normal");
	searchResults = results_layout.findObject("PlaylistPro.list");
	
	parent = scriptGroup.getParent();

	searchResults.setFontSize(22);
	
	searchNews = results_layout.findObject("PlaylistPro.list.news");
	
	main_layout = getContainer("main").getLayout("normal");
	
	initAttribs_Playlist();

	refreshActiveCheck = new Timer;
	refreshActiveCheck.setDelay(100);
	
  ActiveIndicatorBottom.setXmlParam("alpha", "0");
  ActiveIndicatorTop.setXmlParam("alpha", "0");

  if (wacup_attrib.getData() == "1") //v1.15
  {
    plSearchbarSearch.setxmlparam("w", "0"); //v1.15
    OCDPatchVertical.show();
    OCDPatch.hide();
  }
  else
  {
    plSearchbarSearch.setxmlparam("w", "-3"); //v1.15
    OCDPatchVertical.hide();
    OCDPatch.show();
  }

}


plwh.onSetVisible(int on) {
	if (on)
	{
    playlist_victrick_attrib.setData("1");
	}
	else
	{
    playlist_victrick_attrib.setData("0");
    clearSearchBox(); // v1.1 PL is not visible so I want to make the Pl search go away
    searchBox.setxmlParam("h", "0"); // v1.1 set 0 because it won't go away
	}
}


// Vic trick: Implemented to avoid losing data when refreshing or hiding PL.
scriptGroup.onSetVisible(int on){
  if (on)
  {
    GhostPlaylist.hide();
  }
}


System.onScriptUnLoading() {
		delete refreshActiveCheck;
}

refreshActiveCheck.onTimer(){
	if((!System.isAppActive() || System.isMinimized()) && results_layout.isVisible() ) results_layout.hide();
}

results_layout.onSetVisible(boolean onOff){
	if(onOff){
		refreshActiveCheck.start();
	}
	else{
		refreshActiveCheck.stop();
	}
}

System.onShowLayout(Layout _layout){
	if(main_layout.isVisible()) results_layout.setXmlParam("ontop", "1");
}

scriptGroup.onSetVisible(boolean onOff){
	if(!onOff) clearSearchBox();
}

searchButton.onLeftClick(){
	doSearch(searchBox.getText());
}

resizeResults(int items){
	//items++; //temp add one extra for info... xx items found
	if(items>20) items=20;
	
	
	if(items>=1) h_tune=54;
	else h_tune=54;

	results_layout.resize(results_layout.getLeft(), results_layout.getTop(), results_layout.getWidth(), h_tune+items*16);
}

searchBox.onEnter(){
	doSearch(searchBox.getText());
}

doSearch(String input){
	if(input==""){
		clearSearchBox();
		return; 
	}
	
	//search history stuff
	String history = getPublicString("BigBentoModern.PP.hist", "");
	history = replaceString(history, input, "");
	history = replaceString(history, ";;", ";");
	if(strleft(history, 1)==";") history = strright(history, strlen(history)-1);
	if(strright(history, 1)==";") history = strleft(history, strlen(history)-1);
	if(history=="") history= input;
	else history= input+";"+history;
	
	String output = getToken(history, ";", 0);
	for(int i = 1; i<10; i++){
		if(getToken(history, ";", i)=="") break;
		output+=";"+getToken(history, ";", i);
	}
	setPublicString("BigBentoModern.PP.hist", history);


	int itemsfound = 0;
	input = strlower(input);
	
	results_layout.setXmlParam("x", integerToString(fakeSB.clientToScreenX(fakeSB.getLeft()-4)));
	results_layout.setXmlParam("y", integerToString(fakeSB.clientToScreenY(fakeSB.getTop() + fakeSB.getHeight())));
	results_layout.setXmlParam("w", integerToString(scriptGroup.getWidth()-2));
	
	if(!results_layout.isVisible()) results_layout.setXmlParam("h", "1");

	searchResults.deleteAllItems();
	searchResults.scrollToItem(0);
	
	for(int i = 0; i<PlEdit.getNumTracks(); i++){
		foundsomething=false;

		for(tn = 0; tn<10; tn++){
			if(getToken(input, " ", tn)==""){
				break;
			}
		
			temptoken = getToken(input, " ", tn);
			if(strsearch(strlower(PlEdit.getTitle(i) + " " + PlEdit.getFileName(i)), temptoken)>=0){
				foundsomething=true;
			}
			else{
				foundsomething=false;
			}
			
			if(!foundsomething){
				break;
			}
		}
		
		if(foundsomething){
			itemsfound++;
			searchResults.addItem(integerToString(i+1)+". " + PlEdit.getTitle(i));
			if(itemsfound>500){
				searchNews.setText("Search result limited to 500 items");
				searchResults.setXmlParam("h", "-36");
				break;
			}
		}
	}

	if(itemsfound==0){
		searchNews.setText("Nothing was found");
		searchResults.setXmlParam("h", "-66");
	}
	else if(itemsfound<=500){
		searchNews.setText(translate("Items found: ") +integerToString(itemsfound));
		searchResults.setXmlParam("h", "-36");
	}

	if(!results_layout.isVisible()) results_layout.show();

	// Fix if always on top is enabled.. it just refresh the ontop ;)
	results_layout.setXmlParam("ontop", "1");

  
	resizeResults(itemsfound);
}

searchResults.onDoubleClick(Int itemnum){
	PlEdit.playTrack (getPlEntry(itemnum));
	setSearchBox(false);
}

searchResults.onRightClick(Int itemnum){
	search_rc = new PopupMenu;
	search_rc.addCommand("Move selected to top", 1, 0, 0);
	search_rc.addCommand("Move selected to bottom", 2, 0, 0);
	search_rc.addCommand("Move selected after current", 3, 0, 0);
	search_rc.addCommand("Move selected together", 4, 0, 0);
	search_rc.addSeparator();
	search_rc.addCommand("Remove selected from playlist", 5, 0, 0);
	int result = search_rc.popAtMouse();
	delete search_rc;
	
	int lastselected = searchResults.getFirstItemSelected();
	int itemcounter = 1;

	if(result==1){
		PlEdit.moveTo (getPlEntry(lastselected), 0);
		while(searchResults.getNextItemSelected(lastselected) != -1){
			lastselected = searchResults.getNextItemSelected(lastselected);
			PlEdit.moveTo (getPlEntry(lastselected), itemcounter);
			itemcounter++;
		}
		PlEdit.showTrack(0);
	}
	else if(result==2){
		PlEdit.moveTo (getPlEntry(lastselected), PlEdit.getNumTracks ()-1);
		while(searchResults.getNextItemSelected(lastselected) != -1){
			lastselected = searchResults.getNextItemSelected(lastselected);
			PlEdit.moveTo (getPlEntry(lastselected)-itemcounter, PlEdit.getNumTracks ()-1);
			itemcounter++;
		}
		PlEdit.showTrack(PlEdit.getNumTracks ()-1);
	}
	else if(result==3){
		int align = 0;
		int orignalPos = PlEdit.getCurrentIndex();
		int temp = getPlEntry(lastselected);
		if(PlEdit.getCurrentIndex() > temp) align++;

		if(orignalPos > getPlEntry(lastselected)) PlEdit.moveTo (getPlEntry(lastselected), PlEdit.getCurrentIndex());
		else  PlEdit.moveTo (getPlEntry(lastselected), PlEdit.getCurrentIndex()+1);
		
		while(searchResults.getNextItemSelected(lastselected) != -1){
			lastselected = searchResults.getNextItemSelected(lastselected);
			
			if(orignalPos != getPlEntry(lastselected)){
				if(orignalPos > getPlEntry(lastselected)){
					PlEdit.moveTo (getPlEntry(lastselected)-align, PlEdit.getCurrentIndex()+itemcounter);
				}
				else{
					PlEdit.moveTo (getPlEntry(lastselected), PlEdit.getCurrentIndex()+itemcounter+1);
				}

				temp = getPlEntry(lastselected);
				if(orignalPos > temp) align++;
				itemcounter++;
			}
		}
		PlEdit.showCurrentlyPlayingTrack();
	}
	else if(result==4){
		int startpos = getPlEntry(lastselected);
		while(searchResults.getNextItemSelected(lastselected) != -1){
			lastselected = searchResults.getNextItemSelected(lastselected);
			PlEdit.moveTo (getPlEntry(lastselected), startpos+itemcounter);
			itemcounter++;
		}
		PlEdit.showTrack(startpos);
	}
	else if(result==5){
		PlEdit.removeTrack (getPlEntry(lastselected));
		while(searchResults.getNextItemSelected(lastselected) != -1){
			lastselected = searchResults.getNextItemSelected(lastselected);
			PlEdit.removeTrack (getPlEntry(lastselected)-itemcounter);	
			itemcounter++;
		}
	}
	
	else return;
	
	//hides the search
	setSearchBox(false);
}

int getPlEntry(int search_item){
	return stringToInteger(getToken(searchResults.getItemLabel(search_item,0), ". ", 0))-1;
}

setSearchBox(boolean onOff){
	if(onOff){
		searchBox.show();
		searchBox.setxmlParam("h", "23"); // v1.1 set it because I make it 0 when toggling PL
		clearButton.show();
		searchButton.hide();
		searchButtonBG.hide();
		clearButtonText.show();
		helpSearch.hide();
		searchBox.setFocus();
    ActiveIndicatorBottom.setXmlParam("alpha", "253");
    ActiveIndicatorTop.setXmlParam("alpha", "253");
	}
	else{
		searchBox.hide();
		clearButton.hide();
		clearButtonText.hide();
		searchButtonBG.show();
		searchButton.show();
		helpSearch.show();
		results_layout.hide();
    ActiveIndicatorBottom.setXmlParam("alpha", "0");
    ActiveIndicatorTop.setXmlParam("alpha", "0");
  }
}


fakeSB.onLeftButtonDown(int x, int y){
  ActiveIndicatorTop.setXmlParam("x", "40");
  ActiveIndicatorTop.setAlpha(0);
  ActiveIndicatorTop.setXmlParam("w", "-800");
	ActiveIndicatorTop.setTargetX(0);
  ActiveIndicatorTop.setTargetA(253);
	ActiveIndicatorTop.setTargetW(0);
	ActiveIndicatorTop.setTargetSpeed(0.7);
	ActiveIndicatorTop.gotoTarget();


  ActiveIndicatorBottom.setXmlParam("x", "40");
  ActiveIndicatorBottom.setAlpha(0);
  ActiveIndicatorBottom.setXmlParam("w", "-800");
	ActiveIndicatorBottom.setTargetX(0);
  ActiveIndicatorBottom.setTargetA(253);
	ActiveIndicatorBottom.setTargetW(0);
	ActiveIndicatorBottom.setTargetSpeed(0.7);
	ActiveIndicatorBottom.gotoTarget();

  setSearchBox(true);	
}

fakeSB.onRightButtonDown(int x, int y){
	search_rc = new PopupMenu;
	search_rc.addCommand("Search History", 0, 0, 1);
	search_rc.addSeparator();
 	
	String history = getPublicString("BigBentoModern.PP.hist", "");
	boolean historyfound=false;
	for(int i=0;i<10;i++){
		String historyitem = getToken(history, ";", i);
		if(historyitem==""){
			if(i>0) historyfound=true;
			break;
		}
		search_rc.addCommand(historyitem, i+1, 0, 0);
	}
	if(historyfound) search_rc.addSeparator();
	search_rc.addCommand("Clear History", 100, 0, 0);

	int result = search_rc.popAtXY(getMousePosX()-15, clientToScreenY(fakeSB.getTop())+28);
	
	delete search_rc;

	if(result>0 && result<100){
		setSearchBox(true);
		searchBox.setText(getToken(history, ";", result-1));
		searchButton.leftClick();
	}
	else if(result==100){
		setPublicString("BigBentoModern.PP.hist", "");
	}

  ActiveIndicatorTop.setAlpha(0);
  ActiveIndicatorBottom.setAlpha(0);	
		
}

clearSearchBox(){
  ActiveIndicatorTop.setXmlParam("x", "0");
  ActiveIndicatorTop.setAlpha(253);
  ActiveIndicatorTop.setXmlParam("w", "0");
	ActiveIndicatorTop.setTargetX(40);
  ActiveIndicatorTop.setTargetA(0);
	ActiveIndicatorTop.setTargetW(-800);
	ActiveIndicatorTop.setTargetSpeed(0.7);
	ActiveIndicatorTop.gotoTarget();


  ActiveIndicatorBottom.setXmlParam("x", "0");
  ActiveIndicatorBottom.setAlpha(253);
  ActiveIndicatorBottom.setXmlParam("w", "0");
	ActiveIndicatorBottom.setTargetX(40);
  ActiveIndicatorBottom.setTargetA(0);
	ActiveIndicatorBottom.setTargetW(-800);
	ActiveIndicatorBottom.setTargetSpeed(0.7);
	ActiveIndicatorBottom.gotoTarget();

	searchBox.setText("");
	setSearchBox(false);
}

main_layout.onMove(){
	if(results_layout.isVisible()){
		results_layout.setXmlParam("x", integerToString(fakeSB.clientToScreenX(fakeSB.getLeft()-4)));
		results_layout.setXmlParam("y", integerToString(fakeSB.clientToScreenY(fakeSB.getTop() + fakeSB.getHeight())));
		results_layout.setXmlParam("ontop", "1");
	}
}

main_layout.onResize(int x, int y, int w, int h){
	if(results_layout.isVisible()) clearSearchBox();
}

scriptGroup.onResize(int x, int y, int w, int h){
	if(results_layout.isVisible()) clearSearchBox();
	
	if(h<102 || playlist_search_attrib.getData()=="0"){
	
		if(!topbar.isVisible()) return; //Don't do the same code over and over

		topbar.hide();
		plwh.setXmlParam("y", "4");
		plwh.setXmlParam("h", "-5");
		OCDPatchVertical.setXmlParam("y", "4"); //v1.15
		OCDPatchVertical.setXmlParam("h", "-5"); //v1.15
	}
	else{
		if(topbar.isVisible()) return; //Don't do the same code over and over

		topbar.show();
		OCDPatchVertical.setXmlParam("y", "35"); //v1.15
		OCDPatchVertical.setXmlParam("h", "-36"); //v1.15
		plwh.setXmlParam("y", "35");
		plwh.setXmlParam("h", "-36");
	}
}

clearButton.onLeftClick(){
	clearSearchBox();
}

playlist_search_attrib.onDataChanged(){
	scriptGroup.onResize(scriptGroup.getLeft(), scriptGroup.getTop(), scriptGroup.getWidth(), scriptGroup.getHeight());


	if (getData() == "0"){
		topbar.hide();
		plwh.setXMLParam("y", "4");
		plwh.setXMLParam("h", "-5");
		OCDPatchVertical.setXmlParam("y", "4");
		OCDPatchVertical.setXmlParam("h", "-5");
	}
	else if(getData() == "1"){
	
		topbar.show();
		OCDPatchVertical.setXmlParam("y", "35");
		OCDPatchVertical.setXmlParam("h", "-36");
		plwh.setXMLParam("y", "35");
		plwh.setXMLParam("h", "-36");
		
	} // Vic mod: Re-enabled to get a activation more consistent (tested)
}

String replaceString(string baseString, string toreplace, string replacedby){
	if (toreplace == "") return baseString;
	string sf1 = strupper(baseString);
	string sf2 = strupper(toreplace);
	int i = strsearch(sf1, sf2);
	if (i == -1) return baseString;
	string left = "", right = "";
	if (i != 0) left = strleft(baseString, i);
	if (strlen(basestring) - i - strlen(toreplace) != 0) {
		right = strright(basestring, strlen(basestring) - i - strlen(toreplace));
	}
	return left + replacedby + right;
}

System.onKeyDown(String key) {
	if (key == "esc")
	{
    if(clearButton.isVisible() == 1) clearSearchBox(); // Vic note: Yeah.. checking if clearButton is visible is a lame way to check if the input box is open
    else { return; }
  }
}


plwh.onLeftButtonDown(int x, int y) { // v1.Not working..

  clearSearchBox();
  searchBox.setxmlParam("h", "0");
    
  //int mousey = getMousePosY();
  //if (!results_layout.isMouseOverRect()) { clearSearchBox(); }
  //if (y > searchNews.getTop()) { clearButton.hide(); }
  //if (mousey < scriptGroup.getGuiH()) { clearButton.hide(); }
  //else { return; }
    /*if(clearButton.isVisible() == 1) clearSearchBox();
    else { return; }*/
}