/*---------------------------------------------------
-----------------------------------------------------
Filename:	pledit.m
Version:	3.1

Type:		maki
Date:		18. Sep. 2007 - 19:42
Author:		Martin Poehlmann aka Deimos + Victhor mods (08-2017)
E-Mail:		victorbrocaz@gmail.com
Internet:	victhor.deviantart.com
		
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"

//#define FILE_NAME "pledit.m"

#define PL_GUID "{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}"
#define PLC_POPPLER_POS 335

#include "attribs/init_playlist.m"
#include "attribs/init_windowpage.m"

Function fitContent (int playlistw, int playlistx);
Function fit (group g, int x, int rx, int y, int ry, int w, int rw, int h, int rh);
Function int updatePoppler(int w);
Function int updateMainPoppler(int w);

Global Frame dualwnd, pl_dualwnd, mainframe;

Global Group g_playlist, g_player, g_sui, g_buttons, g_mcv, g_cover, g_upper, wdh_pl;
Global Button p_enlarge, p_small;
Global Button p_resize;
Global int down_x, down_gx, isresizing;
Global layout normal, shade; // v1.14 (shade)
Global Container player;
Global Text pl_time;

Global Button pe_add, pe_rem, pe_sel, pe_misc, pe_manage;

Global Boolean startup, isBig, bypass_nocomp;

Global Timer dc_openPl, dc_closePl, dc_loadWnd;

Global Int COMP_Y, COMP_H, SUI_Y, SUI_H, BOTTOMSPACER, MAX_PL_H;
Global Int DEF_PL_W, SIDESPACER, DEF_PL_W_SIDE;

Global Int min_infowidth;


System.onScriptLoaded ()
{
	initAttribs_Playlist();
	initAttribs_windowpage();
	normal = getScriptGroup();
	player = normal.getContainer();
	
	shade = player.getLayout("shade"); // v1.14

  mainframe = normal.getObject("player.mainframe.big");

	dualwnd = mainframe.findObject("player.dualwnd");
	g_mcv = dualwnd.findObject("player.component.fileinfo");
	g_upper = dualwnd.findObject("player.component.playlist.frame");
	pl_dualwnd = dualwnd.findObject("playlist.dualwnd");
	g_playlist = pl_dualwnd.findObject("player.component.playlist");
	g_cover = pl_dualwnd.findObject("player.component.playlist.albumart");
	g_player = dualwnd.findObject("player.layout");
	g_sui = normal.getObject("sui.content");
	g_buttons = g_playlist.getObject("player.component.playlist.buttons");
	p_enlarge = g_buttons.getObject("player.playlist.enlarge");
	p_small = g_buttons.getObject("player.playlist.small");
	p_resize = g_playlist.getObject("player.resize");
	wdh_pl = g_playlist.getObject("playlistpro");
	pl_time = g_buttons.getObject("PLTime");
	
	pe_add = g_buttons.getObject("player.playlist.add");
	pe_rem = g_buttons.getObject("player.playlist.rem");
	pe_sel = g_buttons.getObject("player.playlist.sel");
	pe_misc = g_buttons.getObject("player.playlist.misc");
	pe_manage = g_buttons.getObject("player.playlist.manage");

	min_infowidth = stringtoInteger(dualwnd.getXmlParam("maxwidth"));

	dc_openPl = new Timer;
	dc_openPl.setDelay(1);

	dc_closePl = new Timer;
	dc_closePl.setDelay(1);

	dc_loadWnd = new Timer;
	dc_loadWnd.setDelay(1);

	//	Global Definitions:

	DEF_PL_W = g_playlist.getGuiW(); // (-)
	DEF_PL_W_SIDE = wdh_pl.getGuiW(); // (-)
	SIDESPACER = g_sui.getGuiX(); // (+)
	COMP_Y = mainframe.getGuiY(); // (+)
	COMP_H = mainframe.getGuiH(); // (+)
	SUI_Y = g_sui.getGuiY(); // (+)
	SUI_H = g_sui.getGuiH(); // (-)
	BOTTOMSPACER = SUI_Y + SUI_H; // (-)
	MAX_PL_H = BOTTOMSPACER - COMP_Y; // (-)

	startup = 1;

	// show playlist album art if checked
	playlist_cover_attrib.onDataChanged();

  getPrivateInt("Big Bento Modern", "pledit poppler width2", 335);

	//Bento v0.8 hack
	if (mainframe.getPosition() < stringToInteger(mainframe.getXmlParam("minwidth")))
	{
		mainframe.setPosition(stringToInteger(mainframe.getXmlParam("minwidth")));
	}
}

system.onScriptUnloading ()
{
	int pos = pl_dualwnd.getPosition();
	if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos);
	
	int pos2 = getPrivateInt("Big Bento Modern", "pledit poppler width", 335);
	if (pos2 > 0) setPrivateInt("Big Bento Modern", "pledit poppler width2", pos2);

	delete dc_loadWnd;
	delete dc_openPl;
	delete dc_closePl;
}

dc_loadWnd.onTimer ()
{
	stop();
	int pos = dualwnd.getPosition();
	if (pos > 0) updatePoppler(pos);
	playlist_enlarge_attrib.onDataChanged();

	if (dualwnd.getPosition() > 0
#ifdef DOHIDEMCV
		|| dualwnd.getXMlParam("from") == "left"
#endif
		) dc_openPL.start();


	else wdh_pl.hide(); //hideWa2Component(PL_GUID);
}

playlist_enlarge_attrib.onDataChanged ()
{
	int pl_w = dualwnd.getPosition();

#ifdef DOHIDEMCV
	if (dualwnd.getXmlParam("from") == "left")
	{
		pl_w = dualwnd.getWidth() - 6;
	}
#endif	

	int pl_x = 0 - ( pl_w + SIDESPACER ); // (-)

	if (getData() == "1")
	{
		int sui_w = pl_x - SIDESPACER; // (-)

		dualwnd.setXmlParam("relath", "1");
		dualwnd.setXmlParam("h", integerToString(0));
		mainframe.setXmlParam("relath", "1");
		mainframe.setXmlParam("h", integerToString(MAX_PL_H));

		g_sui.setXmlParam("w", integerToString(sui_w-4));

		int pos = getPrivateInt("Big Bento Modern", "playlist_cover_poppler", PLC_POPPLER_POS);
		if (playlist_cover_attrib.getData() == "1" && pos > 0 && getPrivateString("Big Bento Modern", "Component", "Media Library") != "Hidden")
		{
			g_cover.show();
			pl_dualwnd.setPosition (pos);
		}
		else
		{
			pl_dualwnd.setPosition (0);
			g_cover.hide();
		}

		p_enlarge.hide();
		p_small.show();
	}
	else
	{
		int sui_w = 0 - SIDESPACER - SIDESPACER; // (-)
		int pc_w = pl_x - SIDESPACER; // (-)

		g_cover.hide();

		if (playlist_cover_attrib.getData() == "1")
		{
			int pos = pl_dualwnd.getPosition();
			if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos);
		}
		pl_dualwnd.setPosition (0);

		dualwnd.setXmlParam("h", integerToString(COMP_H-3));
		dualwnd.setXmlParam("relath", "0");
		mainframe.setXmlParam("h", integerToString(COMP_H));
		mainframe.setXmlParam("relath", "0");

		g_sui.setXmlParam("w", integerToString(sui_w));
		p_enlarge.show();
		p_small.hide();
	}
}

g_playlist.onResize (int x, int y, int w, int h)
{
	int pos = dualwnd.getPosition();

  updateMainPoppler(min_infowidth - pos - 10);

	if (pos > 0 
#ifdef DOHIDEMCV
		|| dualwnd.getXMlParam("from") == "left"
#endif
		) 
	{
			
    if (!wdh_pl.isVisible()) // v1.1 added?
		{
			setPrivateString("Big Bento Modern", "Pledit_pos", "top");
			g_sui.sendAction("hide_comp", "pe", 0,0,0,0);

			dc_openPl.start();
		}
		//if (isBig) // v1.1: removed this + a chunk before the "else wdh_pl.hide();"
		//{
			if (w > 308) // Attention: this can cause the player to open with the SUI in a strange width on first load (v1.1: is it?)
			{
				pe_add.show();
				pe_rem.show();
				pe_sel.show();
				pe_misc.show();
				pe_manage.show();
			}
			else // v1.1: Just close Pl if not enough room
			{
				pe_add.show();
				pe_rem.show();
				pe_sel.show();
				pe_misc.show();
				pe_manage.hide();
        g_playlist.hide();
        dualwnd.setPosition(0);
			}
	}
	else { wdh_pl.hide(); }
	
	if (playlist_enlarge_attrib.getdata() == "1")
	{
		int sui_w = - g_playlist.getWidth() - (2 * SIDESPACER) - 14;
		g_sui.setXmlParam("w", integerToString(sui_w));
		if (startup)
		{
			startup = 0;
			mainframe.setXmlParam("relath", "1");
			mainframe.setXmlParam("h", integerToString(MAX_PL_H));
			dualwnd.setXmlParam("relath", "1");
			dualwnd.setXmlParam("h", integerToString(0));
		}
	}
}

normal.onSetVisible (Boolean onoff)
{
	if (onoff)
	{
		playlist_enlarge_attrib.onDataChanged();
		int pos = dualwnd.getPosition();
		if (pos > 0 
#ifdef DOHIDEMCV
			|| dualwnd.getXMlParam("from") == "left"
#endif
			) 
		{
			updatePoppler(pos);
			dc_openPL.start();
		}
		else wdh_pl.hide();
	}

}

normal.onUserResize (int x, int y, int w, int h)
{
	int pos = dualwnd.getPosition();
	if (pos > 0) updatePoppler(pos);
}

/** Hide pl_time if it cannot be full displayed */

pl_time.onResize (int x, int y, int w, int h)
{
	if (w < getTextWidth())
	{
		hide();
	}
	else
	{
		show();
	}
}

pl_time.onTextChanged (String newtxt)
{
	if (getWidth() < getTextWidth())
	{
		hide();
	}
	else
	{
		show();
	}
}


dualwnd.onLeftButtonDown(int x, int y) // v1.1: Saving now this position in case it goes to 0 (I don't want to save a 0 position!!)
{
	int pleditpopplerw2 = dualwnd.getPosition();
	setPrivateInt("Big Bento Modern", "pledit poppler width2", pleditpopplerw2);
}

dualwnd.onLeftButtonUp(int x, int y) // v1.1
{
  int pleditpopplerw2 = getPrivateInt("Big Bento Modern", "pledit poppler width2", 335);
  
  if (dualwnd.getPosition() < 1) // v1.1: Button went up when dualwnd was in 0, so I'm saving the number retrieved when the Button went down
  {
    setPrivateInt("Big Bento Modern", "pledit poppler width", pleditpopplerw2);
	}
	else if (dualwnd.getPosition() > 0)
	{
		setPrivateInt("Big Bento Modern", "pledit poppler width", dualwnd.getPosition());
	}
}


/** Playlist Component Handling */

System.onGetCancelComponent (String guid, boolean goingvisible)
{
	if (getPrivateString("Big Bento Modern", "Pledit_pos", "top") == "sui")
	{
		return;
	}

	if (guid == PL_GUID)
	{
		Boolean isShade = player.getCurLayout() != normal;
		if (goingvisible == TRUE && !isShade) // v1.1 Pl is about to show
		{
      if (dualwnd.getPosition() == 0)
      {
        int max_w = stringToInteger(dualwnd.getXmlParam("maxwidth")); // v1.1: This number here is negative (i.e. "-194")..
        int max_w_positive = max_w-max_w*2; // v1.1: Making the int into a positive number
        int min_w = stringToInteger(dualwnd.getXmlParam("minwidth"));
        int minmax_w = (max_w_positive+min_w)+480; // v1.1: 480 is the Display area + the divider + a little extra
    
        int screenw = getMonitorWidth();
        int player_chunk_missing = minmax_w - normal.getwidth();
        
    if (normal.getwidth() < minmax_w && normal.getwidth() == (screenw)/2 && normal.getLeft() != 0) { normal.resize(normal.getLeft() - player_chunk_missing,normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough and Snaped2Right
    else if (normal.getwidth() < minmax_w && normal.getwidth() < (normal.getwidth() + screenw)/2 && normal.getLeft() == 0) { normal.resize(normal.getLeft(),normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough and Snaped2Left
    else if (normal.getwidth() < minmax_w && normal.getLeft() != 0) { normal.resize(normal.getLeft(),normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough
    else { normal.resize(normal.getLeft(),normal.getTop(),normal.getWidth(),normal.getHeight()); } // v1.11
    
        int poppler_w = getPrivateInt("Big Bento Modern", "pledit poppler width2", 335); // Get the saved dualwnd position
        g_playlist.show();
        updatePoppler(poppler_w); // apply the new position of dualwnd
        dc_openPl.start();
        //return FALSE;
      }
      else
      {
        int poppler_w = getPrivateInt("Big Bento Modern", "pledit poppler width", 335);
        g_playlist.show();
        updatePoppler(poppler_w); // apply the new position of dualwnd
        dc_openPl.start();
        //return FALSE;
      }
		}
		else //PL is closing with Keyboard or Pl button
		{
			if (dualwnd.getPosition() > 0) { // v1.1
        setPrivateInt("Big Bento Modern", "pledit poppler width2", dualwnd.getPosition());
        wdh_pl.hide();
        dualwnd.setPosition(0);
        return FALSE;
			}
		}
	}

}

normal.onAction (String action, String param, Int x, int y, int p1, int p2, GuiObject source)
{
	if (action == "load_comp" && strlower(param) == "pledit") // v1.1
	{
    int max_w = stringToInteger(dualwnd.getXmlParam("maxwidth")); // v1.1: This number here is negative (i.e. "-194")...
    int max_w_positive = max_w-max_w*2; // v1.1: Making the int into a positive number
    int min_w = stringToInteger(dualwnd.getXmlParam("minwidth"));
    int minmax_w = (max_w_positive+min_w)+480; // v1.1: 480 is the Display area + the divider + a little extra

    int screenw = getMonitorWidth();
    int player_chunk_missing = minmax_w - normal.getwidth();

    if (normal.getwidth() < minmax_w && normal.getwidth() == (screenw)/2 && normal.getLeft() != 0) { normal.resize(normal.getLeft() - player_chunk_missing,normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough and Snaped2Right
    else if (normal.getwidth() < minmax_w && normal.getwidth() < (normal.getwidth() + screenw)/2 && normal.getLeft() == 0) { normal.resize(normal.getLeft(),normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough and Snaped2Left
    else if (normal.getwidth() < minmax_w && normal.getLeft() != 0) { normal.resize(normal.getLeft(),normal.getTop(),minmax_w,normal.getHeight()); } // v1.1: Making room for PL when player width is not enough
    else { normal.resize(normal.getLeft(),normal.getTop(),normal.getWidth(),normal.getHeight()); } // v1.11
        
		int poppler_w = getPrivateInt("Big Bento Modern", "pledit poppler width", 335);
		int poppler_w2 = getPrivateInt("Big Bento Modern", "pledit poppler width2", 335);

		if (dualwnd.getPosition() > 0)
		{
      updatePoppler(poppler_w);
      dc_openPl.start();
		}
    else 
    {
      if (poppler_w2 < 320) { updatePoppler(335); }
      else {
      updatePoppler(poppler_w2); }
      dc_openPl.start(); 
    }
		
	}
	if (action == "hide_comp" && strlower(param) == "pledit")
	{
    if (dualwnd.getPosition() > 0) // v1.1
		{
      setPrivateInt("Big Bento Modern", "pledit poppler width2", dualwnd.getPosition());
    }
    else
    {
      int poppler_w2 = getPrivateInt("Big Bento Modern", "pledit poppler width2", 335);
      setPrivateInt("Big Bento Modern", "pledit poppler width", poppler_w2);
    }
      wdh_pl.hide();
      dualwnd.setPosition(0);
	}
	if (action == "pledit_posupdate")
	{
		int pos = dualwnd.getPosition();
		if (pos > 0) updatePoppler(pos);
	}
	if (action == "sui")
	{
		if (param == "tonocomp")
		{
			if (playlist_cover_attrib.getData() == "1")
			{
				int pos = pl_dualwnd.getPosition();
				if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos);
			}
			bypass_nocomp = TRUE; //we need to add a bypass otherwise playlist_cover_attrib will be turned OFF
			pl_dualwnd.setPosition (0);
			g_cover.hide();
			bypass_nocomp = FALSE;
		}
		else if (param == "fromnocomp")
		{
			playlist_cover_attrib.onDataChanged ();
		}
	}
}


dualwnd.onAction (String action, String param, Int x, int y, int p1, int p2, GuiObject source)
{
	if (action == "set_maxwidth")
	{
		// update poppler for playlist/infocomp
		updatePoppler(dualwnd.getPosition());
		// update poppler bands for player/infocomp
		min_infowidth = x;
		updateMainPoppler(min_infowidth - dualwnd.getPosition() - 14); // v1.1 fix
	}
}

wdh_pl.onSetVisible (Boolean onoff)
{
	if (onoff)
	{
		playlist_cover_attrib.onDataChanged();
	}
	else
	{
		int pos = pl_dualwnd.getPosition();
		if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos);
	}
}

updatePoppler(int w)
{
	if (dualwnd.getPosition() == 0 && w == 0) return;
	int min_w = stringToInteger(dualwnd.getXmlParam("minwidth"));
	int max_w = stringToInteger(dualwnd.getXmlParam("maxwidth"));
	if (max_w < 0) max_w = dualwnd.getWidth() + max_w;
	boolean reset = FALSE;
	reset += (w == 0);
	reset += (w < min_w);
	if (reset) w = min_w;

	// Prevent the playlist from overlapping the player
	if (w > max_w) 
	{
		w = max_w;

		// Resize the player to get more space
		if (max_w < min_w)
		{
			w = min_w;
			int mainframe_pos = mainframe.getPosition() - (min_w - max_w); // I need to save this in a variable first, otherwise mainframe.setPos will crash...
			mainframe.setPosition(mainframe_pos);
		}
	}
	dualwnd.setPosition(w);
}

updateMainPoppler (int w)
{
	mainframe.setXmlparam("maxwidth", integerToString(w));
}

dc_openPl.onTimer ()
{
	dc_openPl.stop();
	wdh_pl.show();
	g_playlist.show();
	g_upper.show();
}

dc_closePl.onTimer ()
{
	dc_closePl.stop();
	wdh_pl.hide();
}

//----------------------------------------------------------------------------------------------------------------
// Playlist Album Art Handles
//----------------------------------------------------------------------------------------------------------------

Global boolean attrib_bypass = false;

playlist_cover_attrib.onDataChanged ()
{
	if (attrib_bypass)
		return;

	if (playlist_enlarge_attrib.getData() == "0")
		return;

	if (getData() == "1")
	{
		int pos = getPrivateInt("Big Bento Modern", "playlist_cover_poppler", PLC_POPPLER_POS);
		if (pos > 0 && getPrivateString("Big Bento Modern", "Component", "Media Library") != "Hidden")
		{
			pl_dualwnd.setPosition (pos);
			g_cover.show();
		}
		else
		{
			pl_dualwnd.setPosition (0);
			g_cover.hide();
		}
	}
	else
	{
		int pos = pl_dualwnd.getPosition();
		if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos);
		pl_dualwnd.setPosition(0);
		g_cover.hide();
	}
}

Global Boolean bypass;

player.onBeforeSwitchToLayout (Layout oldlayout, Layout newlayout)
{
  if (oldlayout == normal)
	{
    String window_content = getPrivateString("Big Bento Modern", "Pledit_pos", "top"); // v1.14
	
    if (window_content == "sui") { dualwnd.setPosition(0); } // v1.14
    else
    {
      int pos2 = dualwnd.getPosition();
      setPrivateInt("Big Bento Modern", "pledit poppler width", pos2);
		}
		
		bypass = 1;
	}
	
	//int pos = pl_dualwnd.getPosition(); // removed in v1.14
	//if (pos > 0) setPrivateInt("Big Bento Modern", "playlist_cover_poppler", pos); // removed in v1.14
}

player.onSwitchToLayout (Layout normal) // v1.14
{
	String window_content = getPrivateString("Big Bento Modern", "Pledit_pos", "top");
	
  if (window_content == "sui") { dualwnd.setPosition(0); }
  else
  {
    int pos2 = getPrivateInt("Big Bento Modern", "pledit poppler width", 335);
    dualwnd.setPosition(pos2);
  }
}

g_cover.onSetVisible (Boolean onoff)
{
	if (bypass)
	{
		bypass = 0;
		return;
	}

	if (!onoff && !bypass_nocomp && playlist_cover_attrib.getdata() == "1" && getPrivateString("Big Bento Modern", "Component", "Media Library") != "Hidden" && playlist_enlarge_attrib.getData() == "1" && dualwnd.getPosition() > 0)
	{
		playlist_cover_attrib.setdata("0");
	}
	else if (onoff && !bypass_nocomp && playlist_cover_attrib.getdata() == "0" && dualwnd.getPosition() > 0)
	{
		attrib_bypass = true;
		playlist_cover_attrib.setdata("1");
		attrib_bypass = false;
	}
}


p_enlarge.onRightButtonDown(int x, int y){ //Winamp bug hack
	p_enlarge.setXmlParam("action", "");
}

p_enlarge.onRightButtonUp(int x, int y){

  playlist_cover_attrib.setdata("1"); 
  
  complete;
	p_enlarge.setXmlParam("action", "");
}


p_small.onRightButtonDown(int x, int y){ //Winamp bug hack
	p_small.setXmlParam("action", "");
}

p_small.onRightButtonUp(int x, int y){

  playlist_cover_attrib.setdata("1"); 
  
  complete;
	p_small.setXmlParam("action", "");
}