#include "std.mi"
#include "attribs/init_Autoresize.m"


Function fullScreen(boolean onOff);
Function saveSkinPos();
Function updateMax();
Function viewPortUpdate();

Global Group scriptGroup, regions, Titlebar;
Global Container player;
Global Layout shade, normal;
Global Layer resizer, noResizer, topResizer, resizerbottom, resizerd, noResizerTB, resizerright, resizerleft, PlayerResizerCollapse, MaximizeG, RestoreG, CloseG/*, Wallp*/;
Global GuiObject MousetrapTB;
Global Button Maximize, Restore, CloseBtn;
Global Button /*hide_sui, */show_sui; //v1.1 leftover disabled on v1.2
Global Boolean fullscreen, doubleClick;
Global Timer delayViewPort;

//AeroSnap by pjn123
#define i_aerobox_start 40 
#define i_aerobox_screen_side 10 

Global Container c_aerosnap;
Global Layout l_aerosnap;
Global Boolean clipped;

Global int 	l_x, l_y, l_w, l_h;
Global int 	vp_x, vp_x2, vp_y, vp_w, vp_h;
Global int i_y, i_center;
Global int i_clip_w, i_clip_h, i_snapMode; // i_snapMode: 0=disabled, 1=left, 2=top, 3=right


System.onScriptLoaded() {
	initAttribs_Autoresize();

	player = System.getContainer("main");
	normal = player.getLayout("normal");

  delayViewPort = new Timer;
	delayViewPort.setDelay(10);
	
	scriptGroup = getScriptGroup();
	Titlebar = scriptGroup.findObject("player.titlebar");
	//Wallp = scriptGroup.findObject("wallp");
	//MousetrapTB = Titlebar.findObject("player.mousetrap.maximize"); // v1.15 changed for player.titlebar.grid to eliminate one layer
	MousetrapTB = Titlebar.findObject("player.titlebar.grid");
	
	Maximize = scriptGroup.findObject("player.titlebar.button.maximize"); // v1.1 mod
	Restore = scriptGroup.findObject("player.titlebar.button.restore"); // v1.1 mod
	MaximizeG = scriptGroup.findObject("player.titlebar.button.maximize.glyph"); // v1.1 added
	RestoreG = scriptGroup.findObject("player.titlebar.button.restore.glyph"); // v1.1 added
	CloseBtn = scriptGroup.findObject("close.btn"); // v1.1 added
	CloseG = scriptGroup.findObject("close.glyph"); // v1.1 added

	resizer = normal.findObject("player.resizer.bottomright");
	resizerleft = normal.findObject("two.frame.4");
	resizerright = normal.findObject("two.frame.6");
	resizerbottom = normal.findObject("player.resizer.bottom");
	topResizer = Titlebar.findObject("titlebar.resizer.top");
	resizerd = normal.findObject("player.resizer.bottomright.dummy");
	noResizer = normal.findObject("player.resizer.disable");
	noResizerTB = normal.findObject("titlebar.resizer.disable");
	regions = normal.findObject("window.background.regions");


	//hide_sui = normal.getObject("sui.hide"); //v1.1 leftover disabled on v1.2
	show_sui = normal.getObject("sui.show");
	PlayerResizerCollapse = normal.getObject("player.resizer.collapse"); // v1.1: Used to hide/cover show_sui and hide_sui

	updateMax();


	fullscreen = getPublicInt("BigBentoModern.fs",false);

  if (fullScreen) { PlayerResizerCollapse.show(); } // Vic mod (v1.1)
 
  if (getPublicInt("BigBentoModern.clipped", 0) == 1) { PlayerResizerCollapse.show(); } // Vic mod (v1.1): Handle side snap saved state
  else if (getPublicInt("BigBentoModern.clipped", 0)) { PlayerResizerCollapse.hide(); } // Vic mod (v1.1): Handle side snap saved state

	//Remember last clip size
	i_clip_w = getPublicInt("BigBentoModern.i_clip_w", 772);
	i_clip_h = getPublicInt("BigBentoModern.i_clip_h", 530);
	clipped = getPublicInt("BigBentoModern.clipped", 0);

  resizerd.show();
  
//v1.2 experiment
  /*int wallhe = System.getMonitorHeight();
  int wallwi = System.getMonitorWidth();
  
  Wallp.setxmlparam("h", integerToString(wallhe));
  Wallp.setxmlparam("w", integerToString(wallwi));*/
}


//v1.2 experiment
/*normal.onMove() {
	//int PosLeft = System.getCurAppLeft();
	int PosTop = System.getCurAppTop();
	int PosTopo = (getMousePosY() - PosTop);
	//int PosTopx = (getMousePosX() - PosLeft);
  
  Wallp.setxmlparam("y", integerToString(PosTopo));
  //Wallp.setxmlparam("x", integerToString(PosTopx));
}*/



System.onScriptUnLoading(){
	delete delayViewPort;
	saveSkinPos();
}

normal.onAction (String action, String param, int x, int y, int p1, int p2, GuiObject source){
      
	if (strlower(action) == "toggle_fs"){
		if(Maximize.isVisible()) Maximize.leftClick();
		else Restore.leftClick();
	}
}

System.onShowLayout(Layout _layout){
	if(shade == NULL) shade = player.getLayout("shade");

	if(_layout==shade && normal.isVisible()){
		saveSkinPos();
	}
	
	else if(_layout==normal && !shade.isVisible()){
		fullScreen(fullscreen); //On cold start
		l_x=normal.getLeft();
		l_y=normal.getTop();
	}
}

System.onHideLayout(Layout _layout){
	if(_layout==shade && normal.isVisible()){
		fullScreen(fullscreen);
	}
}

normal.onScale (Double newscalevalue){
	if (normal != player.getCurLayout()) return;

	updateMax();
	
  if(getPublicInt("BigBentoModern.fs", 0)==1){
		double newscalevalue = normal.getScale();
		normal.resize(getViewPortLeftfromGuiObject(normal), getViewPortTopfromGuiObject(normal), getViewPortWidthfromGuiObject(normal)/newscalevalue, getViewPortHeightfromGuiObject(normal)/newscalevalue);
	}
		
}


/*
View port Changes for Windows 8+
*/
viewPortUpdate(){
	updateMax();

	vp_x = System.getViewportLeftFromPoint(normal.getLeft(), normal.getTop());
	vp_y = System.getViewportTopFromPoint(normal.getLeft(), normal.getTop());
	vp_w = System.getViewportWidthFromPoint(normal.getLeft(), normal.getTop());
	vp_h = System.getViewportHeightFromPoint(normal.getLeft(), normal.getTop());
	

	if(fullscreen){
		double newscalevalue = normal.getScale();
		normal.resize(getViewPortLeftfromGuiObject(normal), getViewPortTopfromGuiObject(normal), getViewPortWidthfromGuiObject(normal)/newscalevalue, getViewPortHeightfromGuiObject(normal)/newscalevalue);
	}
	else if (clipped){
		if(normal.getLeft()==vp_x){
			normal.resize(vp_x,vp_y,vp_w/2,vp_h);
		}
		else{
			normal.resize(vp_x+vp_w/2,0,vp_w/2,vp_h);
		}
	}

}

System.onViewPortChanged(int width, int height){
	if (delayViewPort) delayViewPort.start();
	else viewPortUpdate();
}

delayViewPort.onTimer(){
	delayViewPort.stop();
	viewPortUpdate();
}
/*
End of: View port Changes for Windows 8+
*/


updateMax(){
	double newscalevalue = normal.getScale();
	normal.setXmlParam("maximum_w", integerToString(getViewPortWidthfromGuiObject(normal)/newscalevalue));
	normal.setXmlParam("maximum_h", integerToString(getViewPortHeightfromGuiObject(normal)/newscalevalue));
}


normal.onResize(int x, int y, int w, int h){
  // v1.1: Added to force fullscreen off when sui_autorsize_attrib is on and 1x or 2x are toggled
  if(w != getViewPortWidth() || h != getViewPortHeight() && sui_autorsize_attrib.getData() == "1" && getPrivateString("Big Bento Modern", "Component", "Media Library") == "Video")
  {
    Restore.hide();
    RestoreG.hide();
    Maximize.show();
    MaximizeG.show();
      
    noResizer.setXmlParam("h", "-10"); noResizer.setXmlParam("w", "-20"); noResizer.setXmlParam("x", "10"); noResizerTB.setXmlParam("h", "0");
    regions.show();

    PlayerResizerCollapse.hide();

    if(getPublicInt("BigBentoModern.saveby", 0)==1 && collapse_bottom_attrib.getData() == "1" && linkPosWidth.getData() == "1"){ y-=h-42; }
	}

  if(!fullscreen) { PlayerResizerCollapse.hide(); } // v1.1: forced for when playing video, snapping to side and then toggling 1X, 2X
	
	if(w*h>0){
		l_x=normal.getLeft();
		l_y=normal.getTop();
	}
	
	l_w=w;
	l_h=h;
}




// ------------------------------------------------------------------------------
// Prohibit autoresizing by Video if we're in maximized player (layout_normal)
// ------------------------------------------------------------------------------

sui_autorsize_attrib.onDataChanged ()
{
	if (getData() == "1")
	{
		normal.setXMLParam("lockminmax", "0");
	}
	else
	{
		double d = normal.getScale();
		if (normal.getLeft() == getViewportLeft() && normal.getTop() == getViewportTop() && normal.getWidth() == getViewPortWidthfromGuiObject(normal)/d && normal.getHeight() == getViewPortHeightfromGuiObject(normal)/d)
		{
			normal.setXMLParam("lockminmax", "1");
		}
	}
}


System.onKeyDown (String key)
{
	if (key == "ctrl+w" && (shade.isActive() || normal.isActive()))
	{
		if (shade != player.getCurLayout()) 
		{
			player.switchToLayout("shade");
		}
		else
		{
			player.switchToLayout("normal");
		}
		complete;
	}
}



saveSkinPos(){
	if(!fullscreen){
		if(normal.isVisible()){
			i_y = normal.getTop();
			if(i_y<0) i_y=0;
			setPublicInt("BigBentoModern.x", normal.getLeft());
			setPublicInt("BigBentoModern.y", i_y);
			setPublicInt("BigBentoModern.w", normal.getWidth());
			setPublicInt("BigBentoModern.h", normal.getHeight());
      
			setPublicInt("BigBentoModern.saveby", 0); //0=normal ; 1=shade
		}
    else{
			i_y = l_y;
			if(i_y<0) i_y=0;
			setPublicInt("BigBentoModern.x", l_x);
			setPublicInt("BigBentoModern.y", i_y);
			setPublicInt("BigBentoModern.w", l_w);
			setPublicInt("BigBentoModern.h", l_h);

			setPublicInt("BigBentoModern.saveby", 0); //0=normal ; 1=shade
		}
	}

}


fullScreen(boolean onOff){
	if(onOff){

    //Victhor mod: Force enable "Showing SUI" to prevent blank SUI area
    if (getPrivateString("Big Bento Modern", "Component", "Media Library") == "Hidden") { show_sui.leftClick(); } // Vic mod (v1.1): This button's visibility is re-used when reloading the skin

		//hide_sui.hide(); // Victhor mod: Added to prevent a conflicting behaviour - Re-showed when Restoring
		//show_sui.hide(); // Vic mod (v1.1)

    PlayerResizerCollapse.show();

		Maximize.hide();
		MaximizeG.hide();
		Restore.show();
		RestoreG.show();
				
		noResizer.setXmlParam("h", "0");
		noResizer.setXmlParam("w", "0");
		noResizer.setXmlParam("x", "0");
		noResizerTB.setXmlParam("h", "10");
		
		regions.hide();

    
		double newscalevalue = normal.getScale();
		normal.resize(getViewPortLeftfromGuiObject(normal), getViewPortTopfromGuiObject(normal), getViewPortWidthfromGuiObject(normal)/newscalevalue, getViewPortHeightfromGuiObject(normal)/newscalevalue);

		if (sui_autorsize_attrib.getData() == "0") normal.setXMLParam("lockminmax", "1"); // Vic mod (v1.1)
		else normal.setXMLParam("lockminmax", "0"); // Vic mod (v1.1)
	}
	else{
		Restore.hide();
		RestoreG.hide();
		Maximize.show();
		MaximizeG.show();
		
		noResizer.setXmlParam("h", "-10");
		noResizer.setXmlParam("w", "-20");
    noResizer.setXmlParam("x", "10");
		noResizerTB.setXmlParam("h", "0");
		regions.show();

		
		int x = getPublicInt("BigBentoModern.x", getCurAppLeft());
		int y = getPublicInt("BigBentoModern.y", getCurAppTop());

		int w = getPublicInt("BigBentoModern.w", 1536); // This happens to control the width on the first load..
		int h = getPublicInt("BigBentoModern.h", 878); // This happens to control the height on the first load..

    // check if player_w is too small // Vic v1.1: Disabled
    //if (w < stringToInteger(normal.getXmlParam("minimum_w"))) w = stringToInteger(normal.getXmlParam("minimum_w"));
    
    /*normal.resize(x, y, w, h);
    normal.sendAction("pledit_posupdate", "", 0,0,0,0);*/
    PlayerResizerCollapse.hide();

    normal.setXMLParam("lockminmax", "0"); // Vic mod (v1.1)

		if(getPublicInt("BigBentoModern.saveby", 0)==1 && collapse_bottom_attrib.getData() == "1" && linkPosWidth.getData() == "1"){
			y-=h-42; // 42 = Shade height
			
    }
 
	normal.resize (x, y, w, h);

  }
}


Maximize.onLeftClick(){
	saveSkinPos();

	fullscreen=true;
	setPublicInt("BigBentoModern.fs", fullscreen);
	fullScreen(fullscreen);
}

Restore.onLeftClick(){
	fullscreen=false;
	setPublicInt("BigBentoModern.fs", fullscreen);
	fullScreen(fullscreen);

  PlayerResizerCollapse.hide();
}

MousetrapTB.onLeftButtonDblClk(int x, int y) // v1.2 moved up here (possible fix)
{
	doubleClick=true;
}


MousetrapTB.onLeftButtonUp(int x, int y) {
	if(doubleClick){
		if(titlebar_dblclk_max_attib.getData() == "1"){
			if(Maximize.isVisible()){
				Maximize.leftClick();
				regions.hide();
			}
			else{
				Restore.leftClick();
        regions.show();				
			}
		}
		else{
			player.switchToLayout("shade");
		}
	}
	doubleClick=false;
}


player.onSwitchToLayout(Layout shade) // v1.1: Partial fix for "Link shade and player width" option not using fullscreen width
{
  if(linkPosWidth.getData() == "1" && fullscreen)
  {
    x = normal.getLeft();
    y = normal.getTop();
    w = normal.getWidth();
    //h = normal.getHeight(); // v1.2 get the height of the shade, not Normal, you dumbass
    h = shade.getHeight();
  
    shade.resize(x,y,w,h);
  }
}



/*
WIN 7 CLIP
*/
normal.onMove(){
	if (aerosnap_attrib.getData() == "0")
	{
    if(fullscreen && normal.getLeft() + normal.getTop()!= getViewPortTopfromGuiObject(normal) ){
   
      setPublicInt("BigBentoModern.x", normal.getLeft());
      setPublicInt("BigBentoModern.y", normal.getTop());

      Restore.leftClick();
      
      //normal.setXMLParam("lockminmax", "0");
    }
  }

  else if (aerosnap_attrib.getData() == "1")
  {

	l_x=normal.getLeft();
	l_y=normal.getTop();

	vp_x = System.getViewportLeftFromPoint(System.getMousePosX(), System.getMousePosY());
	vp_y = System.getViewportTopFromPoint(System.getMousePosX(), System.getMousePosY());
	vp_w = System.getViewportWidthFromPoint(System.getMousePosX(), System.getMousePosY());
	vp_h = System.getViewportHeightFromPoint(System.getMousePosX(), System.getMousePosY());
	

    if(clipped && normal.getTop()!= getViewPortTopfromGuiObject(normal) ){

		normal.resize(normal.getLeft(),normal.getTop(),i_clip_w,i_clip_h);
		
		clipped=false;
		setPublicInt("BigBentoModern.clipped", clipped);
	
    }
      else if(fullscreen && normal.getLeft() + normal.getTop()!= getViewPortTopfromGuiObject(normal) ){
        setPublicInt("BigBentoModern.x", normal.getLeft());
        setPublicInt("BigBentoModern.y", normal.getTop());

        Restore.leftClick();
    }

    //LEFT SNAP
    if(System.getMousePosX()< vp_x+10 && i_snapMode==0 ){
      i_snapMode=1;
      c_aerosnap = newDynamicContainer("main.aerosnap");
      l_aerosnap = c_aerosnap.getLayout("normal");
  
      /*Winamp can't resize the frame so that it looks like the frame is anchored to the right of the screen.
      Doesn't look smooth, so disabling the animation :( */ // Re-enabled and modded by Victhor (looks good enough for me)
      
      l_aerosnap.resize(vp_x + i_aerobox_screen_side-i_aerobox_screen_side, System.getMousePosY()-i_aerobox_start/2,i_aerobox_start,i_aerobox_start);      
      l_aerosnap.setTargetX(vp_x + i_aerobox_screen_side);
      l_aerosnap.setTargetY(vp_y + i_aerobox_screen_side);
      l_aerosnap.setTargetW(vp_w/2);
      l_aerosnap.setTargetH(System.getViewportHeight()-i_aerobox_screen_side*2);
      l_aerosnap.setTargetSpeed(0.25);
      l_aerosnap.gotoTarget();
  
      l_aerosnap.show();
    }
	
    else if(System.getMousePosX()> vp_x+15  && i_snapMode==1){
      i_snapMode = 0;
      c_aerosnap.close();
      c_aerosnap = NULL;
      l_aerosnap = NULL;
    }


    //RIGHT SNAP
    if(System.getMousePosX() > vp_x +vp_w - 10 && i_snapMode==0){
      i_snapMode=3;
      c_aerosnap = newDynamicContainer("main.aerosnap");
      l_aerosnap = c_aerosnap.getLayout("normal");

      /*Winamp can't resize the frame so that it looks like the frame is anchored to the right of the screen.
      Doesn't look smooth, so disabling the animation :( */ // Re-enabled and modded by Victhor (looks good enough for me)
		
      l_aerosnap.resize(System.getMousePosX(),System.getMousePosY(),vp_w/2,i_aerobox_start);
      l_aerosnap.setTargetX(vp_x+vp_w/2);
      l_aerosnap.setTargetY(vp_y + i_aerobox_screen_side);
      l_aerosnap.setTargetW(vp_w/2);
      l_aerosnap.setTargetH(System.getViewportHeight()-i_aerobox_screen_side*2);
      l_aerosnap.setTargetSpeed(0.25);
      l_aerosnap.gotoTarget();
  
   
      l_aerosnap.show();
    }
    else if(System.getMousePosX()< vp_x+vp_w-15 && i_snapMode==3){
      i_snapMode = 0;
      c_aerosnap.close();
      c_aerosnap = NULL;
      l_aerosnap = NULL;
    }


    //Top SNAP
    if(System.getMousePosY()< vp_y+5 && i_snapMode==0 && !fullscreen){
      i_snapMode=2;
      c_aerosnap = newDynamicContainer("main.aerosnap");
      l_aerosnap = c_aerosnap.getLayout("normal");
  
      
      /*Winamp can't resize the frame so that it looks like the frame is anchored to the right of the screen.
      Doesn't look smooth, so disabling the animation :( */ // Re-enabled and modded by Victhor (looks good enough for me)
      
      l_aerosnap.resize(System.getMousePosX(),System.getMousePosY(),i_aerobox_start,i_aerobox_start);
      l_aerosnap.setTargetX(vp_x);
      l_aerosnap.setTargetY(vp_y);
      l_aerosnap.setTargetW(vp_w);
      l_aerosnap.setTargetH(vp_h);
      l_aerosnap.setTargetSpeed(0.25);
      l_aerosnap.gotoTarget();
      
  
      l_aerosnap.show();
    }
    else if(System.getMousePosY()>vp_y+15 && i_snapMode==2){
      i_snapMode = 0;
      c_aerosnap.close();
      c_aerosnap = NULL;
      l_aerosnap = NULL;
    }
	
 }	
		
}



normal.onEndMove(){
	if(aerosnap_attrib.getData() == "0") return;
	//debug("123");

	if(i_snapMode==0) //{ 
    //if (getPrivateString("Big Bento Modern", "Component", "Media Library") != "Hidden") hide_sui.show();  // Vic mod (v1.1)
    return;
  //}

	i_clip_w = normal.getWidth();
	i_clip_h = normal.getHeight();
	
  //if (getPrivateString("Big Bento Modern", "Component", "Media Library") != "Hidden") PlayerResizerCollapse.hide(); // Vic mod (v1.1)

	if(i_snapMode==1){
		//Delete frame
		i_snapMode = 0;
		c_aerosnap.close();
		c_aerosnap = NULL;
		l_aerosnap = NULL;
    
    //Victhor mod: Force enable "Showing SUI" to prevent blank SUI area
    if (show_sui.isVisible()) show_sui.leftClick();
    
		//Resize player
		clipped=true;
		normal.resize(vp_x,vp_y,vp_w/2,vp_h);
		//hide_sui.hide(); // Vic mod (v1.1)
		PlayerResizerCollapse.show();
	}
	else if(i_snapMode==2){
		//Delete frame
		i_snapMode = 0;
		c_aerosnap.close();
		c_aerosnap = NULL;
		l_aerosnap = NULL;
				    
    //Victhor mod: Force enable "Showing SUI" to prevent blank SUI area
    //if (show_sui.isVisible()) show_sui.leftClick();	hide_sui.hide();
    if (show_sui.isVisible()) show_sui.leftClick();	PlayerResizerCollapse.show();

    Maximize.leftClick();
	}
	else if(i_snapMode==3){
	
		//Delete frame
		i_snapMode = 0;
		c_aerosnap.close();
		c_aerosnap = NULL;
		l_aerosnap = NULL;

    //Victhor mod: Force enable "Showing SUI" to prevent blank SUI area
    if (show_sui.isVisible()) show_sui.leftClick();
    
		//Resize player
		clipped=true;
		normal.resize(vp_x+vp_w/2,vp_y,vp_w/2,vp_h);
    //hide_sui.hide(); // Vic mod (v1.1)
    PlayerResizerCollapse.show();
	}
	
	setPublicInt("BigBentoModern.i_clip_w", i_clip_w);
	setPublicInt("BigBentoModern.i_clip_h", i_clip_h);
	setPublicInt("BigBentoModern.clipped", clipped);
}


// Victhor mod: Hover effect on right-bottom resizer
resizerd.onEnterArea()
{
  resizerd.setXmlParam("image", "window.background.resizer.h");
  resizerd.sendAction("set_image", "window.background.resizer.h", 0, 0, 0, 0);
}

resizerd.onLeaveArea()
{
  resizerd.setXmlParam("image", "window.background.resizer.hidden");
  resizerd.sendAction("set_image", "window.background.resizer.hidden", 0, 0, 0, 0);
}

System.onAccelerator(String action, String section, String key)
{
  if (action == "HOTKEY_FULLSCREEN") {
		if (Maximize.isVisible() == 1) Maximize.leftClick();
		else if (Restore.isVisible() == 1) Restore.leftClick();
  }

  /*if (action == "HOTKEY_MAXIMIZE") {
		if (Maximize.isVisible() == 1) Maximize.leftClick();
  }
  
  if (action == "HOTKEY_RESTORE") {
		//if (Restore.isVisible() == 1) Restore.leftClick();
		Restore.leftClick();
  }

  vp_x = System.getViewportLeftFromPoint(System.getMousePosX(), System.getMousePosY());
  vp_y = System.getViewportTopFromPoint(System.getMousePosX(), System.getMousePosY());
  vp_w = System.getViewportWidthFromPoint(System.getMousePosX(), System.getMousePosY());
  vp_h = System.getViewportHeightFromPoint(System.getMousePosX(), System.getMousePosY());

  if (action == "HOTKEY_SNAPRIGHT") {
    if (aerosnap_attrib.getData() == "1")
    {
      i_snapMode = 0;

      if (show_sui.isVisible()) show_sui.leftClick();
    
      //Resize player
      clipped=true;
      normal.resize(vp_x+vp_w/2,vp_y,vp_w/2,vp_h);
      PlayerResizerCollapse.show();
    }
  }
  if (action == "HOTKEY_SNAPLEFT") {
    if (aerosnap_attrib.getData() == "1")
    {
      i_snapMode = 0;

      if (show_sui.isVisible()) show_sui.leftClick();
    
		//Resize player
      clipped=true;
      normal.resize(vp_x,vp_y,vp_w/2,vp_h);
      PlayerResizerCollapse.show();
    }
  }*/
}

resizerright.onLeftButtonDblClk(int x, int y) // v1.1 added
{
  vp_x = System.getViewportLeftFromPoint(normal.getLeft(), normal.getTop());
	vp_y = normal.getTop();
	vp_w = System.getViewportWidthFromPoint(normal.getLeft(), normal.getTop());
	vp_h = normal.getHeight();

  normal.resize(vp_x,vp_y,vp_w,vp_h);
			
  saveSkinPos();
}

resizerleft.onLeftButtonDblClk(int x, int y) // v1.1 added
{
  vp_x = System.getViewportLeftFromPoint(normal.getLeft(), normal.getTop());
	vp_y = normal.getTop();
	vp_w = System.getViewportWidthFromPoint(normal.getLeft(), normal.getTop());
	vp_h = normal.getHeight();

  normal.resize(vp_x,vp_y,vp_w,vp_h);
			
  saveSkinPos();
}

topResizer.onLeftButtonDblClk(int x, int y) // v1.1 added
{
	vp_x = normal.getLeft();
	vp_y = System.getViewportTopFromPoint(normal.getLeft(), normal.getTop());
	vp_w = normal.getWidth();
	vp_h = System.getViewportHeightFromPoint(normal.getLeft(), normal.getTop());

  normal.resize(vp_x,vp_y,vp_w,vp_h);
			
  saveSkinPos();
}

resizerbottom.onLeftButtonDblClk(int x, int y) // v1.1 added
{
	vp_x = normal.getLeft();
	vp_y = System.getViewportTopFromPoint(normal.getLeft(), normal.getTop());
	vp_w = normal.getWidth();
	vp_h = System.getViewportHeightFromPoint(normal.getLeft(), normal.getTop());

  normal.resize(vp_x,vp_y,vp_w,vp_h);
			
  saveSkinPos();
}



CloseBtn.onEnterArea() // v1.1 added to cover the glyph for a bit so I can show a hover pic
{
  CloseG.setAlpha(0);
}

CloseBtn.onLeaveArea() // v1.1 added to cover the glyph for a bit so I can show a hover pic
{
  CloseG.setAlpha(253);
}