/*---------------------------------------------------
-----------------------------------------------------
Filename:	shadesize.m
Version:	2.1
Type:		maki
Date:		23. Jul. 2007 - 17:24 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "lib/pldir.mi" //It's important that this is loaded here...
#include "attribs/init_Autoresize.m"
#include "attribs/init_songticker.m"
#include "attribs/init_appearance.m"
#include "lib/colormgr.mi"
#include "lib/quickPlaylist.mi" //... and this here

Function updateObjectPosition(int w);
Function gotoGlobal();
Function saveGlobal();

Global int lastKnownW;
//Global GammaSet Current;

Global GuiObject SongTicker;
Global Timer reCheck;
Global Container player;
Global Layout shade, normal;
Global Boolean docked;

Global Group scriptGroup, ShadeDisplay;
Global Group g_cbuttons, g_sysbuttons, g_display, g_volume, g_seek, g_vis;

Global Int /*minumim_w, */x_cbuttons, w_cbuttons, w_sysbuttons, w_volume, w_display, w_seek, w_vis, x_seek;
Global Button shade_switch, MainMenuButton, STOverlayButton;
Global Layer WinampTextShade, WACUPTextShade;


System.onScriptLoaded ()
{
	initAttribs_Autoresize();
	initAttribs_Songticker();
  initAttribs_Appearance();
  
	player = System.getContainer("main");
	normal = player.getLayout("normal");
	shade = player.getLayout("shade");
	
	scriptGroup = getScriptGroup();
  ShadeDisplay = scriptGroup.findObject("shade.display");
  STOverlayButton = ShadeDisplay.findObject("songticker.overlay.button");
  shade_switch = scriptGroup.findObject("shade.switch");
	MainMenuButton = scriptGroup.findObject("shade.sysmenu");
	SongTicker = ScriptGroup.findObject("songticker");
	
	g_cbuttons = scriptGroup.findObject("player.cbuttons");
	x_cbuttons = stringToInteger(g_cbuttons.getXmlParam("x"));
	w_cbuttons = stringToInteger(g_cbuttons.getXmlParam("w"));

	g_seek = scriptGroup.findObject("shade.seek");
	w_seek = stringToInteger(g_seek.getXmlParam("w"));
	x_seek = stringToInteger(g_seek.getXmlParam("x"));

	g_vis = scriptGroup.findObject("shade.vis");
	w_vis = stringToInteger(g_vis.getXmlParam("w"));

	w_sysbuttons = stringToInteger(getParam());

	g_display = scriptGroup.findObject("shade.display");
	w_display = stringToInteger(g_display.getXmlParam("w"));
	g_volume = scriptGroup.findObject("shade.volume");
	w_volume = stringToInteger(g_volume.getXmlParam("w"));

  WinampTextShade = shade.findObject("text.winamp");
  WACUPTextShade = shade.findObject("text.wacup");
    
  if (wacup_attrib.getData() == "1")
  {
    WinampTextShade.hide();
    WACUPTextShade.show();
  }
  else
  {
    WinampTextShade.show();
    WACUPTextShade.hide();
  }

	reCheck = new Timer;
	reCheck.setDelay(10);
}

scriptGroup.onResize (int x, int y, int w, int h)
{
	updateObjectPosition(w);
	if(shade.isVisible()) saveGlobal();
	delete reCheck;	
}

scriptGroup.onSetVisible (Boolean onoff)
{
	if (onoff)
	{
		updateObjectPosition(scriptGroup.getWidth());
	}
}

//Normal shows > Shade still open (so busy with switch) > Save pos for  normal mode
System.onShowLayout(Layout _layout){
  
	if(_layout==normal && shade.isVisible()){ 
		saveGlobal();
	}
	else if(_layout==shade && !normal.isVisible()){
		gotoGlobal(); //On cold start
	}
}

//Normal hides > Shade is open (so
System.onHideLayout(Layout _layout){

	if(_layout==normal && shade.isVisible()){
		gotoGlobal();
	}
}

gotoGlobal(){
	String piPrefix;
	if(linkPosWidth.getData() == "1") piPrefix = "BigBentoModern.";
	else piPrefix = "BigBentoModern.2";

	if(docked) return;
	int x = getPublicInt(piPrefix+"x", getCurAppLeft());
	int y = getPublicInt(piPrefix+"y", getCurAppTop());
	int w = getPublicInt(piPrefix+"w", 772);
	int h = 42;

	if(w<565) w= 565;
	
	//Winshade -> Normal : Bottom of screen
	if(getPublicInt("BigBentoModern.saveby", 0)==0 && collapse_bottom_attrib.getData() == "1" && linkPosWidth.getData() != "0"){
		y=y+getPublicInt("BigBentoModern.h", getCurAppHeight())-42;
	}

	shade.resize(x,y,w,h);
}

saveGlobal(){

  //setPrivateString("Big Bento Modern", "Pledit_pos", "top");
  //setPrivateString("Big Bento Modern", "Component", "Media Library"); //////////////////////////////
  
		String piPrefix;
		if(linkPosWidth.getData() == "1") piPrefix = "BigBentoModern.";
		else piPrefix = "BigBentoModern.2";

		lastKnownW = shade.getWidth();
		
		setPublicInt(piPrefix+"x", shade.getLeft());
		setPublicInt(piPrefix+"y", shade.getTop());
		setPublicInt(piPrefix+"w", lastKnownW);

		if(linkPosWidth.getData() == "1") setPublicInt("BigBentoModern.saveby", 1); //0=normal ; 1=shade
}

reCheck.onTimer(){
		reCheck.stop();
		gotoGlobal();
}
shade.onDock(int side){
	docked=true;
}

shade.onUndock(){
	docked=false;
}

updateObjectPosition (int w)
{
	if (w >= x_cbuttons + w_cbuttons + 2 * w_display + w_volume + w_sysbuttons + 3.5 * w_seek + w_vis/* + w_links*/)
	{
		g_seek.setXmlParam("x", integerToString(x_seek - 2*w_seek));
		g_seek.setXmlParam("w", integerToString(3 * w_seek));
		g_cbuttons.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis));
		g_volume.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis + w_cbuttons));
		g_display.setXmlParam("x", integerToString(2 + x_cbuttons + w_cbuttons + w_volume + w_vis));
		g_display.setXmlParam("w", integerToString(0 - 1 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume - 3 * w_seek - w_vis/* - w_links*/));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.show();
		g_vis.show();
	}
	else if (w >= x_cbuttons + w_cbuttons + 2 * w_display + w_volume + w_sysbuttons + 2 * w_seek + w_vis/* + w_links*/)
	{
		g_seek.setXmlParam("x", integerToString(x_seek - w_seek));
		g_seek.setXmlParam("w", integerToString(2 * w_seek));
		g_cbuttons.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis));
		g_volume.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis + w_cbuttons));
		g_display.setXmlParam("x", integerToString(2 + x_cbuttons + w_cbuttons + w_volume + w_vis));
		g_display.setXmlParam("w", integerToString(0 - 1 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume - 2 * w_seek - w_vis/* - w_links*/));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.show();
		g_vis.show();
	}
	else if (w >= x_cbuttons + w_cbuttons + w_display + w_volume + w_sysbuttons + w_seek + w_vis/* + w_links*/)
	{
		g_seek.setXmlParam("x", integerToString(x_seek));
		g_seek.setXmlParam("w", integerToString(w_seek));
		g_cbuttons.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis));
		g_volume.setXmlParam("x", integerToString(2 + x_cbuttons + w_vis + w_cbuttons));
		g_display.setXmlParam("x", integerToString(2 + x_cbuttons + w_cbuttons + w_volume + w_vis));
		g_display.setXmlParam("w", integerToString(0 - 1 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume - w_seek - w_vis/* - w_links*/));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.show();
		g_vis.show();
	}
	else if (w >= x_cbuttons + w_cbuttons + w_display + w_volume + w_sysbuttons + w_seek/* + w_links*/)
	{
		g_seek.setXmlParam("x", integerToString(x_seek));
		g_seek.setXmlParam("w", integerToString(w_seek));
		g_volume.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons));
		g_cbuttons.setXmlParam("x", integerToString(x_cbuttons));
		g_display.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons + w_volume));
		g_display.setXmlParam("w", integerToString(0 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume - w_seek/* - w_links*/));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.show();
		g_vis.hide();
	}
	else if (w >= x_cbuttons + w_cbuttons + w_display + w_volume + w_sysbuttons + w_seek)
	{
		g_seek.setXmlParam("x", integerToString(x_seek));
		g_seek.setXmlParam("w", integerToString(w_seek));
		g_volume.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons));
		g_cbuttons.setXmlParam("x", integerToString(x_cbuttons));
		g_display.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons + w_volume));
		g_display.setXmlParam("w", integerToString(0 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume - w_seek));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.show();
		g_vis.hide();
	}
	else if (w >= x_cbuttons + w_cbuttons + w_display + w_volume + w_sysbuttons)
	{
		g_cbuttons.setXmlParam("x", integerToString(x_cbuttons));
		g_volume.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons));
		g_display.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons + w_volume));
		g_display.setXmlParam("w", integerToString(0 - x_cbuttons - w_cbuttons - w_sysbuttons - w_volume));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.show();
		g_seek.hide();
		g_vis.hide();
	}
	else if (w >= x_cbuttons + w_cbuttons + w_display + w_sysbuttons)
	{
		g_cbuttons.setXmlParam("x", integerToString(x_cbuttons));
		g_volume.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons));
		g_display.setXmlParam("x", integerToString(x_cbuttons + w_cbuttons));
		g_display.setXmlParam("w", integerToString(0 - x_cbuttons - w_cbuttons - w_sysbuttons));
		g_display.setXmlParam("relatw", "1");
		g_display.show();
		g_volume.hide();
		g_seek.hide();
		g_vis.hide();
	}
	else
	{
		g_cbuttons.setXmlParam("x", integerToString(x_cbuttons));
		g_volume.hide();
		g_display.hide();
		g_seek.hide();
		g_vis.hide();
	}
}

shade_switch.onRightButtonUp(int x, int y){
  System.minimizeApplication();
  complete;
	return;
}


// Attempt to fix the color theme not updating after changing CT and switching to normal - Not working

//player.onBeforeSwitchToLayout(Layout shade, Layout normal) // Tried - Not working
//player.onSwitchToLayout(Layout normal) // Tried - Not working
/*player.onShowLayout(Layout normal)
{  
  //String CurrentGammaSet2 = ColorMgr.getCurrentGammaSet();
  ColorMgr.onLoaded();
   
 // Current = ColorMgr.getCurrentGammaSet();
  ColorMgr.getCurrentGammaSet();
    
  //Current.update();
}*/

// Vic re-use of Main menu button's right click:

MainMenuButton.onRightButtonDown(int x, int y)
{
  MainMenuButton.setxmlparam("action", "WA5:Prefs"); //When mouse RC button is down, change button's action to open Winamp prefs
  MainMenuButton.setxmlparam("param", "0"); //Also set it for General prefs page
  MainMenuButton.leftclick(); //And click it, so it opens inmediately
}

MainMenuButton.onRightButtonUp(int x, int y) //When mouse RC button is up, all is done, leave everything as before
{
  MainMenuButton.setxmlparam("action", "SYSMENU");
}

songticker_shade_quickplaylist.onDataChanged()
{
  if (getdata() == "1") {
    STOverlayButton.show();
  }
  else {
    STOverlayButton.hide();
  }
}

STOverlayButton.onLeftClick()
{
  popQuickPlaylist(System.getViewportHeight()/24, false); // Here, "True" enables Repeat and Shuffle -not working on QuickPlaylist v1.1-
}

SongTicker.onLeftButtonUp(int x, int y)
{
  if (songticker_shade_quickplaylist.getdata() == "1")
  {
  STOverlayButton.leftClick(); //Triggered this way to mantain Songticker RC menu
  return;
  }
  else
  {
  //Do nothing
  }
}

SongTicker.onLeftButtonDblClk(int x, int y)
{
  if (songticker_shade_quickplaylist.getdata() == "1")
  {
  STOverlayButton.leftClick(); // Placed here to ignore traditional Dblclick action if QuickPL is enabled
  }
  else
  {
  return;
  }
}