/*---------------------------------------------------
-----------------------------------------------------
Filename:	songticker.m
Version:	1.0

Type:		maki
Date:		18. Nov. 2006 - 16:08 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_songticker.m"
#include "attribs/init_playlist.m"
#include "attribs/init_windowpage.m"
#include "lib/com/songinfo.m"
#include "lib/pldir.mi"
#include "lib/application.mi"

Function updateTickerScrolling();
function OpenDialogBox();


Global Timer SongTickerTimer;
Global GuiObject SongTicker, SongtimesHider;
Global Text SongTime, SongTime2, InfoDisplay, Songtime3/*, SongTickerText*/; // to implement later
Global Layout Normal, Shade;
Global Button SendToButtonMenu, ViewFileinfoButton, searchPl, OpenPl;
Global Group Songtimes, SongtimesGroup;

Global Button TimerMode; // v1.13
Global int TimerModeStatus; // v1.13

Function songinfo_reload();

Global Boolean byPassTimer;

// v1.15 Welcome message customization 
Global container WelcomessageCont;
Global layout WelcomessageLayout;
Global button WelcomessageOKButton, Reset;
Global edit WelcomessageEditBox;
Global string WelcomeMessage;
function setWelcomeMessage();

#define CENTER_VAR Songtimes
#include "lib/com/centerlayer.m"
#undef CENTER_VAR


System.onScriptLoaded ()
{
	initAttribs_Songticker();
  initAttribs_Playlist();
  initAttribs_windowpage();
    
	group ScriptGroup = getScriptGroup();
  
  WelcomeMessage = getPrivateString("Big Bento Modern", "WelcomeMessage", "Hello Winamper"); //v1.15

  
  

  if (ScriptGroup.getParentLayout().getID() == "normal")
  {
  Normal = getContainer("main").getLayout("normal");
  SongTicker = ScriptGroup.findObject("songticker");
  //SongTickerText = ScriptGroup.findObject("songticker"); // // to implement later - hack? (added to achieve right click trigger)
	InfoDisplay = ScriptGroup.findObject("InfoDisplay");
	Songtimes = ScriptGroup.findObject("songtimes.group");
	SongtimesHider = ScriptGroup.findObject("songtimes.hider");
	Songtime = Songtimes.findObject("SongTime");
	TimerMode = Songtimes.findObject("timer.mode.btn"); // v1.13
	SongtimesGroup = Songtimes.findObject("songtimes");
	Songtime2 = SongtimesGroup.findObject("SongTime2");
	Songtime3 = SongtimesGroup.findObject("SongTime3");
  SendToButtonMenu = Normal.findObject("sendto.menu");
  ViewFileinfoButton = ScriptGroup.findObject("view.fileinfo.button");
  searchPl = ScriptGroup.findObject("pltools.search");
  OpenPl = scriptGroup.getParentLayout().findObject("pltools.pl");

  _SongtimesInit(SongtimesGroup, Songtimes, 1, 0);
  
  TimerModeStatus = getPrivateInt("Big Bento Modern", "TimerModeStatus", TimerModeStatus); // v1.13 from here..

  	if (TimerModeStatus==0)
    {
      Songtime.setXmlParam("timerhours", "1");
      Songtime.setXmlParam("timeroffstyle", "3");
      Songtime.setXmlParam("display", "TIMEELAPSED");

      TimerModeStatus=0;
    }
    else if (TimerModeStatus==1)
    {
      Songtime.setXmlParam("timerhours", "1");
      Songtime.setXmlParam("timeroffstyle", "3");
      Songtime.setXmlParam("display", "TIMEREMAINING");
      
      TimerModeStatus=1;
    }
    else if (TimerModeStatus==2)
    {
      Songtime.setXmlParam("timerhours", "0");
      Songtime.setXmlParam("timeroffstyle", "1");
      Songtime.setXmlParam("display", "TIMEELAPSED");
      
      TimerModeStatus=2;
    }
    else if (TimerModeStatus==3)
    {
      Songtime.setXmlParam("timerhours", "0");
      Songtime.setXmlParam("timeroffstyle", "1");
      Songtime.setXmlParam("display", "TIMEREMAINING");
      
      TimerModeStatus=3;
    } // v1.13 ..to here
    	
  }
  else if (ScriptGroup.getParentLayout().getID() == "shade")
  {
  Shade = getContainer("main").getLayout("shade");
  SongTicker = ScriptGroup.findObject("songticker");
  //SongTickerText = ScriptGroup.findObject("songticker"); // to implement later - hack? (added to achieve right click trigger)
	InfoDisplay = ScriptGroup.findObject("InfoDisplay");
  SendToButtonMenu = Shade.findObject("sendto.menu");
  ViewFileinfoButton = ScriptGroup.findObject("view.fileinfo.button");
  searchPl = ScriptGroup.findObject("pltools.search");	
  OpenPl = ScriptGroup.findObject("pltools.pl");
  }


	SongTickerTimer = new Timer;
	SongTickerTimer.setDelay(1200);
		
	updateTickerScrolling();

  if (Songticker.getParentLayout().getID() == "normal") {

	songinfo_reload();
  if (songinfo_isStream == 1) SongtimesHider.show(); else SongtimesHider.hide(); // Vic lame patch to hide small timers if it's just a stream playing
  
    Songticker.setAlpha(0);
    Songticker.setTargetA(253);
    Songticker.setTargetW(-202); // v1.13
    Songticker.setTargetSpeed(0.9);
    Songticker.gotoTarget();
  
      if(System.getStatus() != STATUS_STOPPED){
        Songtimes.setTargetA(253);
        Songtimes.setTargetSpeed(0.5);
        Songtimes.gotoTarget();
              
        Songtime2.setXmlParam("h", "30");
        Songtime2.setXmlParam("y", "4");
        Songtime2.setTargetA(253);
        Songtime2.setTargetSpeed(0.5);
        Songtime2.gotoTarget();

        Songtime3.setXmlParam("h", "30");
        Songtime3.setXmlParam("y", "4");
        Songtime3.setTargetA(253);
        Songtime3.setTargetSpeed(0.5);
        Songtime3.gotoTarget();
      }
      else if(System.getStatus() == STATUS_STOPPED){
      
        Songtimes.setTargetA(130);
        Songtimes.setTargetSpeed(0.5);
        Songtimes.gotoTarget();

        Songtime2.setXmlParam("h", "30");
        Songtime2.setXmlParam("y", "4");    
        Songtime2.setTargetA(0);
        Songtime2.setTargetSpeed(0.5);
        Songtime2.gotoTarget();
        
        Songtime3.setXmlParam("h", "30");
        Songtime3.setXmlParam("y", "4");        
        Songtime3.setTargetA(0);
        Songtime3.setTargetSpeed(0.5);
        Songtime3.gotoTarget();        
        
        SongTicker.sendAction("showinfo", WelcomeMessage, 0, 0, 0, 0);
      }
  
  }
  else if (Songticker.getParentLayout().getID() == "shade"){
    SongTicker.setXmlParam("alpha", "253");
    if (System.getStatus() == STATUS_STOPPED) SongTicker.sendAction("showinfo", WelcomeMessage, 0, 0, 0, 0);
  }

}


System.onScriptUnloading ()
{
	SongTickerTimer.stop();
	delete SongTickerTimer;
	setPrivateInt("Big Bento Modern", "TimerModeStatus", TimerModeStatus); // v1.13
}


TimerMode.onLeftClick() // v1.13
{
  	if (TimerModeStatus==0)
    {
      Songtime.setXmlParam("timerhours", "1"); Songtime.setXmlParam("timeroffstyle", "3"); Songtime.setXmlParam("display", "TIMEREMAINING");

      TimerModeStatus=1;
    }
    else if (TimerModeStatus==1)
    {
      Songtime.setXmlParam("timerhours", "0"); Songtime.setXmlParam("timeroffstyle", "1"); Songtime.setXmlParam("display", "TIMEELAPSED");
      
      TimerModeStatus=2;
    }
    else if (TimerModeStatus==2)
    {
      Songtime.setXmlParam("timerhours", "0"); Songtime.setXmlParam("timeroffstyle", "1"); Songtime.setXmlParam("display", "TIMEREMAINING");

      TimerModeStatus=3;
    }
    else if (TimerModeStatus==3)
    {
      Songtime.setXmlParam("timerhours", "1"); Songtime.setXmlParam("timeroffstyle", "3"); Songtime.setXmlParam("display", "TIMEELAPSED");

      TimerModeStatus=0;
    }
}

System.onStop ()
{
  if (Songticker.getParentLayout().getID() == "normal") {

    Songtimes.setTargetA(130);
    Songtimes.setTargetSpeed(0.9);
    Songtimes.gotoTarget();
            
    Songtime3.setTargetA(0);
    Songtime3.setTargetH(1);
    Songtime3.setTargetY(15);
    Songtime3.setTargetSpeed(0.7);
    Songtime3.gotoTarget();
    
    Songtime2.setTargetA(0);
    Songtime2.setTargetH(1);
    Songtime2.setTargetY(15);
    Songtime2.setTargetSpeed(0.7);
    Songtime2.gotoTarget();
  }
}


System.onPlay ()
{
  if (Songticker.getParentLayout().getID() == "normal") {

    SongtimesGroup.setAlpha(253);
    
    Songtimes.setTargetA(253);
    Songtimes.setTargetSpeed(0.9);
    Songtimes.gotoTarget();
              
    Songtime3.setTargetA(253);
    Songtime3.setTargetSpeed(0.9);
    Songtime3.gotoTarget();

    Songtime2.setXmlParam("alpha", "0");
    Songtime2.setXmlParam("h", "1");
    Songtime2.setXmlParam("y", "15");
    Songtime2.setTargetA(253);
    Songtime2.setTargetH(30);
    Songtime2.setTargetY(4);
    Songtime2.setTargetSpeed(0.9);
    Songtime2.gotoTarget();

    Songtime3.setXmlParam("alpha", "0");    
    Songtime3.setXmlParam("h", "1");
    Songtime3.setXmlParam("y", "15");
    Songtime3.setXmlParam("alpha", "0");
    Songtime3.setTargetA(253);
    Songtime3.setTargetH(30);
    Songtime3.setTargetY(4);
    Songtime3.setTargetSpeed(0.9);
    Songtime3.gotoTarget();    
    
    Songtime.setXmlParam("w", "1");
    Songtime.setXmlParam("x", "65");
    Songtime.setTargetA(253);
    Songtime.setTargetW(194); // v1.14
    Songtime.setTargetX(2); // v1.14
    Songtime.setTargetSpeed(0.5);
    Songtime.gotoTarget();
  }
}


System.onResume () // v1.13
{
  if (Songticker.getParentLayout().getID() == "normal") {
    SongtimesGroup.setAlpha(253);
    
    Songtimes.setTargetA(253);
    Songtimes.setTargetSpeed(0.1);
    Songtimes.gotoTarget();
              
    Songtime3.setTargetA(253);
    Songtime3.setTargetSpeed(0.1);
    Songtime3.gotoTarget();

    Songtime2.setTargetA(253);
    Songtime2.setTargetH(30);
    Songtime2.setTargetY(4);
    Songtime2.setTargetSpeed(0.1);
    Songtime2.gotoTarget();

    Songtime3.setTargetA(253);
    Songtime3.setTargetH(30);
    Songtime3.setTargetY(4);
    Songtime3.setTargetSpeed(0.1);
    Songtime3.gotoTarget();    

    Songtime.setTargetA(253);
    Songtime.setTargetW(194); // v1.14
    Songtime.setTargetX(2); // v1.14
    Songtime.setTargetSpeed(0.1);
    Songtime.gotoTarget();
  }
}


SongTicker.onAction (String action, String param, Int x, int y, int p1, int p2, GuiObject source)
{	  
	if (strlower(action) == "showinfo")
	{
		InfoDisplay.cancelTarget();
		Songticker.cancelTarget();
		SongTickerTimer.stop();
		SongTickerTimer.start();
		InfoDisplay.setText(param);
		InfoDisplay.setAlpha(253);		
		SongTicker.setAlpha(0);
	}
	else if (strlower(action) == "cancelinfo")
	{
		SongTickerTimer.onTimer ();
	}
}

SongTickerTimer.onTimer ()
{
	SongTickerTimer.stop();
	InfoDisplay.cancelTarget();
	InfoDisplay.setTargetA(0);
	InfoDisplay.setTargetSpeed(0.3);
	InfoDisplay.gotoTarget();
}

InfoDisplay.onTargetReached ()
{
	if (InfoDisplay.getAlpha() == 0)
	{
		Songticker.cancelTarget();
		Songticker.setTargetA(253);
		
		Songticker.setTargetSpeed(0.3);
		Songticker.gotoTarget();
	}
}

/* Changing TickerScrolling via Config Attrib */

ScrollingAttribute.onDataChanged () 
{
	updateTickerScrolling();
}


updateTickerScrolling ()
{
	if (Songticker == NULL)
	{
		return;
	}
  
	if (songticker_scrolling_disabled_attrib.getData() == "1") SongTicker.setXMLParam("ticker", "off");
	if (songticker_style_modern_attrib.getData() == "1") SongTicker.setXMLParam("ticker", "bounce");
	if (songticker_style_old_attrib.getData() == "1") SongTicker.setXMLParam("ticker", "scroll");
}


//SongTickerText.onRightButtonUp (int x, int y) // to implement later
SongTicker.onRightButtonUp (int x, int y)
{
  getCurrentTrackRating();
  
  popupmenu songtickermenu = new popupmenu;
  	  
  songtickermenu.addCommand("Current track:", -1, 0, 1);
	songtickermenu.addcommand(translate("View file info...")+"\t"+translate("Alt+3 or Dblclick"), 13, 0,0);
	songtickermenu.addcommand(translate("Jump to file...")+"\tJ", 14, 0,0);
  songtickermenu.addcommand("Send to (open menu)", 8, 0,0);

  songtickermenu.addSeparator();	
	songtickermenu.addcommand("Rate 5", 6, 0,0);
	songtickermenu.addcommand("Rate 4", 5, 0,0);
	songtickermenu.addcommand("Rate 3", 4, 0,0);
	songtickermenu.addcommand("Rate 2", 3, 0,0);
	songtickermenu.addcommand("Rate 1", 2, 0,0);
	songtickermenu.addcommand("Not rated", 7, 0,0);	

  //songtickermenu.addSeparator();
	//songtickermenu.addcommand("Copy songticker info to clipboard", 1, 0,0); //v1.15 disabled

	songtickermenu.addSeparator();
  songtickermenu.addCommand("Songticker:", -1, 0, 1);
  songtickermenu.addcommand("Disable Songticker Scrolling", 10, 0,0);
  songtickermenu.addcommand("Modern Songticker Scrolling", 11, 0,0);
  songtickermenu.addcommand("Classic Songticker Scrolling", 12, 0,0);
	songtickermenu.addSeparator();
  songtickermenu.addcommand("Scroll Playlist to this track", 9, 0,0);
  songtickermenu.addcommand("Change welcome message", 15, 0,0); //v1.15


    if (getCurrentTrackRating() == 2)
    {
    songtickermenu.checkCommand(3, 1);
    }
    else if (getCurrentTrackRating() == 3)
    {
    songtickermenu.checkCommand(4, 1);
    }
    else if (getCurrentTrackRating() == 4)
    {
    songtickermenu.checkCommand(5, 1);
    }
    else if (getCurrentTrackRating() == 5)
    {
    songtickermenu.checkCommand(6, 1);
    }
    else if (getCurrentTrackRating() == 0)
    {
    songtickermenu.checkCommand(7, 1);
    }
    else if (getCurrentTrackRating() == 1)
    {
    songtickermenu.checkCommand(2, 1);
    }
 

    if (SongTicker.getXMLParam("ticker") == "off")
    {
    	songtickermenu.checkCommand(10, 1);
    }
    else if (SongTicker.getXMLParam("ticker") == "bounce")
    {
    	songtickermenu.checkCommand(11, 1);
    }
    else if (SongTicker.getXMLParam("ticker") == "scroll")
    {
    	songtickermenu.checkCommand(12, 1);
    }

   	
	int result = songtickermenu.popAtMouse(); //v1.15 Re-enabled
	//int result = songtickermenu.popAtXY(getMousePosX()-12, clientToScreenY(SongTicker.getHeight()+10)); // Height set mostly to show below Shade Songticker
	  
	  
  /*if (result == 1)
	{
  String currentinfo = getPlayItemDisplayTitle();
  System.setClipboardText(currentinfo);
	}
  else */if (result == 2)
	{
		setCurrentTrackRating(1);
		songinfo_reload();
	}
	else if (result == 3)
	{
		setCurrentTrackRating(2);
		songinfo_reload();
	}
		else if (result == 4)
	{
    songinfo_reload();
		setCurrentTrackRating(3);
	}
		else if (result == 5)
	{
		setCurrentTrackRating(4);
		songinfo_reload();
	}
		else if (result == 6)
	{
		setCurrentTrackRating(5);
		songinfo_reload();
	}
	else if (result == 7)
	{
		setCurrentTrackRating(0);
		songinfo_reload();
	}
		else if (result == 8)
	{
  int x = screenToClientX(getMousePosX())-15;
  int y = screenToClientY(getMousePosY());

    SendToButtonMenu.setTargetX(x);
    SendToButtonMenu.setTargetY(y);
    SendToButtonMenu.setTargetSpeed(0.0);
    SendToButtonMenu.gotoTarget();
	}
			else if (result == 9)
	{
	  if (isNamedWindowVisible("guid:pl") == 1) // V1.1 =  Checks if PL window is visible
    {
      PlEdit.showCurrentlyPlayingTrack();
    }
    else
    {
      System.showWindow("guid:pl", "", 0);
      PlEdit.showCurrentlyPlayingTrack();
    }
    
	}
		else if (result == 10)
	{
	songticker_scrolling_disabled_attrib.setData("1");
	}
		else if (result == 11)
	{
	songticker_style_modern_attrib.setData("1");
	}
		else if (result == 12)
	{
	songticker_style_old_attrib.setData("1");
	}
		else if (result == 13)
	{
  ViewFileinfoButton.leftClick();
	}
	else if (result == 14)
	{
  searchPl.leftClick();
	}
	else if (result == 15)
	{
  	OpenDialogBox();
	}
	
	complete;
}

SendToButtonMenu.onTargetReached()
{
  SendToButtonMenu.leftClick();
}

searchPl.onLeftClick() {
  String skinpath = Application.GetApplicationPath()+ "\Skins/Big Bento Modern/scripts/shortcuts/bbm_sendmessage_40318.exe";
  navigateURL(skinpath);
}

System.onTitleChange(String newtitle)
{
  songinfo_reload(); // Vic note: Why this is not present on original Bento?
 
  if (Songticker.getParentLayout().getID() == "normal") {
  
  if (songinfo_isStream == 1) SongtimesHider.show(); else SongtimesHider.hide(); // Vic lame patch to hide small timers if it's just a stream playing (otherwise it conflicts with animations)
  }

}


//v1.15 Welcome message implementation

OpenDialogBox() {
	if (isObjectValid(WelcomessageCont)) { // if already open, dont reopen
		layout WelcomessageLayout = WelcomessageCont.enumLayout(0);
		WelcomessageLayout.setFocus();
		WelcomessageLayout.center();
		return;
	}
	
	WelcomessageCont = newDynamicContainer("welcomessage");
	if (WelcomessageCont) {
		WelcomessageCont.show();
		WelcomessageLayout = WelcomessageCont.getLayout("normalwm");
		WelcomessageLayout.center();
		WelcomessageOKButton = WelcomessageLayout.findObject("ok");
		Reset = WelcomessageLayout.findObject("reset");
		WelcomessageEditBox = WelcomessageLayout.findObject("welcomessage.editbox");
	}

	WelcomeMessage = getPrivateString("Big Bento Modern", "WelcomeMessage", "Hello Winamper");
  WelcomessageEditBox.setText(WelcomeMessage);
}


Reset.onLeftClick() {
	string welcomedefault = "Hello Winamper";
	
	SongTicker.sendAction("showinfo", welcomedefault, 0, 0, 0, 0);
	setPrivateString("Big Bento Modern", "WelcomeMessage", welcomedefault);
	//setWelcomeMessage();
}

WelcomessageOKButton.onLeftClick() {
	//if (WelcomessageEditBox.getText()=="") return;
	setPrivateString("Big Bento Modern", "WelcomeMessage", WelcomessageEditBox.getText());
	WelcomessageCont.close();
	WelcomessageCont = NULL;
	
	setWelcomeMessage();
}


WelcomessageEditBox.onEnter() {
	WelcomessageOKButton.onLeftClick();
}

setWelcomeMessage() {

	if (WelcomessageEditBox.getText() == "") { 	string welcomedefault = "Hello Winamper";

	WelcomeMessage == "Hello Winamper";
	setPrivateString("Big Bento Modern", "WelcomeMessage", WelcomeMessage);
	}
	else {
	WelcomeMessage = getPrivateString("Big Bento Modern", "WelcomeMessage", WelcomessageEditBox.getText());	}

	SongTicker.sendAction("showinfo", WelcomeMessage, 0, 0, 0, 0);
	setPrivateString("Big Bento Modern", "WelcomeMessage", WelcomeMessage);
}