/*---------------------------------------------------
-----------------------------------------------------
Filename:	external_handles.m

Type:		maki
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
Depending Files:
		scripts/suicore.maki
-----------------------------------------------------
---------------------------------------------------*/

#ifndef included
#error This script can only be compiled as a #include
#endif


//----------------------------------------------------------------------------------------------------------------
// The main component switching as triggered by user menus, keyboard shortcuts, etc
//----------------------------------------------------------------------------------------------------------------

System.onGetCancelComponent(String guid, boolean goingvisible) {

	Boolean isShade = (player.getCurLayout() != normal);

    // isVideo() hasn't been set yet in System.onPlay and System.onTitleChange, so we check it here instead.
    //if (play_auto_fs_video && !isVideo()) play_auto_fs_video = 0;

	// Do Playlist Stuff First (is unlinked from SUI)

	if (guid == PL_GUID)
	{
		if (goingvisible && isShade && (getPrivateString("Big Bento Modern", "Pledit_pos", "top") == "top" || playlist_tab_attrib.getData() == "0"))
		{
			player.switchToLayout("normal");
      	
      normal.sendAction("load_comp", "pledit", 0,0,0,0);
			return TRUE;
		}
	}

	// Now we detect if suicore is already performing an action - if so we will return.

	if (bypasscancel)
	{
		return FALSE;
	}
	if (guid == ML_GUID && !goingvisible && hiding_ml)
	{
		return FALSE;
	}
	if (guid == VIDEO_GUID && !goingvisible && hiding_video)
	{
		return FALSE;
	}
	if (guid == VIS_GUID && !goingvisible && hiding_vis)
	{
		return FALSE;
	}
	if (guid == PL_GUID && !goingvisible && hiding_pl)
	{
		return FALSE;
	}
	if (guid == ML_GUID && goingvisible && showing_ml)
	{
		return FALSE;
	}
	if (guid == VIDEO_GUID && goingvisible && showing_video)
	{
		return FALSE;
	}
	if (guid == VIS_GUID && goingvisible && showing_vis)
	{
		return FALSE;
	}
	if (guid == PL_GUID && goingvisible && showing_pl)
	{
		return FALSE;
	}

	// Let's get our current Content

	String window_content =  getPrivateString("Big Bento Modern", "Component", "Media Library");

	// If a window wants to hide but we are still in collapsed mode - return
	if (!goingvisible && window_content == "Hidden")
	{
		return FALSE;
	}

	// All comps that want to be shown
	if (goingvisible) {
		if (guid == VIDEO_GUID && (window_content != "Video" || isShade)) {

			if (isShade)
			{
				sui_video.hide();
				player.switchToLayout("normal");
			}

			hideEq();
			hideBrw();
			hideVis();
			hideMl();
			hidePL();
			hideCfg();

			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Video");
				dc_showSUI ();
				return TRUE;
			}
      sui_about_attrib.setData("0"); // v1.1
      sui_colorthemes_attrib.setData("0"); // v1.1
			dc_showVideo();

			return TRUE;
		} else if (guid == VIS_GUID && (window_content != "Vis" || isShade)) {

			if (vis_inbig_attrib.getData() == "0")
			{
				return FALSE;
			}

			if (isShade)
			{
				sui_vis.hide();
				player.switchToLayout("normal");
			}


			disablePSOVC();
			hideVideo();
			hideMl();
			hideEq();
			hideBrw();
			hidePL();
			hideCfg();
			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Vis");
				dc_showSUI ();
				return TRUE;
			}
      sui_about_attrib.setData("0"); // v1.1
      sui_colorthemes_attrib.setData("0"); // v1.1
			sui_vis_wdh.setXmlParam("autoopen", "0");
			showVis();
			sui_vis_wdh.setXmlParam("autoopen", "1");
			return FALSE;
		} else if (guid == ML_GUID && (window_content != "Media Library" || isShade)) {

			if (isShade)
			{
				sui_ml.hide();
				player.switchToLayout("normal");
			}


			disablePSOVC();
			hideVideo();
			hideVis();
			hidePL();
			hideEq();
			hideBrw();
			hideCfg();
			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Media Library");
				dc_showSUI ();
				return TRUE;
			}
      sui_about_attrib.setData("0"); // v1.1
      sui_colorthemes_attrib.setData("0"); // v1.1
			dc_showMl();

			return TRUE;
		} else if (guid == PL_GUID && (window_content != "Pledit" || isShade) && playlist_tab_attrib.getData() == "1") {
			if (getPrivateString("Big Bento Modern", "Pledit_pos", "top") != "sui")
			{

				return FALSE;
			}
			

			if (isShade)
			{
				sui_pl.hide();
				player.switchToLayout("normal");
			}


			disablePSOVC();
			hideVideo();
			hideVis();
			hideEq();
			hideBrw();
			hideML();
			hideCfg();
			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Pledit");
				dc_showSUI ();
				return TRUE;
			}
			dc_showPl();
      sui_about_attrib.setData("0"); // v1.1
      sui_colorthemes_attrib.setData("0"); // v1.1

			return TRUE;
		}
	}
	
	// All comps that want to be hidden
	if (!goingvisible) {
		if (guid == VIDEO_GUID && window_content == "Video") {

			if (getStatus() != 0 && isVideo() && cfg_Video.getBool("autoopen") && cfg_Video.getBool("autoclose"))
			{
				return true;
			}
			else
			{
				disablePSOVC();
				hideVideo();
				hideVis();
				hideEq();
				hideBrw();
				hideCfg();
				dc_showMl(); // normal Component
				return false;
			}
		}
		if (guid == PL_GUID && window_content == "Pledit" && playlist_tab_attrib.getData() == "1") {

			if (getStatus() != STATUS_STOPPED && system.isVideo())
			{

				disablePSOVC();
				hideML();
				hideVis();
				hideEq();
				hideBrw();
				hidePL();
				hideCfg();
				dc_showVideo(); // normal Component

				return false;

			}
			else
			{
				disablePSOVC();
				hideVideo();
				hideVis();
				hideEq();
				hideBrw();
				hidePL();
				hideCfg();
				dc_showMl(); // normal Component
				return false;
			}
		}
		if (guid == VIS_GUID && window_content == "Vis") {
			if (vis_inbig_attrib.getData() == "0")
			{
				return FALSE;
			}
			if (getStatus() != STATUS_STOPPED && system.isVideo())
			{
				hideMl();
				hideVis();
				hidePL();
				hideEq();
				hideBrw();
				hideCfg();
				dc_showVideo();
			} 
			else 
			{
				hideVideo();
				hideVis();
				hideEq();
				hideBrw();
				hidePL();
				hideCfg();
				dc_showMl(); // normal Component
			}
			return FALSE;
		}
		if (guid == ML_GUID && window_content == "Media Library") {
			if ((getStatus() == STATUS_PLAYING || getStatus() == STATUS_PAUSED) && isVideo())
			{
				hideMl();
				hideVis();
				hidePL();
				hideEq();
				hideBrw();
				hideCfg();
				dc_showVideo();
				return FALSE;
			} 
			else 
			{
				hideMl();
				hideVis();
				hideBrw();
				hidePL();
				hideCfg();
				hideVideo();
				hideEq();
				dc_closeSUI();
				return false;
			}

		}
	}

	return FALSE;
}


Player.onSwitchToLayout (Layout _layout)
{
	if (_layout.getId() != "normal")
	{
		mychange = 1;
		sui_browser_attrib.setData("0");
		mychange = 0;
	}
}

//----------------------------------------------------------------------------------------------------------------
// Windows that aren't registered with winamp will be handled here, the visibility state is linked to cfgattribs
//----------------------------------------------------------------------------------------------------------------

sui_browser_attrib.onDataChanged ()
{
	if (mychange) return;
	mychange = 1;
	String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");
	if (getData() == "1")
	{
	    sui_about_attrib.setData("0");
	    sui_colorthemes_attrib.setData("0");
		if (player.getCurLayout() != normal)
		{
			player.switchToLayout("normal");
			hideMl();
			hideVis();
			hideCfg();
			hideVideo();
			hideEq();
			dc_showBrw();
			return;
		}
		if (window_content == "Hidden")
		{
			setPrivateString("Big Bento Modern", "Hidden Component", "Web Reader");
			switchFromNoComp ();
			return;
		}
		switchToBrw();
	}
	else
	{
		if ((getStatus() == STATUS_PLAYING || getStatus() == STATUS_PAUSED) && isVideo())
		{
			hideBrw();
			dc_showVideo();
		} 
		else
		{
			hideBrw();
			dc_showml();
		}
	}
	mychange = 0;
}

sui_config_attrib.onDataChanged ()
{
	if (mychange) return;
	mychange = 1;
	String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");
	if (getData() == "1")
	{
		if (player.getCurLayout() != "normal")
		{
			player.switchToLayout("normal");
			hideMl();
			hidePl();
			hideVis();
			hideBrw();
			hideCfg();
			hideVideo();
			hideEq();
			dc_showCfg();
			return;
		}
		if (window_content == "Hidden")
		{
			setPrivateString("Big Bento Modern", "Hidden Component", "Config");
			switchFromNoComp ();
			return;
		}
		switchToCfg();
	}
	else
	{
		if ((getStatus() == STATUS_PLAYING || getStatus() == STATUS_PAUSED) && isVideo())
		{
			hideCfg();
			dc_showVideo();
		} 
		else
		{
			hideCfg();
			dc_showml();
		}
	}
	mychange = 0;
}


sui_eq_attrib.onDataChanged ()
{
	if (mychange) return;
	mychange = 1;
	String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");
	if (getData() == "1")
	{
    sui_about_attrib.setData("0");
    sui_colorthemes_attrib.setData("0");
		if (player.getCurLayout() != normal)
		{
			player.switchToLayout("normal");
			hidePl();
			hideMl();
			hideVis();
			hideBrw();
			hideCfg();
			hideVideo();
			dc_showEq();
			return;
		}
		if (window_content == "Hidden" )
		{
			setPrivateString("Big Bento Modern", "Hidden Component", "Equalizer");
			switchFromNoComp ();
			return;
		}
		switchToEq();
	}
	else
	{
		if ((getStatus() == STATUS_PLAYING || getStatus() == STATUS_PAUSED) && isVideo())
		{
			hideEq();
			dc_showVideo();
		}
		else
		{
			hideEq();
			dc_showml();
		}
	}
	mychange = 0;
}


sui_about_attrib.onDataChanged () // v1.1 added
{
	if (mychange) return;
	mychange = 1;
	if (getData() == "1")
	{
    if (player.getCurLayout() != normal) { player.switchToLayout("normal"); }
    
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    sui.sendAction ("opentab", "cnfg", 0, 0, 0, 0);

    normal.sendAction("load_cfg", "about", 0,0,0,0);
    
    sui_colorthemes_attrib.setData("0");
	}
	else
	{
  // Do nothing
	}
	mychange = 0;
}


sui_colorthemes_attrib.onDataChanged () // v1.1 added
{
	if (mychange) return;
	mychange = 1;
	if (getData() == "1")
	{
    if (player.getCurLayout() != normal) { player.switchToLayout("normal"); }
    
    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    sui.sendAction ("opentab", "cnfg", 0, 0, 0, 0);

    normal.sendAction("load_cfg", "colorthemes", 0,0,0,0);
    
    sui_about_attrib.setData("0");
	}
	else
	{
  // Do nothing
	}
	mychange = 0;
}

//----------------------------------------------------------------------------------------------------------------
// If a link is clicked within winamp this function *should* be called by wasabi core.
// returning 1 prevents winamp to open the url in an external browser
// Victhor note: Modded to work with Web Reader.
//----------------------------------------------------------------------------------------------------------------


System.onOpenUrl(string url)
{
  
	// If winamp is in shade mode
	if (player.getCurLayout() != normal)
	{
		setPrivateString("Big Bento Modern", "UrlXgive", url);
		player.switchToLayout("normal");
		hideMl();
		hideVis();
		hideCfg();
		hideVideo();
		hideEq();

		dc_showBrw();
	
		return;
	}

	String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");

	// just deliver the url since the browser is already visible
	if (window_content == "Web Reader")
	{
		browser myBrowser = sui_brw.findObject("browserpro.browser");
		if (myBrowser != NULL)
		{
			myBrowser.sendAction ("openurl", url, 0, 0, 0, 0);
		}
	}
	// Some other component is visible - so we store the url and show the browser
	else
	{
	
  if (use_reader_attrib.getdata() == "1")
  {
		setPrivateString("Big Bento Modern", "UrlXgive", url);
		if (window_content == "Hidden")
		{
			setPrivateString("Big Bento Modern", "Hidden Component", "Web Reader");
			switchFromNoComp ();
			return;
		}
		switchToBrw();
		
		//String coversearch = ("www.bing.com/?scope=images&FORM=Z9LH1&q=" + urlEncode(sartist) + " " + urlEncode(salbum) + " " + "cover");

    group sui = getContainer("main").getLayout("normal").findObject("sui.content");
    sui.sendAction ("browser_navigate", url, 0, 0, 0, 0);
	}
  else if (use_browser_attrib.getdata() == "1")
  {
		//Do what Winamp wants
  }

	}
  if (use_reader_attrib.getdata() == "1")
  {
  	return 1;
  }
  else if (use_browser_attrib.getdata() == "1")
  {
  	return;
  }

}


//----------------------------------------------------------------------------------------------------------------
// the sui window can recieve messages from other scripts (mainly: fileinfo.maki) - we handle this here
//----------------------------------------------------------------------------------------------------------------

sui_window.onAction (String action, String param, Int x, int y, int p1, int p2, GuiObject source)
{
	// Perform a search in the browser
	if (strlower(action) == "browser_search")
	{
		browser myBrowser = sui_brw.findObject("browserpro.browser");

		String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");
		if (window_content == "Web Reader")
		{
			if (myBrowser != NULL)
			{
				myBrowser.sendAction ("search", param, 0, 0, 0, 0);
			}
		}
		else
		{
			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Web Reader");
				switchFromNoComp ();
				myBrowser.sendAction ("search", param, 0, 0, 0, 0);
				return 1;
			}
			switchToBrw();
			myBrowser.sendAction ("search", param, 0, 0, 0, 0);
		}
		return 1;
	}
	// Just navigate to a site
	else if (strlower(action) == "browser_navigate")
	{
		browser myBrowser = sui_brw.findObject("browserpro.browser");
		if (player.getCurLayout() != normal)
		{
			player.switchToLayout("normal");
			hideMl();
			hideVis();
			hideCfg();
			hideVideo();
			hideEq();
			dc_showBrw();
			myBrowser.sendAction ("openurl", param, 0, 0, 0, 0);
			return 1;
		}
		String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");
		if (window_content == "Web Reader")
		{
			if (myBrowser != NULL)
			{
				myBrowser.sendAction ("openurl", param, 0, 0, 0, 0);
			}
		}
		else
		{
			if (window_content == "Hidden")
			{
				setPrivateString("Big Bento Modern", "Hidden Component", "Web Reader");
				myBrowser.sendAction ("openurl", param, 0, 0, 0, 0);
				switchFromNoComp ();
				return 1;
			}
			switchToBrw();
			myBrowser.sendAction ("openurl", param, 0, 0, 0, 0);
		}
		return 1;
	}
	
	

	else if (strlower(action) == "opentab")
	{
		if (strlower(param) == "ml")
		{
      String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");

      if (window_content == "Hidden")
        {
        setPrivateString("Big Bento Modern", "Hidden Component", "Media Library");
        switchFromNoComp ();
        return;
        }
        
			switchToMl();
		}
  else if (strlower(param) == "cnfg")
		{
      String window_content = getPrivateString("Big Bento Modern", "Component", "Media Library");

      if (window_content == "Hidden")
        {
        setPrivateString("Big Bento Modern", "Hidden Component", "Config");
        switchFromNoComp ();
        return;
        }
        
        switchToCfg();
     }
		
	}
	else if (action == "hide_comp" && param == "pe")
	{
		if (getPrivateString("Big Bento Modern", "Component", "Media Library") == "Pledit")
		{
			switchToMl();
		}
	}

}


//----------------------------------------------------------------------------------------------------------------
// Switching Vis Plugin between MCV and SUI
//----------------------------------------------------------------------------------------------------------------

vis_inbig_attrib.onDataChanged ()
{
	if (mychange) return;
	String window_content2 =  getPrivateString("Big Bento Modern", "Component", "Cover");
	String window_content =  getPrivateString("Big Bento Modern", "Component2", "Media Library");
	int xg = getPrivateInt("Big Bento Modern", "ComponentXgive", 0);
	if (getData() == "1" && (ic_vis.getData() == "1" || ic_vis_fileinfo.getData() == "1"  || xg))
	{
    sui_about_attrib.setData("0");
    sui_colorthemes_attrib.setData("0");
		if (xg) setPrivateInt("Big Bento Modern", "ComponentXgive", 0);
		switchToVis();
	}
	else if (getData() == "0" && sui_Vis.isVisible())
	{
		setPrivateInt("Big Bento Modern", "ComponentXgive", 1);
		hideVis();
		switchToMl();
	}
}



//System.onHideLayout(Layout _layout){
//player.onBeforeSwitchToLayout(Layout normal, Layout shade)
player.onSwitchToLayout(Layout shade)
{
	/*if(_layout==normal && shade.isVisible()){
		gotoGlobal();
	}*/
  setPrivateString("Big Bento Modern", "Component", "Media Library");
}