/*---------------------------------------------------
-----------------------------------------------------
Filename:	show_hide.m

Type:		maki
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
Depending Files:
		scripts/suicore.maki
-----------------------------------------------------
---------------------------------------------------*/

#ifndef included
#error This script can only be compiled as a #include
#endif

switchToMl()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hideVis();
	hideVideo();
	hidePL();
	hideEq();
	hideBrw();
	hideCfg();
	//prohibit a closing bug
	if (!startup) showMl();
	else
	{
		dc_showMl();
		onshowMl();
	}

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1
    
	if (hide_sui.isVisible() == 0) { /*Do nothing */ }
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToPl()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hideVis();
	hideVideo();
	hideML();
	hideEq();
	hideBrw();
	hideCfg();
	//prohibit a closing bug
	if (!startup) showPl();
	else
	{
		dc_showPl();
		onshowPl();
	}

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1
  
	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToVideo()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	hideMl();
	hidePL();
	hideVis();
	hideEq();
	hideBrw();
	hideCfg();
	showVideo();

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1

	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToVis()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hideMl();
	hidePL();
	hideVideo();
	hideEq();
	hideBrw();
	hideCfg();
	showVis();

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1

	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToBrw()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hideVis();
	hidePL();
	hideVideo();
	hideEq();
	hideMl();
	hideCfg();
	showBrw();

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1
  
	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToEq()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hidePL();
	hideVis();
	hideVideo();
	hideMl();
	hideBrw();
	hideCfg();
	showEq();

  sui_about_attrib.setData("0"); // v1.1
  sui_colorthemes_attrib.setData("0"); // v1.1
  
	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToCfg()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();
	hidePL();	
	hideVis();
	hideVideo();
	hideMl();
	hideBrw();
	hideEq();
	showCfg();

  if (sui_about_attrib.getData() != "1") sui_about_attrib.setData("0"); // v1.1
  if (sui_colorthemes_attrib.getData() != "1") sui_colorthemes_attrib.setData("0"); // v1.1

	if (hide_sui.isVisible() == 0) { /*Do nothing */ } 
	else { hide_sui.show();
	show_sui.hide(); }
}

switchToNoComp ()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;
	tempDisable.start();
	disablePSOVC();

	onBeforeHideSUI();

	hideVis();
	hideVideo();
	hideMl();
	hidePL();
	hideBrw();
	hideEq();
	hideCfg();

	string comp = getPrivateString("Big Bento Modern", "Component", "Media Library");
	if (comp != "Hidden")
	{
		normal.sendAction("sui", "tonocomp", 0,0,0,0);
		setPrivateString("Big Bento Modern", "Hidden Component", comp);
		setPrivateString("Big Bento Modern", "Component", "Hidden");
		if (!getPrivateInt("Big Bento Modern", "isMainWndMaximized", 0)) setPrivateInt("Big Bento Modern", "nomax_h", normal.getHeight());
	}
	else normal.sendAction("sui", "tonocomp", 1,0,0,0);
	
	normal_resizer.setXmlParam("resize", "right");
	normal_resizer2.setXmlParam("resize", "left");
	normal_resizer3.setXmlParam("resize", "");
	normal_resizer4.setXmlParam("resize", "");
	normal_TBresizer.setXmlParam("resize", "right");
	normal_TBresizer2.setXmlParam("resize", "left");
	normal_TBresizer3.hide();
	normal.setXmlParam("minimum_h" , h);
	
	int sy = normal.getGuiY() + normal.getGuiH() - stringtointeger(h);
	normal.setXmlParam("h" , h);
	if (collapse_bottom_attrib.getdata() == "1") normal.setXmlParam("y" , integerToString(sy));

	hide_sui.hide();
	show_sui.show();

	onHideSUI();
}

switchFromNoComp ()
{
	if (callbackTimer.isRunning()) return;
	if (tempDisable.isRunning()) return;

	string comp = getPrivateString("Big Bento Modern", "Hidden Component", "Media Library");
	setPrivateString("Big Bento Modern", "Component", comp);

	int sh = getPrivateInt("Big Bento Modern", "nomax_h", 600);
	if (sh < 530) sh = 530;

	normal.sendAction("sui", "fromnocomp", 0,0,0,0);
	normal_resizer.setXmlParam("resize", "bottomright");
	normal_resizer2.setXmlParam("resize", "bottomleft");
	normal_resizer3.setXmlParam("resize", "bottom");
	normal_resizer4.setXmlParam("resize", "bottom");
	normal_TBresizer.setXmlParam("resize", "topright");
	normal_TBresizer2.setXmlParam("resize", "topleft");
	normal_TBresizer3.show();
	normal.setXmlParam("minimum_h" , "530");
	double d_scale = normal.getScale();
	normal.beforeRedock();
	if (getPrivateInt("Big Bento Modern", "isMainWndMaximized", 0)) normal.resize(getViewPortLeft(),getViewPortTop(),getViewPortWidth()/d_scale, getViewPortHeight()/d_scale);
	else 
	{
		if (collapse_bottom_attrib.getdata() == "1")
		{
			int sy = normal.getGuiY() + normal.getGuiH() - sh;
			if (sy < 0) sy = 0;
			normal.setXmlParam("y" , integerToString(sy));			
		}
		normal.setXmlParam("h" , integerToString(sh));
	}
	normal.redock();
	loadSUI (comp);

	hide_sui.show();
	show_sui.hide();

	onShowSUI();
}

tempDisable.onTimer()
{
	tempDisable.stop();
}

showMl()
{

	showing_ml = 1;
	setPrivateString("Big Bento Modern", "Component", "Media Library");
	GuiObject o = sui_ml;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}

	onShowMl();
	showing_ml = 0;

}

hideMl()
{
	callback_showing_ml = 0;

	hiding_ml = 1;
	GuiObject o = sui_ml;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}

	onHideMl();
	hiding_ml = 0;
}

showPl()
{
	showing_pl = 1;
	setPrivateString("Big Bento Modern", "Component", "Pledit");
	setPrivateString("Big Bento Modern", "Pledit_pos", "sui");
	normal.sendAction("hide_comp", "pledit", 0,0,0,0);

	GuiObject o = sui_pl;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}

	onShowPl();
	showing_pl = 0;
}

hidePl()
{
	callback_showing_pl = 0;
  
	hiding_pl = 1;

	GuiObject o = sui_pl;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}

	onHidePl();
	hiding_pl = 0;
}

showVis()
{
	if (vis_inbig_attrib.getData() == "1")
	{
		showing_vis = 1;

		setPrivateString("Big Bento Modern", "Component", "Vis");
		GuiObject o = sui_vis;
		if (o != NULL)
		{ 
			bypasscancel = 1;
			if (o) o.show();
			bypasscancel = 0;
		}
		onShowVis();
		showing_vis = 0;
	}
}

hideVis()
{
	callback_showing_vis = 0;

	hiding_vis = 1;
	GuiObject o = sui_vis;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}

	onHideVis();
	hiding_vis = 0;
}

showVideo()
{
	showing_video = 1;

	setPrivateString("Big Bento Modern", "Component", "Video");
	GuiObject o = sui_video;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}

	onShowVideo();
	showing_video = 0;
}

hideVideo()
{
	hiding_video = 1;
	GuiObject o = sui_video;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}
	onHideVideo();
	hiding_video = 0;
}

showBrw()
{
	showing_brw = 1;

	setPrivateString("Big Bento Modern", "Component", "Web Reader");
	GuiObject o = sui_brw;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}
	onShowBrw();

	mychange = 1;
	sui_browser_attrib.setData("1");
	mychange = 0;

	showing_brw = 0;
}

hideBrw()
{
	callback_showing_brw = 0;

	hiding_brw = 1;
	GuiObject o = sui_brw;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}

	onHideBrw();
	hiding_brw = 0;

	mychange = 1;
	sui_browser_attrib.setData("0");
	mychange = 0;
}

showEq()
{
	showing_eq = 1;

	setPrivateString("Big Bento Modern", "Component", "Equalizer");	
	GuiObject o = sui_eq;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}
	onshowEq();

	mychange = 1;
	sui_eq_attrib.setData("1");
	mychange = 0;

	showing_eq = 0;
}

hideEq()
{
	callback_showing_eq = 0;

	hiding_eq = 1;
	GuiObject o = sui_eq;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}
	onhideEq();
	hiding_eq = 0;

	mychange = 1;
	sui_eq_attrib.setData("0");
	mychange = 0;
}

showCfg()
{
	showing_Cfg = 1;

	setPrivateString("Big Bento Modern", "Component", "Config");
	GuiObject o = sui_Cfg;
	if (o != NULL)
	{ 
		bypasscancel = 1;
		if (o) o.show();
		bypasscancel = 0;
	}

	onShowCfg();

	mychange = 1;
	sui_Config_attrib.setData("1");
	mychange = 0;

	showing_Cfg = 0;
}

hideCfg()
{
	callback_showing_cfg = 0;

	hiding_Cfg = 1;
	GuiObject o = sui_Cfg;
	if (o != NULL) { 
		bypasscancel = 1;
		if (o) o.hide();
		bypasscancel = 0;
	}
	onHideCfg();
	hiding_Cfg = 0;

	mychange = 1;
	sui_config_attrib.setData("0");
	mychange = 0;

}

callbackTimer.onTimer()
{
	callbackTimer.stop();

	int _callback_showing_vis = callback_showing_vis;
	int _callback_hiding_vis = callback_hiding_vis;
	int _callback_showing_video = callback_showing_video;
	int _callback_hiding_video = callback_hiding_video;
	int _callback_showing_ml = callback_showing_ml;
	int _callback_hiding_ml = callback_hiding_ml;
	int _callback_showing_pl = callback_showing_pl;
	int _callback_hiding_pl = callback_hiding_pl;
	int _callback_showing_eq = callback_showing_eq;
	int _callback_hiding_eq = callback_hiding_eq;
	int _callback_showing_brw = callback_showing_brw;
	int _callback_hiding_brw = callback_hiding_brw;
	int _callback_showing_cfg = callback_showing_cfg;
	int _callback_hiding_cfg = callback_hiding_cfg;
	int _callback_showing_sui = callback_showing_sui;
	int _callback_closing_sui = callback_closing_sui;

	callback_showing_vis = 0;
	callback_hiding_vis = 0;
	callback_showing_video = 0;
	callback_hiding_video = 0;
	callback_showing_ml = 0;
	callback_hiding_ml = 0;
	callback_showing_pl = 0;
	callback_hiding_pl = 0;
	callback_showing_eq = 0;
	callback_hiding_eq = 0;
	callback_showing_brw = 0;
	callback_hiding_brw = 0;
	callback_showing_cfg = 0;
	callback_hiding_cfg = 0;

	callback_showing_sui = 0;
	callback_closing_sui = 0;

	if (_callback_showing_ml == 1)
	{
		showMl();
	}
	if (_callback_hiding_ml == 1)
	{
		hideMl();
	}
	if (_callback_showing_pl == 1)
	{
		showPl();
	}
	if (_callback_hiding_pl == 1)
	{
		hidePl();
	}
	if (_callback_showing_video == 1)
	{
		showVideo();
	}
	if (_callback_showing_vis == 1)
	{
		showVis();
	}
	if (_callback_hiding_vis == 1)
	{
		hideVis();
	}
	if (_callback_hiding_video == 1)
	{
		hideVideo();
	}
	if (_callback_showing_eq == 1)
	{
		showEq();
	}
	if (_callback_hiding_eq == 1)
	{
		hideEq();
	}
	if (_callback_showing_brw == 1)
	{
		showBrw();
	}
	if (_callback_hiding_brw == 1)
	{
		hideBrw();
	}
	if (_callback_showing_cfg == 1)
	{
		showCfg();
	}
	if (_callback_hiding_cfg == 1)
	{
		hideCfg();
	}
	if (_callback_showing_SUI == 1)
	{
		switchFromNoComp();
	}
	if (_callback_closing_SUI == 1)
	{
		switchToNoComp();
	}
}

dc_showMl()
{
	callback_showing_ml = 1;
	callback_hiding_ml = 0;
	callbackTimer.start();
}

dc_hideMl()
{
	callback_showing_ml = 1;
	callback_hiding_ml = 0;
	callbackTimer.start();
}

dc_showPl()
{
	callback_showing_pl = 1;
	callback_hiding_pl = 0;
	callbackTimer.start();
}

dc_hidePl()
{
	callback_showing_pl = 0;
	callback_hiding_pl = 1;
	callbackTimer.start();
}

dc_showVideo()
{
	callback_showing_video = 1;
	callback_hiding_video = 0;
	callbackTimer.start();
}

dc_showVis()
{
	callback_showing_vis = 1;
	callback_hiding_vis = 0;
	callbackTimer.start();
}

dc_hideVideo()
{
	callback_showing_video = 0;
	callback_hiding_video = 1;
	callbackTimer.start();
}

dc_hideVis()
{
	callback_showing_vis = 0;
	callback_hiding_vis = 1;
	callbackTimer.start();
}

dc_showBrw()
{
	callback_showing_brw = 1;
	callback_hiding_brw = 0;
	callbackTimer.start();
}

dc_hideBrw()
{
	callback_showing_brw = 0;
	callback_hiding_brw = 1;
	callbackTimer.start();
}

dc_showEq()
{
	callback_showing_eq = 1;
	callback_hiding_eq = 0;
	callbackTimer.start();
}

dc_hideEq()
{
	callback_showing_eq = 0;
	callback_hiding_eq = 1;
	callbackTimer.start();
}

dc_showCfg()
{
	callback_showing_cfg = 1;
	callback_hiding_cfg = 0;
	callbackTimer.start();
}

dc_hideCfg()
{
	callback_showing_cfg = 0;
	callback_hiding_cfg = 1;
	callbackTimer.start();
}

dc_showSUI()
{
	callback_showing_sui = 1;
	callback_closing_sui = 0;
	callbackTimer.start();
}

dc_closeSUI()
{
	callback_showing_sui = 0;
	callback_closing_sui = 1;
	callbackTimer.start();
}



normal.onDock(int side) // v1.1 added
{
  setPrivateInt("Big Bento Modern", "nomax_h", normal.getHeight());
}
  
normal.onUndock() // v1.1 added to cope wiht the SUI area dissapearing
{
  /*if (show_sui.isVisible())
  {
    //normal.sendAction("sui", "tonocomp", 1,0,0,0); // With this SUI area dissapears
    //normal.sendAction("sui", "fromnocomp", 0,0,0,0); // With this SUI area dissapears
    hide_sui.leftClick();
  }
  else if (hide_sui.isVisible())
  {
    normal.sendAction("sui", "tonocomp", 0,0,0,0);
    //show_sui.leftClick(); // This triggers an "old" SUI component
  }*/
  
	string comp = getPrivateString("Big Bento Modern", "Component", "Media Library");
	if (comp != "Hidden")
	{
		normal.sendAction("sui", "tonocomp", 0,0,0,0);
	}
	//else normal.sendAction("sui", "tonocomp", 1,0,0,0); // Why this doesn't work?
	//else normal.sendAction("sui", "fromnocomp", 0,0,0,0); // Why this doesn't work?
	else hide_sui.leftClick();
}