/*---------------------------------------------------
-----------------------------------------------------
Filename:	visualizer.m
Version:	1.4

Type:		maki
Date:		07. Okt. 2007 - 19:56  
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
---------------------------------------------------*/

#include "std.mi"
#include "attribs/init_appearance.m"

Function updateObj(int w);

Function refreshVisSettings();
Function setVis (int mode);
Function ProcessMenuResult (int a);

Global Group scriptGroup, parent, PlayerCbuttons, visualizerg, vis_horizontal_lines, visualizergalt;
Global Vis visualizer, visualizer_m, visualizer2, visualizer_m2, visualizer_alt, visualizer_m_alt;
Global Text tmr;

Global PopUpMenu visMenu;
Global PopUpMenu specmenu;
Global PopUpMenu oscmenu;
Global PopUpMenu pksmenu;
Global PopUpMenu anamenu;
Global PopUpMenu stylemenu;

Global Int currentMode, a_falloffspeed, p_falloffspeed, a_coloring;
Global Boolean show_peaks;
Global Boolean show_lines;
Global Boolean alt_vis;
Global layer trigger, triggerblocker;



System.onScriptLoaded()
{ 
	initAttribs_Appearance();

	scriptGroup = getScriptGroup();
  visualizerg = scriptGroup.findObject("main.vis.group");
  visualizergalt = scriptGroup.findObject("main.vis.group.alt");
	
	parent = visualizerg.getParent();
	PlayerCbuttons = parent.findObject("player.cbuttons");

	visualizer = visualizerg.findObject("main.vis");
	visualizer_alt = visualizergalt.findObject("main.vis.alt");
	visualizer2 = visualizerg.findObject("main.vis2");
	visualizer_m = visualizerg.findObject("main.vis.mirror");
	visualizer_m_alt = visualizergalt.findObject("main.vis.mirror.alt");
	visualizer_m2 = visualizerg.findObject("main.vis.mirror2");

	trigger = scriptGroup.findObject("main.vis.trigger");
	triggerblocker = scriptGroup.findObject("vis.trigger.blocker");
	vis_horizontal_lines = scriptGroup.findObject("vis.horizontal.lines");

	tmr = visualizerg.findObject("SongTime");

	visualizer.setXmlParam("peaks", integerToString(show_peaks));
	visualizer.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer.setXmlParam("falloff", integerToString(a_falloffspeed));
	
	visualizer2.setXmlParam("peaks", integerToString(show_peaks));
	visualizer2.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer2.setXmlParam("falloff", integerToString(a_falloffspeed));

  updateObj(PlayerCbuttons.getWidth());

  show_lines = getPrivateInt("Big Bento Modern", "Visualizer show Lines", 1); // This way default option is to set it enabled
  alt_vis = getPrivateInt("Big Bento Modern", "Alt Visualizer", 0);
  
  if (show_lines == 0) { vis_horizontal_lines.hide(); show_lines = 0; }
  else if (show_lines == 1) { vis_horizontal_lines.show(); show_lines = 1; }
  
  if (alt_vis == 0) { visualizerg.setXmlParam("alpha", "253"); visualizergalt.setXmlParam("alpha", "0"); alt_vis = 0; }
  else if (alt_vis == 1) { visualizergalt.setXmlParam("alpha", "253"); visualizerg.setXmlParam("alpha", "0"); alt_vis = 1; }  
}

visualizerg.onSetVisible(int on) {
	if (on) refreshVisSettings ();
}

visualizergalt.onSetVisible(int on) {
	if (on) refreshVisSettings ();
}

refreshVisSettings ()
{
	currentMode = getPrivateInt("Big Bento Modern", "Visualizer Mode", 1);
	show_peaks = getPrivateInt("Big Bento Modern", "Visualizer show Peaks", 1);
	a_falloffspeed = getPrivateInt("Big Bento Modern", "Visualizer analyzer falloff", 3);
	p_falloffspeed = getPrivateInt("Big Bento Modern", "Visualizer peaks falloff", 2);
	a_coloring = getPrivateInt("Big Bento Modern", "Visualizer analyzer coloring", 0);

	visualizer.setXmlParam("peaks", integerToString(show_peaks));
	visualizer.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer.setXmlParam("falloff", integerToString(a_falloffspeed));

	visualizer_alt.setXmlParam("peaks", integerToString(show_peaks));
	visualizer_alt.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer_alt.setXmlParam("falloff", integerToString(a_falloffspeed));
	
	visualizer2.setXmlParam("peaks", integerToString(show_peaks));
	visualizer2.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer2.setXmlParam("falloff", integerToString(a_falloffspeed));
	
	visualizer_m.setXmlParam("peaks", integerToString(show_peaks));
	visualizer_m.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer_m.setXmlParam("falloff", integerToString(a_falloffspeed));

	visualizer_m_alt.setXmlParam("peaks", integerToString(show_peaks));
	visualizer_m_alt.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer_m_alt.setXmlParam("falloff", integerToString(a_falloffspeed));
	
	visualizer_m2.setXmlParam("peaks", integerToString(show_peaks));
	visualizer_m2.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
	visualizer_m2.setXmlParam("falloff", integerToString(a_falloffspeed));		
	

	if (a_coloring == 0)
	{
		visualizer.setXmlParam("coloring", "Normal");
		visualizer_alt.setXmlParam("coloring", "Normal");
		visualizer_m.setXmlParam("coloring", "Normal");
		visualizer_m_alt.setXmlParam("coloring", "Normal");
		visualizer2.setXmlParam("coloring", "Normal");
		visualizer_m2.setXmlParam("coloring", "Normal");
	}
	else if (a_coloring == 1)
	{
		visualizer.setXmlParam("coloring", "Normal");
		visualizer_alt.setXmlParam("coloring", "Normal");
		visualizer_m.setXmlParam("coloring", "Normal");
		visualizer_m_alt.setXmlParam("coloring", "Normal");
		visualizer2.setXmlParam("coloring", "Normal");
		visualizer_m2.setXmlParam("coloring", "Normal");
	}
	else if (a_coloring == 2)
	{
		visualizer.setXmlParam("coloring", "Fire");
		visualizer_alt.setXmlParam("coloring", "Fire");
		visualizer_m.setXmlParam("coloring", "Fire");
		visualizer_m_alt.setXmlParam("coloring", "Fire");
		visualizer2.setXmlParam("coloring", "Fire");
		visualizer_m2.setXmlParam("coloring", "Fire");
	}
	else if (a_coloring == 3)
	{
		visualizer.setXmlParam("coloring", "Line");
		visualizer_alt.setXmlParam("coloring", "Line");
		visualizer_m.setXmlParam("coloring", "Line");
		visualizer_m_alt.setXmlParam("coloring", "Line");
		visualizer2.setXmlParam("coloring", "Line");
		visualizer_m2.setXmlParam("coloring", "Line");
	}

	setVis (currentMode);
}

trigger.onLeftButtonDown (int x, int y)
{
	currentMode++;

	if (currentMode == 6)
	{
		currentMode = 0;
	}

	setVis	(currentMode);
	complete;
}




trigger.onRightButtonUp (int x, int y)
{
	visMenu = new PopUpMenu;
	specmenu = new PopUpMenu;
	oscmenu = new PopUpMenu;
	pksmenu = new PopUpMenu;
	anamenu = new PopUpMenu;
	stylemenu = new PopUpMenu;

	visMenu.addCommand("Presets:", 999, 0, 1);
	visMenu.addCommand("No Visualization", 100, currentMode == 0, 0);
	specmenu.addCommand("Thick Bands", 1, currentMode == 1, 0);
	specmenu.addCommand("Thin Bands", 2, currentMode == 2, 0);
	visMenu.addSubMenu(specmenu, "Spectrum Analyzer");

	oscmenu.addCommand("Lines", 3, currentMode == 3, 0);
	oscmenu.addCommand("Dots", 4, currentMode == 4, 0); //v1.15 swapped 'solid' and 'lines'
	oscmenu.addCommand("Solid", 5, currentMode == 5, 0);
	visMenu.addSubMenu(oscmenu, "Oscilloscope");

	visMenu.addSeparator();
	visMenu.addCommand("Options:", 102, 0, 1);
	visMenu.addCommand("Show Peaks", 101, show_peaks == 1, 0);
	visMenu.addCommand("Show Grid", 404, show_lines == 1, 0);
	pksmenu.addCommand("Slower", 200, p_falloffspeed == 0, 0);
	pksmenu.addCommand("Slow", 201, p_falloffspeed == 1, 0);
	pksmenu.addCommand("Moderate", 202, p_falloffspeed == 2, 0);
	pksmenu.addCommand("Fast", 203, p_falloffspeed == 3, 0);
	pksmenu.addCommand("Faster", 204, p_falloffspeed == 4, 0);
	visMenu.addSubMenu(pksmenu, "Peak Falloff Speed");
	anamenu.addCommand("Slower", 300, a_falloffspeed == 0, 0);
	anamenu.addCommand("Slow", 301, a_falloffspeed == 1, 0);
	anamenu.addCommand("Moderate", 302, a_falloffspeed == 2, 0);
	anamenu.addCommand("Fast", 303, a_falloffspeed == 3, 0);
	anamenu.addCommand("Faster", 304, a_falloffspeed == 4, 0);
	visMenu.addSubMenu(anamenu, "Analyzer Falloff Speed");
	stylemenu.addCommand("Normal", 400, a_coloring == 0, 0);
	stylemenu.addCommand("Fire", 402, a_coloring == 2, 0);
	stylemenu.addCommand("Line", 403, a_coloring == 3, 0);
	visMenu.addSubMenu(stylemenu, "Analyzer Coloring");
	visMenu.addSeparator();
	visMenu.addCommand("Classic Visualization", 409, alt_vis == 1, 0);

	ProcessMenuResult (visMenu.popAtMouse());
	//ProcessMenuResult (visMenu.popAtXY(getMousePosX()-12, getMousePosY()+15));

	delete visMenu;
	delete specmenu;
	delete oscmenu;
	delete pksmenu;
	delete anamenu;
	delete stylemenu;

	complete;	
}

ProcessMenuResult (int a)
{
	if (a < 1) return;

	if (a > 0 && a <= 6 || a == 100)
	{
		if (a == 100) a = 0;
		setVis(a);
	}

	else if (a == 101)
	{
		show_peaks = (show_peaks - 1) * (-1);
		visualizer.setXmlParam("peaks", integerToString(show_peaks));
		visualizer_alt.setXmlParam("peaks", integerToString(show_peaks));
		visualizer_m.setXmlParam("peaks", integerToString(show_peaks));
		visualizer_m_alt.setXmlParam("peaks", integerToString(show_peaks));
		visualizer2.setXmlParam("peaks", integerToString(show_peaks));
		visualizer_m2.setXmlParam("peaks", integerToString(show_peaks));
		setPrivateInt("Big Bento Modern", "Visualizer show Peaks", show_peaks);
	}

	else if (a >= 200 && a <= 204)
	{
		p_falloffspeed = a - 200;
		visualizer.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		visualizer_alt.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		visualizer_m.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		visualizer_m_alt.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		visualizer2.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		visualizer_m2.setXmlParam("peakfalloff", integerToString(p_falloffspeed));
		setPrivateInt("Big Bento Modern", "Visualizer peaks falloff", p_falloffspeed);
	}

	else if (a >= 300 && a <= 304)
	{
		a_falloffspeed = a - 300;
		visualizer.setXmlParam("falloff", integerToString(a_falloffspeed));
		visualizer_alt.setXmlParam("falloff", integerToString(a_falloffspeed));
		visualizer_m.setXmlParam("falloff", integerToString(a_falloffspeed));
		visualizer_m_alt.setXmlParam("falloff", integerToString(a_falloffspeed));
		visualizer2.setXmlParam("falloff", integerToString(a_falloffspeed));
		visualizer_m2.setXmlParam("falloff", integerToString(a_falloffspeed));
		setPrivateInt("Big Bento Modern", "Visualizer analyzer falloff", a_falloffspeed);
	}

	else if (a >= 400 && a <= 403)
	{
		a_coloring = a - 400;
		if (a_coloring == 0)
		{
			visualizer.setXmlParam("coloring", "Normal");
			visualizer_alt.setXmlParam("coloring", "Normal");
			visualizer_m.setXmlParam("coloring", "Normal");
			visualizer_m_alt.setXmlParam("coloring", "Normal");
			visualizer2.setXmlParam("coloring", "Normal");
			visualizer_m2.setXmlParam("coloring", "Normal");
		}
		else if (a_coloring == 1)
		{
			visualizer.setXmlParam("coloring", "Normal");
			visualizer_alt.setXmlParam("coloring", "Normal");
			visualizer_m.setXmlParam("coloring", "Normal");
			visualizer_m_alt.setXmlParam("coloring", "Normal");
			visualizer2.setXmlParam("coloring", "Normal");
			visualizer_m2.setXmlParam("coloring", "Normal");
		}
		else if (a_coloring == 2)
		{
			visualizer.setXmlParam("coloring", "Fire");
			visualizer_alt.setXmlParam("coloring", "Fire");
			visualizer_m.setXmlParam("coloring", "Fire");
			visualizer_m_alt.setXmlParam("coloring", "Fire");
			visualizer2.setXmlParam("coloring", "Fire");
			visualizer_m2.setXmlParam("coloring", "Fire");
		}
		else if (a_coloring == 3)
		{
			visualizer.setXmlParam("coloring", "Line");
			visualizer_alt.setXmlParam("coloring", "Line");
			visualizer_m.setXmlParam("coloring", "Line");
			visualizer_m_alt.setXmlParam("coloring", "Line");
			visualizer2.setXmlParam("coloring", "Line");
			visualizer_m2.setXmlParam("coloring", "Line");
		}
		setPrivateInt("Big Bento Modern", "Visualizer analyzer coloring", a_coloring);
	}
	
		else if (a >= 404 && a <= 405)
	{
    if (show_lines) {show_lines = 0; vis_horizontal_lines.hide(); show_lines = 0;}
		else {show_lines = 1; vis_horizontal_lines.show(); }
		setPrivateInt("Big Bento Modern", "Visualizer show Lines", show_lines);
  }

		else if (a >= 408 && a <= 410)
	{
    if (alt_vis) { alt_vis = 0; visualizerg.setXmlParam("alpha", "253"); visualizergalt.setXmlParam("alpha", "0"); alt_vis = 0; }
		else {alt_vis = 1; visualizergalt.setXmlParam("alpha", "253"); visualizerg.setXmlParam("alpha", "0"); }
		setPrivateInt("Big Bento Modern", "Alt Visualizer", alt_vis);
  }

}



setVis (int mode)
{
	setPrivateInt("Big Bento Modern", "Visualizer Mode", mode);
	if (mode == 0)
	{
		visualizer.setMode(0);
		visualizer_alt.setMode(0);
		visualizer_m.setMode(0);
		visualizer_m_alt.setMode(0);
		visualizer2.setMode(0);
		visualizer_m2.setMode(0);
	}
	else if (mode == 1)
	{
		visualizer.setXmlParam("bandwidth", "wide");
		visualizer.setMode(1);
		visualizer_alt.setXmlParam("bandwidth", "wide");
		visualizer_alt.setMode(1);
		visualizer2.setXmlParam("bandwidth", "wide");
		visualizer.setXmlParam("x", "-9"); // Vic trick: I move it 9 pixels off because of a Winamp bug where the 1st beat gets stucked
		visualizer_alt.setXmlParam("x", "-1"); // Vic trick: I move it 1 pixel off because of.. perfectionism
		visualizer2.setXmlParam("x", "137"); // Vic trick: I move it 9 pixels off because of a Winamp bug where the 1st beat gets stucked
		visualizer2.setMode(1);
		visualizer_m.setXmlParam("bandwidth", "wide");
		visualizer_m.setMode(1);
		visualizer_m_alt.setXmlParam("bandwidth", "wide");
		visualizer_m_alt.setMode(1);
		visualizer_m2.setXmlParam("bandwidth", "wide");
		visualizer_m.setXmlParam("x", "-9"); // Vic trick: I move it 9 pixels off because of a Winamp bug where the 1st beat gets stucked
		visualizer_m_alt.setXmlParam("x", "-1");
		visualizer_m2.setXmlParam("x", "137"); // Vic trick: I move it 9 pixels off because of a Winamp bug where the 1st beat gets stucked
		visualizerg.setXmlParam("x", "440"); // Fixed the x position of the group to make the trick less evident
		visualizer_m2.setMode(1);
	}
	else if (mode == 2)
	{
		visualizer.setXmlParam("bandwidth", "thin");
		visualizer.setMode(1);
		visualizer_alt.setXmlParam("bandwidth", "thin");
		visualizer_alt.setMode(1);
		visualizer2.setXmlParam("bandwidth", "thin");
		visualizer.setXmlParam("x", "0"); // Vic trick: I restore the vis position because here there is no Winamp bug
		visualizer_alt.setXmlParam("x", "0");
		visualizer2.setXmlParam("x", "144"); // Vic trick: I restore the vis position because here there is no Winamp bug
		visualizer2.setMode(1);
    visualizer_m.setXmlParam("bandwidth", "thin");
		visualizer_m.setMode(1);
    visualizer_m_alt.setXmlParam("bandwidth", "thin");
		visualizer_m_alt.setMode(1);
		visualizer_m2.setXmlParam("bandwidth", "thin");
		visualizer_m.setXmlParam("x", "0"); // Vic trick: I restore the vis position because here there is no Winamp bug
		visualizer_m_alt.setXmlParam("x", "0");
		visualizer_m2.setXmlParam("x", "144"); // Vic trick: I restore the vis position because here there is no Winamp bug
		visualizerg.setXmlParam("x", "431"); // Fixed the x position of the group to make the trick less evident
		visualizer_m2.setMode(1);
	}
	else if (mode == 3)
	{
		visualizer.setXmlParam("oscstyle", "solid");
		visualizer.setMode(2);
		visualizer_alt.setXmlParam("oscstyle", "solid");
		visualizer_alt.setMode(2);
		visualizer2.setXmlParam("oscstyle", "solid");
		visualizer.setXmlParam("x", "0");
		visualizer2.setXmlParam("x", "144");
		visualizer2.setMode(2);
		visualizer_m.setXmlParam("oscstyle", "solid");
		visualizer_m.setMode(2);
		visualizer_m_alt.setXmlParam("oscstyle", "solid");
		visualizer_m_alt.setMode(2);
		visualizer_m2.setXmlParam("oscstyle", "solid");
		visualizer_m.setXmlParam("x", "0");
		visualizer_m2.setXmlParam("x", "144");
		visualizerg.setXmlParam("x", "431");
		visualizer_m2.setMode(2);
	}
	else if (mode == 4)
	{
		visualizer.setXmlParam("oscstyle", "dots");
		visualizer.setMode(2);
		visualizer_alt.setXmlParam("oscstyle", "dots");
		visualizer_alt.setMode(2);
		visualizer2.setXmlParam("oscstyle", "dots");
		visualizer.setXmlParam("x", "0");
		visualizer2.setXmlParam("x", "144");
		visualizer2.setMode(2);
		visualizer_m.setXmlParam("oscstyle", "dots");
		visualizer_m.setMode(2);
		visualizer_m_alt.setXmlParam("oscstyle", "dots");
		visualizer_m_alt.setMode(2);
		visualizer_m2.setXmlParam("oscstyle", "dots");
		visualizer_m.setXmlParam("x", "0");
		visualizer_m2.setXmlParam("x", "144");
		visualizerg.setXmlParam("x", "431");
		visualizer_m2.setMode(2);
	}
	else if (mode == 5)
	{
		visualizer.setXmlParam("oscstyle", "lines");
		visualizer.setMode(2);
		visualizer_alt.setXmlParam("oscstyle", "lines");
		visualizer_alt.setMode(2);
		visualizer2.setXmlParam("oscstyle", "lines");
		visualizer.setXmlParam("x", "0");
		visualizer2.setXmlParam("x", "144");
		visualizer2.setMode(2);
		visualizer_m.setXmlParam("oscstyle", "lines");
		visualizer_m.setMode(2);
		visualizer_m_alt.setXmlParam("oscstyle", "lines");
		visualizer_m_alt.setMode(2);
		visualizer_m2.setXmlParam("oscstyle", "lines");
		visualizer_m.setXmlParam("x", "0");
		visualizer_m2.setXmlParam("x", "144");
		visualizerg.setXmlParam("x", "431");
		visualizer_m2.setMode(2);
	}
	currentMode = mode;
}



PlayerCbuttons.onResize (int x, int y, int w, int h)
{
	updateObj(w);
}

updateObj (int w)
{
	if (w > 730)
	{
		visualizerg.show();
	}
	else
	{
		visualizerg.hide();
	}

	if (w > 705)
	{
		visualizergalt.show();
	}
	else
	{
		visualizergalt.hide();
	}


	if (w < 731 && alt_vis == 0) // v1.15 fix
	{
		triggerblocker.show();
		triggerblocker.setxmlparam("w", "288");
	}
	else
	{
		triggerblocker.hide();
	}

	if (w < 706 && alt_vis == 1)
	{
		triggerblocker.show();
		triggerblocker.setxmlparam("w", "258");
	}
	else if (w > 704 && w < 730 && alt_vis == 1)
	{
		triggerblocker.hide();
	}

}