/*---------------------------------------------------
-----------------------------------------------------
Author:		iron2000 + victhor mods
E-Mail:		victorbrocaz@gmail.com
Internet:	victhor.deviantart.com

Victhor mod:
Added a second Mute Warning and some parts of how the mute-unmute relation works
-----------------------------------------------------
---------------------------------------------------*/


#include "std.mi"

Global int VOLUME_FILL_MAX_W;

Function doFade();
Function stopFade();
Function startFade();
Function sliderMove(int newpos);
Function mainVol(int muted);
Global Boolean direction;
Global Timer myTimer;

Global Group scriptGroup, SkinVol, CButtons;
Global Slider vol_slider;
Global Layer vol_layer, muteWarning, muteWarning2;

Global Boolean BtnPressed;
Global GuiObject fill;
Global GuiObject SongTicker;

Global container player;
Global layout normal, shade;
Global Button volOn, volMuted;

Global Togglebutton mute_but;

System.onScriptLoaded() {
  scriptGroup = getscriptGroup();

	player = System.getContainer("main");
	normal = player.getLayout("normal");
	shade = player.getLayout("shade");	
	
	/*if (scriptGroup.getParentLayout().getID() == "normal") volOn = normal.findObject("vol.on");
	if (scriptGroup.getParentLayout().getID() == "shade") volOn = shade.findObject("vol.on");
	if (scriptGroup.getParentLayout().getID() == "normal") volMuted = normal.findObject("vol.muted");
	if (scriptGroup.getParentLayout().getID() == "shade") volMuted = shade.findObject("vol.muted");*/

  if (normal)
  {
	volOn = scriptGroup.findObject("vol.on");
	SkinVol = scriptGroup.findObject("skin.vol");
	
	volMuted = scriptGroup.findObject("vol.muted");
	vol_slider = SkinVol.findObject("volume");
	vol_layer = SkinVol.findObject("volume.bg");

	mute_but = SkinVol.findObject("mute");
	muteWarning = scriptGroup.findObject("mute.warning");
	muteWarning2 = SkinVol.findObject("mute.warning2");
	fill = SkinVol.findObject("player.volume.fill");
	}

  if (shade)
  {
	CButtons = scriptGroup.findObject("player.cbuttons");
	SkinVol = CButtons.findObject("skin.vol");
	
	volOn = CButtons.findObject("vol.on");
	volMuted = CButtons.findObject("vol.muted");
	vol_slider = SkinVol.findObject("volume");
	vol_layer = SkinVol.findObject("volume.bg");

	mute_but = SkinVol.findObject("mute");
	muteWarning = CButtons.findObject("mute.warning");
	muteWarning2 = SkinVol.findObject("mute.warning2");
	fill = SkinVol.findObject("player.volume.fill");
	}
	
  if (scriptGroup.getParentLayout().getID() == "normal") vol_layer.setXmlParam("w", integerToString(302/255*getVolume()));
  else if (scriptGroup.getParentLayout().getID() == "shade") vol_layer.setXmlParam("w", integerToString(191/255*getVolume()));	

	SongTicker = scriptGroup.findObject("songticker");

	
	VOLUME_FILL_MAX_W = stringToInteger(getParam());
	fill.setXmlParam("w", integerToString(VOLUME_FILL_MAX_W*getVolume()/255));
	
	myTimer = new Timer;
	myTimer.setDelay(700);
	
	if(getPrivateInt("Big Bento Modern", "muted", 0)==1){
    SongTicker.sendAction("showinfo", "Mute ON", 0, 0, 0, 0);
		mute_but.setActivated(true);
		mute_but.setXmlParam("tooltip", "Turn Volume On");
    volMuted.show();
    volOn.hide();
		startFade();
	}
	else{
		mute_but.setActivated(false);
		mute_but.setXmlParam("tooltip", "Mute Volume");
    volMuted.hide();
    volOn.show();		
	}

	
		BtnPressed = 0;
}

System.onScriptUnloading(){
	setPrivateInt("Big Bento Modern", "muted", mute_but.getCurCfgVal());
	delete myTimer;
}

mainVol(int muted){
  if(muted==0){
    volMuted.hide();
    volOn.show();
  }
  else{
    volMuted.show();
    volOn.hide();
  }
}


//mute button activate on slider move to 0 and vice versa
sliderMove(int newpos){
  if (scriptGroup.getParentLayout().getID() == "normal") vol_layer.setXmlParam("w", integerToString(302/255*newpos));
  else if (scriptGroup.getParentLayout().getID() == "shade")  vol_layer.setXmlParam("w", integerToString(191/255*newpos));
	
	if(mute_but.getCurCfgVal()==1 && newpos>0){
		mute_but.setActivated(false);
		mainVol(0);
    SongTicker.sendAction("showinfo", "Mute: Off", 0, 0, 0, 0);
		setPrivateInt("Big Bento Modern", "muted", 0);
		stopFade();
	}
	if(mute_but.getCurCfgVal()==0 && newpos==0){
		mute_but.setActivated(true);
		mainVol(1);
		SongTicker.sendAction("showinfo", "Mute: On", 0, 0, 0, 0);
		setPrivateInt("Big Bento Modern", "muted", 1);
		startFade();
	}
}

vol_slider.onSetPosition(int newpos){
	sliderMove(newpos);
}

vol_slider.onPostedPosition(int newpos){
	sliderMove(newpos);
}

System.onvolumechanged(int newvol)
{
	fill.setXmlParam("w", integerToString(VOLUME_FILL_MAX_W*getVolume()/255));
	if (!BtnPressed)
	{
		SongTicker.sendAction
		("showinfo", (translate("Volume:")) + integerToString(newvol/2.55) + "%", 0, 0, 0, 0);
			}
	BtnPressed = 0;
}


// Victhor tricks to warn on max volume status (currently only working on mouse wheel and keyboard arrows Volume change)

/*normal.onMouseWheelUp(int clicked , int lines)
{
  if (System.getVolume() == 255)
    {
    SongTicker.sendAction("showinfo", "Volume already at 100%", 0, 0, 0, 0);
    }
}

System.onKeyDown(String key) {
	if (key == "up")
	{
    if (System.getVolume() == 255)
    {
      SongTicker.sendAction("showinfo", "Volume already at 100%", 0, 0, 0, 0);
    }
	}
}*/

shade.onMouseWheelUp(int clicked , int lines)
{
  if (System.getVolume() == 255)
    {
    SongTicker.sendAction("showinfo", "Volume already at 100%", 0, 0, 0, 0);
    }
}


mute_but.onToggle(Boolean onoff){
	if(mute_but.getCurCfgVal()==0){
		setVolume(getPrivateInt("Big Bento Modern", "saveVol", 100));
		mute_but.setXmlParam("tooltip", "Mute Volume");
		SongTicker.sendAction("showinfo", "Volume Unmuted", 0, 0, 0, 0);
		stopFade();
		mainVol(0);
		BtnPressed = 1;
	}
	else{
		setPrivateInt("Big Bento Modern", "saveVol", getVolume());
		setVolume(0);
		SongTicker.sendAction("showinfo", "Volume Muted", 0, 0, 0, 0);
		mute_but.setXmlParam("tooltip", "Turn Volume On");
		startFade();
		mainVol(1);
		BtnPressed = 0;
	}
	setPrivateInt("Big Bento Modern", "muted", mute_but.getCurCfgVal());
}

vol_slider.onEnterArea(){
	vol_layer.setXmlParam("image", "volume.bg.hover");
}
vol_slider.onLeaveArea(){
	vol_layer.setXmlParam("image", "volume.bg");
}

//Mute warning, fading in out
myTimer.onTimer(){
	doFade();
}

doFade(){
	if(direction){
		muteWarning.setTargetA(0);
		muteWarning2.setTargetA(0);
	}
	else{
		muteWarning.setTargetA(253);
		muteWarning2.setTargetA(253);
	}
	muteWarning.setTargetSpeed(0.6);
	muteWarning.gotoTarget();
	muteWarning2.gotoTarget();
	muteWarning2.setTargetSpeed(0.6);
	direction=!direction;
}
startFade(){
	direction=false;
	doFade();
	myTimer.start();
	muteWarning.show();
	muteWarning2.show();
}
stopFade(){
	myTimer.stop();
	muteWarning.cancelTarget();
	muteWarning.setAlpha(0);
	muteWarning.hide();
	muteWarning2.cancelTarget();
	muteWarning2.setAlpha(0);
	muteWarning2.hide();
}